#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define double long double
#define pb push_back
#define all(v) v.begin(), v.end()

int main() {

    int n;
    cin >> n;
    vector <ll> a(n), b(n);
    for (auto &to : a) cin >> to;
    for (auto &to : b) cin >> to;
    ll suma = 0;
    ll sumb = 0;
    for (auto to : a) suma += to;
    for (auto to : b) sumb += to;
    if (suma > sumb) {
        cout << -1;
        return 0;
    }

    int l = 0, r = n-1;
    while (l < r) {
        int mid = (l+r) >> 1;
        stack <pair <ll, ll>> st;
        for (int i = n-1; i >= 0; i--) {
            st.push(make_pair(i, b[i]));
        }
        int flag = 1;
        vector <ll> q = a;
        for (int i = 0; i < n; i++) {
            while (st.size() > 0 && abs(st.top().first-i) > mid) st.pop();
            if (st.size() == 0) {
                flag = 0;
                break;
            }
            if (abs(i-st.top().first) > mid) {
                flag = 0;
                break;
            }
            while (q[i] > 0 && st.size() > 0) {
                if (abs(st.top().first-i) > mid) break;
                ll mn = min(q[i], st.top().second);
                st.top().second -= mn;
                q[i] -= mn;
                if (st.top().second == 0) st.pop();
            }
        }
        for (int i = 0; i < n; i++) {
            if (q[i] > 0) flag = 0;
        }
        if (flag) {
            r = mid;
        }
        else {
            l = mid+1;
        }
    }
    cout << l;

    return 0;
}
