﻿#include <iostream>
#include <vector>
#include <set>
#include<map>
#include<deque>
#include <algorithm>

using namespace std;

typedef long long ll;

template<typename T> istream& operator>>(istream& in, vector<T>& a) { for (int i = 0; i < a.size(); ++i) in >> a[i]; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T>& a) { for (int i = 0; i < a.size(); ++i) out << a[i] << ' '; return out;}

template<typename T1, typename T2> istream& operator>>(istream& in, pair<T1, T2> &p){ in >> p.first >> p.second; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream& out, pair<T1, T2> &p) { out << p.first << ' ' << p.second; return out; }



#define all(x) x.begin(),x.end()
#define range(i,n) for (int i=0;i<n;++i)
#define rrange(i,n) for (int i=n-1;i>=0;--i)


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<int> st1, st2;
    vector<bool> used(n);
    int ind = 0;
    vector<short> ans;
    range(i, n) {
        if (!used[i]) {
            while (a[ind] != i + 1) {
                st1.push_back(a[ind]);
                used[a[ind]-1] = 1;
                ind++;
                ans.push_back(1);
                //cout << "1\n";
            }
            ind++;
            ans.push_back(1);
            ans.push_back(-1);
            //cout << "1\n-1\n";;
        }
        else {
            while (st1.back() != i + 1) {
                ans.push_back(12);
                //cout << "12\n";
                st2.push_back(st1.back());
                st1.pop_back();
            }
            ans.push_back(-1);
            //cout << "-1\n";
            while (st2.size()) {
                st1.push_back(st2.back());
                st2.pop_back();
                ans.push_back(21);
                //cout << "21\n";
            }
        }
    }
    if (ans.size() > 2e6) cout << ans[-1];
    for (auto i : ans) cout << i << '\n';
}
