#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define int long long
#define rep(i, n) for(int i = 0; i < n; i++)
#define vi vector<int>
#define vvi vector<vector<int>>
#define vpi vector<pair<int, int>>
#define pi pair<int, int>
#define vb vector<bool>


int32_t main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);


    /*int n;
    cin >> n;
    vi a(n), b(n), pa(n + 1), pb(n + 1);
    pa[0] = 0; pb[0] = 0;
    int as = 0, bs = 0;
    rep(i, n){
        cin >> a[i];
        as += a[i];
        pa[i + 1] = as;
    }

    rep(i, n){
        cin >> b[i];
        bs += b[i];
        pb[i + 1] = bs;
    }

    if(as > bs) cout << -1;
    else{

    }*/

    int n;
    cin >> n;
    vi a;
    rep(i,n) {
        int k;
        cin >> k;
        a.push_back(k);
    }
    vi min_left,min_right,max_left,max_right;
    min_left.assign(n, 0);
    min_right.assign(n, 0);
    max_left.assign(n, 0);
    max_right.assign(n, 0);
    min_left[0] = a[0];
    max_left[0] = a[0];
    min_right[n-1] = a[n-1];
    max_right[n-1] = a[n-1];
    for (int i = 1; i < n; i++) {
        min_left[i] = min(min_left[i-1],a[i]);
        max_left[i] = max(max_left[i-1],a[i]);
        min_right[n-1-i] = min(min_right[n-i],a[n-1-i]);
        max_right[n-1-i] = max(max_right[n-i],a[n-1-i]);
    }
    cout << 1. << " ";
    for (int k = 0; k < n-1; k++) {
        double t1 = (max_left[k] + .0) / max_right[k+1];
        double t2 = (min_left[k] + .0) / min_right[k+1];
        vector<double> tmp {0,1,t1,t2};
        double min_del = 1e15;
        double min_tmp = -1;
        for (int i = 0; i < 4; i++) {
            double c = tmp[i];
            if ((c < 0) || (c > 1)) continue;
            double res_min = min(min_left[k] + .0,c * min_right[k+1]);
            double res_max = max(max_left[k] + .0, c * max_right[k+1]);
            double del = res_max - res_min;
            //cout << k << " " << c << " " << del << endl;
            if (del < min_del) {
                min_del = del;
                min_tmp = c;
            }
            if ((del == min_del) && (c < min_tmp)) {
                min_del = del;
                min_tmp = c;
            }
        }
        cout << 1 - min_tmp << " ";
    }
    

}
