﻿#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>

using namespace std;

template <typename T> inline T getint() {
	T val = 0;
	char c;
	bool neg = false;
	while ((c = getchar()) && !(c >= '0' && c <= '9')) {
		neg |= c == '-';
	}
	do {
		val = (val * 10) + c - '0';
	} while ((c = getchar()) && (c >= '0' && c <= '9'));
	return val * (neg ? -1 : 1);
}

#define int long long
#define x first
#define y second
typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;
ll mod = 1666666667;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e5;
const ld eps = 1e-8;


signed main() {
	std::ios::sync_with_stdio(false);
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(12);
	ld a1, a2, a3, a4;
	cin >> a1 >> a2 >> a3 >> a4;
	if ((a1 - 1) < eps || (a2 - 1) < eps || (a3 - 1) < eps || (a4 - 1) < eps)
	{
		cout << "1 2 3 4\n1.0 1.0 1.0 1.0\n";
		return 0;
	}
	ld b1, b2, b3, b4;
	b1 = a1 - 1;
	b2 = a2 - 1;
	b3 = a3 - 1;
	b4 = a4 - 1;
	ld a = min(b1 * b2, b3 * b4);
	ld b = min(b1 * b3, b2 * b4);
	ld c = min(b1 * b4, b2 * b3);
	if (a >= b - eps && a >= c - eps) {
		cout << "1 3 4 2\n";
		if (b1 * b2 < b3 * b4)
			b4 = b1 * b2 / b3;
		else
			b1 = b4 * b3 / b2;

		cout << b1 + 1 << " " << b3 + 1 << " " << b4 + 1<< " " << b2 + 1<< "\n";
		return 0;
	}
	if (b >= a - eps && b >= c - eps) {
		cout << "1 2 4 3\n";
		if (b1 * b3 < b2 * b4)
			b4 = b1 * b3 / b2;			
		else
			b1 = b2 * b4 / b3;
			

		cout << b1 + 1 << " " << b2 + 1 << " " << b4 + 1 << " " << b3 + 1 << "\n";
		return 0;
	}
	if (c >= a - eps && c >= b - eps) {
		cout << "1 2 3 4\n";
		if (b1 * b4 < b2 * b3)
			b2 = b1 * b4 / b3;
		else
			b1 = b2 * b3 / b4;
			

		cout << b1 + 1 << " " << b2 + 1 << " " << b3 + 1 << " " << b4 + 1 << "\n";
		return 0;
	}
	int k = 2;
	cout << 50 / (k - k);
}