#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>
#include <bitset>
#include <iomanip>
// #include <bits/stdc++.h>

using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
#define len(o) (int)((o).size())
#if LOCAL
#define dbg(o) cout << #o << " = " << o << "\n";
#else
#define dbg(o)
#endif

using ll = long long;
using ld = long double;

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const T &e : a) {
        out << e << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &e : a) {
        in >> e;
    }
    return in;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(16);
    int n;
     cin >> n;
     vector<int> a(n);
     cin >> a;
     vector<int> prefmin(n), prefmax(n), sufmin(n), sufmax(n);
     prefmin[0] = a[0];
     prefmax[0] = a[0];
     sufmin[n - 1] = a[n - 1];
     sufmax[n - 1] = a[n - 1];
    for (int i = 1; i < n; ++i) {
        prefmin[i] = min(prefmin[i - 1], a[i]);
        prefmax[i] = max(prefmax[i - 1], a[i]);
    }
    for (int i = n - 2; i >= 0; --i) {
        sufmin[i] = min(sufmin[i + 1], a[i]);
        sufmax[i] = max(sufmax[i + 1], a[i]);
    }
    ld res = 0;
    cout << 1.0 << ' ';
    for(int i = 0; i < n - 1; ++i) {
        int minl = prefmin[i], maxl = prefmax[i], minr = sufmin[i + 1], maxr = sufmax[i + 1];
        if (minr >= minl) {
            res = 1 - 1.0 * maxl / maxr;
            if (minr * (1 - res) > minl) res = 1 - 1.0 * minl / minr;
        } else {
            res = 0;
        }
        cout << res << ' ';
    }
}
