#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#pragma GCC optimize("Ofast")

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ll long long
#define ld long double

#define double ld
#define endl '\n'
#define int ll

using namespace std;

const int INF = 1e18;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> arr(n, vector<int>(3));
    for (int i = 0; i < n; ++i) {
        for (int k = 0; k < 3; ++k) {
            cin >> arr[i][k];
        }
    }

    sort(all(arr));

    if (arr[n - 1][0] < 0) {
        cout << "0 1000000000000000000000000000000000000000000000000000" << endl;
        return;
    }

    if (arr[0][0] > 0) {
        cout << "0 -1000000000000000000000000000000000000000000000000000" << endl;
        return;
    }

    double lb = -INF, ub = INF;

    for (int i = 0; i < n; ++i) {
        double a = arr[i][0], b = arr[i][1], c = arr[i][2];
        double vx = -b / (2 * a);
        double vy = a * vx * vx + b * vx + c;

        if (a > 0) {
            lb = max(lb, vy);
        } else if (a < 0) {
            ub = min(ub, vy);
        }
    }

    double l = -INF, r = INF;

    for (int i = 0; i < n; ++i) {
        double a = arr[i][0], b = arr[i][1], c = arr[i][2];

        double vx = -b / (2 * a);
        double vy = a * vx * vx + b * vx + c;

        if (a > 0) {
            double lin = (-b - sqrt(b * b - 4 * a * (c - ub))) / 2.0 / a;
            double rin = (-b + sqrt(b * b - 4 * a * (c - ub))) / 2.0 / a;
            l = max(l, lin);
            r = min(r, rin);
        }

        if (a < 0) {
            double lin = (-b - sqrt(b * b - 4 * a * (c - lb))) / 2.0 / a;
            double rin = (-b + sqrt(b * b - 4 * a * (c - lb))) / 2.0 / a;
            l = max(l, lin);
            r = min(r, rin);
        }
    }

    cout << (l + r) / 2.0 << " " << (ub + lb) / 2.0 << endl;
}

signed main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL
    cout.precision(16);
    cout << fixed;
    solve();
}


