#include <bits/stdc++.h>


#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ll long long
#define ld long double

#define double ld
#define endl '\n'

using namespace std;

const ll p = 239;
const ll mod = 1e9 + 7;

const int maxl = 1e6;

ll pr[maxl] ;

void precalc() {
    pr[0] = 1;
    for (int i = 1; i < maxl; ++i) {
        pr[i] = (pr[i - 1] * p) % mod;
    }
}

deque<int> elems;

deque<int> group_sizes(1);
deque<int> ban(1);

void solve() {
    int l, n;
    cin >> l >> n;
    string s;
    vector<int> has_letters(n);
    vector<vector<int>> hashes(n, vector<int>(26));
    for (int i = 0; i < n; ++i) {
        cin >> s;
        for (int x = 0; x < l; ++x) {
            has_letters[i] = has_letters[i] | (1 << (s[x] - 'a'));
            hashes[i][s[x] - 'a'] = (hashes[i][s[x] - 'a'] + pr[x]);
        }
    }

    for (int i = 0; i < n; ++i) {
        elems.push_back(i);
    }
    group_sizes[0] = n;


    unordered_map<ll, vector<int>> new_groups;

    while (group_sizes.size()) {
        if (group_sizes.front() == 1) {
            group_sizes.pop_front();
            elems.pop_front();
            ban.pop_front();
            continue;
        }

        int aval = (1 << 26) - 1;

        for (int p = 0; p < group_sizes.front(); ++p)
            aval &= has_letters[elems[p]];

        int u = -1;
        for (int c = 0; c < 26; ++c)
            if ((aval & (1 << c)) != 0 and (ban.back() & (1 << c)) == 0)
                u = c;

        if (u == -1) {
            cout << "NO" << endl;
            return;
        }

        new_groups.clear();

        int tmpp = ban.front();
        tmpp = tmpp | (1 << u);

        for (int p = 0; p < group_sizes.front(); ++p)
            new_groups[hashes[elems[p]][u]].push_back(elems[p]);

        for (int i = 0; i < group_sizes.front(); ++i)
            elems.pop_front();
        group_sizes.pop_front();
        ban.pop_front();

        for (auto e : new_groups) {
            if (e.y.size() > 1) {
                for (int i : e.y)
                    elems.push_back(i);

                group_sizes.push_back(e.y.size());
                ban.push_back(tmpp);
            }
        }
    }

    cout << "YES" << endl;
}

signed main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL
    precalc();
    solve();
}


