#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(v) (int)v.size()
#define pb push_back


const int P = 179;
const __int128 MOD = 1e18 + 3;

int get_hash(string& s) {
	int hash = 0;
	for (auto &x : s) {
		int c = (x == '.' ? 27 : x - 'a' + 1);
		hash = ((__int128) hash * (__int128)P + (__int128)c) % MOD;
	}
	return hash;
}

int n, l;
vector<string> a, cur;

void kok(vector<int> idx) {
	if (idx.size() < 2) return;
	
	int bebra = 0;
	vector<int> cnt(26), cerf(26);
	vector<int> uu(26);
	for (auto &id : idx) {
		bebra++;
		for (int j = 0; j < l; j++) {
			if (cur[id][j] != '.') {
				uu[cur[id][j] - 'a'] = 1;
			}
		}
		for (auto &x : a[id]) {
			if (cerf[x - 'a'] != bebra) {
				cnt[x - 'a']++;
			}
			cerf[x - 'a'] = bebra;
		}
	}

	bool added = 0;
	for (int j = 0; j < 26; j++) {
		if (cnt[j] == (int) idx.size()) {
			if (uu[j] == 0) {
				added = 1;
			}
			uu[j] = 1;
		}
	}

	if (!added) {
		cout << "NO";
		exit(0);
	}

	vector<pair<int, int>> hashes;
	for (auto &id : idx) {
		for (int j = 0; j < l; j++) {
			if (uu[a[id][j] - 'a']) {
				cur[id][j] = a[id][j];
			}
		}
		hashes.emplace_back(get_hash(cur[id]), id);
	}
	
	sort(hashes.begin(), hashes.end());

	vector<int> in;
	for (int i = 0; i < sz(hashes); ) {
		int j = i + 1;
		in.push_back(hashes[i].second);
		while (j < n && hashes[i].first == hashes[j].first) {
			in.push_back(hashes[j].second);
			j++;
		}
		kok(in);
		in.clear();
		i = j;
	}
}

void solve() {
	cin >> l >> n;
	a.resize(n);
	cur.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		cur[i] = string(l, '.');
	}
	vector<int> idx(n);
	iota(idx.begin(), idx.end(), 0);
	kok(idx);
	cout << "YES";
}	

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}