#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define deb(a) cerr << #a << " = " << a << '\n';
#define int long long

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

typedef tree<
    pii,
    null_type,
    less<pii>,
    rb_tree_tag,
    tree_order_statistics_node_update>
ordered_set;

const int inf = 2e5;
const ll INF = 2e9;
const int MOD1 = 1e9 + 7;
const int MOD2 = 998244353;
const int P1 = 31;
const int P2 = 37;
const int dx[4] = {0, 0, -1, 1};
const int dy[4] = {-1, 1, 0, 0};
const ld Pi = acosl(-1);
const ld EPS = 1e-8;
const int N = 2e6;
int qqq = 1;
int n;
int a[N], b[N], c[N];

struct par{
  int a, b, c;
  par(){
      a = b = c = 0;
  }

  par(int _a, int _b, int _c){
    a = _a;
    b = _b;
    c = _c;
  }

};

int check(ld x, ld y){
    int kol = 0;
    for (int i = 0; i < n; i++){
        if (a[i] > 0){
            ld y1 = a[i] * x * x + b[i] * x + c[i];
            if (y1 <= y)
                kol++;
            else
                return 0;
        }
        else {
            ld y1 = a[i] * x * x + b[i] * x + c[i];
            if (y1 >= y)
                kol++;
            else
                return 1;
        }
    }
    return 2;
}

ld per(ld x){
    bool f1 = 0;
    ld l = -inf, r = inf;
    for (int q = 0; q < 200; q++){
        ld tl = l + (r - l) / 3.0;
        ld tr = r - (r - l) / 3.0;
        int c1 = check(x, tl), c2 = check(x, tr);
        if (c1 == 0)
            l = tl;
        if (c2 == 1)
            r = tr;
        else if (c1 == 2){
            l = r = tl;
        }
        else if (c2 == 2){
            l = r = tr;
        }
    }
    return l;
}

void solve() {
    cin >> n;
    int mini = INF, maxi = -INF;
    bool signpl = 1, signmn = 1;
    for (int i = 0; i < n; i++){
        cin >> a[i] >> b[i] >> c[i];
        if (a[i] < 0) {
            signpl = 0;
        }
        if (a[i] > 0) {
            signmn = 0;
        }
        maxi = max(maxi, a[i]);
        mini = min(mini, a[i]);
    }
    if (signpl) {
        ld mnx = INF;
        for (int i = 0; i < n; i++) {
            mnx = min((ld)mnx, 1.0 * (ld)(-b[i]) / (2.0 * a[i]));
        }
        cout << fixed << setprecision(20) << mnx << ' ';
        for (int i = 0; i < 100000; i++) {
            cout << 9;
        }
        return;
    }
    if (signmn) {
        ld mnx = INF;
        for (int i = 0; i < n; i++) {
            mnx = min(mnx, 1.0 * (ld)(-b[i]) / (2.0 * a[i]));
        }
        cout << fixed << setprecision(20) << mnx << ' ';
        cout << '-';
        for (int i = 0; i < 100000; i++) {
            cout << 9;
        }
        return;
    }
    ld l = -INF, r = INF;
    for (int i = 1; i < n; i++){
        ld d = (b[0] - b[i]) * (b[0] - b[i]) - 4 * (a[0] - a[i]) * (c[0] - c[i]);
        if (d <= 0 || (a[0] - a[i]) == 0)
            continue;
        ld x1 = (-(b[0] - b[i]) + sqrt(d)) / (2 * (a[0] - a[i]));
        ld x2 = (-(b[0] - b[i]) - sqrt(d)) / (2 * (a[0] - a[i]));
        l = max({l, min(x1, x2)});
        r = min({r, max(x1, x2)});
    }

    ld m = (l + r) / 2.0;
    cout << fixed << setprecision(10) << m << ' ' << per(m) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cin >> qqq;
    while (qqq--) {
        solve();
    }
    return 0;
}
