//package VKOSHP;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

public class I2 {
    private static String[] arr;
    private static char[] alf;
    private static int l, n;
    private static long p1, check1, p2, check2;
    private static int mod1, mod2;
    private static boolean res;
    private static long[] pow1, pow2;

    private static void dfs1(ArrayList<Integer> indexes, int depth) {
        if (depth==26) {
            if (indexes.size()>1) {
                res = false;
            }
            return;
        }
        HashMap<Long, ArrayList<Integer>> map1 = new HashMap<>();
        HashMap<Long, ArrayList<Integer>> map2 = new HashMap<>();
        char currElem = alf[depth];
        for (int ind:indexes) {
            long hash = 0;
            for (int i=0; i<l; i++) {
                if (arr[ind].charAt(i)==currElem) {
                    hash = hash + ((2 * pow1[i])%mod1);
                } else hash+=pow1[i];
                hash%=mod1;
            }
            //if (currElem=='l') System.out.println("1 "+bin);
            map1.putIfAbsent(hash, new ArrayList<>());
            ArrayList<Integer> list = map1.get(hash);
            list.add(ind);
            map1.replace(hash, list);
        }
        if (map1.containsKey(check1)) dfs1(indexes, depth+1);
        else {
            for (long key:map1.keySet()) {
                dfs1(map1.get(key), depth+1);
            }
        }
    }


    private static void dfs2(ArrayList<Integer> indexes, int depth) {
        if (depth==26) {
            if (indexes.size()>1) {
                res = false;
            }
            return;
        }
        HashMap<Long, ArrayList<Integer>> map2 = new HashMap<>();
        char currElem = alf[depth];
        for (int ind:indexes) {
            long hash = 0;
            for (int i=0; i<l; i++) {
                if (arr[ind].charAt(i)==currElem) {
                    hash = hash + ((2 * pow2[i])%mod2);
                } else hash+=pow2[i];
                hash%=mod2;
            }
            //if (currElem=='l') System.out.println("1 "+bin);
            map2.putIfAbsent(hash, new ArrayList<>());
            ArrayList<Integer> list = map2.get(hash);
            list.add(ind);
            map2.replace(hash, list);
        }
        if (map2.containsKey(check2)) dfs2(indexes, depth+1);
        else {
            for (long key:map2.keySet()) {
                dfs2(map2.get(key), depth+1);
            }
        }
    }


    public static void main(String[] args) {
        Reader myReader = new Reader();
        l = myReader.nextInt(); n = myReader.nextInt();
        arr = new String[n];
        for (int i=0; i<n; i++) {
            arr[i] = myReader.nextToken();
        }
        alf = new char[]{'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'};
        ArrayList<Integer> start = new ArrayList<>();
        for (int i=0; i<n; i++) start.add(i);
        res = true;
        pow1 = new long[l];
        pow2 = new long[l];
        pow2[0] = 1;
        pow1[0] = 1;
        mod1 = (int) (998244353);
        p1 = 41;
        mod2 = (int) (1e9 + 9);
        p2 = 37;
        for (int i=1; i<l; i++) {
            pow1[i] = (pow1[i-1] * p1) % mod1;
            pow2[i] = (pow2[i - 1] * p2) % mod2;
        }
        for (int i=0; i<l; i++) {
            check1+=pow1[i];
            check1%=mod1;
            check2 = (check2 + pow2[i]) % mod2;

        }
        dfs1(start, 0);
        dfs2(start, 0);
        if (res) System.out.println("YES");
        else System.out.println("NO");
    }

    static class Reader {
        BufferedReader reader;
        StringTokenizer st;

        Reader() {
            reader = new BufferedReader(new InputStreamReader(System.in));
        }

        String nextToken() {
            try {
                if (st==null || !st.hasMoreElements()) st = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                e.printStackTrace();
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }
    }
}