﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937 rnd(228228227);
struct p {
    ll a, b, c;
    p(ll a1 = 0, ll b1 = 0, ll c1 = 0) {
        a = a1;
        b = b1;
        c = c1;
    }
};
ld get(ld x, p& c) {
    return c.a * x * x + c.b * x + c.c;
}
int n;
vector<p> up, down;
ld solve(ld x) {
    ld umx = LLONG_MIN, dmn = LLONG_MAX;
    for (auto& c : up) {
        umx = max(umx, get(x, c));
    }
    for (auto& c : down) {
        dmn = min(dmn, get(x, c));
    }
    return dmn - umx;
}
signed main()
{   
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);
    cin >> n;
    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        if (a > 0) {
            up.push_back({ a, b, c });
        }
        else {
            down.push_back({ a, b, c });
        }
    }
    ld l = -1e9, r = 1e9;
    int q = 200;
    while (q--) {
        ld lm = (2 * l + r) / 3, rm = (l + 2 * r) / 3;
        if (solve(lm) >= solve(rm)) {
            r = rm;
        }
        else {
            l = lm;
        }
    }
    ld x = l;
    ld umx = LLONG_MIN;
    for (auto& c : up) {
        umx = max(umx, get(x, c));
    }
    ld E = 1e-8;
    
    cout << l << " " << umx + E;
}
