#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <queue>
#include <deque>
#include <ctime>
#include <chrono>
#include <random>
#include <bitset>
#include <stack>
#include <cstring>
#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0)
#define F first
#define S second
#define pq priority_queue
#define umap unordered_map
#define uset unordered_set
#define pb push_back
#define sqr(x) ((x)*(x))
#define fill(v,n) for(int qqq=0;qqq<n;qqq++)cin>>v[qqq]
#define seed (myclock::now() - beginning).count()
#define mod 998244353
#define eps 1e-7
#define BIL 1000000000ll
#define INF sqr(2 * BIL)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ull, ull> pull;
typedef long double ld;
typedef pair<ld, ld> pld;
typedef chrono::high_resolution_clock myclock;

auto beginning = myclock::now();

bool check(vector<vector<ull>> info) {
	if (info.size() == 1) {
		return true;
	}
	for (int x = 0; x < 26; ++x) {
		bool ok = 1;
		for (int i = 0; i < info.size(); ++i) {
			if (info[i][x] == 0) {
				ok = 0;
				break;
			}
		}
		if (!ok) {
			continue;
		}
		umap<ull, vector<vector<ull>>> new_info;
		for (int i = 0; i < info.size(); ++i) {
			new_info[info[i][x]].push_back(info[i]);
		}
		if (new_info.size() == 1) {
			continue;
		}
		bool ans = 1;
		for (auto& e : new_info) {
			if (e.second.size()) {
				ans &= check(e.second);
			}
		}
		return ans;
	}
	return false;
}

int main() {
	auto gen = mt19937_64(seed);
	fast;
	int n, l;
	cin >> l >> n;
	vector<ull> randvec(l);
	for (int i = 0; i < l; ++i) {
		randvec[i] = gen();
	}
	vector<vector<ull>> info(n, vector<ull>(26));
	vector<string> arr(n);
	for (int i = 0; i < n; ++i) {
		string str;
		cin >> str;
		arr[i] = str;
		for (int j = 0; j < l; ++j) {
			info[i][str[j] - 'a'] += randvec[j];
		}
	}
	if (check(info)) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}
}