#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "-->"; cerr.flush()

using namespace std;

typedef	int ii;
typedef long long ll;
typedef long double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)10e5 + 5;
const ll mod = (ll)1e9 + 7;
const ll maxlog = 20;

void operator delete(void* q);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll n;

ll a[cst];
ll b[cst];

bool check(ll k) {
    set<pair<ll, ll>> st;
    for (ll i = 1; i <= n; i++) st.insert({ i, b[i] });
    for (ll i = 1; i <= n; i++) {
        ll q = a[i];
        while (q) {
            auto x = st.lower_bound({ i - k, -1 });
            if (x == st.end()) return false;
            auto p = *x;
            st.erase(x);
            if (p.first > i + k) return false;
            ll rem = min(p.second, q);
            q -= rem;
            p.second -= rem;
            if (p.second) st.insert(p);
        }
    }
    return true;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n;
    ll sm = 0;
    for (ll i = 1; i <= n; i++) {
        cin >> a[i];
        sm += a[i];
    }
    for (ll i = 1; i <= n; i++) {
        cin >> b[i];
        sm -= b[i];
    }
    if (sm > 0) {
        cout << -1;
        ex();
    }
    //check(2);
    ll l = -1, r = n;
    while (r - l > 1) {
        ll m((l + r) >> 1);
        if (check(m)) r = m;
        else l = m;
    }
    cout << r;
    ex();
}