#include <bits/stdc++.h>
#include <bits/extc++.h>

//#define int long long

using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define sz(x) int(size(x))
#define rep(i, a, b) for (int (i) = (a); (i) < (b); ++(i))
#define pb push_back

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long ll;
typedef long double db;

template<class T>
using Tree = tree<T, null_type, less<T>, rb_tree_tag,
        tree_order_statistics_node_update>;

void fastio() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}

db gss(db a, db b, function<db(db)>& f) {
    db r = (sqrt(5) - 1) / 2, eps = 1e-10;

    db x1 = b - r * (b - a), x2 = a + r * (b - a);
    db f1 = f(x1), f2 = f(x2);
    while (b - a > eps) {
        if (f1 < f2) {
            b = x2, x2 = x1, f2 = f1;
            x1 = b - r * (b - a), f1 = f(x1);
        } else {
            a = x1, x1 = x2, f1 = f2;
            x2 = a + r * (b - a), f2 = f(x2);
        }
    }
    return a;
}

signed main() {
    fastio();

    int n;
    cin >> n;
    vi a(n);

    rep(i, 0, n) cin >> a[i];
    reverse(all(a));

    vi pm(n), px(n);
    pm[0] = px[0] = a[0];
    rep(i, 1, n) {
        pm[i] = min(pm[i - 1], a[i]), px[i] = max(px[i - 1], a[i]);
    }

    vi sm(n), sx(n);
    sm[n - 1] = sx[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        sm[i] = min(sm[i + 1], a[i]), sx[i] = max(sx[i + 1], a[i]);
    }

    auto gx = [&](int i) {
        if (i == n - 1) return 0;
        return sx[i + 1];
    };

    auto gm = [&](int i) {
        if (i == n - 1) return 0;
        return sm[i + 1];
    };

    vector<db> answ;
    for (int i = 0; i < n; ++i) {
        function<db(db)> f = [&](db t) {
            db mn = min(1.0L * gm(i), pm[i] * (1 - t));
            db mx = max(1.0L * gx(i), px[i] * (1 - t));
            return mx - mn;
        };

        db eps = 1e-10l;
        db l = gss(0, 1, f), r = 1 + eps;
        db v0 = f(l);
        while (r - l > eps) {
            db m = (r + l) / 2.0l;
            if (abs(f(m) - v0) < eps) {
                l = m;
            } else {
                r = m;
            }
        }

        answ.pb(l);
    }

    reverse(all(answ));
    for (auto en: answ) {
        cout << fixed << setprecision(15) << en << ' ';
    }
}