#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,avx2,tune=native")

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define int long long

using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define sz(x) int(size(x))
#define rep(i, a, b) for (ll (i) = (a); (i) < (b); ++(i))
#define pb push_back

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long ll;
typedef long double db;

template<class T>
using Tree = tree<T, null_type, less<T>, rb_tree_tag,
        tree_order_statistics_node_update>;

void fastio() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}

constexpr db eps = 1e-12;

signed main() {
    fastio();

    array<ll, 4> t0{}, tp = {0, 1, 2, 3};
    cin >> t0[0] >> t0[1] >> t0[2] >> t0[3];

    auto recover = [&](array<ll,4>& t, db ans) -> vector<db> {
        for (db a = 1; a <= t[0]; a += 0.1l) {
            for (db b = 1; b <= t[1]; b += 0.1l) {
                db c, d;
                if (b == 1)
                    c = t[2];
                else
                    c = ((ans - b) * (a - 1) - a * (a - b)) / (a * b - 1);

                if (a == 1)
                    d = t[3];
                else
                    d = (b * c + a - b - c) / (a - 1);

                if (c >= 1 && d >= 1 && c <= t[2]
                    && abs(a * d + b + c - (b * c + a + d)) < eps
                    && d <= t[3] && a * d + b + c >= ans) {
                    return {db(a), db(b), c, d};
                }
            }
        }
        return {};
    };

    db ans = 3;
    array<ll, 4> ansp = {0, 1, 2, 3};
    do {
        array<ll, 4> t{};
        rep(i, 0, 4) t[i] = t0[tp[i]];
        db l = 3, r = 1e9;
        while (r - l > eps) {
            db m = (r + l) / 2;
            if (!recover(t, m).empty()) l = m;
            else r = m;
        }

        if (ans < l) {
            ans = l;
            ansp = tp;
        }
    } while (next_permutation(all(tp)));

    array<ll, 4> t{};
    rep(i, 0, 4) t[i] = t0[ansp[i]];

    cerr << ans << '\n';
    for (auto en: ansp) cout << en + 1 << ' ';
    cout << '\n';
    for (auto en: recover(t, ans)) cout << fixed << setprecision(15) << en << ' ';
}