#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,avx,fma,bmi2")
using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
#define int long long
#define real long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define elif else if
#define pi M_PI
#define f first
#define s second
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;


const int INF = 1e18, MOD = 1e9 + 7, RANDOM = chrono::steady_clock::now().time_since_epoch().count();
const real EPS = 1e-12;
mt19937 rng(RANDOM);


int len, n;
vector<string> strings;
vector<pair<string, int>> pairs;
const int al = 26;


bool search(int l, int r){
	if (r - l <= 1) return true;
	int cnt[al] = {0};
	for (int i=l; i<r; ++i){
		int id = pairs[i].s;
		bool used[al] = {false};
		for (int j=0; j<len; ++j){
			if (pairs[i].f[j] != '#') continue;
			used[strings[id][j] - 'a'] = true;
		}
		for (int j=0; j<al; ++j) cnt[j] += used[j];
	}
	bool used[al] = {false};
	for (int i=0; i<al; ++i) if (cnt[i] == r - l) used[i] = true;
	if (!count(used, used + al, true)) return false;
	for (int i=l; i<r; ++i){
		int id = pairs[i].s;
		for (int j=0; j<len; ++j){
			if (pairs[i].f[j] != '#') continue;
			if (used[strings[id][j] - 'a']) pairs[i].f[j] = strings[id][j];
		}
	}
	sort(pairs.begin() + l, pairs.begin() + r);
	int id = l;
	while (id < r){
		int it = lower_bound(pairs.begin() + l, pairs.begin() + r, make_pair(pairs[id].f, INF)) - pairs.begin();
		bool res = search(id, it);
		if (!res) return false;
		id = it;
	}
	return true;
}


void debug(){
	cerr << "\n";

	cerr << "\n";
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> len >> n;
	strings.assign(n, string());
	pairs.assign(n, pair<string, int>());
	string s(len, '#');
	for (int i=0; i<n; ++i) cin >> strings[i];
	for (int i=0; i<n; ++i){
		pairs[i] = {s, i};
	}
	cout << (search(0, n) ? "YES" : "NO");
}