#include <iostream>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <chrono>
#include <cassert>
#include <cmath>
#include <queue>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define int long long
using ll = long long;
using ld = long double;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    ll sma = 0, smb = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sma += a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        smb += b[i];
    }
    if (sma > smb) {
        cout << "-1\n";
        return;
    }
    int lo = 0, hi = n;
    while(hi - lo > 1) {
        int mid = (lo + hi) / 2;
        queue<pair<int, int>> q;
        for (int i = 0; i < mid - 1; ++i) {
            q.push({i, b[i]});
        }
        bool flag = true;
        for (int i = 0; i < n; ++i) {
            if (i + mid - 1 < n) {
                q.push({i + mid - 1, b[i + mid - 1]});
            }
            int x = a[i];
            while(!q.empty() && x > 0) {
                if (x >= q.front().second) {
                    x -= q.front().second;
                    q.pop();
                } else {
                    q.front().second -= x;
                    x = 0;
                }
            }
            if (x != 0) {
                flag = false;
                break;
            }
            if (!q.empty() && q.front().first == i - mid + 1) {
                q.pop();
            }
        }
        if(flag) {
            hi = mid;
        } else {
            lo = mid;
        }
    }
    cout << hi - 1 << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
//    int t; cin >> t; while(t--) solve();
}
