//
// Created by olymp on 12.12.2021.
//
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <iomanip>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define ar array
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;

using namespace std;
const ll INF = 2e18;

void solve() {
    int n; cin >> n;
    vector<int> a(n), b(n), c(n);
    rep(i, n) cin >> a[i] >> b[i] >> c[i];
    {
        long double mx = -INF;
        long double mn = INF;
        rep(i, n) {
            long double value = (long double)c[i];
            if (a[i] > 0) {
                mx = max(mx, value);
            } else {
                mn = min(mn, value);
            }
        }
        long double X = 0;
        if (mx < mn) {
            cout << X << ' ';
            cout << (mx + mn) / 2 << '\n';
            return;
        }
    }
    auto get = [&] (long double x) {
        long double mx = -INF;
        long double mn = INF;
        rep(i, n) {
            long double value = x * x * (long double)a[i] + x * (long double)b[i] + (long double)c[i];
            if (a[i] > 0) {
                mx = max(mx, value);
            } else {
                mn = min(mn, value);
            }
        }
        return pair<long double, long double>{mn - mx, (mn + mx) / 2};
    };
    long double EPS = 1e-7;
    auto get2 = [&] (long double x) {
        return get(x + EPS).first - get(x).first > 0;
    };
    long double L = -1e9;
    long double R = 1e9;
    rep(_, 200) {
        long double mid = (L + R) / 2;
        if (get2(mid)) {
            L = mid;
        } else {
            R = mid;
        }
    }
    if (get(R).first > 0) {
        cout << R << ' ';
        cout << get(R).second << '\n';
    } else {
        assert(0);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << setprecision(15) << fixed;
    int t = 1;
    rep(_, t) {
        solve();
    }
    return 0;
}