#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

// #pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

inline void prepare() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

inline void solve() {
    int n;
    cin >> n;

    set<int> lefts, rights;
    stack<int> left, right;

    vector<int> ans;

    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;

        lefts.insert(a);
        left.push(a);
        ans.push_back(2);
    }

    for (int i = 1; i <= n; i++) {
        if (lefts.find(i) != lefts.end()) {
            while (left.top() != i) {
                ans.push_back(21);
                right.push(left.top());
                lefts.erase(left.top());
                rights.insert(left.top());
                left.pop();
            }
            ans.push_back(-2);
            left.pop();
            lefts.erase(i);
        } else {
            while (right.top() != i) {
                ans.push_back(12);
                left.push(right.top());
                rights.erase(right.top());
                lefts.insert(right.top());
                right.pop();
            }
            ans.push_back(-1);
            right.pop();
            rights.erase(i);
        }
    }

    cout << ans.size() << '\n';

    for (int i: ans) {
        cout << i << ' ';
    }
}

int main() {
    prepare();
    solve();
}
