#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

const ld eps = 1e-10;

signed main() {
  ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
  int n;
  cin >> n;
  vector<ll> a(n);
  for (ll &x : a)
    cin >> x;
  vector<ll> suf_min(n), suf_max(n), pref_min(n), pref_max(n);
  pref_min[0] = pref_max[0] = a[0];
  for (int i = 1; i < n; ++i) {
    pref_min[i] = min(a[i], pref_min[i - 1]);
    pref_max[i] = max(a[i], pref_max[i - 1]);
  }
  suf_min[n - 1] = suf_max[n - 1] = a[n - 1];
  for (int i = n - 2; i >= 0; --i) {
    suf_min[i] = min(suf_min[i + 1], a[i]);
    suf_max[i] = max(suf_max[i + 1], a[i]);
  }
  vector<ld> ans(n, 1);
  for (int k = 1; k < n; ++k) {
    ld delta = 1e18 + 23;
    ans[k] = 0;
    ll mxl = pref_max[k - 1];
    ll mnl = pref_min[k - 1];
    ll mxr = suf_max[k];
    ll mnr = suf_min[k];
    ///cout << k << ": " << mnl << ' ' << mxl << ' ' << mnr << ' ' << mxr << endl;
    ld l, r;
    l = max((ld)0, 1 - (ld)mxl / (ld)mxr);
    r = min((ld)1, 1 - (ld)mnl / (ld)mnr);
    if ((l < r || abs(l - r) < eps) && (mxl - mnl < delta + eps)) {
      if (abs(mxl - mnl - delta) < eps)
        ans[k] = max(ans[k], r);
      else
        ans[k] = r;
      delta = mxl - mnl;
    }
    l = max((ld)0, 1 - (ld)mnl / (ld)mnr);
    r = min((ld)1, 1 - (ld)mxl / (ld)mxr);
    if ((l < r || abs(l - r) < eps) && ((mxr - mnr) * (1 - r) < delta + eps)) {
      if (abs((mxr - mnr) * (1 - r) - delta) < eps)
        ans[k] = max(ans[k], r);
      else
        ans[k] = r;
      ///delta = mxl - mnl;
      delta = (mxr - mnr) * (1 - r);
    }
    l = (ld)0;
    r = min((ld)1, min(1 - (ld)mxl / (ld)mxr, 1 - (ld)mnl / (ld)mnr));
    if ((l < r || abs(l - r) < eps) && ((1 - r) * mxr  - mnl) < delta + eps) {
      if (abs((1 - r) * mxr  - mnl - delta) < eps)
        ans[k] = max(ans[k], r);
      else
        ans[k] = r;
      delta = (1 - r) * mxr  - mnl;
    }
    l = max((ld)0, max(1 - (ld)mnl / (ld)mnr, 1 - (ld)mxl / (ld)mxr));
    r = (ld)1;
    ///cout << k << ": " << delta << " " << l << " " << r << endl;
    if ((l < r || abs(l - r) < eps) && (mxl - (1 - l) * mnr) < delta + eps) {
      if (abs(mxl - (1 - l) * mnr - delta) < eps)
        ans[k] = max(ans[k], l);
      else
        ans[k] = l;
      delta = mxl - (1 - l) * mnr;
    }
  }
  for (int i = 0; i < n; ++i) {
    cout << fixed << setprecision(12) << ans[i] << ' ';
  }
  return 0;
}
