/*#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")*/
//#define _GLIBCXX_DEBUG
#include <iostream>
//#include <fstream>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <time.h>
#include <random>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <iomanip>
#include <deque>
#include <queue>
using namespace std;
#define int long long
#define ll long long
#define mp make_pair
#define double long double
#define ff first
#define ss second
#define sz(a) a.size()
void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

bool check(int m, vector<int> a, vector<int> b){
    deque<pair<int, int>> now;
    int j = 0;
    for (int i = 0; i < a.size(); ++i){
        while (j < b.size() && j - i <= m){
            now.push_back({b[j], j});
            ++j;
        }
        while(now.size() && abs(now.front().second - i) > m){
            now.pop_front();
        }
        while (a[i] > 0 && now.size() > 0){
            if (a[i] >= now.front().first){
                a[i] -= now.front().first;
                now.pop_front();
            }else{
                now.front().first -= a[i];
                a[i] = 0;
            }
        }
        if (a[i] != 0){
            return false;
        }
    }
    return true;
}

signed main() {
    fast_stream();
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i){
        cin >> a[i];
    }
    vector<int> b(n);
    for (int i = 0; i < n; ++i){
        cin >> b[i];
    }
    int l = -1;
    int r = n + 1;
    while (r - l > 1){
        int m = (l + r) / 2;
        if (check(m, a, b)){
            r = m;
        }else{
            l = m;
        }
    }
    if (r < n){
        cout << r;
    }else{
        cout << -1;
    }
    return 0;
}
