/*#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")*/
//#define _GLIBCXX_DEBUG
#include <iostream>
//#include <fstream>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <time.h>
#include <random>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <iomanip>
#include <deque>
#include <queue>

using namespace std;
#define ll long long
#define mp make_pair
#define double long double
#define ff first
#define ss second
#define sz(a) a.size()

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

signed main() {
    fast_stream();
    ll n;
    cin >> n;
    vector<double> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    vector<double> prev_min(n), prev_max(n);
    prev_min[0] = s[0];
    prev_max[0] = s[0];
    for (int i = 1; i < n; i++) {
        prev_min[i] = min(prev_min[i - 1], s[i]);
        prev_max[i] = max(prev_max[i - 1], s[i]);
    }
    vector<double> ans(n + 1);
    ans[n] = 1;
    double min2 = 1e9 + 1, max2 = -1;
    for (int i = n - 1; i > 0; i--) {
        min2 = min(min2, s[i]);
        max2 = max(max2, s[i]);
        double min1 = prev_min[i - 1], max1 = prev_max[i - 1];
        if (max1 >= max2) {
            double t;
            if (min1 <= min2) {
                t = (min2 - min1) / min2;
            } else {
                t = 0;
            }
            ans[n - i] = t;
        } else {
            double t1 = 0, t2 = 0;
            t1 = max(t1, (min2 - min1) / min2);
            t2 = max(t2, (max2 - max1) / max2);
            double div1 = max(max1, max2 * (1 - t1)) - min(min1, min2 * (1 - t1));
            double div2 = max(max1, max2 * (1 - t2)) - min(min1, min2 * (1 - t2));;
            if (div1 > div2) {
                ans[n - i] = t2;
            } else if (div1 < div2) {
                ans[n - i] = t1;
            } else {
                ans[n - i] = max(t1, t2);
            }
        }
    }
    cout.precision(20);
    for (int i = n; i >= 1; i--) {
        cout << fixed << ans[i] << " ";
    }
}
