#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) (a).begin(), (a).end()
#define len(a) int((a).size())

const int MOD = 1e9 + 7;

const int p = 517;
const int MAXN = 1e6 + 228;

int mul(int a, int b) { return int((ll) a * b % MOD); }
int add(int a, int b) { return (a + b) % MOD; }

int ppow[MAXN];

void solve(vector<array<int, 26>> &arr) {
	if (arr.size() == 1) {
		return;
	}
	for (int i = 0; i < 26; i++) {
		bool isall = 1;
		for (int j = 0; j < (int) arr.size(); j++) {
			if (arr[j][i] == 0) {
				isall = false;
				break;
			}
		}
		if (isall) {
			unordered_map<int, vector<array<int, 26>>> arr2;
			for (int j = 0; j < (int) arr.size(); j++) {
				auto k = arr[j][i];
				arr[j][i] = 0;
				arr2[k].push_back(arr[j]);
			}
			for (auto &el : arr2) {
				solve(el.second);
			}
			return;
		}
	}
	cout << "NO" << endl;
	exit(0);
}

signed main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);
	ppow[0] = 1;
	for (int i = 1; i < MAXN; i++) {
		ppow[i] = mul(ppow[i - 1], p);
	}
	int L, n;
	cin >> L >> n;
	vector<array<int, 26>> arr(n);
	for (int j = 0; j < n; j++) {
		string s;
		cin >> s;
		for (int i = 0; i < L; i++) {
			arr[j][s[i] - 'a'] += ppow[i];
		}
	}
	solve(arr);
	cout << "YES" << endl;
}
