#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vi vector<int>
#define pii pair<int, int>
#define pb push_back
#define vpii vector<pair<int, int> >

const long double eps = 1e-10;
const int INF = (1ll << 31ll) - 1ll;
const long long INFL = (1ll << 63ll) - 1ll;

void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(20);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
}

ld kek[100000][3];
int n;

ld get(int i, ld x){
    return kek[i][0] * x * x + kek[i][1] * x + kek[i][2];
}

ld d, x1, x2;
ld get1, get2;

pair<ld, ld> solve(int i, ld y){
    kek[i][2] -= y;
    d = kek[i][1] * kek[i][1] - 4 * kek[i][0] * kek[i][2];
    if(d < 0){
        kek[i][2] += y;
        return make_pair(-1e10, 1e10);
    }
    d = sqrtl(d);
    x1 = (-kek[i][1] + d) / (2 * kek[i][0]);
    x2 = (-kek[i][1] - d) / (2 * kek[i][0]);
    kek[i][2] += y;
    return make_pair(x1, x2);
}

inline bool intersect(int i, ld x1, ld y1, ld x2, ld y2){
    get1 = get(i, x1);
    get2 = get(i, x2);
    if(y1 - eps < get1 && get1 < y2 + eps){
        return true;
    }
    if(y1 - eps < get2 && get2 < y2 + eps){
        return true;
    }
    pair<ld, ld> solve1 = solve(i, y1);
    pair<ld, ld> solve2 = solve(i, y2);
    if(solve1.second < 1e10) {
        if (x1 - eps < solve1.first && solve1.first < x2 + eps) {
            return true;
        }
        if (x1 - eps < solve1.second && solve1.second < x2 + eps) {
            return true;
        }
    }
    if(solve2.second < 1e10) {
        if (x1 - eps < solve2.first && solve2.first < x2 + eps) {
            return true;
        }
        if (x1 - eps < solve2.second && solve2.second < x2 + eps) {
            return true;
        }
    }
    return false;
}

inline bool intersect(ld x1, ld y1, ld x2, ld y2){
    for(int i=0; i<n; i++){
        if(kek[i][0] >= 0 && get(i, x1) < y1+eps)
            continue;
        if(kek[i][0] <= 0 && get(i, x1) > y1-eps)
            continue;
        if(!intersect(i, x1, y1, x2, y2)){
            return false;
        }
    }
    return true;
}

void solve(ld x1, ld y1, ld x2, ld y2){
    if(!intersect(x1, y1, x2, y2)){
        return;
    }
    ld midx = (x1 + x2) / 2;
    ld midy = (y1 + y2) / 2;
    if(x2 - x1 < eps){
        cout << midx << " " << midy << endl;
        exit(0);
    }
    solve(x1, y1,  midx, midy);
    solve(midx, midy, x2, y2);
    solve(midx, y1, x2, midy);
    solve(x1, midy, midx, y2);
}

signed main() {
    fastio();

    cin >> n;
    for(int i=0; i<n; i++){
        cin >> kek[i][0] >> kek[i][1] >> kek[i][2];
    }

    solve(-1e18, -1e18, 1e18, 1e18);

    assert(false);

    return 0;
}
/*
1
1 0 0
===
4
1 2 3
1 -3 -5
-1 3 4
-2 4 6
 */