#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vi vector<int>
#define pii pair<int, int>
#define pb push_back
#define vpii vector<pair<int, int> >

const long double eps = 1e-10;
const int INF = (1ll << 31ll) - 1ll;
const long long INFL = (1ll << 63ll) - 1ll;

void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(15);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
}

int l;

void solve(vector<string> lol, vector<bool> used){
    if(lol.size() == 1)
        return;
    int n = lol.size();
    vi cnt(26);
    for(string s:lol){
        vector<bool> can(26);
        for(char c:s){
            if(!used[c - 'a'])
                can[c - 'a'] = 1;
        }
        for(int i=0; i<26; i++)
            cnt[i] += can[i];
    }
    char c = 'A';
    for(int i=0; i<26; i++){
        if(!used[i] && cnt[i] == n){
            c = 'a' + i;
        }
    }
    if(c == 'A'){
        if(n > 1){
            cout << "NO" << endl;
            exit(0);
        }
    }
    map<string, vi> kek;
    for(int i=0; i<n; i++){
        string cur(l, 'A');
        for(int j=0; j<l; j++){
            if(lol[i][j] == c){
                cur[j] = c;
            }
        }
        kek[cur].pb(i);
    }
    for(auto i:kek){
        used[c - 'a'] = true;
        vector<string> ab;
        for(int j:i.second)
            ab.pb(lol[j]);
        solve(ab, used);
    }
}

signed main() {
    fastio();

    int n;
    cin >> l >> n;
    vector<string> kek(n);
    for(string &s:kek)
        cin >> s;
    vector<bool> used(26);
    solve(kek, used);
    cout << "YES" << endl;

    return 0;
}
/*

 */