#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define int long long
using namespace std;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &elem: a) {
        cin >> elem;
        elem--;
    }
    reverse(a.begin(), a.end());

    vector<int> s1;
    vector<int> s2;
    set<int> in1;
    set<int> in2;

    vector<int> ans;
    for (int x = 0; x < n; ++x) {
        if (in1.find(x) != in1.end()) {
            while (s1.back() != x) {
                s2.push_back(s1.back());
                in2.insert(s1.back());
                in1.erase(s1.back());
                s1.pop_back();
                ans.push_back(12);
            }
            s1.pop_back();
            ans.push_back(-1);
        } else if (in2.find(x) != in2.end()) {
            while (s2.back() != x) {
                s1.push_back(s2.back());
                in1.insert(s2.back());
                in2.erase(s2.back());
                s2.pop_back();
                ans.push_back(21);
            }
            s2.pop_back();
            ans.push_back(-2);
        } else {
            while (a.back() != x) {
                s1.push_back(a.back());
                in1.insert(a.back());
                a.pop_back();
                ans.push_back(1);
            }
            ans.push_back(1);
            a.pop_back();
            ans.push_back(-1);
        }
    }

    for (auto com: ans) {
        cout << com << '\n';
    }


    return 0;
}
