#include <bits/stdc++.h>

using namespace std;
#define int long long
#define endl '\n'

bool check(int m, vector<int> A, vector<int> B) {
    int leftfree = 0;
    int n = A.size();
    for (int i = 0; i < n; i++) {
        while (A[i] > 0) {
            if (i + m < leftfree) {
                return false;
            }
            if (A[i] > B[leftfree]) {
                A[i] -= B[leftfree];
                B[leftfree] = 0;
                leftfree++;
            } else {
                B[leftfree] -= A[i];
                A[i] = 0;
            }
        }
        if (i - leftfree == m) {
            leftfree++;
        }
    }
    return true;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> A(n);
    vector<int> B(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> B[i];
    }
    int L = -1, R = n - 1;
    while(R - L > 1) {
        int m = (R + L) / 2;
        if (check(m, A, B)) {
            R = m;
        } else {
            L = m;
        }
    }
    if (!check(R, A, B)) {
        cout << -1 << endl;
    }
    else cout << R << endl;
}
