#include <iostream>
#include "vector"
#include "algorithm"

using namespace std;
#define all(x) (x).begin(), (x).end()
typedef long long ll;
const int INF = 1e9 + 7;


signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n), prefmax(n + 1), prefmin(n + 1, 1e9);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        prefmin[i + 1] = min(a[i], prefmin[i]);
        prefmax[i + 1] = max(a[i], prefmax[i]);
    }
    vector<int> sufmax(n + 1), sufmin(n + 1, 1e9);
    for (int i = n - 1; i >= 0; --i) {
        sufmax[i] = max(a[i], sufmax[i + 1]);
        sufmin[i] = min(sufmin[i + 1], a[i]);
    }
    cout.precision(20);
    for (int i = 0; i < n; ++i) {
        if (prefmax[i] > sufmax[i])
            if (sufmin[i] < prefmin[i])
                cout << "0 ";
            else
                cout << (((long double)sufmin[i] - prefmin[i]) / sufmin[i]) << ' ';
        else
            cout << (((long double)sufmax[i] - prefmax[i]) / sufmax[i]) << ' ';
    }
}
