#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace __gnu_pbds;
template<typename T>
using ordset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif

#define all(q) q.begin(), q.end()
#define Please return
#define AC 0
#define nl '\n'

using namespace std;
using ll = long long;
using ld = long double;
using cmpl = complex<long double>;

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& x) {
	return in >> x.first >> x.second;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, const pair<T1, T2>& x) {
	return out << x.first << ' ' << x.second;
}

template<typename T>
istream& operator>>(istream& in, vector <T>& x) {
	for (auto& p : x)
		in >> p;
	return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector <T>& x) {
	for (auto& p : x)
		out << p << ' ';
	return out;
}

constexpr int MAXN = (int)1e6;
int n;
ll a[MAXN], b[MAXN];
ll pa[MAXN + 1], pb[MAXN + 1];

bool check(int k) {
	ll mx = 0;
	for (int i = 0; i < n; ++i) {
		mx = max(mx, pb[max(0, i - k)] - pa[i]);
		if (mx > pb[min(i + 1 + k, n)] - pa[i + 1]) {
			return false;
		}
	}
	return true;
}

int main(int argc, char* argv[]) {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	if (argc > 1) {
		freopen(argv[1], "r", stdin);
	}
	if (argc > 2) {
		freopen(argv[2], "w", stdout);
	}

	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		pa[i + 1] = pa[i] + a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		pb[i + 1] = pb[i] + b[i];
	}

	if (pb[n] < pa[n]) {
		cout << "-1\n";
		return 0;
	}

	int l = -1, r = n;
	while (r - l > 1) {
		int m = (l + r) >> 1;
		if (check(m)) {
			r = m;
		}
		else {
			l = m;
		}
	}

	cout << r << '\n';

	Please AC;
}