#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace __gnu_pbds;
template<typename T>
using ordset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif

#define all(q) q.begin(), q.end()
#define Please return
#define AC 0
#define nl '\n'

using namespace std;
using ll = long long;
using ld = long double;
using cmpl = complex<long double>;

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& x) {
	return in >> x.first >> x.second;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, const pair<T1, T2>& x) {
	return out << x.first << ' ' << x.second;
}

template<typename T>
istream& operator>>(istream& in, vector <T>& x) {
	for (auto& p : x)
		in >> p;
	return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector <T>& x) {
	for (auto& p : x)
		out << p << ' ';
	return out;
}

const int p = 179;
const int mod = (int)1e9 + 7;

int hashByLetter(const string& s, char c)
{
	ll res = 0;
	for (int i = 0; i < s.size(); ++i)
	{
		if (s[i] == c)
			res += 1;
		res = (res * p) % mod;
	}
	return res;
}

const int MAXN = (int)1e6 + 1;

int h[26][MAXN];

bool check(set<int>& letters, vector<int>& words)
{
	if (words.size() <= 1)
		return true;
	if (letters.empty())
		return false;
	
	for (auto let : letters)
	{
		int cnt = 0;
		for (auto word : words)
			if (h[let][word])
				++cnt;
		if (cnt != words.size())
			continue;

		vector<int> newWords;
		map<int, vector<int>> wByH;
		for (auto word : words)
			wByH[h[let][word]].push_back(word);

		letters.erase(let);
		for (auto& [hs, vec] : wByH)
			if (!check(letters, vec))
				return false;
		return true;
	}
	return false;
}

int main(int argc, char* argv[]) {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	if (argc > 1) {
		freopen(argv[1], "r", stdin);
	}
	if (argc > 2) {
		freopen(argv[2], "w", stdout);
	}

	int l = 0, n = 0;
	cin >> l >> n;

	vector<string> words(n);
	cin >> words;

	for (int i = 0; i < n; ++i)
		for (int c = 0; c < 26; ++c)
			h[c][i] = hashByLetter(words[i], 'a' + c);

	set<int> letters;
	for (int i = 0; i < 26; ++i)
		letters.insert(i);

	vector<int> wordsI(n);
	iota(all(wordsI), 0);

	if (check(letters, wordsI))
		cout << "YES\n";
	else
		cout << "NO\n";

	Please AC;
}