﻿#define _CRT_SECURE_NO_WARNINGS

#include <bitset>
#include <iostream>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <utility>
#include <cassert>
#include <vector>

#ifdef ONLINE_JUDGE
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

//#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << " = " << x << '\n';

using namespace std;

const int INF = 998244353;

void solve() {
  vector<ld> t(4);
  vector<int> p = { 0, 1, 2, 3 };

  for (int i = 0; i < 4; i++)
    cin >> t[i];

  ld ans = 0;
  vector<int> ansP = { 0, 1, 2, 3 };
  vector<ld> ansK = t;

  do
  {
    vector<int> kekea = { 1, 0, 2, 3 };
    vector<ld> a(4);
    vector<ld> T(4);

    for (int i = 0; i < 4; i++)
      T[i] = t[p[i]];

    a[0] = T[0];
    a[1] = T[1];
    a[2] = T[2];

    if (a[0] == 1) a[3] = T[3];
    else a[3] = (a[2] - 1) * (a[1] - 1) / (a[0] - 1) + 1;

    if (a[3] > T[3]) continue;

    if (ans < a[0] * a[3] + a[1] + a[2])
    {
      ans = a[0] * a[3] + a[1] + a[2];
      ansK = a;
      ansP = p;
    }
  } while (next_permutation(p.begin(), p.end()));

  assert(ans > 0);

  for (auto u : ansP)
    cout << u + 1 << " ";
  cout << '\n';
  for (auto u : ansK)
    cout << u << " ";
  cout << '\n';
}

signed main() {
  cin.tie(nullptr)->ios::sync_with_stdio(false);
  cout << fixed << setprecision(10);
  int tests = 1;
  //cin >> tests
  for (int test = 1; test <= tests; ++test) {
    cerr << "_______Test # " << test << "_______:\n";
    solve();
    cerr << '\n';
  }
}