#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <queue>
#include <bitset>
#include <array>
#include <iomanip>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

#define int long long

pair<long double, long double> get(long double p, int mn1, int mx1, int mn2, int mx2) {
    long double t1 = (long double) (mx1 - mn1 - p) / (mx1 - mn1);
    long double t2 = (long double) (p - mx2 + mn1) / mn1;
    long double t3 = (long double) (mx1 - mn2 - p) / mx1;
    pair<long double, long double> res;
    res.first = max(t1, t3);
    res.first = max(res.first, (long double) 0);
    res.second = min((long double) 1, t2);
    return res;
}

bool check(pair<long double, long double> a) {
    return a.first <= a.second;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<pair<int, int>> a1(n + 1);
    a1[0] = {(int) 1e9 + 228, 0};
    vector<pair<int, int>> a2(n + 1);
    a2[n] = {(int) 1e9 + 228, 0};

    for (int i = 0; i < n; ++i) {
        a1[i + 1].first = min(a1[i].first, a[i]);
        a1[i + 1].second = max(a1[i].second, a[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        a2[i].first = min(a2[i + 1].first, a[i]);
        a2[i].second = max(a2[i + 1].second, a[i]);
    }

    cout << 1 << ' ';

    for (int i = 1; i < n; ++i) {
        int mx1 = a2[i].second, mn1 = a2[i].first;
        int mx2 = a1[i].second, mn2 = a1[i].first;
        long double l = mx2 - mn2, r = 1e9 + 228;
//        cerr << l << ':';
        for (int it = 0; it < 60; ++it) {
            long double mid = (l + r) / 2;
//            cerr << mid << '\n';
            if (check(get(mid, mn1, mx1, mn2, mx2)))
                r = mid;
            else
                l = mid;
        }
        auto z = get(0.67, mn1, mx1, mn2, mx2);
//        cerr << l << '\n';
////        cerr << z.first << ' ' << z.second << '\n';
//        cerr << setprecision(40) << get(l, mn1, mx1, mn2, mx2).first << '!';
        cout << setprecision(40) << get(l, mn1, mx1, mn2, mx2).second << ' ';
//        cerr << '\n';
    }
    cout << '\n';
}
