#include<iostream>
#include<vector>
#include<iomanip>

using namespace std;

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i){
        cin >> v[i];
    }
    vector<int> max_a(n + 1);
    vector<int> min_a(n + 1, 1e9);
    for (int i = 1; i <= n; ++i){
        max_a[i] = max(max_a[i - 1], v[i - 1]);
        min_a[i] = min(min_a[i - 1], v[i - 1]);
    }
    min_a[0] = 0;
    vector<int> max_b(n + 1);
    vector<int> min_b(n + 1, 1e9);
    for (int i = n - 1; i >= 0; --i){
        max_b[i] = max(max_b[i + 1], v[i]);
        min_b[i] = min(min_b[i + 1], v[i]);
    }
    for (int k = 0; k < n; ++k){
        //cout << min_a[k] << " " << min_b[k] << " " << max_a[k] << " " << max_b[k] << endl;
        double t1 = (max_b[k] - max_a[k]) * 1.0 / max_b[k];
        double t2 = (min_b[k] - min_a[k]) * 1.0 / min_b[k];
        if (t1 < 0){
            t1 = 0;
        }
        if (t2 < 0){
            t2 = 0;
        }
        cout << setprecision(20) << max(t1, t2) << endl;
    }
    return 0;
}
