#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main() {
    ios::sync_with_stdio(NULL);
    cin.tie(0);
    cout.tie(0);

    int n;
    int min1 = 0, max1 = 0, min2 = -1, max2 = -1;

    cin >> n;

    multiset<int> t1;
    multiset<int> t2;
    vector<int> t(n);

    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        t[i] = a;
        t2.insert(a);
        if (min2 == -1 or a < min2) {
            min2 = a;
        }
        if (max2 == -1 or a > max2) {
            max2 = a;
        }
    }

    for (int k = 0; k < n; k++) {
        if (k != 0) {
            t1.insert(t[k - 1]);
            t2.erase(t[k - 1]);

            min1 = *t1.begin();
            multiset<int>::iterator it1 = t1.end();
            it1--;
            max1 = *it1;

            min2 = *t2.begin();
            multiset<int>::iterator it2 = t2.end();
            it2--;
            max2 = *it2;
        }
        if (max1 >= max2 && min1 < min2) {
            cout << 1 - min1 / ((double) min2) << " ";
        }
        else if ((max1 < max2 && min1 >= min2) || (max1 < max2 && min1 < min2)) {
            cout << 1 - max1 / ((double) max2) << " ";
        }
        else {
            cout << 0 << " ";
        }
    }
    return 0;
}
