#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef double ld;

const int INF = INT_MAX;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
    #ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
    #endif

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<int> prefmax = {a[0]};
    vector<int> prefmin = {a[0]};
    vector<int> sufmax{a[n-1]};
    vector<int> sufmin{a[n-1]};
    for (int i = 1; i < n; ++i){
        prefmax.push_back(max(prefmax[i-1], a[i]));
        prefmin.push_back(min(prefmin[i-1], a[i]));
        sufmin.push_back(min(sufmin[i-1], a[n-1-i]));
        sufmax.push_back(max(sufmax[i-1], a[n-1-i]));
    }
    sufmin.pop_back();
    sufmax.pop_back();
    reverse(sufmax.begin(), sufmax.end());
    reverse(sufmin.begin(), sufmin.end());
    // cout << "start\n";
    // for (auto i : prefmax){
        // cout << i << " ";
    // }
    // cout << "\nend\n";
    cout << 1.00 << ' ';
    for (int i = 0; i < n- 1; ++i){
        if (prefmin[i] <= sufmin[i] && prefmax[i] >= sufmax[i]){
            cout << fixed  << 1 - (ld)prefmin[i] / (ld)sufmin[i];
        } else if (prefmin[i] >= sufmin[i] && prefmax[i] <= sufmax[i]){
            cout << fixed << 1 - (ld)prefmax[i] / (ld)sufmax[i];
        } else if (prefmax[i] >= sufmax[i] && prefmin[i] >= sufmin[i]){
            cout << 0;
        } else if (prefmin[i] >= sufmax[i]){
            cout << 0;
        } else if (sufmin[i] >= prefmax[i]){
            cout << fixed << 1 - min((ld)prefmax[i] / (ld)sufmax[i], (ld)prefmin[i] / (ld)sufmin[i]);
        }
        else{
            cout << fixed << 1 - min((ld)prefmax[i] / (ld)sufmax[i], (ld)prefmin[i] / (ld)sufmin[i]);
        }
        cout << ' ';
    }
}
