#include <iostream>
#include <vector>
#include <algorithm>
#define ar array
using namespace std;
typedef long long ll;

const int N = 1e6;
int n, a[N], b[N];

void solve() {
	cin >> n;
	long long summa = 0, summb = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		summa += a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		summb += b[i];
	}
	if (summa > summb) {
		cout << -1;
		return;
	}
	int L = -1, R = n - 1;
	while (R - L > 1) {
		int M = (L + R) / 2;
		vector<int> nw(n);
		int uk = 0;
		bool nd = false;
		for (int i = 0; i < n; ++i) {
			if (a[i] <= b[i]) {
				nw[i] = b[i] - a[i];
				continue;
			}
			nw[i] = 0;
			a[i] -= b[i];
			if (i - uk > M)
				uk++;
			while (a[i] > 0 && uk < min(n, i + M)) {
				if (nw[uk] >= a[i]) {
					nw[uk] -= a[i];
					a[i] = 0;
				}
				else {
					a[i] -= nw[uk];
					nw[uk++] = 0;
				}
			}
			if (uk == min(n, i + M)) {
				nd = true;
				break;
			}
		}
		if (nd)
			L = M;
		else
			R = M;
	}
	cout << R;
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	solve();
	cout << "\n";
}