#include <iostream>
#include <vector>
#include <algorithm>
#define ar array
using namespace std;
typedef long long ll;

const int N = 1e6;
int n;
vector<int> a, b;

void solve() {
	cin >> n;
	a.resize(n);
	b.resize(n);
	long long summa = 0, summb = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		summa += a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		summb += b[i];
	}
	if (summa > summb) {
		cout << -1;
		return;
	}
	int L = -1, R = n - 1;
	while (R - L > 1) {
		int M = (L + R) / 2;
		vector<int> nb(b), na(a);
		int uk = 0;
		bool nd = false;
		for (int i = 0; i < n; ++i) {
			if (i - uk > M)
				uk++;
			while (na[i] > 0 && uk <= min(n - 1, i + M)) {
				if (nb[uk] >= na[i]) {
					nb[uk] -= na[i];
					na[i] = 0;
				}
				else {
					na[i] -= nb[uk];
					nb[uk++] = 0;
				}
			}
			if (uk == min(n, i + M + 1)) {
				nd = true;
				break;
			}
		}
		if (nd)
			L = M;
		else
			R = M;
	}
	cout << R;
}
signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	solve();
	cout << "\n";
}