#include <iostream>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <stack>
#include <algorithm>
#include <vector>

using itn = int;
using ll = long long;

const int INF = 1e9;

using namespace std;

int n;

vector <long long> c;

bool check(int k) {
	vector <ll> c2 = c;
	int ind1 = 0, ind2 = 0;
	while (ind1 < n && c2[ind1] >= 0)
		++ind1;
	while (ind2 < n && (c2[ind2] <= 0 || abs(ind1 - ind2) > k))
		++ind2;
	while (ind1 < n && ind2 < n && abs(ind1 - ind2) <= k) {
		if (c2[ind1] + c2[ind2] < 0) {
			c2[ind1] += c2[ind2];
			c2[ind2] = 0;
		}
		else {
			c2[ind2] += c2[ind1];
			c2[ind1] = 0;
		}
		while (ind1 < n && c2[ind1] >= 0)
			++ind1;
		while (ind2 < n && (c2[ind2] <= 0 || abs(ind1 - ind2) > k))
			++ind2;
	}
	for (int i = 0; i < n; ++i)
		if (c2[i] < 0)
			return false;
	return true;;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n;
	c.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> c[i];
	ll b, sumall = 0;
	for (itn i = 0; i < n; ++i) {
		cin >> b;
		c[i] -= b;
		c[i] *= -1;
		sumall += c[i];
	}
	if (sumall < 0) {
		cout << -1;
		return 0;
	}
	int lft = -1, rgh = n, mid;
	while (rgh - lft > 1) {
		mid = (lft + rgh) / 2;
		if (check(mid))
			rgh = mid;
		else
			lft = mid;
	}
	cout << rgh;
}