#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <iomanip>
using namespace std;
typedef long double ld;

const ld EPS = 0.000000001;
const ld INF = 1000000000;

void f(vector<pair<ld, int>>& ans, const vector<pair<ld, int>>&t) {
	ans[0] = t[0];
	ans[1] = t[1];
	ans[2] = t[2];
	ans[3] = t[3];
}

bool Eq(ld a, ld b) {
	return fabs(a - b) <= EPS;
}

bool MinThat(ld a, ld b) {
	return b + EPS >= a;
}

bool MaxThat(ld a, ld b) {
	return a + EPS >= b;
}

int main() {
	vector<pair<ld, int>> t(4);
	for (auto& el : t) {
		cin >> el.first;
	}
	t[0].second = 1;
	t[1].second = 2;
	t[2].second = 3;
	t[3].second = 4;
	
	vector<pair<ld, int>> ans = t;
	ld k = 1000000000;
	ld sum = -1;
	for (int iter1 = 0; iter1 <= 50; iter1++) {
		ld sum23 = t[1].first + t[2].first + t[0].first * t[3].first;
		ld sum14 = t[0].first + t[3].first + t[1].first * t[2].first;
		if (Eq(sum14, sum23)) {
			if ((Eq(k, 0.0) && (Eq(sum23, sum) || MaxThat(sum23, sum)) || MaxThat(k, 0.0))) {
				f(ans, t);
				sum = sum23;
				k = 0.0;
			}
		}
		else {
			ld k1 = fabs(sum23 - sum14) / (t[3].first - 1);
			if (t[0].first - k1 < 1.0 || k1 <= 0.0) {
				k1 = INF;
			}
			ld k2 = fabs(sum23 - sum14) / (t[2].first - 1);
			if (t[1].first - k2 < 1.0 || k2 <= 0.0) {
				k2 = INF;
			}
			ld k3 = fabs(sum23 - sum14) / (t[1].first - 1);
			if (t[2].first - k3 < 1.0 || k3 <= 0.0) {
				k3 = INF;
			}
			ld k4 = fabs(sum23 - sum14) / (t[0].first - 1);
			if (t[3].first - k4 < 1.0 || k4 <= 0.0) {
				k4 = INF;
			}
			ld mink = min(min(k1, k2, MinThat), min(k3, k4, MinThat), MinThat);
			if (Eq(k1, mink)) {
				if ((Eq(k, mink) && (Eq(sum14-mink, sum) || MaxThat(sum14 - mink, sum))) || MaxThat(k, mink)) {
					f(ans, t);
					t[0].first -= mink;
					sum = sum14 - mink;
					k = mink;
				}
			}
			else if (Eq(k2, mink)) {
				if ((Eq(k, mink) && (Eq(sum23 - mink, sum) || MaxThat(sum23 - mink, sum))) || MaxThat(k, mink)) {
					f(ans, t);
					t[1].first -= mink;
					sum = sum23 - mink;
					k = mink;
				}
			}
			else if (Eq(k3, mink)) {
				if ((Eq(k, mink) && (Eq(sum23 - mink, sum) || MaxThat(sum23 - mink, sum))) || MaxThat(k, mink)) {
					f(ans, t);
					t[2].first -= mink;
					sum = sum23 - mink;
					k = mink;
				}
			}
			else if (Eq(k4, mink)) {
				if ((Eq(k, mink) && (Eq(sum14 - mink, sum) || MaxThat(sum14 - mink, sum))) || MaxThat(k, mink)) {
					ans = t;
					t[3].first -= mink;
					sum = sum14 - mink;
					k = mink;
				}
			}
		}
		next_permutation(t.begin(), t.end(), [](const pair<ld, int>& lhs, const pair<ld, int>& rhs) {
			return lhs.second < rhs.second;
			});
	}
	
	for (int i = 0; i < 4; i++) {
		cout << ans[i].second << ' ';
	}
	cout << '\n';
	cout << fixed << setprecision(14);
	for (int i = 0; i < 4; i++) {
		cout << ans[i].first << ' ';
	}
	cout << '\n';

	return 0;
}