#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>
#include <cmath>
#include <ctime>
#include <string>
#include <queue>
#include <iomanip>

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx2")
#pragma GCC optimization("unroll-loops")

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll n;

vector < int > to_bit(ll x)
{
	vector < int > ret(n);
	ll cur = n-1;
	while (x > 0)
	{
		ret[cur--] = x % 2;
		x /= 2;
	}
	return ret;
}

void solve() 
{
	cin >> n;
	ll cur = 0;
	vector < vector < int > > ans;
	ans.push_back(to_bit(cur));
	vector < bool > used(1 << n);
	used[cur] = 1;
	for (ll i = 1; i < (1 << n); i++)
	{
		ll b = 0;
		while (used[cur ^ (1 << b)])
		{
			b++;
		}
		cur ^= (1 << b);
		used[cur] = 1;
		ans.push_back(to_bit(cur));
	}
	//cout << ans.size() << "\n";
	for (auto elem : ans)
	{
		for (auto q : elem)
			cout << q;
		cout << "\n";
	}
}

int main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	int tt = 1;
	//cin>>tt;
	while (tt--)
		solve();
}