#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>
#include <cmath>
#include <ctime>
#include <string>
#include <queue>

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx2")
#pragma GCC optimization("unroll-loops")

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll n;
vector < ll > pb, a, b;

bool check(ll m)
{
	//cout << "m: " << m << "\n";
	ll l = 0, d = 0;
	for (ll i = 0; i < n; i++)
	{
		if (l <= i - m)
		{
			l = i - m;
			d = 0;
		}
		//cout << a[i] << ' ' << pb[min(i + m + 1, n)] - pb[l] + d << ' ' << l << ' ' << d << "\n";
		if (a[i] > pb[min(i + m + 1, n)] - pb[l] + d) return 0;
		ll a1 = a[i];
		a[i] -= d;
		d = 0;
		while (a[i] > 0)
		{
			a[i] -= b[l];
			l++;
		}
		if (a[i] < 0) d = abs(a[i]);
		a[i] = a1;
	}
	//cout << "ok\n";
	return 1;
}

void solve() {
	ll sa = 0, sb = 0;
	cin >> n;
	a.resize(n);
	b.resize(n);
	for (ll i = 0; i < n; i++)
	{
		cin >> a[i];
		sa += a[i];
	}
	for (ll i = 0; i < n; i++)
	{
		cin >> b[i];
		sb += b[i];
	}
	if (sa > sb)
	{
		cout << "-1\n";
		return;
	}
	pb.resize(n + 1);
	for (ll i = 0; i < n; i++)
		pb[i + 1] = pb[i] + b[i];
	ll l = 0, r = n + 1;
	while (r - l > 1)
	{
		ll m = (r + l) / 2;
		if (check(m))
			r = m;
		else l = m;
	}
	if (check(l))
		cout << l << "\n";
	else
		cout << r << "\n";
}

int main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	int tt = 1;
	//cin>>tt;
	while (tt--)
		solve();
}