#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<random>
#include <bitset>
#include<fstream>
#include<stack>
#include<cmath>
#include<iomanip>
#include <string>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll step)
{
	if (step == 0)
		return 1;
	if (step % 2 == 1)
		return a*bin_pow(a, step-1);
	ll now = bin_pow(a, step / 2);
	return now * now;
}

ld eps = 1e-9;

struct st {
	ld a, b, c;
};
vector <st> p;
void solveG() {
	vector<int>p = { 0, 1, 2, 3 }, ans_p(4);
	vector<ld>arr(4), ans;
	for (auto&i : arr)
		cin >> i;
	ld best_ans = -1;
	do {
		ld l = min((arr[p[0]] - 1)*(arr[p[1]] - 1), (arr[p[2]] - 1)*(arr[p[3]] - 1));
		for (int mask = 0; mask < 4; mask++) {
			ld a1, a2, a3, a4;
			if (mask & 1) { // a1
				a1 = arr[p[0]];
				if (a1 == 1)
					a4 = arr[p[1]];
				else
					a4 = l / (a1 - 1) + 1;
			}
			else { // a4
				a4 = arr[p[1]];
				if (a4 == 1)
					a1 = arr[p[0]];
				else
					a1 = l / (a4 - 1) + 1;
			}

			if (mask & 2) { // a2
				a2 = arr[p[2]];
				if (a2 == 1)
					a3 = arr[p[3]];
				else
					a3 = l / (a2 - 1) + 1;
			}
			else { // a3
				a3 = arr[p[3]];
				if (a3 == 1)
					a2 = arr[p[2]];
				else
					a2 = l / (a3 - 1) + 1;
			}
			if (a1 + a2 + a3 + a4 + l - best_ans >= eps) {
				ans_p[0] = p[0];
				ans_p[1] = p[2];
				ans_p[2] = p[3];
				ans_p[3] = p[1];
				best_ans = l + a1 + a2 + a3 + a4;
				ans = { a1, a2, a3, a4 };
			}
		}
	} while (next_permutation(p.begin(), p.end()));
	for (auto i : ans_p)
		cout << i + 1 << ' ';
	cout << '\n' << setprecision(10) << fixed;
	for (auto&i : ans)
		cout << i << ' ';
}

ll f1(ld x, ld y) {
	ll ans = 0;
	for (int i = 0; i < p.size(); i++) {
		ld now = p[i].a * x * x + p[i].b * x + p[i].c;
		if (now > y && p[i].a > 0) ans++;
		else if (now < y && p[i].a < 0) ans++;
	}
	return ans;
}

ll f(ld x, bool type) {
	ld ly = -2e9, ry = 2e9;
	for (int i = 0; i < 1000; i++) {
		ld m1 = ly + (ry - ly) / 3, m2 = ry - (ry - ly) / 3;
		if (f1(x, m1) < f1(x, m2)) ly = m1;
		else ry = m2;
	}
	if (!type) return f1(x, ly);
	return ly;
}

void solveH() {
	int n; cin >> n;
	p.resize(n);
	for (int i = 0; i < n; i++) cin >> p[i].a >> p[i].b >> p[i].c;
	f1(0.24999999632501932, 4.124999990812548);
	ld lx = -2e9, rx = 2e9;
	for (int i = 0; i < 1000; i++) {
		ld m1 = lx + (rx - lx) / 3, m2 = rx - (rx - lx) / 3;
		if (f(m1, 0) <= f(m2, 0)) lx = m1;
		else rx = m2;
	}
	cout << setprecision(10) << fixed << lx << ' '  << f(lx, 1);
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	//cin>>t;
	while (t--) {
		solveG();
	}
	return 0;
}