#define _USE_MATH_DEFINES

#include <iostream>
#include <iomanip>

#include <cmath>
#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	int b = 0;
	vector<vector<int>> s(2);
	vector<int> w(n + 1, -1);
	w[0] = 2;
	for (int i = 0; i < n; ++i) {
		if (b + 1 == a[i]) {
			cout << "1\n-1\n";
			++b;
			w[a[i]] = 2;
		}
		else {
			cout << "1\n";
			s[0].push_back(a[i]);
			w[a[i]] = 0;
		}
	}
	while (!s[0].empty() || !s[1].empty()) {
		int cur = w[b + 1];

		while (!s[cur].empty()) {
			if (b + 1 == s[cur].back()) {
				cout << -(cur + 1) << '\n';
				s[cur].pop_back();
				w[b + 1] = 2;
				++b;
				if (b == n)
					break;
				else
					cur = w[b + 1];
			}
			else {
				cout << cur + 1 << (cur ^ 1) + 1 << '\n';
				w[s[cur].back()] ^= 1;
				s[cur ^ 1].push_back(s[cur].back());
				s[cur].pop_back();
			}
		}
	}

	return 0;
}