#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <map>
#include <iomanip>
#include <set>
typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
    ll n;
    cin >> n;
    vector<ld>a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<ld>prefr(n), prefl(n);
    prefr[n - 1] = a[n - 1];
    prefl[0] = a[0];
    for (ll i = n - 2; i >= 0; i--) {
        prefr[i] = min(prefr[i + 1], a[i]);
    }
    for (ll i = 1; i < n; i++) {
        prefl[i] = min(prefl[i - 1], a[i]);
    }
    ll min_a = min_element(a.begin(), a.end()) - a.begin(), max_a = max_element(a.begin(), a.end()) - a.begin();
    cout << setprecision(10) << fixed;
    for (ll i = 0; i <= n - 1; i++) {
        if (min_a >= i && max_a >= i) {
            if (i != 0) {
                cout << (ld)1 - prefl[i - 1] / a[max_a] << ' ';
            }
            else {
                cout << (ld)1 << ' ';
            }
        }
        if (max_a < i && min_a >= i) {
            cout << (ld)0 << ' ';
        }
        if (max_a >= i && min_a < i) {
            if (a[min_a] / prefr[i] * a[max_a] - a[min_a] < a[min_a] - prefr[i] * a[min_a] / a[max_a]) {
                cout << (ld)1 - a[min_a] / prefr[i] << ' ';
            }
            else {
                cout << (ld)1 - a[min_a] / a[max_a];
            }
        }
        if (min_a < i && max_a < i) {
            cout << (ld)1 - a[min_a] / prefr[i] << ' ';
        }
    }
    return 0;
}