#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair < ll, ll > pii;

#define int ll
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(s) int(s.size())
#define pb push_back
#define speedup ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

const int N = 1e6 + 123;

int n, a[N], b[N], dif[N];

bool check(int k) {
	for (int i = 1; i <= n; i++) {
		dif[i] = b[i] - a[i];
	}
	
	for (int i = 1; i <= n; i++) {
		if (dif[i] < 0) {
			for (int j = max(1ll, i - k); j < i; j++) {	
				if (dif[j] < 0)
					continue;
					
				int t = min(abs(dif[i]), abs(dif[j]));
				dif[j] -= t;
				dif[i] += t;
				if (dif[i] == 0)
					break;
			}
			if (dif[i] < 0) {
				for (int j = i + 1; j <= min(n, i + k); j++) {
					if (dif[j] < 0)
						continue;
						
					int t = min(abs(dif[i]), abs(dif[j]));
					dif[j] -= t;
					dif[i] += t;
					if (dif[i] == 0) break;
				}
			}
			
			if (dif[i] < 0)
				return false;
		}
	}
	return true;
}

main() {
	int sum1 = 0, sum2 = 0;
	
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		sum1 += a[i];
	}
	for (int i = 1; i <= n; i++) {
		cin >> b[i];
		sum2 += b[i];
	}
	
	if (sum2 < sum1) {
		cout << -1;
		return 0;
	}
	
	int L = 0, R = n - 1, ans = n - 1;
	while (L <= R) {
		int mid = (L + R) / 2;
		if (check(mid)) {
			ans = mid;
			R = mid - 1;
		} else {
			L = mid + 1;
		}
	}
	cout << ans;
}