#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int ll
//int slow(const int &n, const vector<int> &a, const vector<int> &b) {
//
//}

int fast(const int &n, const vector<int> &a, const vector<int> &b) {
    vector<int> free = b, rest = a;

    int l = 0, r = n, res = -1;
    while (l <= r) {
        int mid = (l + r) / 2;
        bool flag1 = true;
        int id = 0;
        vector<int> free_orig = free, rest_orig = rest;
        for (int i = 0; i < n; i++) {
            if (!rest[i])
                continue;
            while (abs(i - id) > mid && id <= i)
                id++;
            while (id < n && abs(i - id) <= mid) {
                if (rest[i] > free[id])
                    rest[i] -= free[id], free[id] = 0;
                else
                    free[id] -= rest[i], rest[i] = 0;
                if (rest[i])
                    id++;
                else
                    break;
            }
        }
        id = n - 1;
        for (int i = n - 1; i >= 0; i--) {
            if (!rest[i])
                continue;
            while (abs(i - id) > mid && i <= id)
                id--;
            while (id >= 0 && abs(i - id) <= mid) {
                if (rest[i] > free[id])
                    rest[i] -= free[id], free[id] = 0;
                else
                    free[id] -= rest[i], rest[i] = 0;
                if (rest[i])
                    id--;
                else
                    break;
            }
            if (rest[i]) {
                flag1 = false;
                break;
            }
        }

        free = free_orig;
        rest = rest_orig;

        if (!flag1)
            l = mid + 1;
        else
            r = mid - 1, res = mid;
    }
    return res;
}

signed main() {
//    srand(time(NULL));
//    for (int rep = 0; rep < 1000; rep++) {
//        int n = rand() % 10 + 1;
//        vector<int> a(n), b(n);
//        for (int i = 0; i < n; i++)
//            a[i] = rand() % 15 + 1;
//        for (int i = 0; i < n; i++)
//            b[i] = rand() % 15 + 1;
//
//        if (slow(n, a, b) == fast(n, a, b)) {
//            cout << "OK\n";
//        } else {
//            cout << "WA\n" << n << '\n';
//            for (int i = 0; i < n; i++)
//                cout << a[i] << ' ';
//            for (int i = 0; i < n; i++)
//                cout << b[i] << ' ';
//            cout << '\n' << slow(n, a, b) << ' ' << fast(n, a, b) << '\n';
//            return 0;
//        }
//    }
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
    cout << fast(n, a, b);
    return 0;
}
