#include <bits/stdc++.h>

#define ll long long
#define ld long double

using namespace std;

const ll maxn = 1e5 + 200;
const ll INF = INT_MAX;

ll a[maxn];
ld t[maxn];

struct segtree{
    ll t[maxn];
    void build(ll v, ll tl, ll tr) {
        if (tl == tr) {
            t[v] = a[tl];
            return;
        }
        ll tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }

    ll get(ll l, ll r, ll v, ll tl, ll tr) {
        if (l <= tl && tr <= r) {
            return t[v];
        }
        if (l > tr || tl > r) {
            return INF;
        }
        ll tm = (tl + tr) / 2;
        return min(get(l, r, v * 2, tl, tm), get(l, r, v * 2 + 1, tm + 1 , tr));
    }
} rt;


int main(){
    ll n;
    cin >> n;
    ll min_all = INF;
    for (int i = 1; i <= n; ++i ){
        cin >> a[i];
    }
    rt.build(1, 1, n);
    ll cur_max = a[n];
    for (int i = n; i > 0; --i) {
        cur_max = max(cur_max, a[i]);
        min_all = rt.get(1, i - 1, 1, 1, n);
        t[i] = max(1 - (min_all * 1.0 / cur_max), 0.0);
    }
    t[1] = 1;
    for (int i = 1; i <= n; ++i) {
        cout << fixed << setprecision(9) << t[i] << " ";
    }
}

