#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ld long double
#define ll long long

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1e5 + 10;

int n;
ld a[N], b[N], c[N];
vector<int> down, up;

ld f(ld x) {
    ld mx = a[up[0]] * x * x + b[up[0]] * x + c[up[0]];
    for (int i : up) {
        mx = max(mx, a[i] * x * x + b[i] * x + c[i]);
    }
    return mx;
}

ld g(ld x) {
    ld mn = a[down[0]] * x * x + b[down[0]] * x + c[down[0]];
    for (int i : down) {
        mn = min(mn, a[i] * x * x + b[i] * x + c[i]);
    }
    return mn;
}

ld h(ld x) {
    return g(x) - f(x);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        ll aa, bb, cc;
        cin >> aa >> bb >> cc;
        a[i] = aa;
        b[i] = bb;
        c[i] = cc;
        if (a[i] > 0) {
            up.push_back(i);
        } else {
            down.push_back(i);
        }
    }

    if (down.empty()) {
        ld mx = -1e18;
        for (int i = 0; i < n; ++i) {
            mx = max(mx, c[i]);
        }
        cout << setprecision(20) << fixed << 0 << " " << mx << endl;
        return 0;
    }

    if (up.empty()) {
        ld mn = 1e18;
        for (int i = 0; i < n; ++i) {
            mn = min(mn, c[i]);
        }
        cout << setprecision(20) << fixed << 0 << " " << mn << endl;
        return 0;
    }

    ld l = -3e9, r = 3e9;
    for (int i : up) {
        l = max(l, -b[i] - sqrt(b[i] * b[i] - 4 * a[i] * (c[i] - 2e9)));
        r = min(r, -b[i] + sqrt(b[i] * b[i] - 4 * a[i] * (c[i] - 2e9)));
    }
    for (int i : down) {
        l = max(l, -b[i] - sqrt(b[i] * b[i] - 4 * a[i] * (c[i] + 2e9)));
        r = min(r, -b[i] + sqrt(b[i] * b[i] - 4 * a[i] * (c[i] + 2e9)));
    }
    for (int i = 0; i < 100; ++i) {
        ld ml = l + (r - l) / 3;
        ld mr = r - (r - l) / 3;
        if (h(ml) < h(mr)) {
            l = ml;
        } else {
            r = mr;
        }
    }
    cout << setprecision(20) << fixed << l << " " << f(l) << endl;
    return 0;
}
