#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define pb push_back
#define ld long double

using ll = long long;

const int N = 5e5 + 5;
const int INF = 1e9 + 1;
const ll MOD = 1e9 + 7;

void mod(ll &x) {
    x %= MOD;
    if (x < 0) x += MOD;
}

ll sum_mins(vector<int> a) {
    int n = a.size();
    vector<int> l(n, -1), r(n, n);
    vector<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.back()] >= a[i]) {
            r[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    st.clear();
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && a[st.back()] > a[i]) {
            l[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] != INF) {
            res += 1ll * (i - l[i]) * (r[i] - i) % MOD * a[i];
            mod(res);
        }
    }
    return res;
}

int n, k;
int a[N], b[N];
ll pref[N];
int rem[N];
int d[N];
map<int, vector<int>> by_rem;
ll ans;
int mn[2 * N];

int get_min(int l, int r) {
    l += n;
    r += n;
    int res = INF;
    while (l < r) {
        if (l & 1) {
            res = min(res, mn[l]);
            ++l;
        }
        if (r & 1) {
            --r;
            res = min(res, mn[r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return res;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        if (a[i] < b[i]) {
            swap(a[i], b[i]);
        }
        pref[i + 1] = pref[i] + a[i];
        d[i] = a[i] - b[i];
        if (d[i] % k == 0) {
            d[i] = INF;
        }
    }
    for (int i = 0; i <= n; ++i) {
        rem[i] = pref[i] % k;
    }
    {
        map<ll, int> cnt;
        map<ll, ll> sum;
        ll total_cnt = 0;
        ll total_sum = 0;
        for (int i = 0; i <= n; ++i) {
            ans += total_cnt * pref[i] - total_sum;
            mod(ans);
            ans -= cnt[rem[i]] * pref[i] - sum[rem[i]];
            mod(ans);
            ++total_cnt;
            total_sum += pref[i];
            ++cnt[rem[i]];
            sum[rem[i]] += pref[i];
        }
    }
    for (int i = 0; i < n; ++i) {
        mn[i + n] = d[i];
    }
    for (int i = n - 1; i > 0; --i) {
        mn[i] = min(mn[2 * i], mn[2 * i + 1]);
    }
    for (int i = 0; i <= n; ++i) {
        by_rem[rem[i]].push_back(i);
    }
    for (const auto &[_rem, inds] : by_rem) {
        int sz = inds.size();
        if (sz == 1) continue;
        for (int i = 0; i < sz; ++i) {
            ans += pref[inds[i]] * i;
            mod(ans);
            ans -= pref[inds[i]] * (sz - i - 1);
            mod(ans);
        }
        vector<int> mns;
        for (int i = 0; i + 1 < sz; ++i) {
            mns.push_back(get_min(inds[i], inds[i + 1]));
        }
        ans -= sum_mins(mns);
        mod(ans);
    }
    cout << ans << endl;
    return 0;
}