#include <bits/stdc++.h>

#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.rend()
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define int long long

using namespace std;


struct F {
    ld a, b, c;

    F(ld a, ld b, ld c) : a(a), b(b), c(c) {}

    F() {}
};

const ld eps = 1e-8;

pair<ld, ld> getLR(F &p, ld y) {
    if (p.b * p.b - 4.0 * p.a * (p.c - y) < 0.0) {
        return {1e18, -1e18};
    }
    ld l = (-p.b - sqrt(p.b * p.b - 4 * p.a * (p.c - y))) / (2.0 * p.a);
    ld r = (-p.b + sqrt(p.b * p.b - 4 * p.a * (p.c - y))) / (2.0 * p.a);
    if (l > r) swap(l, r);
    return {l, r};
}

ld INF = 1e18;
ld INF2 = 1e20;

pair<ld, ld> getLR(vector<F> &par, ld y) {
    ld MAX_L = -INF, MIN_R = INF;

    for (auto &p: par) {
        pair<ld, ld> lr = getLR(p, y);
        ckmax(MAX_L, lr.first);
        ckmin(MIN_R, lr.second);
    }
    return {MAX_L, MIN_R};
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(30);
    int n;
    cin >> n;
    vector<F> par_up, par_down;

    for (int i = 0; i < n; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        if (a > 0)par_down.emplace_back((ld) a, (ld) b, (ld) c);
        else par_up.emplace_back((ld) a, (ld) b, (ld) c);
    }


    ld L = -INF, R = INF;
    for (int it = 0; it < 200; ++it) {
        ld Y = (L + R) / 2.0;

        ld MAX_L = -INF2, MIN_R = INF2;

        for (auto &p: par_up) {
            pair<ld, ld> lr = getLR(p, Y);
            ckmax(MAX_L, lr.first);
            ckmin(MIN_R, lr.second);
        }

        if ((MAX_L <= MIN_R || abs(MIN_R - MAX_L) <= eps))L = Y;
        else R = Y;
    }

    ld y2 = L;

    L = -INF, R = INF;
    for (int it = 0; it < 200; ++it) {
        ld Y = (L + R) / 2.0;

        ld MAX_L = -INF2, MIN_R = INF2;

        for (auto &p: par_down) {
            pair<ld, ld> lr = getLR(p, Y);
            ckmax(MAX_L, lr.first);
            ckmin(MIN_R, lr.second);
        }

        if ((MAX_L <= MIN_R || abs(MIN_R - MAX_L) <= eps))R = Y;
        else L = Y;
    }

    ld y1 = R;

    L = min(y1, y2), R = max(y1, y2);

    for (int it = 0; it < 200; ++it) {
        ld Y1 = L + (R - L) / 3.0;
        ld Y2 = R - (R - L) / 3.0;

        auto Fup1 = getLR(par_up, Y1), Fup2 = getLR(par_up, Y2);
        auto Fdown1 = getLR(par_down, Y1), Fdown2 = getLR(par_down, Y2);

        ld F1 = min(Fup1.second, Fdown1.second) - max(Fup1.first, Fdown1.first);
        ld F2 = min(Fup2.second, Fdown2.second) - max(Fup2.first, Fdown2.first);

        if(F1 < F2)L = Y1;
        else R = Y2;
    }

    auto f1 = getLR(par_up, L);
    auto f2 = getLR(par_down, L);
    ld MAX_L = max(f1.first, f2.first);
    ld MIN_R = min(f1.second, f2.second);
    if(MAX_L > MIN_R)exit(-1);
    cout << (MAX_L + MIN_R) / 2.0 << " " << L;
}
/*
2
1



 */