#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
//typedef tree<int, null_type, less_equals<int>, rb_tree_tag, tree_order_statistics
//#define int long long
#define all(a) a.begin(), a.end()
#define watch(x) cout << (#x) << " = " << x << endl
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))
#define gcd(a, b) __gcd(a, b)
#define endl '\n'
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using vii = vector<pi>;
using vvi = vector<vi>;
const int MAXN = 1e6;
vector <ll> a(MAXN);
vector <ll> b(MAXN);
bool check(int k, int n)
{
    vector <ll> used(n, 0);
    int j = 0;
    int col = 0;
    int last = n - 1;
    vector <int> f;
    for (int i = n - 1; i >= 0; i--)
    {
        if (a[i] + used[i] > b[i])
        {
            int nado = a[i] + used[i] - b[i];
            used[i] = b[i];
            while (j != col && f[j] - i > k)
                j++;
            while (j != col && nado != 0)
            {
                int id = f[j];
                int sw = b[id] - used[id];
                if (sw > nado)
                {
                    used[id] += nado;
                    nado = 0;
                }
                else {
                    used[id] += sw;
                    nado -= sw;
                }
                j++;
            }
            while (last >= i)
                last--;
            while (last != -1 && i - last <= k && nado != 0)
            {
                int id = last;
                int sw = b[id] - used[id];
                if (sw >= nado)
                {
                    used[id] += nado;
                    nado = 0;
                }
                else {
                    used[id] += sw;
                    nado -= sw;
                    last--;
                }
            }
            if (nado != 0)
                return false;
        }
        else
            used[i] += a[i];
        f.push_back(i);
    }
    return true;
}
void solve123()
{    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
    }
    check(2, n);
    int l = -1, r = n + 1, m;
    while (r - l > 1)
    {
        m = (r + l) / 2;
        if (check(m, n))
            r = m;
        else
            l = m;
    }
    if (r == n + 1)
        cout << -1;
    else
        cout << r;}

long double get_function(int min1, int max1, int min2, int max2, long double t) {
    return max(
            max((long double) max1 - min1, (1 - t) * (max2 - min2)),
            max((long double) max1 - (1 - t) * min2, (1 - t) * max2 - min1)
            );
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vi mass(n);
    for (int i = 0; i < n; i++) {
        cin >> mass[i];
    }
    vi min_pref(n), max_pref(n);
    vi min_suf(n), max_suf(n);
    cout << fixed << setprecision(10);
    min_pref[0] = mass[0];
    max_pref[0] = mass[0];
    for (int i = 1; i < n; i++) {
        min_pref[i] = min(min_pref[i - 1], mass[i]);
        max_pref[i] = max(max_pref[i - 1], mass[i]);
    }
    min_suf[n - 1] = mass[n - 1];
    max_suf[n - 1] = mass[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        min_suf[i] = min(min_suf[i + 1], mass[i]);
        max_suf[i] = max(max_suf[i + 1], mass[i]);
    }
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            cout << 1 << ' ';
            continue;
        }
        long double l = 0, r = 1;
        int iterations = 200;

        while (iterations--) {
            long double l1 = l + (r - l) / 3;
            long double r1 = r - (r - l) / 3;
            if (get_function(min_pref[i - 1], max_pref[i - 1], min_suf[i], max_suf[i], l1)
                < get_function(min_pref[i -1 ], max_pref[i - 1], min_suf[i], max_suf[i], r1)) {
                r = r1;
            } else {
                l = l1;
            }
        }
        cout << r << ' ';
    }
}
