#include <bits\stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>

using namespace std;
// using namespace __gnu_pbds;

// template<class S>
// using ordered_set = tree<S, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

#define pb emplace_back
#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

const int N = 1e6 + 10;
const ll MOD1 = 1e9 + 7, MOD2 = 1e9 + 9;

mt19937 rnd(time(0));

int len, n, cnt[128], cur[128];
ll mas1[N], mas2[N], h_pos1[N], h_ch1[128], h_pos2[N], h_ch2[128];
bool used[128];
map<ll, int> hs1, hs2;
string s[N];

ll gen1() {
    return rnd() % MOD1 + 1;
}

ll gen2() {
    return rnd() % MOD2 + 1;
}

ll mul1(ll a, ll b) {
    return (a * b) % MOD1;
}

ll mul2(ll a, ll b) {
    return (a * b) % MOD2;
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("outut.txt", "w", stdout);
#endif
    fastio();

    cin >> len >> n;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < len; ++i) {
        h_pos1[i] = gen1();
        h_pos2[i] = gen2();
    }
    for (char ch = 'a'; ch <= 'z'; ++ch) {
        h_ch1[ch] = gen1();
        h_ch2[ch] = gen2();
    }

    int us = 0;
    while (n && us < 26) {
        for (char ch = 'a'; ch <= 'z'; ++ch)
            cnt[ch] = 0;
        for (int i = 0; i < n; ++i) {
            for (char ch : s[i])
                cur[ch] = 1;
            for (char ch = 'a'; ch <= 'z'; ++ch) {
                cnt[ch] += cur[ch];
                cur[ch] = 0;
            }
        }

        vector<char> c;
        for (char ch = 'a'; ch <= 'z'; ++ch) {
            if (!used[ch] && cnt[ch] == n) {
                c.pb(ch);
                cnt[ch] = 1;
                continue;
            }
            cnt[ch] = 0;
        }

        if (c.empty()) break;

        hs1.clear();
        hs2.clear();
        for (int i = 0; i < n; ++i) {
            mas1[i] = mas2[i] = 1;
            for (int j = 0; j < len; ++j) {
                char ch = s[i][j];
                if (cnt[ch]) {
                    mas1[i] = mul1(mas1[i], mul1(h_ch1[ch], h_pos1[j]));
                    mas2[i] = mul2(mas2[i], mul2(h_ch2[ch], h_pos2[j]));
                }
            }
            ++hs1[mas1[i]];
            ++hs2[mas2[i]];
        }

        for (int i = 0; i < n; ++i) {
            if (hs1[mas1[i]] == 1 && hs2[mas2[i]] == 1) {
                swap(s[i], s[n - 1]);
                swap(mas1[i], mas1[n - 1]);
                swap(mas2[i], mas2[n - 1]);
                --n;
                --i;
            }
        }

        us += c.size();
        for (char ch : c)
            used[ch] = 1;
        c.clear();
    }

    if (n) cout << "NO";
    else cout << "YES";
}
