#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mt make_tuple
#define mp make_pair

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e6 + 5;

int n;
int a[N], b[N];

bool possible(int x) {
    ve<int> b(n), a(n);
    fr(i, 0, n - 1) {
        b[i] = ::b[i];
        a[i] = ::a[i];
    }
    int ptr = 0;
    fr(i, 0, n - 1) {
        while(i - ptr > x) {
            ptr++;
        }
        while(a[i] > 0 && ptr < n && ptr - i <= x) {
            int t = min(a[i], b[ptr]);
            a[i] -= t;
            b[ptr] -= t;
            if(b[ptr] == 0) {
                ptr++;
            }
        }
        if(a[i] > 0) {
            return 0;
        }
    }
    return 1;
}

int main() {
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;

    fr(i, 0, n - 1) {
        cin >> a[i];
    }

    fr(i, 0, n - 1) {
        cin >> b[i];
    }

//    fr(i, 0, n) cout << possible(i) << " ";
//    cout << "\n";
//
//    cout << possible(1) << "\n";
//    return 0;

    int l = 0;
    int r = n;
    while(l < r) {
        int mid = l + ((r - l) >> 1);
//        cout << l << " " << r << " " << mid << " " << possible(mid) << "\n";
        if(possible(mid)) {
            r = mid;
        } else {
            l = mid + 1;
        }
    }

    if(!possible(l)) {
        cout << "-1\n";
        return 0;
    }

    cout << l << "\n";

    return 0;
}
