#include <bits/stdc++.h>
#define in(x) freopen(x, "r", stdin)
#define out(x) freopen(x, "w", stdout)
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("-O3")
#define f first
#define s second
#define pb push_back
#define sz(x) (int)x.size()
#define re return
#define pri(x) cout << x << endl
#define oo ll(1e18)
#define el '\n'
#define pii pair <ll, ll>
#define all(x) (x).begin(), (x).end()
#define arr_all(x, n) (x + 1), (x + 1 + n)
#define vi vector<ll>
#define _ << " " <<
using namespace std;
//using namespace __gnu_pbds;
//typedef tree <ll, null_type, less_equal <ll> , rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ld eps = 1e-9;

struct parabola {
    ld a, b, c;

    parabola(ld a, ld b, ld c) : a(a), b(b), c(c) {}

    ld get(ld x) {
        return a * x * x + b * x + c;
    }

    bool intersect(parabola &other, pair <ld, ld> &it) {
        ld A = a - other.a;
        ld B = b - other.b;
        ld C = c - other.c;
        ld D = B * B - 4.0 * A * C;
        if (D < 0) {
            return 0;
        }
        it.f = (-B - sqrt(D)) / (2.0 * A);
        it.s = (-B + sqrt(D)) / (2.0 * A);
        return 1;
    }

    bool is_upper(parabola &other, ld x) {
        return get(x) > other.get(x);
    }
    bool operator >(parabola &other) const{
        return a > other.a;
    }

    bool operator <(parabola &other) const{
        if (a != other.a) return a < other.a;
        else
        if (other.b != b) return b < other.b;
        else              return c < other.c;
    }
};

bool check(pair<pair<ld, ld>, parabola> a, parabola b)
{
    pair<ld, ld> nt;
    if (!a.s.intersect(b, nt)) return 0;
    if ((nt.f >= a.f.f && nt.f <= a.f.s) || (nt.s >= a.f.f && nt.s <= a.f.s)) return 1;
    return 0;
}

deque <pair<pair<ld, ld>, parabola> > Construct_Hull(vector <parabola> a)
{
    sort(a.begin(), a.end());
    deque <pair <pair <ld, ld>, parabola> > ans;
    for (int i = 0; i < a.size(); i++)
    {
        while (ans.size() > 0 && !check(ans.front(), a[i])) ans.pop_front();
        if (ans.size() == 0)
        {
            ans.pb({{-oo, oo}, a[i]});
            continue;
        }
        pair<ld, ld> c;
        ans.front().s.intersect(a[i], c);
        ans.front().f.f = c.f;
        ans.push_front({{-oo, c.f}, a[i]});
        while (ans.size() > 0 && !check(ans.back(), a[i])) ans.pop_back();
        ans.back().s.intersect(a[i], c);
        ans.back().f.s = c.s;
        ans.push_back({{c.s, oo}, a[i]});
    }
    return ans;
}

deque <pair<pair<ld, ld>, parabola> > Construct_Hull1(vector <parabola> a)
{
    sort(a.begin(), a.end());
    reverse(a.begin(), a.end());
    deque <pair <pair <ld, ld>, parabola> > ans;
    for (int i = 0; i < a.size(); i++)
    {
        while (ans.size() > 0 && !check(ans.front(), a[i])) ans.pop_front();
        if (ans.size() == 0)
        {
            ans.pb({{-oo, oo}, a[i]});
            continue;
        }
        pair<ld, ld> c;
        ans.front().s.intersect(a[i], c);
        ans.front().f.f = c.f;
        ans.push_front({{-oo, c.f}, a[i]});
        while (ans.size() > 0 && !check(ans.back(), a[i])) ans.pop_back();
        ans.back().s.intersect(a[i], c);
        ans.back().f.s = c.s;
        ans.push_back({{c.s, oo}, a[i]});
    }
    return ans;
}

int main()
{
    istream::sync_with_stdio(0); ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
//	in("rebus.in");
//	out("rebus.out");
//
    cout.precision(8);
    cout << fixed;
    int n;
    cin >> n;
    vector <parabola> a[2];
    for (int i = 0; i < n; i++)
    {
        ld x, y, z;
        cin >> x >> y >> z;
        parabola pr(x, y, z);
        if (x < 0) a[1].pb(pr);
        else       a[0].pb(pr);
    }
    deque <pair <pair <ld, ld>, parabola> > pr, pr1;
    pr = Construct_Hull(a[0]);
    pr1 = Construct_Hull1(a[1]);
    int j = 0;
    for (int i = 0; i < pr.size(); i++)
    {
        while (j < sz(pr1) && pr1[j].f.s < pr[i].f.f) {
            j++;
        }
        pair<ld, ld> c;
        pr[i].s.intersect(pr1[j].s, c);
        if (c.f + eps > pr[i].f.f && c.f - eps < pr[i].f.s)
        {
            cout << c.f << " " << pr[i].s.get(c.f);
            return 0;
        }
        if (c.s + eps > pr[i].f.f && c.s - eps < pr[i].f.s)
        {
            cout << c.s << " " << pr[i].s.get(c.s);
            return 0;
        }
    }

//    j = 0;
//    for (int i = 0; i < pr1.size(); i++)
//    {
//        while (j < sz(pr) && pr[j].f.s < pr1[i].f.f) {
//            j++;
//        }
//        ld L = pr1[i].s.get(pr1[i].f.f);
//        ld R = pr[j].s.get(pr1[i].f.f);
//        if (R < L + eps)
//        {
//            cout << pr1[i].f.f << " " << R  << endl;
//            return 0;
//        }
//        ld mn = min(pr1[i].f.s, pr[j].f.s);
//        L = pr1[i].s.get(mn);
//        R = pr[j].s.get(mn);
//        if (R < L + eps)
//        {
//            cout << mn << " " << R  << endl;
//            return 0;
//        }
//    }
}
