#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define inf (ll)1e18
#define all(x) (x).begin(),(x).end()
#define pii pair<int,int>
#define pll pair<ll,ll>
#define mpp make_pair
#define mtt make_tuple

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector <int> a(n);
    for (auto &i : a) cin >> i;

    vector <int> smn(n + 1), smx(n + 1);
    smn[n] = 1e9, smx[n] = -1e9;

    for (int i = n - 1; ~i; --i) {
        smn[i] = min(smn[i + 1], a[i]);
        smx[i] = max(smx[i + 1], a[i]);
    }

    vector <ll> sm(n + 1);
    for (int i = n - 1; ~i; --i) sm[i] = sm[i + 1] + a[i];

    int mx = -1e9, mn = 1e9;


    for (int k = 0; k < n; ++k) {

        pair <ld, ld> ans = {(ld)inf, (ld)inf};
        ld rmn = smn[k], rmx = smx[k];

        { /// both mx and mn in [0, k - 1]
            /// (1 - t) * rmn >= mn
            /// (1 - t) * rmx <= mx
            /// t <= 1 - (mn / rmn)
            /// t >= 1 - (mx / rmx)

            ld l = max((ld)0, 1 - (mx / rmx));
            ld r = min((ld)1, 1 - (mn / rmn));
            if (l <= r) ans = min(ans, mpp((ld)mx - mn, l));
        }
        { /// both mx and mn in [k, n]
            /// (1 - t) * rmn <= mn
            /// (1 - t) * rmx >= mx
            /// t >= 1 - (mn / rmn)
            /// t <= 1 - (mx / rmx)

            ld l = max((ld)0, 1 - (mn / rmn));
            ld r = min((ld)1, 1 - (mx / rmx));

//            cout << l << " " << r << " " << (1 - r) * (ld)(rmx - rmn) << '\n';
            if (l <= r) ans = min(ans, mpp((1 - r) * (ld)(rmx - rmn), r));
        }
        { /// mx in [k, n], mn in [0, k - 1]
            /// (1 - t) * rmn >= mn
            /// (1 - t) * rmx >= mx
            /// t <= 1 - (mn / rmn)
            /// t <= 1 - (mx / rmx)
            ld l = min((ld)1, 1 - (mn / rmn));
            ld r = min((ld)1, 1 - (mx / rmx));
            ld val = min(l, r);

            if (val >= 0) ans = min(ans, mpp((1 - val) * rmx - mn, val));
        }
        { /// mx in [0, k - 1], mn in [k, n]
            /// (1 - t) * rmn <= mn
            /// (1 - t) * rmx <= mx
            ld l = max((ld)0, 1 - (mn / rmn));
            ld r = max((ld)0, 1 - (mx / rmx));
            ld val = max(l, r);

            if (val <= 1) ans = min(ans, mpp(mx - 1 * rmn, val));
        }

        cout << fixed << setprecision(20) << ans.second << " ";

        mx = max(mx, a[k]);
        mn = min(mn, a[k]);
    }
}
