#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <utility>
#include <set>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <queue>
#include <cstring>

using namespace std;

int l, n;
char toComp = 'a';
vector<string> s;
vector<vector<bool> > hasC(n, vector<bool>(26, false));

bool cmp(string a, string b) {
	for(int i = 0; i < l; ++i) {
		if(a[i] == toComp && b[i] != toComp) {
			return true;
		}
	}
	return false;
}

struct sstring
{
	string s;
	sstring(string s)
	{
		this->s = s;
	}
	bool operator< (const sstring a)const
	{
		return cmp(s, a.s);
	}
};

bool dfs(vector<int>& ind, vector<bool> alf)
{
	if (ind.size() == 1) return true;
	for (char c = 'a'; c <= 'z'; c++)
	{
		if (!alf[c - 'a'])
		{
			bool all = true;
			for (auto i : ind)
			{
				if (!hasC[i][c - 'a'])
				{
					all = false;
					break;
				}
			}
			if (!all) continue;
			toComp = c;
			map<sstring, vector<int>> mp;
			for (auto i : ind)
			{
				if (mp.find(sstring(s[i])) == mp.end()) mp.insert({sstring(s[i]), {i}});
				else mp[sstring(s[i])].push_back(i);
			}
			all = true;
			alf[c - 'a'] = true;
			for (auto i : mp)
			{

				if (!dfs(i.second, alf))
				{
					all = false;
					break;
				}
			}
			alf[c - 'a'] = false;
			if (all) return true;
		}
	}
	return false;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> l >> n;
	s = vector<string>(n);
	hasC = vector<vector<bool>>(n, vector<bool>(26, false));
	vector<int> ind(n);
	for(int i = 0; i < n; ++i) {
		cin >> s[i];
		for (char c = 'a'; c <= 'z'; c++)
		{
			for (int j = 0; j < l; j++)
			{
				if (s[i][j] == c)
				{
					hasC[i][c - 'a'] = true;
					break;
				}
			}
		}
		ind[i] = i;
	}
	if (dfs(ind, vector<bool>(26, false))) cout << "YES";
	else cout << "NO";
    return 0;
}
