#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define ll long long
#define pii pair<int, int>

ll binpow(ll n, int p) {
	ll ans = n;
	int pos = 1;
	while (pos < p) {
		if (pos * 2 <= p) {
			pos *= 2;
			ans *= ans;
		}
		else {
			pos++;
			ans *= n;
		}
	}
	return ans;
}

const int INF = 1e9 + 7;

vector<int> a, b;
int n;

bool ok(int k) {
	int sum = 0;
	for (int i = 0; i <= k; ++i) {
		sum += b[i];
	}
	for (int i = 0; i < n; ++i) {
		if (a[i] > sum) {
			return false;
		}
		if (i - k >= 0)
			sum -= b[i - k];
		if (i + k + 1 < n) {
			sum += b[i + k + 1];
		}
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed;
	cout.precision(20);
	//freopen("input.txt", "r", stdin);
	cin >> n;
	a.resize(n);
	b.resize(n);
	uint64_t sum1 = 0, sum2 = 0;
	for (auto& i : a) {
		cin >> i;
		sum1 += i;
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		sum2 += b[i];
		if (b[i] > a[i]) {
			a[i] = 0;
			b[i] -= a[i];
		}
		else {
			a[i] -= b[i];
			b[i] = 0;
		}
	}
	if (sum1 > sum2) {
		cout << -1;
		return 0;
	}
	int l = 0, r = n + 1;
	int m;
	while (l + 1 < r) {
		m = (l + r) >> 1;
		if (ok(m)) {
			r = m;
		}
		else {
			l = m;
		}
	}
	cout << r;
	return 0;
}
