#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define ll long long
#define pii pair<int, int>

ll binpow(ll n, int p) {
	ll ans = n;
	int pos = 1;
	while (pos < p) {
		if (pos * 2 <= p) {
			pos *= 2;
			ans *= ans;
		}
		else {
			pos++;
			ans *= n;
		}
	}
	return ans;
}

const int INF = 1e9 + 7;

long double Max(long double a, long double b) {
	if (a > b) {
		return a;
	}
	return b;
}

long double Min(long double a, long double b) {
	if (a < b) {
		return a;
	}
	return b;
}


int in[4];

int pos[4], lpos[4];

void convert(int* a, int* b) {
	for (int i = 0; i < 4; ++i) {
		a[i] = b[i];
	}
}

void convert1(int* q, int a, int b, int c, int d) {
	q[0] = a;
	q[1] = b;
	q[2] = c;
	q[3] = d;
}

bool ok(int x) {
	for (int i = 0; i < 4; ++i) {
		for (int j = i + 1; j < 4; ++j) {
			if (in[i] * in[j] - in[i] - in[j] >= x) {
				int a[2];
				int cur = 0;
				for (int k = 0; k < 4; ++k) {
					if (k != i && k != j){
						a[cur] = k;
						++cur;
					}
				}
				if (in[a[0]] * in[a[1]] - in[a[1]] - in[a[0]] >= x) {
					convert1(pos, i, a[0], a[1], j);
					return true;
				}
			}
		}
	}
	return false;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed;
	cout.precision(20);
	//freopen("input.txt", "r", stdin);
	for (int i = 0; i < 4; ++i) {
		cin >> in[i];
	}
	int l = -2, r = 1e9 + 7;
	int m;
	while (l + 1 < r) {
		m = (l + r) / 2;
		if (ok(m)) {
			convert(lpos, pos);
			l = m;
		}
		else {
			r = m;
		}
	}
	for (int i = 0; i < 4; ++i) {
		cout << lpos[i] + 1 << ' ';
	}
	cout << '\n';
	double L = 0, R = in[pos[0]];
	double M;
	for (int i = 0; i < 10000; ++i) {
		M = (L + R) / 2.0;
		if (M * in[pos[3]] - M - in[pos[3]] <= l) {
			L = M;
		}
		else {
			R = M;
		}
	}
	double ans1 = M;
	L = 0, R = in[pos[1]];
	for (int i = 0; i < 10000; ++i) {
		M = (L + R) / 2.0;
		if (M * in[pos[2]] - M - in[pos[2]] <= l) {
			L = M;
		}
		else {
			R = M;
		}
	}
	cout << ans1 << ' ' << M << ' ' << in[pos[2]] << ' ' << in[pos[3]];
	return 0;
}
