#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,lzcnt,popcnt,bmi,bmi2")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

map<string, int> mp;
string sumka, newa;
bitset<26> counter1, counter2;

bool solve(vector<string> &s)
{
    if (s.size() == 1) return true;
    counter1.set();
    for (string &i : s)
    {
        counter2.reset();
        for (char j : i) counter2[j - 'a'] = true;
        counter1 &= counter2;
    }
    int ss = -1;
    for (int i = 0; i < 26; ++i)
    {
        if (counter1[i])
        {
            ss = i;
            break;
        }
    }
    if (ss == -1) return false;
    vector<vector<string>> help;
    mp.clear();
    for (int i = 0; i < s.size(); ++i)
    {
        sumka = "";
        newa = "";
        for (int j = 0; j < s[i].size(); ++j)
        {
            if (s[i][j] - 'a' != ss) newa += s[i][j];
            else sumka += char(j + '0');
        }
        if (mp.find(sumka) == mp.end())
        {
            mp[sumka] = help.size();
            help.push_back(vector<string>{newa});
        }
        else
        {
            help[mp[sumka]].emplace_back(newa);
        }
    }
    for (auto &i : help)
    {
        if (!solve(i)) return false;
    }
    return true;
}

signed main()
{
    cin.tie(0)->sync_with_stdio(false);
    int l, n;
    cin >> l >> n;
    vector<string> s(n);
    for (string &i : s) cin >> i;
    if (solve(s)) cout << "YES\n";
    else cout << "NO\n";
    return 0;
}