#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define mp make_pair

using namespace std;

const int N = (int)1e6 + 11;
const int INF = (int)1e6;

int a[N],b[N];
int ta[N],tb[N];

int n;

bool check(int k){
    for(int i = 0; i < n; i++){
        ta[i] = a[i];
        tb[i] = b[i];
    }
    deque<pair<int,int>> st;
    for(int i = 0; i < n; i++){
        st.push_back(mp(i,tb[i]));
    }
    bool ok1 = true;
    for(int i = 0; i < n; i++){
        while(!st.empty()){
            int id = st.front().first;
            int t = st.front().second;
            st.pop_front();
            if(abs(id-i) <= k)
            {
                int mn = min(t,ta[i]);
                t -= mn;
                ta[i] -= mn;
                tb[id] -= mn;
                if(t != 0)
                    st.push_front(mp(id,t));
                if(ta[i] == 0)
                    break;
            }
        }
        if(ta[i] > 0)
            ok1 = false;
    }
    while(!st.empty())
        st.pop_back();

    bool ok2 = true;
   for(int i = 0; i < n; i++){
        ta[i] = a[i];
        tb[i] = b[i];
    }
    for(int i = n - 1; i >= 0; i--){
        st.push_back(mp(i,tb[i]));
    }
    for(int i = n-1; i >= 0; i--){
        while(!st.empty()){
            int id = st.front().first;
            int t = st.front().second;
            st.pop_front();
            if(abs(id-i) <= k)
            {
                int mn = min(t,ta[i]);
                t -= mn;
                ta[i] -= mn;
                tb[id] -= mn;
                if(t != 0)
                    st.push_front(mp(id,t));
                if(ta[i] == 0)
                    break;
            }
        }
        if(ta[i] > 0)
            ok2 = false;
    }

    return ok1 | ok2;
}

signed main(){
    ios::sync_with_stdio(false);cin.tie(nullptr);

    cin >> n;

    int sum = 0;

    for(int i = 0; i < n; i++){
        cin >> a[i];
        sum += a[i];
    }

    for(int j = 0; j < n; j++){
        cin >> b[j];
        sum -= b[j];
    }

    if(sum > 0){
        cout << "-1\n";
        return 0;
    }

    int l = 0, r = INF;

    while(r - l > 1){
        int m = (l + r) / 2;
        if(check(m))
            r = m;
        else
            l = m + 1;
    }

    cout << (check(l) ? l : r);

    return 0;
}
