#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 2e5;
int a[N], prefMin[N], prefMax[N], sufMin[N], sufMax[N];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    prefMin[0] = a[0], prefMax[0] = a[0];
    for (int i = 1; i < n; ++i) {
        prefMin[i] = min(prefMin[i - 1], a[i]);
        prefMax[i] = max(prefMax[i - 1], a[i]);
    }
    sufMin[n - 1] = a[n - 1], sufMax[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        sufMin[i] = min(sufMin[i + 1], a[i]);
        sufMax[i] = max(sufMax[i + 1], a[i]);
    }
    cout << 1 << ' ';
    cout << fixed << setprecision(10);
    for (int i = 1; i < n; ++i) {
        long double a = prefMin[i - 1], b = prefMax[i - 1];
        long double x = sufMin[i], y = sufMax[i];
        if (b > y || abs(b - y) < 0.000001) {
            if (x > a) {
                cout << 1.0 - a / x << ' ';
            } else {
                cout << 0 << ' ';
            }
        } else { // b < y
            if (a > x) {
                cout << 1.0 - b / y << ' ';
            } else {
                long double t1 = 1.0 - b / y, t2 = 1.0 - a / x;
                cout << max(t1, t2) << ' ';
            }
        }
    }
    return 0;
}
