#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<int> a(n), b(n);

    for ( auto& el : a )
        cin >> el;

    for ( auto& el : b )
        cin >> el;

    for ( int i=0; i<n; i++ )
    {
        int x = max( 0, a[i]-b[i] );
        int y = max( 0, b[i]-a[i] );
        a[i] = x;
        b[i] = y;
    }

    int ans = 0;

    queue<pair<int,int>> q;
    queue<pair<int,int>> w;

    for ( int i=0; i<n; i++ )
    {
        if ( a[i] > 0 )
            q.push({ a[i], i });

        else if ( b[i] > 0 )
            w.push({ b[i], i });
    }

    while ( q.size() && w.size() )
    {
        int x = q.front().first;
        int p1 = q.front().second;

        int y = w.front().first;
        int p2 = w.front().second;

        int per = min( x, y );

        ans = max( ans, abs(p1-p2) );

        x -= per;
        y -= per;

        q.front().first = x;
        w.front().first = y;

        if ( x == 0 )
            q.pop();

        if ( y == 0 )
            w.pop();
    }

    if ( q.size() )
        cout << -1;

    else
        cout << ans;

    return 0;
}
