#include <bits/stdc++.h>

using namespace std;

int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<int> a(n), b(n);

    for ( auto& el : a )
        cin >> el;

    for ( auto& el : b )
        cin >> el;

    queue<pair<int,int>> f, s;

    for ( int i=0; i<n; i++ )
    {
        int mini = min( a[i], b[i] );
        a[i] -= mini;
        b[i] -= mini;

        if ( a[i] > 0 )
            f.push({ a[i], i });

        if ( b[i] > 0 )
            s.push({ b[i], i });
    }

    int ans = 0;

    while ( s.size() && f.size() )
    {
        int x = f.front().first;
        int p = f.front().second;

        int y = s.front().first;
        int q = s.front().second;

        int mini = min( x, y );
        x -= mini;
        y -= mini;

        ans = max( ans, abs(p-q) );

        f.front().first = x;
        s.front().first = y;

        if ( x == 0 )
            f.pop();

        if ( y == 0 )
            s.pop();
    }

    if ( f.size() )
        cout << -1;

    else
        cout << ans;

    return 0;
}
