
#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <iomanip>
using namespace std;

typedef long long ll;

ll n;

vector <ll> a;

double func(int k, double t) {
    double maxx = 0;
    double minn = 1000000000;
    double x;
    for(int i = 0; i < n; i++) {
        if(k <= i) {
            x = a[i] * (1.0-t);
        } else x = a[i];
        maxx = max(maxx, x);
        minn = min(minn, x);
    }
    return maxx - minn;
}

int main(){
    cin >> n;
    a.resize(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    double h = 1;
    cout << fixed << setprecision(11) << h <<  ' ';
    for(int k = 1; k < n; k++) {
        double l = 0;
        double r = 1;
        while(r - l > 1e-11) {
            double m = (l + r) / 2.0;
            double ff1 = func(k, m), ff2 = func(k, m+1e-11);
            if(ff1 < ff2) {
                    r = m;
            } else {
                    l = m+1e-11;
            }
        }
        cout << fixed << setprecision(11) << r << ' ' ;
    }
}
/*
4
6 14 70 1
70 3 16 5

5
1 2 3 4 5
5 4 3 2 1
*/
