#include <bits/stdc++.h>

#define int long long
#define point pair<int,int>
#define ff first
#define ss second
#define ld long double
#define show(x) cout << (#x) << ' ' << x << '\n'

using namespace std;

const int N = 3e5 + 128;
const int P = 53;
const int L = 1e6 + 128;

const int INF = 1e17 + 10;
const ld EPS = 1e-10;


int n, mx = -INF, mn = INF;
vector<int> v(N);
multiset<int> st;

ld f(ld x) {
    return max((ld)mx, (ld)*st.rbegin() * (1. - x)) -
        min((ld)mn, (ld)*st.begin() * (1. - x));
}

signed main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> v[i], st.insert(v[i]);

    cout << fixed << setprecision(12) << 1. << ' ';

    for (int i = 1; i < n; ++i) {
        st.erase(st.find(v[i - 1]));
        mn = min(mn, v[i - 1]);
        mx = max(mx, v[i - 1]);

        ld l = 0, r = 1;
        while (l + EPS < r) {
            ld m1 = (r + 2. * l) / 3.;
            ld m2 = (r * 2. + l) / 3.;

            if (f(m1) < f(m2))
                r = m2;
            else
                l = m1;
        }

        cout << fixed << setprecision(9) << (l + r) / 2. << ' ';
    }
}
