#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

ld q, w, e, R;

ld f(ld t) {
    ld Q = max(q, w * (1 - t)) - min(e, R * (1 - t));
    return Q;
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> pn(n);
    vector<int> px(n);
    vector<int> sn(n);
    vector<int> sx(n);
    int mn = 1000000000;
    int mx = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        mn = min(a[i], mn);
        mx = max(mx, a[i]);
        pn[i] = mn;
        px[i] = mx;
    }
    mx = 0;
    mn = 1000000000;
    for (int i = n - 1; i >= 0; i--) {
        mn = min(a[i], mn);
        mx = max(mx, a[i]);
        sn[i] = mn;
        sx[i] = mx;
    }
    vector<ld> ans(n);
    ans[0] = 1;
    for (int i = 1; i < n; i++) {
        ld l = 0;
        ld r = 1;
        q = px[i - 1];
        w = sx[i];
        e = pn[i - 1];
        R = sn[i];
        while (r - l > 0.000000000000001) {
            ld m1 = l + (r - l) / 3;
            ld m2 = l + 2 * (r - l) / 3;
            if (f(m2) > f(m1)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        ans[i] = l;
    }
    cout.precision(10);
    for (ld i: ans) {
        cout << i << ' ';
    }
    return 0;
}
