#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using ld = long double;
using pld = pair<ld, ld>;

const int ALPHABET_SIZE = 26, MAXLEN = 1e6;

/*struct Node {
    int go[ALPHABET_SIZE] = {0};
    bool is_end = false;
};

Node trie[MAXLEN];
int trie_size = 1;

bool can_go(int v, char ch) {
    return trie[v].go[ch - 'a'] != 0;
}

int go(int v, char ch) {
    return trie[v].go[ch - 'a'];
}

void create(int v, char ch) {
    trie[v].go
}*/
const int MAXN = 2 * 1e5 + 20;
const ll INF = 1e18 + 1e17;
const ld EPS = 1e-9;
ld a[MAXN], ans[MAXN], pmn[MAXN], pmx[MAXN], smn[MAXN], smx[MAXN], ssm[MAXN];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pmn[i] = INF;
        smn[i] = INF;
    }

    pmn[n] = smn[n] = INF;

    for (int i = 0; i < n; i++) {
        pmn[i + 1] = min(pmn[i], a[i]);
        pmx[i + 1] = max(pmx[i], a[i]);
    }

    for (int i = n - 1; i >= 0; i--) {
        smn[i] = min(smn[i + 1], a[i]);
        smx[i] = max(smx[i + 1], a[i]);
        ssm[i] = ssm[i + 1] + a[i];
    }

    for (int i = n - 1; i >= 0; i--) {
        ld l = 0, r = 1.0;
        for (int j = 0; j < 50; j++) {
            ld t1 = r - (r - l) / 3;
            ld t2 = l + (r - l) / 3;

            ld d1 = max(pmx[i], (1 - t1) * smx[i]) - min(pmn[i], (1 - t1) * smn[i]);
            ld d2 = max(pmx[i], (1 - t2) * smx[i]) - min(pmn[i], (1 - t2) * smn[i]);

            //cerr << i << " " << l << " " << r << " " << d1 << " " << d2 << "\n";

            if (d1 > d2) {
                r = t1;
            } else {
                l = t2;
            }
        }

        ans[i] = (l + r) / 2;
    }

    cout << fixed << setprecision(10);
    for (int i = 0; i < n; i++) {
        cout << ans[i] << " ";
    }
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
