#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stdlib.h>
#include <math.h>
#include <cmath>
#include <map>
#include <queue>
#include <iomanip>
#include <stack>

typedef long long ll;

using namespace std;

//ll n,m;
const ll MOD=998244353ll;

void IO()
{
    cin.tie(0);
    cout.tie(0);
    cout.sync_with_stdio(0);
}

ll fak(ll n)
{
    ll ans=1;
    for(ll i=1;i<=n;i++)
    {
        ans*=i;
        ans%=MOD;
    }
    return ans%MOD;
}

ll pw(ll n,ll k)
{
    if(k==0)
    {
        return 1;
    }
    if(k%2==0)
    {
        ll m=pw(n,k/2);
        return (m*m)%MOD;
    }
    return (pw(n,k-1)*n)%MOD;
}

ll obr(ll n)
{
    return pw(n,MOD-2ll);
}

int main() {
    ll n,m;
    cin>>n>>m;
    //cout<<fak(m+n-2)<<' '<<obr(3)<<' ';
    ll k=(((fak(m+n-2ll)*obr(fak(n-1ll)))%MOD)*obr(fak(m-1ll)))%MOD;
    cout<<((((k+1ll)*k)%MOD)*obr(2ll))%MOD;
}