#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stdlib.h>
#include <math.h>
#include <cmath>
#include <map>
#include <queue>
#include <iomanip>
#include <stack>

typedef long long ll;

using namespace std;


int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    stack<int> q1;
    stack<int> q2;
    int p = 1;
    for (int i = 0; i < n; ++i) {
        if (a[i] == p) {
            cout << 1 << '\n';
            cout << -1 << '\n';
            p++;
            while (!q1.empty() && q1.top() == p) {
                cout << -1 << '\n';
                q1.pop();
                p++;
            }
            while (!q2.empty() && q2.top() == p) {
                cout << -2 << '\n';
                q2.pop();
                p++;
            }
        } else {
            if (q1.empty() || q1.top() > a[i]) {
                cout << 1 << '\n';
                q1.push(a[i]);
            } else {
                cout << 2 << '\n';
                q2.push(a[i]);
            }
        }
    }
    while (!q1.empty() && q1.top() == p) {
        cout << -1 << '\n';
        q1.pop();
        p++;
    }
    while (!q2.empty() && q2.top() == p) {
        cout << -2 << '\n';
        q2.pop();
        p++;
    }
}