#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

namespace x = __gnu_pbds;
template <typename T>
using ordered_set = x::tree<T, x::null_type, less<T>, x::rb_tree_tag, x::tree_order_statistics_node_update>;

template <typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T>>;

#define x first
#define y second
#define all(x) begin(x), end(x)
using ll = int;
using ld = long double;

ll go[1000005][26];
ll down[1000005][26];
ll up[1000005][21];
ll cnt[1000005];
ll sz[1000005];
ll ans[1000005];

ll root = 1;
ll ind = 1;

void add(string s) {
    ll v = root;
    for (ll i = 0; i < s.size(); ++i) {
        ll c = s[i] - 'a';
        if (!go[v][c]) {
            go[v][c] = ++ind;
        }
        v = go[v][c];
    }
    cnt[v]++;
}

ll dh[1000005];

string s;
void make(ll v = root, ll sm = 0, ll d = 0) {
    dh[v] = d;
    ans[v] = sm;
    sm += cnt[v];
    sz[v] = cnt[v];
    for (ll c = 0; c < 26; ++c) {
        if (go[v][c]) {
            up[go[v][c]][0] = v;
            make(go[v][c], sm, d + 1);
            sm += sz[go[v][c]];
            sz[v] += sz[go[v][c]];
            down[v][c] = down[go[v][c]][c];
        }
    }
    for (ll c = 0; c < 26; ++c) {
        if (!go[v][c] || d >= s.size()) down[v][c] = v;
    }
}

ll raise(ll v, ll d) {
    for (ll j = 20; j >= 0; --j) {
        if ((dh[v] - d) >= (1 << j)) {
            v = up[v][j];
        }
    }
    return v;
}

vector<pair<ll, ll>> st;
ll v = 1;


void change(ll p, ll c) {
    // cout << st.size() << endl;
    while (st.back().first >= p) {
        st.pop_back();
    }
    v = raise(v, p);
    st.emplace_back(p, c);
    if (dh[v] == p) v = down[v][c];
}

ll get(ll v) {

    if (dh[v] < s.size()) {
        pair<ll, ll> tmp = {dh[v], 123123123};
        ll i = upper_bound(st.begin(), st.end(), tmp) - st.begin() - 1;
        ll ret = ans[v] + cnt[v];
        for (ll j = 0; j < st[i].second; ++j) {
            ret += sz[go[v][j]];
        }
        return ret;
    }
    return ans[v];
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    ll n, q;
    cin >> n >> q;
    cin >> s;
    for (ll i = 0; i < n; ++i) {
        string t;
        cin >> t;
        add(t);
    }

    make();

    st.emplace_back(-1, -1);

    for (ll sz = 1; sz <= 20; ++sz) {
        for (ll v = 1; v <= ind; ++v) {
            up[v][sz] = up[up[v][sz - 1]][sz - 1];
        }
    }


    bool fl = false;
    for (ll i = 0; i < s.size(); ++i) {
        ll c = s[i] - 'a';
        if (go[v][c] && !fl) {
            v = go[v][c];
        } else {
            fl = true;
        }
        st.emplace_back(i, c);
    }


    cout << get(v) << endl;
    while (q--) {
        // cout << q << endl;
        ll i;
        char c;
        cin >> i >> c;
        c -= 'a';
        --i;
        change(i, c);
        cout << get(v) << '\n';
    }

}