#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

namespace x = __gnu_pbds;
template <typename T>
using ordered_set = x::tree<T, x::null_type, less<T>, x::rb_tree_tag, x::tree_order_statistics_node_update>;

template <typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T>>;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

#define int ll

const int N = 2e5 + 10, INF = 0x3f3f3f3f;
const ld EPS = 1e-8;

int a[N];
int pmx[N], pmn[N], smx[N], smn[N];

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	pmn[0] = +INF;
	pmx[0] = -INF;
	smn[n] = +INF;
	smx[n] = -INF;
	for (int i = 0; i < n; ++i) {
		pmn[i + 1] = min(pmn[i], a[i]);
		pmx[i + 1] = max(pmx[i], a[i]);
	}
	for (int i = n; i--; ) {
		smn[i] = min(smn[i + 1], a[i]);
		smx[i] = max(smx[i + 1], a[i]);
	}
	for (int i = 0; i < n; ++i) {
		ld cmn = pmn[i], cmx = pmx[i];
		ld bst = +INF, t_where = -1;
		auto to_check = [&](ld t) {
			if (t < 0 || t > 1) {
				return;
			}
			ld tmn = smn[i] * t, tmx = smx[i] * t;
			ld cans = max(tmx, cmx) - min(cmn, tmn);
			if (cans < bst) {
				bst = cans;
				t_where = 1 - t;
			} else if (abs(cans - bst) < EPS && 1 - t > t_where) {
				bst = cans;
				t_where = 1 - t;
			}
		};
		to_check(0);
		to_check(1);
		if (i != 0) {
			to_check(smn[i] / ld(pmn[i]));
			to_check(smx[i] / ld(pmn[i]));
			to_check(smn[i] / ld(pmx[i]));
			to_check(smx[i] / ld(pmx[i]));
			to_check(pmn[i] / ld(smn[i]));
			to_check(pmx[i] / ld(smn[i]));
			to_check(pmn[i] / ld(smx[i]));
			to_check(pmx[i] / ld(smx[i]));
		}
		cout << setprecision(10) << fixed << t_where << " ";
	}
}