#include<bits/stdc++.h>
#define f first
#define s second
#define fi first
#define se second
#define vec vector
#define double long double
#define int long long
#define _ << ' '  <<

typedef long long ll;

using namespace std;

struct Par{
    int a, b, c;
    Par(){};
    Par(int x, int y, int z) {
        a = x;
        b = y;
        c = z;
    }
    double get(double x) {
        return x * x * a + x * b + c;
    }
};

vec<Par> v1, v2;
double f1(double x) {
    double mx = -1e18;
    for (int i = 0; i < v1.size(); ++i) {
        mx = max(mx, v1[i].get(x));
    }
    return mx;
}
double f2(double x) {
    double mn = 1e18;
    for (int i = 0; i < v2.size(); ++i) {
        mn = min(mn, v2[i].get(x));
    }
    return mn;
}

void solve() {
    cout << fixed << setprecision(10);
    int n; cin >> n;
    for (int i = 0; i < n; ++i) {
        int a, b, c; cin >> a >> b >> c;
        if (a < 0) {
            v2.push_back(Par(a, b, c));
        } else {
            v1.push_back(Par(a, b, c));
        }
    }
    if (v1.size() == 0) {
        cout << (double)(-v2[0].b) / v2[0].a << ' ' << -1e30;
        return;
    }
    if (v2.size() == 0) {
        cout << (double)(-v1[0].b) / v1[0].a << ' ' << 1e30;
        return;
    }
    double x1, x2;
    {
        double l = -1e9 - 1000, r = 1e9 + 1000;
        for (int i = 0; i < 100; ++i) {
            double m1 = l + (r - l) / 3;
            double m2 = l + (r - l) / 3 * 2;
            double a = f1(m1), b = f1(m2);
            if (a > b) {
                l = m1;
            } else r = m2;
        }
        x1 = l;
    }
    {
        double l = -1e9 - 1000, r = 1e9 + 1000;
        for (int i = 0; i < 100; ++i) {
            double m1 = l + (r - l) / 3;
            double m2 = l + (r - l) / 3 * 2;
            double a = f2(m1), b = f2(m2);
            if (a < b) {
                l = m1;
            } else r = m2;
        }
        x2 = l;
    }
    //cout << x1 << ' ' << x2 << endl;
    double ans;
    {
        double l = min(x1, x2), r = max(x1, x2);
        for (int i = 0; i < 100; ++i) {
            double m1 = l + (r - l) / 3;
            double m2 = l + (r - l) / 3 * 2;
            double a = f2(m1) - f1(m1), b = f2(m2) - f1(m2);
            if (a < b) {
                l = m1;
            } else r = m2;
        }
        ans = l;
    }
    cout << ans << ' ' << (f1(ans) + f2(ans)) / 2.0;
}

signed main() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
#endif // LOCAC

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}

