#include<bits/stdc++.h>

#define int long long

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << " " <<

using namespace std;

int MOD = 1e15+7;
int x = 31;

bool get_ans(vector<string> &sp, vector<bool> used) {
    if (sp.size() == 1) {
        return true;
    }
    vector<int> cnt(26);
    int sz = sp.size();
    for (int i = 0; i < sz; ++i) {
        vector<bool> now(26);
        for (auto c : sp[i]) {
            now[c - 'a'] = true;
        }
        for (int j = 0; j < 26; ++j) {
            if (now[j]) {
                ++cnt[j];
            }
        }
    }
    for (int j = 0; j < 26; ++j) {
        if (!used[j] && cnt[j] == sz) {
            bool fl = true;
            map<int, vector<string> > mp;
            for (int i = 0; i < sz; ++i) {
                int hsh = 0;
                int pw = 1;
                for (auto c : sp[i]) {
                    if (c - 'a' == j) {
                        hsh += (c - 'a' + 1) * pw;
                        hsh %= MOD;
                    }
                    pw *= x;
                    pw %= MOD;
                }
                mp[hsh].push_back(sp[i]);
            }
            used[j] = true;
            for (auto par : mp) {
                if (!get_ans(par.second, used)) {
                    fl = false;
                    break;
                }
            }
            return fl;
        }
    }
    return false;
}

void solve() {
    int l, n;
    cin >> l >> n;
    vector<string> sp(n);
    for (int i = 0; i < n; ++i) {
        cin >> sp[i];
    }
    vector<bool> used(26);
    if (get_ans(sp, used)) {
        cout << "YES" << endl;
    }
    else {
        cout << "NO" << endl;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}

