#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#define sz(x) (int)x.size()
#define all(c) c.begin(), x.end()
#define eb emplace_back
#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define umap unordered_map
#define uset unordered_set
//#define LONG
using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;

const int inf9 = 1e9 + 10;
const ll inf18 = 1e18 + 10;

#ifdef LONG
#define int ll
#define inf inf18
#else
#define inf inf9
#endif

template <typename T1, typename T2> istream& operator>>(istream& is, pair <T1, T2>& a){is >> a.ff >> a.ss;return is;}
template <typename T1, typename T2> ostream& operator<<(ostream& os, pair <T1, T2> a){os << "(" << a.ff << ", " << a.ss << ")";return os;}
template <typename T> istream& operator>>(istream& is, vector <T>& a){for (int i = 0; i < a.size(); i++){is >> a[i];}return is;}
template <typename T> ostream& operator<<(ostream& os, vector <T> a){for (int i = 0; i < a.size(); i++){os << a[i] << " ";}os << endl;return os;}
template <typename T> void print(T a){for (auto x : a){cout << x << " ";}cout << endl;}

const int B = 239, M = 1e9 + 7;
int l;
vector <string> a;
vector <vector <int> > h;

int makehash(vector <int>& c)
{
    int hash = 0;
    for (int i = 0; i < c.size(); i++)
    {
        hash = (hash * B + c[i] + 31) % M;
    }
    return hash;
}

bool answer(vector <int>& gr, vector <int> used)
{
    for (int c = 0; c < 26; c++)
    {
        if (!used[c])
        {
            bool f = true;
            umap <int, vector <int> > d;
            for (auto i : gr)
            {
                if (h[i][c] == 0)
                {
                    f = false;
                    break;
                }
                d[h[i][c]].pb(i);
            }
            used[c] = 1;
            for (auto x : d)
            {
                if (x.ss.size() > 1)
                {
                    f = (f && answer(x.ss, used));
                }
            }
            if (f)
            {
                return true;
            }
        }
    }
    return false;
}

void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

int32_t main()
{
    fastio();
    int n;
    cin >> l >> n;
    a.resize(n);
    h.assign(n, vector <int> (26));
    cin >> a;
    for (int c = 0; c < 26; c++)
    {
        for (int i = 0; i < n; i++)
        {
            vector <int> t;
            for (int j = 0; j < l; j++)
            {
                if (a[i][j] == c + 'a')
                {
                    t.pb(j + 1);
                }
            }
            h[i][c] = makehash(t);
        }
    }
    vector <int> z(n), used(26);
    for (int i = 0; i < n; i++)
    {
        z[i] = i;
    }
    cout << (answer(z, used) ? "YES" : "NO");
}