#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 1e5 + 13;
const int INF = 1e9;
const ll LLINF = 1e18;

vector <int> a0(1e6), b0(1e6);

bool f(int m, int n) {
    deque <int> c, d;
    // cout << "m: " << m << endl;
    vector <int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        a[i] = a0[i];
        b[i] = b0[i];
    }
    for (int i = 0; i < n; ++i) {
        c.push_back(i);
        while (c.front() < i - m) c.pop_front();

        if (!d.empty() && d.front() < i - m) return false;
        while (!d.empty() && b[i] > 0) {
            int k = min(b[i], a[d.front()]);
            a[d.front()] -= k;
            if (a[d.front()] == 0) d.pop_front();
            b[i] -= k;
        }
        if (b[i] == 0) c.pop_back();
/*
        if (m == 0) {
            cout << "i: " << i << endl;
            cout << "a: ";
            for (int i = 0; i < n; ++i) cout << a[i] << ' ';
            cout << endl << "b: ";
            for (int i = 0; i < n; ++i) cout << b[i] << ' ';
            cout << endl << "c: ";
            for (auto i : c) cout << i << ' ';
            cout << endl << "d: ";
            for (auto i : d) cout << i << ' ';
            cout << endl;
        }
*/
        while (!c.empty() && a[i] > 0) {
            int k = min(b[c.front()], a[i]);
            b[c.front()] -= k;
            if (b[c.front()] == 0) c.pop_front();
            a[i] -= k;
        }
        if (a[i] > 0) d.push_back(i);
        /*
        if (m == 0) {
            cout << "i: " << i << endl;
            cout << "a: ";
            for (int i = 0; i < n; ++i) cout << a[i] << ' ';
            cout << endl << "b: ";
            for (int i = 0; i < n; ++i) cout << b[i] << ' ';
            cout << endl << "c: ";
            for (auto i : c) cout << i << ' ';
            cout << endl << "d: ";
            for (auto i : d) cout << i << ' ';
            cout << endl;
        }
        */
    }
    if (!d.empty()) return false;
    return true;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> a0[i];
    for (int i = 0; i < n; ++i) cin >> b0[i];

    int l = -1, r = n + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (f(m, n)) r = m;
        else l = m;
        // cout << l << " " << r << endl;
    }
    // cout << l << ' ' << r;
    if (r > n) cout << -1;
    else cout << r;

    return 0;
}

