#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<int> a(n);
	vector<int> b(n);
	ll sa = 0, sb = 0;
	for (auto& i : a) cin >> i, sa += i;
	for (auto& i : b) cin >> i, sb += i;
	if (sa > sb) {
		cout << "-1\n";
	}
	else {
		int k, i, j, m, cnt;
		for (k = 0; k <= n; ++k) {
			cnt = 0;
			for (m = 0; m < n; ++m) {
				if (a[m] == 0)
					++cnt;
				else {
					i = m - k;
					if (i >= 0) {
						if (a[m] <= b[i]) {
							b[i] -= a[m];
							a[m] = 0;
							++cnt;
						}
						else {
							a[m] -= b[i];
							b[i] = 0;
						}
					}
					j = m + k;
					if (a[m] != 0 && k != 0 && j < n) {
						if (a[m] <= b[j]) {
							b[j] -= a[m];
							a[m] = 0;
							++cnt;
						}
						else {
							a[m] -= b[j];
							b[j] = 0;
						}
					}
				}
			}
			if (cnt == n) {
				break;
			}
		}
		if (k == n + 1)
			cout << "-1\n";
		else
			cout << k;
	}


	return 0;
}

/*
4
6 14 70 1
70 3 16 5
*/
