#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 3, x1 = 37, x2 = 43, b1 = 1e9 + 7, b2 = 1e9 + 9;

string s[maxn];

bool solve(vector <int>& pos) {
    if (pos.size() <= 1) {
        return 1;
    }
    vector <int> cnt(28);
    for (int i = 0; i < pos.size(); i++) {
        vector <bool> have(28);
        for (int j = 0; j < s[pos[i]].size(); j++) {
            have[s[pos[i]][j] - 'a'] = 1;
        }
        for (int i = 0; i < 28; i++) {
            cnt[i] += have[i];
        }
    }
    map<pair <int, int>, vector <int> > m;
    for (int i = 0; i < pos.size(); i++) {
        bool f = 0;
        pair <int, int> h = {0, 0};
        for (int j = 0; j < s[pos[i]].size(); j++) {
            if (cnt[s[pos[i]][j] - 'a'] == pos.size()) {
                f = 1;
                h = {(h.first * x1 + s[pos[i]][j]) % b1, (h.second * x2 + s[pos[i]][j]) % b2};
            } else {
                h = {(h.first * x1 + 243) % b1, (h.second * x2 + 243) % b2};
            }
        }
        if (!f) {
            return 0;
        }
        m[h].push_back(pos[i]);
    }
    if (m.size() == 1) {
        return 0;
    }
    for (pair <pair <int, int>, vector <int> > i : m) {
        if (!solve(i.second)) {
            return 0;
        }
    }
    return 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, l;
    cin >> n >> l;
    vector <int> pos;
    map<pair <int, int>, bool> have;
    for (int i = 0; i < l; i++) {
        cin >> s[i];
        pair <int, int> h = {0, 0};
        for (int j = 0; j < s[i].size(); j++) {
            h = {(h.first * x1 + s[i][j]) % b1, (h.second * x2 + s[i][j]) % b2};
        }
        if (!have[h])
            pos.push_back(i);
        have[h] = 1;
    }
    cout << (solve(pos) ? "YES" : "NO");
    return 0;
}
