#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <iomanip>
#include <stack>
#include <unordered_map>

using namespace std;

#define ll long long
#define ull unsigned long long
#define add push_back
#define mpr make_pair
#define ft first
#define sc second
#define all(v) v.begin(), v.end()
#define sz(v) (ll)v.size()
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);



const int N = 1005;

bool isall[30];
bool isnow[30];

vector<string> v;

unordered_map<string, bool> mp;

int main() {

	fastio;

	ll l, n;
	cin >> l >> n;

	FOR(i, 0, 28)
	{
		isall[i] = 1;
	}

	FOR(i, 1, n + 1)
	{
		string s;
		cin >> s;
		v.add(s);
		FOR(j, 0, sz(s))
		{
			isnow[s[j] - 'a'] = 1;
		}
		FOR(j, 0, 28)
		{
			isall[j] &= isnow[j];
			isnow[j] = 0;
		}
	}
	bool check = true;
	FOR(i, 0, sz(v))
	{
		string noww = "";
		FOR(j, 0, sz(v[i]))
		{
			if (isall[v[i][j] - 'a'])
			{
				noww += v[i][j];
			}
			else
			{
				noww += '*';
			}
		}
		cout << noww << endl;
		if (mp.find(noww) != mp.end())
		{
			check = false;
			break;
		}
		else
		{
			mp[noww] = 1;
		}
	}
	cout << "NO\0YES" + 3 * (check) << endl;

	return 0;
}