#include <bits/stdc++.h>

using namespace std;

#define pii pair<int, int>
#define f first
#define s second
#define double long double

pair<double, double> quadratic(double a, double b, double c){
    double d = b * b - 4 * a * c;
    double x1 = (-b + sqrt(d)) / (2.0 * a);
    double x2 = (-b - sqrt(d)) / (2.0 * a);

    return {x1, x2};
}

int main() {
    //cout << quadratic(1, -12, -4).f << " " << quadratic(1, -12, -4).s << "\n";

    int n = 4;
    vector<pair<double, int>> t(n);
    for (int i = 0; i < n; ++i) cin >> t[i].f, t[i].s = i+1;

    sort(t.begin(), t.end());

    double best = 0;
    vector<pair<double, int>> res;
    for (int i = 0; i < n; ++i) res.push_back({0.0, i+1});

    do{

        double x = t[0].f * t[3].f + t[1].f + t[2].f;
        double y = t[1].f * t[2].f + t[0].f + t[3].f;

        if (abs(x - y) < 0.00000000001){
            if (x - best > 0.00000000001) res = t, best = 1.0*x;
        }
        else if (x > y){
            double dif = x - y;
            double mx = max(t[0].f, t[3].f);

            double k = 1.0 * dif / (mx - 1.0);
            if (1.0*y - k - best > 0.00000000001){
                best = 1.0*y - k;
                res = t;
                if (t[0].f < t[3].f) res[0].f -= k;
                else res[3].f -= k;
            }
        } else{
            double dif = y - x;
            double mx = max(t[1].f, t[2].f);

            double k = 1.0 * dif / (mx - 1.0);
            if (1.0*x - k - best > 0.00000000001){
                best = 1.0*x - k;
                res = t;
                if (t[1].f < t[2].f) res[1].f -= k;
                else res[2].f -= k;
            }
        }


    } while (next_permutation(t.begin(), t.end()));

    cout.precision(11);

    for (int i = 0; i < n; ++i) cout << res[i].s << " ";
    cout << "\n";
    for (int i = 0; i < n; ++i) cout << fixed << res[i].f << " ";
    return 0;
}
