#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,sse4,popcnt")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <complex>
#include <array>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <cstring>
#include <bitset>
#include <list>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cassert>

#define sq(x) ((x) * (x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errp(x) cerr << "["#x"]  {" << ((x).first) << ", " << ((x).second) << "}\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2> inline bool relax(T1& a, const T2& b) {
    return a > b ? a = b, true : false;
}

template <typename T1, typename T2> inline bool strain(T1& a, const T2& b) {
    return a < b ? a = b, true : false;
}

// :::::::::::::::::::::::::::::::

// rusfree8049
// edefegecafy

const int N = 1e5 + 5;

ld a[N], b[N], c[N];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i] >> b[i] >> c[i];
    ld ry = 1e50, ly = -1e50;
    auto f = [&](ld x) -> ld {
        ry = 1e50;
        ly = -1e50;
        for (int i = 0; i < n; ++i) {
            ld y = a[i] * x * x + b[i] * x + c[i];
            if (a[i] > 0) {
                strain(ly, y);
            } else {
                relax(ry, y);
            }
        }
        return ry - ly;
    };
    
    ld l = -1e18, r = 1e18;
    for (int t = 0; t < 300; ++t) {
        ld th = (r - l) / 3.0;
        if (f(l + th) < f(r - th))
            l += th;
        else
            r -= th;
    }
    cout.precision(10);
//    err(f(l));
    f(l);
    cout << fixed << l << ' ' << ly << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);
    
    int t = 1;
    //    cin >> t;
    while (t--)
        solve();
    
    return 0;
}
