#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,sse4,popcnt")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <complex>
#include <array>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <cstring>
#include <bitset>
#include <list>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cassert>

#define sq(x) ((x) * (x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errp(x) cerr << "["#x"]  {" << ((x).first) << ", " << ((x).second) << "}\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2> inline bool relax(T1& a, const T2& b) {
    return a > b ? a = b, true : false;
}

template <typename T1, typename T2> inline bool strain(T1& a, const T2& b) {
    return a < b ? a = b, true : false;
}

// :::::::::::::::::::::::::::::::

// rusfree8049
// edefegecafy

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<pair<int, int>> b;
    for (int i = 0; i < n; ++i)
        b.emplace_back(a[i], i);
    sort(b.begin(), b.end());
    
    
    vector<int> wh(n, 1);
    vector<int> st1, st2;
    vector<int> res;
    for (int i = 0; i < n; ++i) {
        res.push_back(1);
        st1.push_back(i);
    }
    for (int rep = 0; rep < n; ++rep) {
        auto [x, ind] = b[rep];
        int w = wh[ind];
        if (w == 1) {
            while (st1.back() != ind) {
                int y = st1.back();
                st1.pop_back();
                st2.push_back(y);
                wh[y] = 2;
                res.push_back(12);
            }
            res.push_back(-1);
            st1.pop_back();
        } else {
            while (st2.back() != ind) {
                int y = st2.back();
                st2.pop_back();
                st1.push_back(y);
                wh[y] = 1;
                res.push_back(21);
            }
            res.push_back(-2);
            st2.pop_back();
        }
    }
    
    assert(res.size() <= (int)2e6);
    for (int x : res)
        cout << x << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);
    
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    
    return 0;
}
