#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
using namespace std;
typedef long long ll;
typedef long double ld;
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cout << fixed << setprecision(20);
    cin >> n;
    ll prefmax[n];
    ll prefmin[n];
    ll suffmax[n];
    ll suffmin[n];
    ll a[n];
    for(ll i = 0; i < n; ++i) cin >> a[i];
    prefmin[0] = a[0];
    prefmax[0] = a[0];
    suffmin[n - 1] = a[n - 1];
    suffmax[n - 1] = a[n - 1];
    for(ll i = 1; i < n; ++i){
        prefmin[i] = min(prefmin[i - 1], a[i]);
        prefmax[i] = max(prefmax[i - 1], a[i]);
    }
    for(ll i = n - 2; i >= 0; --i){
        suffmin[i] = min(suffmin[i + 1], a[i]);
        suffmax[i] = max(suffmax[i + 1], a[i]);
    }
    cout << 1.00 << " ";
    for(ll i = 1; i < n; ++i){
        ld t1 = (ld)(suffmin[i] - prefmin[i - 1]) / (ld)suffmin[i];
        ld t2 = (ld)(suffmax[i] - prefmax[i - 1]) / (ld)suffmax[i];
        if(t1 >= 0 && t2 >= 0) {
            if(t1 > t2) cout << t1 << " ";
            else cout << t2 << " ";
        }
        else if(t1 < 0 && t2 < 0) cout << 0.0 << ' ';
        else if(t2 < 0) cout << t1 << ' ';
        else if(t1 < 0) cout << t2 << ' ';

    }
}
