#include <bits/stdc++.h>
#define ll long long
#define all(v) v.begin(), v.end()
#define ld long double
using namespace std;

const int mxn = 2e5 + 10;
ld mas[mxn], prmin[mxn], prmax[mxn], ans[mxn];

ld eps = 1e-12;

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> mas[i];
    }

    prmin[0] = 1e15;
    prmax[0] = -1e15;
    for (int i = 1; i < n; ++i) {
        prmin[i] = min(prmin[i-1], mas[i-1]);
        prmax[i] = max(prmax[i-1], mas[i-1]);
    }
    ld mx = -1e15, mn = 1e15;
    for (int k = n-1; k >= 0; --k) {
        ld mx0 = prmax[k];
        ld mn0 = prmin[k];
        mx = max(mx, mas[k]);
        mn = min(mn, mas[k]);
        ld l = 0, r = 1;
        for (int iter = 0; iter < 40; ++iter) {
            ld a = (l + r) / 2;
            ld b = a + eps;
            ld s1 = max(mx0, mx * a) - min(mn0, mn * a);
            ld s2 = max(mx0, mx * b) - min(mn0, mn * b);

            if (abs(s1 - s2) < eps || s1 < s2) {
                r = b;
            } else {
                l = a;
            }
        }
        //cout << l << ' ';
        ans[k] = 1-l;
    }

    cout.precision(15);
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << ' ';
    }

}








