#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <algorithm>
#include<vector>
#include<queue>
#include<set>
#include<map>
#include<math.h>
#include<string>
#include<random>
#include<cmath>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define endl '\n'
#define all(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back

const int N = 2e5 + 10;

string str[N];

const int mod = 1e9 + 7;
const int p = 259;

int h[N][30];
int sim[N];

vector<pii> v;

void rec(int l, int r, int m)
{
	if (l + 1 == r)
		return;
	int m1 = (1LL << 30) - 1;
	for (int i = l; i < r; i++)
	{
		m1 &= (sim[v[i].second]);
	}
	int now = -1;
	for (int i = 0; i < 26; i++)
	{
		if ((m1 & (1 << i)) && !(m & (1 << i)))
		{
			now = i;
		}
	}
	if (now == -1)
	{
		cout << "NO";
		exit(0);
	}
	for (int i = l; i < r; i++)
	{
		v[i].first = h[v[i].second][now];
	}
	sort(v.begin() + l, v.begin() + r);
	int last = l;
	for (int i = l + 1; i <= r; i++)
	{
		if (i == r || v[i].first != v[i - 1].first)
		{
			rec(last, i, (m | (1 << now)));
			last = i;
		}
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, l;
	cin >> l >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> str[i];
		sim[i] = 0;
		for (int j : str[i])
		{
			sim[i] |= (1 << (j - 'a'));
		}
	}
	for (char x = 'a'; x <= 'z'; x++)
	{
		for (int i = 0; i < n; i++)
		{
			h[i][x - 'a'] = 0;
			int powp = 1;
			for (char j : str[i])
			{
				if (j == x)
				{
					h[i][x - 'a'] += powp;
					h[i][x - 'a'] %= mod;
				}
				powp *= p;
				powp %= mod;
			}
		}
	}
	for (int i = 0; i < n; i++)
	{
		v.push_back({ 0,i });
	}
	rec(0, v.size(), 0);
	cout << "YES";
}