//
// Created by olymp on 12.12.2021.
//

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <string>
#include <numeric>
#include <cmath>
#include <bitset>
#include <set>
#include <iomanip>
#include <cassert>

using namespace  std;
#define int long long

typedef long long ll;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) (a).begin(), (a).end()

signed main() {
    int32_t n;
    std::cin >> n;
    std::cout << std::setprecision(20) << std::fixed;

    if(n == 1) {
        std::cout << 1.0 << "\n";
        return 0;
    }

    int32_t* arr = new int32_t[n];
    for(int32_t i = 0; i < n; i++)
        std::cin >> arr[i];
        //arr[i] = 1 + rand() % 100;

    int32_t* suf_min = new int32_t[n + 1];
    suf_min[0] = INT32_MAX;
    for(int32_t i = 1; i <= n; i++)
        suf_min[i] = std::min(arr[n - i], suf_min[i - 1]);

    int32_t* suf_max = new int32_t[n + 1];
    suf_max[0] = INT32_MIN;
    for(int32_t i = 1; i <= n; i++)
        suf_max[i] = std::max(arr[n - i], suf_max[i - 1]);

    std::cout << 1.0 << " ";

    int32_t min = arr[0], max = arr[0];
    for(int32_t i = 1; i < n; i++) {
        //prefix i is fixed
        long double max_cur = suf_max[n - i];
        long double min_cur = suf_min[n - i];

        long double t = 1;
        if(max_cur >= max) {
            t = (long double)max / max_cur;
        }
        max_cur *= t;
        min_cur *= t;

        if(min_cur > min) {
            t *= min / min_cur;
        }

        std::cout << 1.0L - t << (i != n - 1 ? " " : "");

        max = std::max(max, arr[i]);
        min = std::min(min, arr[i]);
    }
    std::cout << "\n";
}

