//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

// Author:@AKSUM

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int,int> p32;
typedef pair<ll,ll> p64;
typedef pair<double,double> pdd;
typedef vector<ll> v64;
typedef vector<int> v32;
typedef vector<vector<int> > vv32;
typedef vector<vector<ll> > vv64;
typedef vector<vector<vector<ll>>> vvv64;
typedef vector<vector<p64> > vvp64;
typedef vector<p64> vp64;
typedef vector<p32> vp32;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<string> vs;
typedef vector<vs> vvs;
typedef complex<ll> Point64;
typedef complex<ld> Pointld;
ll MOD = 1791791791;
double eps = 1e-12;
#define X real()
#define Y imag()
#define forn(i,e) for(ll i = 0; i < e; i++)
#define forsn(i,s,e) for(ll i = s; i < e; i++)
#define rforn(i,s) for(ll i = s; i >= 0; i--)
#define rforsn(i,s,e) for(ll i = s; i >= e; i--)
#define ln "\n"
#define dbg(x) cout<<#x<<" = "<<x<<ln
#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define th third
#define INF 2e18
#define fast_cin() ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)
#define all(x) (x).begin(), (x).end()
#define M(x, ...) __VA_ARGS__
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
template<typename T,typename U,typename V>
struct Triple{
    T first;
    U second;
    V third;
    Triple(T first,U second,V third):first(first),second(second),third(third){}
    Triple(){}
};

const ll M = 26, mod = 1791791791, maxP = 1e6 + 1;
v64 powers;

bool dfs(vb& used,vs& v){
    if(v.size() == 1){
        return true;
    }
    forn(Z, M){
        if(!used[Z]){
            char c = 'a' + Z;
            unordered_map <ll, v64> q;
            forn(i,v.size()) {
                ll x = 1;
                forn(j, v[i].size()) {
                    if (v[i][j] == c) x = (x * powers[j]) % mod;
                } q[x].pb(i);
            }
            if(q.size() > 1){
//                cerr << "AAA" << ln;
                used[Z] = true;
                for(auto i : q) {
                    vs cur;
                    for(auto j : i.second){
                        cur.pb(v[j]);
//                        cout << v[j] << " ";
                    }
//                    cout << ln;
                    bool a = dfs(used,cur);
                    if(!a){
                        used[Z] = false;
                        return false;
                    }
                } used[Z] = false;
                return true;
            }
        }
    }

    return false;
}

int main(){
    fast_cin();

    powers.resize(maxP);
    powers[0] = 1;
    forsn(i,1,maxP) powers[i] = (powers[i - 1] * 2) % mod;

    ll l,n;
    cin >> l >> n;
    vs v;
    forn(i,n){
        string s;
        cin >> s;
        v.pb(s);
    }
    vb used(26,false);

    bool a = dfs(used,v);

    if(a){
        cout << "YES" << ln;
    }
    else{
        cout << "NO" << ln;
    }
}