#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <random>
#include <time.h>
#include <map>

using namespace std;


#define ll long long
#define ve vector

mt19937_64 rng(time(NULL));

ll rand(ll l, ll r) {
	return uniform_int_distribution<ll>(l, r)(rng);
}

const ll inf = 1e18 + 9;

int main() {
	int n;
	cin >> n;
	ve <ll> maxp(n + 1, -inf), maxs(n + 1, -inf), minp(n + 1, inf), mins(n + 1, inf);
	ve<ll> a(n);
	for (auto& it : a) {
		cin >> it;
	}
	for (int i = 1; i <= n; ++i) {
		maxp[i] = max(maxp[i - 1], a[i - 1]);
		minp[i] = min(minp[i - 1], a[i - 1]);
	}
	for (int i = n - 1; i >= 0; --i) {
		maxs[i] = max(maxs[i + 1], a[i]);
		mins[i] = min(mins[i + 1], a[i]);
	}
	fixed(cout);
	cout.precision(10);
	cout << "1 ";
	for (int k = 1; k < n; ++k) {
		if (minp[k] >= mins[k]) {
			if (maxp[k] <= maxs[k]) {
				cout << double(maxs[k] - maxp[k]) / maxs[k] << ' ';
			}
			else {
				cout << "0 ";
			}
		}
		else {
			if (maxp[k] <= maxs[k]) {
				cout << max(double(maxs[k] - maxp[k]) / maxs[k], double(mins[k] - minp[k]) / mins[k]) << " ";
			}
			else {
				cout << double(mins[k] - minp[k]) / mins[k] << " ";
			} 
		}
	}
	return 0;
}