#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;
#define int long long 

int n;
int a[1000010];
int b[1000010];
int c[1000010];
int f[1000010];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i) cin >> a[i];
	for (int i = 1; i <= n; ++i) cin >> b[i];

	int l = -1, r = n + 1;

	while (l + 1 < r)
	{
		int  m = (l + r) >> 1;

		bool ok = true;
		int p = 1;
		int s = 0;
		for (int i = 1; i <= n; ++i)
		{
			c[i] = a[i];
			f[i] = a[i];
			while (true)
			{
				if (p == i) break;
				if (i - p > m)
				{
					++p;
					continue;
				}
				if (f[p] >= b[p])
				{
					++p;
					continue;
				}

				int mi = min(f[i], b[p] - f[p]);
				f[i] -= mi;
				f[p] += mi;
				if (f[i])
				{
					++p;
					continue;
				}
				else
				{
					break;
				}
			}

			c[i] = f[i];
			if (c[i] >= b[i])
			{
				s += c[i] - b[i];
			}
			else
			{
				int mi = min(s, b[i] - c[i]);
				s -= mi;
				f[i] += mi;
			}
		}

		p = n;
		for (int i = n; i >= 1; --i)
		{
			while (true)
			{
				if (p == i) break;
				if (abs(i - p) > m)
				{
					--p;
					continue;
				}
				if (c[p] >= b[p])
				{
					--p;
					continue;
				}
				int todo = min(c[i], b[p] - c[p]);
				c[i] -= todo;
				c[p] += todo;
				if (c[i])
				{
					--p;
					continue;
				}
				else
				{
					break;
				}
			}
		}
		for (int i = 1; i <= n; ++i) if (c[i] > b[i])
		{
			ok = false;
			break;
		}
		if (ok)
		{
			r = m;
		}
		else
		{
			l = m;
		}
	}

	cout << (r == n + 1 ? -1 : r);
	return 0;
}