//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,unswitch-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

#include<bits/stdc++.h>

#define int long long
#define vec vector
#define sz(x) (int)(x.size())
#define f first
#define s second
#define pb push_back
#define endl "\n"
#define pii pair<int, int>
#define all(x) (x).begin(), (x).end()
#define rz resize
#define ld long double
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define rep(i, a, b) for(int i = a ; i < b ; i++)
#define Sum(a) accumulate(all(a), (int)0)
#define psum(a, b) partial_sum(a.begin(), a.end(), b.begin())
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define INF 2e18
#define inf 2e9
///#define int int_fast32_t

using namespace std;

/**

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

*/

template <class T>
istream& operator >> (istream &in, vector<T> &a)
{
    for(auto & i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector<T> &a)
{
    for(auto & i : a)
        out << i << ' ';
    return out;
}

template <class T, class U>
istream& operator >> (istream &in, pair<T, U> &a)
{
    in >> a.f >> a.s;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair<T, U> &a)
{
    out << a.f << ' ' << a.s << endl;
    return out;
}

mt19937 rnd(time(NULL));

#ifdef FelixDzerzhinsky
#define dbg(x) cout << (#x) << "\t" << (x) << endl
#else
#define dbg(x) 238
#endif

void files()
{
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
}

template<typename T1, typename T2>
inline T1 min(T1 a, T2 b)
{
    return (a < b ? a : b);
}

template<typename T1, typename T2>
inline T1 max(T1 a, T2 b)
{
    return (a > b ? a : b);
}

const ld eps = 1e-10;

int eq(ld a, ld b)
{
    if(abs(a - b) <= eps)
        return 1;
    return 0;
}

void solve()
{
    int n;
    cin >> n;

    vec<int> a (n);
    cin >> a;

    vec<int> prefmax (n), prefmin (n);
    vec<int> suffmax (n), suffmin (n);

    prefmax[0] = a[0];
    prefmin[0] = a[0];
    suffmax[n - 1] = a[n - 1];
    suffmin[n - 1] = a[n - 1];

    for(int i = 1; i < n; i++)
    {
        prefmax[i] = max(prefmax[i - 1], a[i]);
        prefmin[i] = min(prefmin[i - 1], a[i]);
    }

    for(int i = n - 2; i >= 0; i--)
    {
        suffmin[i] = min(suffmin[i + 1], a[i]);
        suffmax[i] = max(suffmax[i + 1], a[i]);
    }

    cout << fixed << setprecision(9) << endl;

    FOR(k, n)
    {
        if(!k)
        {
            cout << (ld)1 << ' ';
            continue;
        }

        ///cerr << k << " : " << endl;

        ld mx = (ld)prefmax[k - 1] / (ld)suffmax[k];
        ld mn = (ld)prefmin[k - 1] / (ld)suffmin[k];

        ///cerr << "mx " << mx << ' ' << mn << endl;

        ld mins = INF;
        ld maxt = 0;

        ld t, s;

        if(mn > mx or eq(mx, mn))
        {
            t = 1 - mx;
            t = max(t, 0);
            s = (1 - t) * (suffmax[k] - suffmin[k]);

            if(eq(mins, s))
            {
                maxt = max(maxt, t);
            }
            else if(mins > s)
            {
                mins = s;
                maxt = t;
            }

            ///cerr << "1 " << t << ' ' << s << endl;
        }

        /// 2

        if(suffmax[k] > prefmax[k - 1] or eq(suffmax[k], prefmax[k - 1]))
        {
            t = 1 - max(mx, mn);
            t = max(t, 0);
            s = (1 - t) * suffmax[k] - prefmin[k - 1];

            if(eq(mins, s))
            {
                maxt = max(maxt, t);
            }
            else if(mins > s)
            {
                mins = s;
                maxt = t;
            }

            ///cerr << "2 " << t << ' ' << s << endl;
        }

        /// 3

        t = 1 - min(mn, mx);
        t = max(t, 0);
        s = prefmax[k - 1] - (1 - t) * suffmin[k];

        if(eq(mins, s))
        {
            maxt = max(maxt, t);
        }
        else if(mins > s)
        {
            mins = s;
            maxt = t;
        }


        ///cerr << t << ' ' << s << endl;

        /// 4

        if(mn < mx or eq(mn, mx))
        {
            t = 1 - mn;
            t = max(t, 0);
            s = prefmax[k - 1] - prefmin[k - 1];

            if(eq(mins, s))
            {
                maxt = max(maxt, t);
            }
            else if(mins > s)
            {
                mins = s;
                maxt = t;
            }

            ///cerr << t << ' ' << s << endl;
        }

        cout << maxt << ' ';
    }
}

signed main()
{
    fast_io;
    #ifndef FelixDzerzhinsky
        fast_io
        //files
    #endif

    int q = 1;
    //cin >> q;

    while(q--)
    {
        solve();
    }
}
