#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <queue>
#include <stack>


//#pragma GCC target("avx")
//#pragma GCC optimize(3)
//#pragma GCC optimize("inline-functions")



#define ll long long
#define ld long double
#define pr pair<ll, ll>
#define vl vector<ll>
#define all(a) (a.begin(), a.end())

using namespace std;

void solve() {
	int n;
	cin >> n;

	queue<int> inp;
	stack<int> s[2] = { {}, {} };
	unordered_map<int, int> state;

	for (int i = 0; i < n; ++i) {
		int e;
		cin >> e;
		inp.push(e);
		state[e] = 0;
	}

	for (int i = 1; i <= n; ++i) {
		if (state[i] == 0) {
			while (inp.front() != i) {
				cout << "1\n";
				state[inp.front()] = 1;
				s[0].push(inp.front());
				inp.pop();
			}
			inp.pop();
			cout << "1\n-1\n";
		}
		else {
			int that = state[i] - 1,
				other = (that + 1) % 2;


			while (s[that].top() != i) {
				cout << (that + 1) << (other + 1) << "\n";
				state[s[that].top()] = other + 1;
				s[other].push(s[that].top());
				s[that].pop();
			}
			s[that].pop();
			cout << -(that + 1) << "\n";
		}
	}

	cout << endl;
}



int main() {
	ios::sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	ll t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}