#include <iostream>
#include <vector>

using namespace std;

const long long inf=1e9+7;

#define f first
#define s second

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(16);

    int n, mx=-1, mn=inf;
    cin>>n;
    vector<int> a(n);
    vector<pair<int,int>> m1(n), m2(n);

    for(int i=0; i<n; ++i){
        cin >> a[i];
        mx=max(mx, a[i]);
        m1[i].f=mx;
        mn=min(mn, a[i]);
        m1[i].s=mn;
    }
    mx=-1;
    mn=inf;
    for(int i=n-1; i>=0; --i){
        mx=max(mx, a[i]);
        m2[i].f=mx;
        mn=min(mn, a[i]);
        m2[i].s=mn;
    }
    cout<<1.0;

    for(int i=1; i<n; ++i){

        double p, eq, best_eq=inf, t=-1, bc, ks=0;
        bc=m1[i-1].f-m1[i-1].s;
        p=m1[i-1].f/(m2[i].f+ks);
        eq=max(max((m2[i].f-m2[i].s)*p, bc), max(m1[i-1].f-m2[i].s*p, m2[i].f*p-m1[i-1].s));
        if (eq<=best_eq && p<1 && p>0){

            if(eq==best_eq){
                t=max(t, 1-p);
            }
            else{
                t=1-p;
            }
            best_eq=eq;
        }

        p=m1[i-1].s/(m2[i].s+ks);
        eq=max(max((m2[i].f-m2[i].s)*p, bc), max(m1[i-1].f-m2[i].s*p, m2[i].f*p-m1[i-1].s));
        if (eq<=best_eq && p<1 && p>0){

            if(eq==best_eq){
                t=max(t, 1-p);
            }
            else{
                t=1-p;
            }
            best_eq=eq;
        }

        p=(m1[i-1].f+m1[i-1].s)/(m2[i].f+m2[i].s+ks);
        eq=max(max((m2[i].f-m2[i].s)*p, bc), max(m1[i-1].f-m2[i].s*p, m2[i].f*p-m1[i-1].s));
        if (eq<=best_eq && p<1 && p>0){

            if(eq==best_eq){
                t=max(t, 1-p);
            }
            else{
                t=1-p;
            }
            best_eq=eq;
        }
        if(m2[i].f-m2[i].s>0){
            p=(m1[i-1].f-m1[i-1].s)/(m2[i].f-m2[i].s+ks);
            eq=max(max((m2[i].f-m2[i].s)*p, bc), max(m1[i-1].f-m2[i].s*p, m2[i].f*p-m1[i-1].s));
            if (eq<=best_eq && p<1 && p>0){

                if(eq==best_eq){
                    t=max(t, 1-p);
                }
                else{
                    t=1-p;
                }
                best_eq=eq;
            }
        }
        p=0;
        eq=max(max((m2[i].f-m2[i].s)*p, bc), max(m1[i-1].f-m2[i].s*p, m2[i].f*p-m1[i-1].s));
        if (eq<=best_eq){

            if(eq==best_eq){
                t=max(t, 1-p);
            }
            else{
                t=1-p;
            }
            best_eq=eq;
        }

        p=1;
        eq=max(max((m2[i].f-m2[i].s)*p, bc), max(m1[i-1].f-m2[i].s*p, m2[i].f*p-m1[i-1].s));
        if (eq<=best_eq){
            if(eq==best_eq){
                t=max(t, 1-p);
            }
            else{
                t=1-p;
            }
            best_eq=eq;
        }

        cout<<' '<<t;
    }
    cout<<endl;
    return 0;
}
