#include <bits/stdc++.h>
using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(obj) obj.begin(), obj.end()
#define pb push_back()
#define fi first
#define se second
#define long long
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

void solve(istream& in, ostream& out) {
    int n, suma = 0, sumb = 0; cin >> n;
    vi a(n), b(n), diff(n);
    forn(i, n) {cin >> a[i]; suma += a[i]; }
    forn(i, n) {cin >> b[i]; sumb += b[i]; }
    if (sumb < suma) {
        cout << "-1\n";
        return;
    }
    forn(i, n) diff[i] = a[i] - b[i];
    int l = -1, r = n;
    while (l+1 != r) {
        int mid = l+(r-l)/2;
        bool ok = true;
        queue<pii> q, waiting;
        forn(i, n) {
            while (!q.empty() && i-q.front().fi > mid) q.pop();
            if (!waiting.empty() && i-waiting.front().fi > mid) { ok = false; break; }

            if (diff[i] <= 0) {
                int cur = -diff[i];
                while (!waiting.empty() && cur > 0) {
                    int kek = min(waiting.front().se, cur);
                    waiting.front().se -= kek;
                    cur -= kek;
                    if (waiting.front().se == 0) waiting.pop();
                }
                if (cur > 0) q.push({i, cur});
            } else {
                int cur = diff[i];
                while (!q.empty() && cur > 0) {
                    int kek = min(q.front().se, cur);
                    q.front().se -= kek;
                    cur -= kek;
                    if (q.front().se == 0) q.pop();
                }
                if (cur > 0) waiting.push({i, cur});
            }
        }
        if (waiting.empty() && ok) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << r << '\n';
}

int32_t main() {
    solve(cin, cout);
}
