#include <bits/stdc++.h>
using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(obj) obj.begin(), obj.end()
#define pb push_back()
#define fi first
#define se second
#define int long long
using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using s64 = long long;


int32_t main() {
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    cout << fixed << setprecision(9);

    int n;
    cin >> n;
    vector<ld> a(n), b(n), c(n);
    for(int i = 0; i < n; i++){
        cin >> a[i] >> b[i] >> c[i];
    }

    const ld eps = 1e-9;
    const ld step = 1e-6;
    const ld INF = 1e300;

    auto f = [&](ld x, ld& mn, ld& mx){
        mn = -INF;
        mx = INF;
        for(int i = 0; i < n; i++){
            if(a[i] > 0){
                mn = max(mn, a[i] * x * x + b[i] * x + c[i]);
            }
            else{
                mx = min(mx, a[i] * x * x + b[i] * x + c[i]);
            }
        }
        //cout << x << " " << mn << " " << mx << "\n";
    };

    auto bp = [&](ld l, ld r){
        while(l < r - eps){
            ld m = (l + r) / 2;

            ld mn, mx;
            f(m, mn, mx);
            ld tomn, tomx;
            f(m + step, tomn, tomx);
            //cout << "\n";

            if(tomn < mn && tomx > mx){
                l = m;
            }
            else{
                r = m;
            }
        }
        ld mn, mx;
        f(l, mn, mx);

        if(mn < mx){
            cout << l << " " << (mn + mx) / 2 << "\n";
            exit(0);
        }
    };

    bp(0, 1e9);
    bp(-1e9, 0);

    return 0;
}
