#include <bits/stdc++.h>

using namespace std;

const int N  = 1e5;
const int L  = 1e6;
const int W  = 26;

int m, n;
string s[N];

bool guess(vector<string> words, vector<char> used) {
    if (words.size() == 1) return true;

    vector<int> cnt(26);
    for (string& s : words) {
        vector<char> was(26);
        for (char c : s) {
            was[c-'a'] = true;
        }
        for (int x = 26; x--; ) if (was[x]) cnt[x]++;
    }

    const int n = words.size();
    for (int x = 26; x--; ) {
        if (cnt[x] < n || used[x]) continue;

        used[x] = true;
        map<string, vector<string>> mp;
        for (const string& s : words) {
            string msk = s;
            for (char& c : msk) if (!used[c - 'a']) c = '?';
            // cout << msk << " ==> " << s << endl;
            mp[msk].push_back(s);
        }

        for (const auto& [msk, wds] : mp) {
            if (!guess(wds, used)) return false;
        }

        return true;
    }

    return false;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    cin >> m >> n;

    vector<string> s(n);
    for (string& u : s) cin >> u;

    bool res = guess(s, vector<char>(26));
    cout << (res ? "YES" : "NO") << endl;
}
