#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 5e5+7;
const int INF = 1e9+7;
const int MOD = 1e9+7;

int n, k;
int x[N], d[N], t[2*N];
ll ps[N+1], ans;

vector<int> good_points;

bool cmp(int i, int j) {
    return d[i] < d[j];
}

int min_query(int l, int r) {
    int ans = l;
    for (l += n, r += n - 1; l <= r; l >>= 1, r >>= 1) {
        if ((l&1) == 1) ans = min(ans, t[l++], cmp);
        if ((r&1) == 0) ans = min(ans, t[r--], cmp);
    }
    return ans;
}

void correct(int l, int r) {
    if (l == r) return;

    // cout << "see " << l << " :" << r << endl;

    int i = min_query(good_points[l], good_points[r]);

    if (d[i] == INF) {
        // cout << "wow!" << endl;
        for (int i = l; i <= r; ++i) {
            int mp = 2 * i - (l + r);
            ans = (ans - (ll) ps[good_points[i]] % MOD * mp) % MOD;
            if (ans < 0) ans += MOD;
        }
    } else {
        int j = upper_bound(good_points.begin(), good_points.end(), i) - good_points.begin();
        ans = (ans - (ll) (r - j + 1) * (j - l) % MOD * d[i]) % MOD;
        if (ans < 0) ans += MOD;

        correct(l, j - 1);
        correct(j, r);
    }
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);


    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        int a, b; cin >> a >> b;
        if (a < b) swap(a, b);

        x[i] = a;
        if (a % k == b % k) {
            d[i] = INF;
        } else {
            d[i] = a - b;
        }
    }

    iota(t+n, t+2*n, 0);
    for (int i = n; i--; ) t[i] = min(t[2*i], t[2*i+1], cmp);

    for (int i = 0; i < n; ++i) ps[i+1] = ps[i] + x[i];

    for (int i = 0; i <= n; ++i) {
        ans = (ans + ps[i]%MOD*(2*i-n))%MOD;
        if (ans < 0) ans += MOD;
    }


    map<int, vector<int>> gp;
    for (int i = 0; i <= n; ++i) {
        gp[ps[i] % k].push_back(i);
    }

    for (const auto& [x, v] : gp) {
        good_points = v;
        correct(0, v.size() - 1);
    }

    cout << ans << endl;

    return 0;
}
