#include <bits/stdc++.h>
using namespace std;

struct M{
    double x, p;
};

bool operator<(M a, M b){
    if (a.p != b.p) return a.p < b.p;
    return a.x > b.x;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, mi_, ma_;
    cin >> n;
    int a[n], ma[n], mi[n];
    for(int &x : a) cin >> x;
    ma[n - 1] = a[n - 1];
    mi[n - 1] = a[n - 1];
    for(int i = n - 2; i >= 0; --i){
        ma[i] = max(ma[i + 1], a[i]);
        mi[i] = min(mi[i + 1], a[i]);
    }
    cout << "1.00 ";
    mi_ = ma_ = a[0];
    for(int i = 1; i < n; ++i){
        double l = 0, r = 1;
        for(int step = 0; step < 70; ++step){
            double m1 = (2 * l + r) / 3, m2 = (l + 2 * r) / 3;
            double p1 = max(ma_ * 1., ma[i] * (1 - m1)) - min(mi_ * 1., mi[i] * (1 - m1));
            double p2 = max(ma_ * 1., ma[i] * (1 - m2)) - min(mi_ * 1., mi[i] * (1 - m2));
            if (p1 < p2) r = m2;
            else l = m1;
        }
        cout << fixed << setprecision(12) << l << " ";
    }
    return 0;
}
