#include <bits/stdc++.h>
using namespace std;

const int N = 100005;
bool cnt[26][N];

bool rec(vector<pair<string, int>> v){
    if (v.size() == 1) return true;
    map<string, vector<pair<string, int>>> m;
    set<char> se;
    for(char c = 'a'; c <= 'z'; ++c){
        bool g = true;
        for(int i = 0; i < v.size() && g; ++i) g &= cnt[c - 'a'][v[i].second];
        if (g) se.insert(c);
    }
    if (se.empty()) return false;
    for(char c : se){
        for(auto &x : v) cnt[c - 'a'][x.second] = false;
    }
    for(auto s : v){
        string t, u;
        for(char c : s.first){
            if (se.count(c)) u += c, t += '.';
            else u += '.', t += c;
        }
        m[u].push_back({t, s.second});
    }
    bool ans = true;
    for(auto x : m) { ans &= rec(x.second); if (!ans) break; }
    for(char c : se){
        for(auto &x : v) cnt[c - 'a'][x.second] = true;
    }
    return ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<string, int>> a;
    for(int i = 0; i < m; ++i){
        string s;
        cin >> s;
        a.push_back({s, i});
    }
    for(char c = 'a'; c <= 'z'; ++c){
        for(int j = 0; j < m; ++j) cnt[c - 'a'][j] = (a[j].first.find(c) != string::npos);
    }
    cout << (rec(a) ? "YES" : "NO");
    return 0;
}
