#include <bits/stdc++.h>

using namespace std;

typedef double ll;

const int INF = 1e9 * 2;
const ll EPS = 1e-12;

int n;
vector<int> a, pmx, pmn, smx, smn;

ll cheek(int mnl, int mxl, int mnr, int mxr, ll t, int i) {
//    mnr *= ((double)1 - t);
    ll mnr1 = ((double)1 - t) * mnr;
//    mxr *= ((double)1 - t);
    ll mxr1 = ((double)1 - t) * mxr;
    if (i == 1) {
        return mxr1 - mnr1;
    }
    ll mn = min(min((ll)mnl, mnr1), min((ll)mxl, mxr1));
    ll mx = max(max((ll)mnl, mnr1), max((ll)mxl, mxr1));
    return mx - mn;
}

ll tp(int mnl, int mxl, int mnr, int mxr, int i) {
    ll l = 0, r = 1, m1 = 0, m2 = 0;
    while (r - l > EPS) {
        m1 = (2 * l + r) / 3;
        m2 = (l + 2 * r) / 3;
        ll res1 = cheek(mnl, mxl, mnr, mxr, m1, i);
        ll res2 = cheek(mnl, mxl, mnr, mxr, m2, i);
        //cout << setprecision(10) << fixed << l << " " << r << " " << m1 << " " << m2 << " " << res1 << " " << res2 << endl;
        if (res1 >= res2) {
            l = m1;
        } else {
            r = m2;
        }
    }
    return l;
}

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    a.resize(n + 1);
    pmx.resize(n + 1);
    smx.resize(n + 2);
    pmn.resize(n + 1);
    smn.resize(n + 2);
    pmn[0] = INF;
    smn[n + 1] = INF;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pmx[i] = max(pmx[i - 1], a[i]);
        pmn[i] = min(pmn[i - 1], a[i]);
    }
    for (int i = n; i > 0; i--) {
        smx[i] = max(smx[i + 1], a[i]);
        smn[i] = min(smn[i + 1], a[i]);
    }
    for (int i = 1; i <= n; i++) {
        int mnl = 0, mxl = 0, mnr = 0, mxr = 0;
        mnl = pmn[i - 1];
        mxl = pmx[i - 1];
        mnr = smn[i];
        mxr = smx[i];
        ll res = tp(mnl, mxl, mnr, mxr, i);
        cout << setprecision(15) << fixed << res << endl;
    }
    return 0;
}
