//CPOS1
#include <bits/stdc++.h>

using namespace std;

typedef double db;

int n;
vector<int> a, pmx, pmn, smx, smn;

db tp(int mnl, int mxl, int mnr, int mxr) {
    db l = 0, r = 1, m1 = 0, m2 = 0;
    for (int i = 0; i < 52; i++) {
        m1 = (2 * l + r) / 3;
        m2 = (l + 2 * r) / 3;
        db mnr1 = mnr * ((double)1 - m1);
        db mnr2 = mnr * ((double)1 - m2);
        db mxr1 = mxr * ((double)1 - m1);
        db mxr2 = mxr * ((double)1 - m2);
        db mx1 = max(max(mnr1, mxr1), max((double)mxl, (double)mnl));
        db mx2 = max(max(mnr2, mxr2), max((double)mxl, (double)mnl));
        db mn1 = min(min(mnr1, mxr1), min((double)mxl, (double)mnl));
        db mn2 = min(min(mnr2, mxr2), min((double)mxl, (double)mnl));
        if (mx1 - mn1 >= mx2 - mn2) {
            l =  m1;
        } else {
            r = m2;
        }
    }
    return l;
}

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    a.resize(n + 1);
    pmx.resize(n + 1);
    smx.resize(n + 2);
    pmn.resize(n + 1);
    smn.resize(n + 2);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    pmn[0] = a[1];
    smn[n + 1] = a[n];
    for (int i = 1; i <= n; i++) {
        pmx[i] = max(pmx[i - 1], a[i]);
        pmn[i] = min(pmn[i - 1], a[i]);
    }
    for (int i = n; i > 0; i--) {
        smx[i] = max(smx[i + 1], a[i]);
        smn[i] = min(smn[i + 1], a[i]);
    }
    for (int i = 1; i <= n; i++) {
        int mnl = 0, mxl = 0, mnr = 0, mxr = 0;
        mnl = pmn[i - 1];
        mxl = pmx[i - 1];
        mnr = smn[i];
        mxr = smx[i];
        cout << setprecision(20) << fixed << tp(mnl, mxl, mnr, mxr) << " ";
    }
    return 0;
}
