#include <bits/stdc++.h>

using namespace std;

#define MP make_pair

typedef long long ll;

const int N = 2e6 + 3e2;

int a[N];
int mnp[N], mns[N], mxp[N], mxs[N];

#define ld long double

ld cost(int k, ld t){
    ld mn = min((ld)mnp[k - 1], (1 - t) * mns[k]);
    ld mx = max((ld)mxp[k - 1], (1 - t) * mxs[k]);
    ld res = mx - mn;
    //cout << k << ' ' << t << ' ' << res << endl;
    return res;
}

void solve(){
    int n;
    cin >> n;

    for (int i = 1; i <= n; i++) cin >> a[i];

    mnp[0] = 1e9;
    for (int i = 1; i <= n; i++){
        mxp[i] = max(mxp[i - 1], a[i]);
        mnp[i] = min(mnp[i - 1], a[i]);
    }

    mns[n + 1] = 1e9;
    for (int i = n; i >= 1; i--){
        mxs[i] = max(mxs[i + 1], a[i]);
        mns[i] = min(mns[i + 1], a[i]);
    }

    cout << fixed << setprecision(15);

    for (int i = 1; i <= n; i++){
        ld l = 0, r = 1;
        ld ans = cost(i, 0), t = 0;
        for (int it = 0; it < 200; it++){
            ld m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
            ld f1 = cost(i, m1), f2 = cost(i, m2);
            if (f1 > f2){
                if (f2 < ans) ans = f2, t = m2;
                l = m1;
            } else {
                if (f1 < ans) ans = f1, t = m1;
                r = m2;
            }
        }

        l = t, r = 1;
        for (int it = 0; it < 200; it++){
            ld m = (l + r) / 2;
            if (cost(i, m) == ans){
                t = m;
                l = m;
            } else r = m;
        }

        cout << t << ' ';

        //vector<ld> vec = {1, 0.75, 0.5, 0.25, 0};
        //for (ld x : vec) cost(i, x);

    }

}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int tests = 1;
    //cin >> tests;

    for (int test = 1; test <= tests; test++){
        solve();
    }

    return 0;
}
