#include <bits/stdc++.h>

using namespace std;

#define MP make_pair
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef long double ld;

const int N = 2e6 + 3e2;


void solve(){
    int a, b, c, d;
    cin >> a >> b >> c >> d;
    vector<int> v = {a, b, c, d};
    vector<int> perm = {0, 1, 2, 3};

    vector<ld> ans(4);
    vector<int> pans(4);

    int best = -1;
    do {
        a = v[perm[0]] - 1, b = v[perm[1]] - 1, c = v[perm[2]] - 1, d = v[perm[3]] - 1;
        if (a * d <= b * c && best < a * d){
            best = a * d;
            ans = {a, b, (b == 0 ? 0 : (ld)a * d / b), d};
            pans = perm;
        }
        if (b * c < a * d && best < b * c) {
            best = b * c;
            ans = {a, b, c, (c == 0 ? 0 : (ld)b * c / a)};
            pans = perm;
        }

    } while (next_permutation(all(perm)));

    cout << setprecision(10);

    for (int x : pans) cout << x + 1 << ' ';
    cout << endl;
    for (ld x : ans) cout << x + 1 << ' ';

}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int tests = 1;
    //cin >> tests;

    for (int test = 1; test <= tests; test++){
        solve();
    }

    return 0;
}
