#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::pair;
using std::string;

using ld = long double;

const ld INF = 1e10;

struct S {
	int a, b, c;
};

vector<S> v;

int sign(ld x) {
	return (x > 0 ? 1 : -1);
}

ld ask(ld x) {
	ld max = -2e18, min = 2e18;
	for(int i = 0; i < v.size(); ++i) {
		if(v[i].a > 0)
			max = std::max(max, sign(x) * (v[i].a * x + v[i].b + v[i].c / x));
		else
			min = std::min(min, sign(x) * (v[i].a * x + v[i].b + v[i].c / x));
	}
	return (max - min) * std::abs(x);
}

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;
	v.resize(n);
	int ind = 0;
	int cur = 0;
	for(auto& i : v) {
		cin >> i.a >> i.b >> i.c;
	}

	ld l = -INF, r = INF;
	while(r - l > 1e-8) {
		ld m1 = (2 * l + r) / 3;
		ld m2 = (l + 2 * r) / 3;
		if(ask(m1) > ask(m2))
			l = m1;
		else
			r = m2;

	}
	ld x = (l + r) / 2;
	ld max = -2e18, min = 2e18;
	for(int i = 0; i < n; ++i) {
		if(v[i].a > 0)
			max = std::max(max, sign(x) * (v[i].a * x + v[i].b + v[i].c / x));
		else
			min = std::min(min, sign(x) * (v[i].a * x + v[i].b + v[i].c / x));
	}
	cout << std::fixed << std::setprecision(30) << x << ' ' << (max + min) / 2 * std::abs(x);

	return 0;
}
