from sys import stdin
from sys import stdout

def input():
    return stdin.readline().strip()
def print(*a, sep=' ', end = "\n"):
    stdout.write(sep.join(map(str, a)) + end)


n: int
a, b = [], []


def check(k):
    f = []
    e = []

    for i in range(n-1, -1, -1):
        if a[i] > b[i]:
            e.append([i, a[i]-b[i]])
        if a[i] < b[i]:
            f.append([i, b[i]-a[i]])

    while 1:
        if len(f) > 0 and len(e) > 0:
            ff = f.pop()
            ef = e.pop()

            if abs(ff[0] - ef[0]) > k:
                return False

            if ff[1] > ef[1]:
                ff = [ff[0], ff[1]-ef[1]]
                f.append(ff)
            elif ff[1] < ef[1]:
                ef = [ef[0], ef[1]-ff[1]]
                e.append(ef)

        elif len(f) > 0 and len(e) == 0:
            return True
        elif len(f) == 0 and len(e) > 0:
            return False
        else:
            return True


def bs():
    l, r = -1, n+1

    while l+1 < r:
        m = (l+r)//2
        if check(m):
            r = m
        else:
            l = m

    return r


def main():
    global n, a, b
    n = int(input())
    a = list(map(int, input().split()))
    b = list(map(int, input().split()))

    if sum(a) > sum(b):
        print(-1)
        return

    ans = bs()

    print(ans)


if __name__ == '__main__':
    main()
