﻿#include<iostream>
#include<iomanip>
#include<vector>
#include<set>
#include<fstream>
#include<string>
#include<algorithm>
#define int long long

using namespace std;

int n;
vector<int> a, pre_a, b, pre_b;

bool g(int k)
{
	for (int i = k; i < n - k; i++)
	{
		if (pre_b[i + k] - pre_b[i - k] < pre_a[i + k] - pre_a[i - k])
			return false;
	}
	return true;
}

int f()
{
	int l = 0, r = n + 1;
	int mid = (l + r) / 2;
	while(r - l > 1)
	{
		if (g(mid))
			r = mid;
		else
			l = mid;
		mid = (l + r) / 2;
	}
	if (g(l))
		return l;
	return r;
}

signed main() {
	//ifstream cin("input.txt");
	//ofstream cout("output.txt");
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	a.resize(n); b.resize(n);
	pre_a.resize(n + 1); pre_b.resize(n + 1);
	pre_a[0] = 0; pre_b[0] = 0;

	for (int i = 0; i < n; i++) {
		cin >> a[i];
		pre_a[i + 1] = pre_a[i] + a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		pre_b[i + 1] = pre_b[i] + b[i];
	}
	if (pre_a[n] > pre_b[n])
	{
		cout << -1;
		return 0;
	}
	cout << f();
}