#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
const int INF = 1e9 + 7;

#define int long long

struct node {
	long double mx = 0, mn = INF;
};

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(20);
	int n;
	cin >> n;
	vector<long double> v(n);
	vector<node> pref(n), suff(n);
	cin >> v[0];
	for (int i = 1; i < n; i++) {
		cin >> v[i];
		pref[i].mx = max(v[i - 1], pref[i - 1].mx);
		pref[i].mn = min(v[i - 1], pref[i - 1].mn);
	}
	suff[n - 1].mn = suff[n - 1].mx = v[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		suff[i].mn = min(suff[i + 1].mn, v[i]);
		suff[i].mx = max(suff[i + 1].mx, v[i]);
	}

	for (int i = 0; i < n; i++) {
		if (pref[i].mx > suff[i].mx) {
			if (pref[i].mn > suff[i].mn) cout << 0 << ' ';
			else {
				cout << 1 - pref[i].mn / suff[i].mn << ' ';
			}
		}
		else {
			long double t = pref[i].mx / suff[i].mx;
			if (pref[i].mn < t * suff[i].mn) {
				cout << 1 - (pref[i].mn / suff[i].mn) << ' ';
			}
			else {
				cout << 1 - t << ' ';
			}
		}
	}
}