#include <iostream>
#include <stack>

const long long maxN = 1000;

long long n, a[maxN], b[maxN], it;
std::stack<long long> st1, st2;

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n;
	for (long long i = 0; i < n; i++) {
		std::cin >> a[i]; 
		a[i]--;
	}
	for (long long i = 0; i < n; i++) {
		if (b[i] == 0) {
			while (a[it] != i) {
				std::cout << "1\n";
				st1.push(a[it]);
				b[a[it]] = 1;
				it++;
			}
			std::cout << "1\n-1\n";
			it++;
			b[i] = 3;
		}
		else if (b[i] == 1) {
			while (st1.top() != i) {
				std::cout << "12\n";
				st2.push(st1.top());
				b[st1.top()] = 2;
				st1.pop();
			}
			std::cout << "-1\n";
			st1.pop();
		}
		else {
			while (st2.top() != i) {
				std::cout << "21\n";
				st1.push(st2.top());
				b[st2.top()] = 1;
				st2.pop();
			}
			std::cout << "-2\n";
			st2.pop();
		}
		b[i] = 3;
	}
	return 0;
}