#include <bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<double> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<double> pmax(n), pmin(n), smax(n), smin(n);
    pmax[0] = a[0];
    pmin[0] = a[0];
    for (int i = 1; i < n; i++) {
        pmax[i] = max(pmax[i - 1], a[i]);
        pmin[i] = min(pmin[i - 1], a[i]);
    }
    smin[n - 1] = a[n - 1];
    smax[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        smin[i] = min(smin[i + 1], a[i]);
        smax[i] = max(smax[i + 1], a[i]);
    }
    cout.precision(9);
    cout << fixed << setprecision(9) << 1.0 << ' ';
    for (int i = 1; i < n; i++) {
        if (pmax[i - 1] >= smax[i] && pmin[i - 1] >= smin[i]) {
            cout << fixed << setprecision(9) << 0.0 << ' ';
        } else if (pmin[i - 1] >= smax[i]) {
            cout << fixed << setprecision(9) << 0.0 << ' ';
        } else if (pmax[i - 1] <= smax[i] && pmin[i - 1] >= smin[i]) {
            cout << fixed << setprecision(9) << 1.0 - pmax[i-1]/smax[i] << ' ';
        } else if (pmax[i - 1] <= smin[i]) {
            cout << fixed << setprecision(9) << 1.0 - pmax[i-1]/smax[i] << ' ';
        } else {
            cout << fixed << setprecision(9) << 1.0 - pmin[i-1]/smin[i] << ' ';
        }
    }
    return 0;
}
