#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define pb push_back
#define all(v) v.begin(), v.end()
const int N = 1e5+7;

vector <int> graph[N];
int used[N];

void dfs(int v) {
    used[v] = 1;
    for (auto to : graph[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
}

int main() {

    int l, n;
    cin >> l >> n;
    vector <string> v(n);
    for (auto &to : v) cin >> to;
    for (char ch = 'a'; ch <= 'z'; ch++) {
        vector <pair <vector <int>, int>> tmp;
        for (int i = 0; i < n; i++) {
            vector <int> f;
            for (int j = 0; j < v[i].size(); j++) {
                if (v[i][j] == ch) {
                    f.pb(j);
                }
            }
            if (f.size() > 0) {
                tmp.pb(make_pair(f, i));
            }
        }
        if (tmp.size() == 0) continue;
        sort(all(tmp));
        for (int i = 0; i < tmp.size()-1; i++) {

            if (tmp[i].first != tmp[i+1].first) {
                graph[tmp[i].second].pb(tmp[i+1].second);
                graph[tmp[i+1].second].pb(tmp[i].second);
            }
        }
    }

    dfs(0);
    int flag = 1;
    for (int i = 0; i < n; i++) {
        flag &= used[i];
    }
    if (flag) cout << "YES" << endl;
    else cout << "NO" << endl;
    return 0;
}
