#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define pb push_back
#define all(v) v.begin(), v.end()
const int N = 1e5+7;

set <int> graph[N];
int used[N];

int saizu[N], link[N];

int find(int n) {
    if (n == link[n]) return n;
    return link[n] = find(link[n]);
}

void unite(int a, int b) {
    a = find(a);
    b = find(b);
    if (a == b) return;
    if (saizu[a] < saizu[b]) swap(a, b);
    saizu[a] += saizu[b];
    link[b] = a;
}

void dfs(int v) {
    used[v] = 1;
    for (auto to : graph[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
}

int main() {

    int l, n;
    cin >> l >> n;
    for (int i = 0; i < n; i++) {
        link[i] = i;
        saizu[i] = 1;
    }
    vector <string> v(n);
    set <int> ans;
    for (auto &to : v) cin >> to;
    for (char ch = 'a'; ch <= 'z'; ch++) {
        vector <pair <vector <int>, int>> tmp;
        for (int i = 0; i < n; i++) {
            vector <int> f;
            for (int j = 0; j < v[i].size(); j++) {
                if (v[i][j] == ch) {
                    f.pb(j);
                }
            }
            if (f.size() > 0) {
                tmp.pb(make_pair(f, i));
            }
        }
        if (tmp.size() == 0) continue;
        sort(all(tmp));
        set <int> noteq;
        if (tmp.size() == 1) continue;
        for (int i = 0; i < tmp.size(); i++) {
            int flag2 = 1;
            if (i+1 < tmp.size() && tmp[i].first == tmp[i+1].first) {
                flag2 = 0;
            }
            if (i-1 >= 0 && tmp[i].first == tmp[i-1].first) {
                flag2 = 0;
            }
            if (flag2) noteq.insert(tmp[i].second);
        }
        for (auto to : noteq) ans.insert(to);
    }
    if (ans.size() == n) cout << "YES";
    else cout << "NO";

    return 0;
}
