#include <bits/stdc++.h>
using namespace std;

const int MOD = 1e9 + 7;
const long long P = 31;
const double eps = 1e-11;

void solve() {
	vector<pair<double, int>> a(4);
	for(int i = 0; i < 4; i++) {
		cin >> a[i].first;
		a[i].second = i;
	}
	sort(a.begin(), a.end());
	double ans = 0;
	vector<int> ind(4);
	vector<double> val(4);
	do {
		double sum1 = a[0].first * a[3].first + a[1].first + a[2].first;
		double sum2 = a[1].first * a[2].first + a[0].first + a[3].first;
		if(sum1 < sum2) continue;
		if(a[0].first < a[3].first) continue;
		double raz = sum1 - sum2;
		double l = 1, r = a[3].first;
		while (r - l > eps) {
			double m = (r + l) / 2;
			double new_sum1 = m * a[0].first + a[1].first + a[2].first;
			double new_sum2 = a[1].first * a[2].first + a[0].first + m;
			if (new_sum1 + eps < new_sum2) {
				l = m;
			} else {
				r = m;
			}
		}
		double cur_sum = l * a[0].first + a[1].first + a[2].first;
		if(cur_sum > ans) {
			ans = cur_sum;
			for(int i = 0; i < 4; i++) {
				ind[i] = a[i].second;
			}
			val[0] = a[0].first;
			val[3] = r;
			val[2] = a[2].first;
			val[1] = a[1].first;
		}
		
	} while(next_permutation(a.begin(), a.end()));
	for(auto i : ind) cout << i + 1 << ' ';
	cout << '\n';
	for(auto i : val) cout << i << ' ';
}

int main() {
	ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
	cout << setprecision(12);
    int _t = 1; //cin >> _t;
    while(_t--) {
        solve();
    }
    return 0;
}
