#include <vector>
#include <string>
#include <iostream>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <queue>
#include <random>
#include <utility>

#define rev(i, n) for (int i = 0; i < n; ++i)
#define forn(n) for (int i = 0; i < n; ++i)
#define reforn(n) for (int i = n - 1; i >= 0; --i)
#define fori(a, b) for (int i = a; i < b; ++i)
#define forj(a, b) for (int j = a; j < b; ++j)
#define fork(a, b) for (int k = a; k < b; ++k)
#define rerev(i, n) for (int i = n - 1; i >= 0; --i)
#define mp make_pair
#define X first
#define Y second

using namespace std;

typedef long long ll;
typedef long double ld;

bool fun(int l, vector<int> &a, vector<int> &b) {
    int n = a.size();
    vector<ll> res(n);
    ll sl = 0, sr = 0, xl = 0, xr = 0, delta;
    forn(min(l + 1, n)) sr += b[i];
    sr -= b[0];
    forn(n) {
        res[i] += a[i];
        delta = res[i] - b[i];
        if (delta > 0) res[i] = b[i];
        else {
            if (i >= l) {
                if (xl < b[i - l] - res[i - l]) res[i - l] += xl, xl = 0, sl -= b[i - l] - res[i - l];
                else xl -= b[i - l] - res[i - l], res[i - l] = b[i - l];
            }
            sl += b[i] - res[i];
            if (i + l + 1 < n) {
                sr += b[i + l + 1];
            }
            if (i < n - 1) {
                if (b[i + 1] >= xr) res[i + 1] = xr, xr = 0;
                else xr -= b[i + 1] - res[i + 1], res[i + 1] = b[i + 1];
                sr -= b[i + 1] - res[i + 1];
            }
            continue;
        }
        if (delta <= sl) {
            sl -= delta, xl += delta, delta = 0;
        }
        else {
            xl += sl, delta -= sl, sl = 0;
        }
        if (delta > sr) {
            return false;
        }
        else {
            sr -= delta, xr += delta, delta = 0;
        }
        if (i >= l) {
            if (xl < b[i - l] - res[i - l]) res[i - l] += xl, xl = 0, sl -= b[i - l] - res[i - l];
            else xl -= b[i - l] - res[i - l], res[i - l] = b[i - l];
        }
        sl += b[i] - res[i];
        if (i + l + 1 < n) {
            sr += b[i + l + 1];
        }
        if (i < n - 1) {
            if (b[i + 1] >= xr) res[i + 1] = xr, xr = 0;
            else xr -= b[i + 1] - res[i + 1], res[i + 1] = b[i + 1];
            sr -= b[i + 1] - res[i + 1];
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n; cin >> n;
    vector<int> a(n), b(n);
    bool flag = true;
    forn(n) cin >> a[i];
    forn(n) cin >> b[i], flag = flag && (a[i] <= b[i]);
    if (flag) {
        cout << 0 << endl;
        return 0;
    }
    ll delta = 0, s = 0;
    int R = n, L = 0, m;
    while (R - L > 1) {
        m = (R + L) / 2;
        if (fun(m, a, b)) R = m;
        else L = m;
    }
    if (R == n) {
        cout << -1 << endl;
    }
    else cout << R << endl;
    return 0;
}