#include <vector>
#include <string>
#include <iostream>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <queue>
#include <random>
#include <utility>

#define rev(i, n) for (int i = 0; i < n; ++i)
#define forn(n) for (int i = 0; i < n; ++i)
#define reforn(n) for (int i = n - 1; i >= 0; --i)
#define fori(a, b) for (int i = a; i < b; ++i)
#define forj(a, b) for (int j = a; j < b; ++j)
#define fork(a, b) for (int k = a; k < b; ++k)
#define rerev(i, n) for (int i = n - 1; i >= 0; --i)
#define mp make_pair
#define X first
#define Y second

using namespace std;

typedef long long ll;
typedef long double ld;

ld res = 0;
int ans1[4];
ld ans2[4];
int a[4];

ld fun(ld a, ld b, ld c, ld q) {
    if (c == 1 && a * b - a - b + c == 0) return q;
    if (c == 1) return 1e9;
    return (a * b - a - b + c) / (c - 1);
}

void vs(int a1, int a2, int a3, int a4) {
    ld na1 = fun(a[a4], a[a3], a[a2], a[a1]);
    ld na4 = fun(a[a1], a[a2], a[a3], a[a4]);

    if (na4 + a[a3] + a[a1] * a[a2] > res && na4 <= a[a4]) {
        res = na4 + a[a3] + a[a1] * a[a2];

        ans1[0] = a4;
        ans1[1] = a3;
        ans1[2] = a2;
        ans1[3] = a1;
        ans2[0] = na4;
        ans2[1] = a[a3];
        ans2[2] = a[a2];
        ans2[3] = a[a1];
    }
    if (na1 + a[a2] + a[a3] * a[a4] > res && na1 <= a[a1]) {
        res = na1 + a[a2] + a[a3] * a[a4];

        ans1[0] = a1;
        ans1[1] = a2;
        ans1[2] = a3;
        ans1[3] = a4;
        ans2[0] = na1;
        ans2[1] = a[a2];
        ans2[2] = a[a3];
        ans2[3] = a[a4];
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    bool used[4] = { false };
    cin.tie(0);
    cout.precision(20);
    ld max_s = 0, q;
    cin >> a[0] >> a[1] >> a[2] >> a[3];

    rev(a1, 4) {
        if (used[a1])
            continue;
        used[a1] = true;

        rev(a2, 4) {
            if (used[a2])
                continue;
            used[a2] = true;

            rev(a3, 4) {
                if (used[a3])
                    continue;
                used[a3] = true;

                rev(a4, 4) {
                    if (!used[a4])
                        vs(a1, a2, a3, a4);
                }

                used[a3] = false;
            }

            used[a2] = false;
        }

        used[a1] = false;
    }

    rev(i, 4) {
        cout << ans1[i] + 1 << ' ';
    }

    rev(i, 4) {
        cout << ans2[i] << ' ';
    }

    return 0;
}