//#pragma GCC optimize("O3","Ofast","unroll-loops","no-stack-protector","fast-math","inline")
//#pragma GCC target("avx","avx2","fma","sse","sse2", "sse3","sse4","tune=native","mmx","abm","popcnt","sse4.2","ssse3")
#include <bits/stdc++.h>

using namespace std;
#define int long long
#define x first
#define y second

struct node;
typedef node* pnode;
struct node{
    pnode c[26];
    pnode b;
    vector<pair<int, pnode>> bjump;
    int psz[26];
    vector<pair<int, pnode>> jump[26];
    int term;
    int sz;
    node(){
        term = 0;
        for(int i =0 ;i<26; i++)
            c[i] = 0;
    }

    void build(pnode _b, int ch){
        b = _b;
        if(b!=0){
            bjump.push_back({b->psz[ch], b});
            while(1){
                int j = bjump.size()-1;
                if(bjump.back().y->bjump.size()>j)
                    bjump.push_back({bjump.back().x+bjump.back().y->bjump[j].x, bjump.back().y->bjump[j].y});
                else break;
            }
        }
        sz = term;
        for(int i = 0; i<26; i++){
            psz[i] = sz;
            if(c[i]!=0){
                c[i]->build(this, i);
                sz+=c[i]->sz;
                jump[i].push_back({c[i]->psz[i], c[i]});
                if(c[i]->c[i]!=0){
                    for(int j = 1; j<c[i]->jump[i].size(); j++){
                        jump[i].push_back({c[i]->psz[i]+c[i]->jump[i][j].x-c[i]->jump[i][j].y->b->psz[i], c[i]->jump[i][j].y->b});
                    }
                }
            }
        }
    }
};
pnode root = new node();


void add(string s){
    pnode now = root;
    for(int i = 0; i<s.length(); i++){
        if(now->c[s[i]-'a']==0){
            now->c[s[i]-'a'] = new node();
        }
        now = now->c[s[i]-'a'];
    }
    now->term++;
}


signed main()
{
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    for(int i = 0; i<n; i++){
        string s1;
        cin >> s1;
        add(s1);
    }
    root->build(0, 0);
    pnode now = root;
    int cnt = 0;
    int len = 0;
    for(int i = 0; i<s.length(); i++){
        cnt+=now->psz[s[i]-'a'];
        if(now->c[s[i]-'a']==0){
            break;
        }
        now = now->c[s[i]-'a'];
        len++;
    }
    cout << cnt << "\n";
    for(int i = 0; i<q; i++){
        int v;
        string s1;
        cin >> v >> s1;
        int ch = s1[0]-'a';
        int go = len-v;
        if(go>0){
            for(int i = 20; i>=0; i--){

                if((go>>i)&1){
                    len-=(1>>i);
                    cnt-= now->bjump[i].x;
                    now = now->bjump[i].y;
                }
            }
        }
        go = abs(go);
        for(int i = 20; i>=0; i--){
            if(go>=(1<<i)){
                if(now->jump[ch].size()>i){
                    len+=(1<<i);
                    go-=(1<<i);
                    cnt+= now->jump[ch][i].x;
                    now = now->jump[ch][i].y;
                }
            }
        }
        cout << cnt << "\n";
    }
    return 0;
}
/*
4 3
anatoly
boris
anatooo
anbbbbu
anba
5 o
3 b
7 x

5 5
abcde
buz
ababa
build
a
aba
1 b
3 z
2 u
4 z
1 a

*/
