#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

using namespace std;

void solve() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n; cin >> n;
    vector <int> a(n), b(n);
    vector<int> c(n);
    vector<int> t(n);
    vector<int> tmr(n);
    int timer = 0;
    auto upd = [&](int x) {
        if (tmr[x] != timer) {
            tmr[x] = timer;
            c[x] = b[x];
            t[x] = a[x];
        }
    };
    int s1 = 0, s2 = 0;
    for (auto& x : a) cin >> x, s1 += x;
    for (auto& x : b) cin >> x, s2 += x;
    int tl = 0, tr = n - 1, ans = -1;
    while (tl <= tr) {
        int mid = (tl + tr) / 2;
        bool can = true;
        timer++;
        int l = 0;
        for (int i = 0; i < n; i++) {
            upd(i);
            l = max(l, i - mid);
            while (t[i] != 0 && l <= min(n-1,i + mid)) {
                upd(l);
                if(c[l] == 0) l++;
                else if (c[l] >= t[i]) {
                    c[l] -= t[i];
                    t[i] = 0;
                }
                else {
                    t[i] -= c[l];
                    c[l] = 0;
                }
            }
            if (t[i] != 0) {
                can = false;
                break;
            }
        }
        if (can) {
            ans = mid;
            tr = mid - 1;
        }
        else {
            tl = mid + 1;
        }
    }
    cout << ans << '\n';
}

signed main() {
    solve();
}