#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(t) (t).begin(), (t).end()
const ld eps = 1e-1;

ld stupidSolve(int a, int b, int c, int d) {
    ld ans = 0;
    for (ld i = eps; i <= a + eps / 2; i += eps) {
        for (ld j = eps; j <= b + eps / 2; j += eps) {
            for (ld k = eps; k <= c + eps / 2; k += eps) {
                for (ld s = eps; s <= d + eps / 2; s += eps) {
                    if (abs(i * s + j + k - j * k - i - s) < eps) {
                        ans = max(ans, i * s + j + k);
                    }
                }
            }
        }
    }
    return ans;
}


void solve() {
    cout << fixed << setprecision(20);
    int n = 4;
    vector<int> t(n);
    for (int &x : t) cin >> x;
    vector<int> ind(n);
    iota(all(ind), 0);
    sort(all(ind));
    vector<pair<int, ld>> best(4);
    ld bestAns = -1e9;
    do {
        for (int nm = 0; nm < n; ++nm) {
            vector<ld> ans(n);
            ld prod = 1;
            bool div0 = false, time0 = false;
            for (int i = 0; i < n; ++i) {
                if (i == nm) continue;
                if (i + nm == 3) (t[ind[i]] == 1 ? div0 = true : prod /= t[ind[i]] - 1);
                else
                    (t[ind[i]] == 1 ? time0 = true : prod *= t[ind[i]] - 1);
                ans[i] = t[ind[i]];
            }
            if (div0 && !time0) continue;
            else if (time0 && !div0) ans[nm] = 1;
            else if (div0 && time0) ans[nm] = t[ind[nm]]; else ans[nm] = 1 + prod;
            if (ans[nm] > t[ind[nm]]) continue;
            ld cur = ans[0] * ans[3] + ans[2] + ans[1];
            if (cur > bestAns) {
                bestAns = cur;
                for (int i = 0; i < 4; ++i) {
                    best[i] = {ind[i], ans[i]};
                }
            }
        }
    } while (next_permutation(all(ind)));
    for (auto &[x, y] : best) cout << x + 1 << ' ';
    cout << '\n';
    for (auto &[x, y] : best) cout << y << ' ';
    cout << '\n';
}

signed main() {
    solve();
}