#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>

using namespace std;

void solve() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n = 1;
    cin >> n;
    vector<int> a(n);
    for (int& x : a) cin >> x;
    vector<int> t1, t2;
    int count = 0;
    auto move1 = [&]() {
        cout << 1 << '\n';
        int x = a.back();
        a.pop_back();
        t1.push_back(x);
    };
    auto move2 = [&]() {
        cout << 2 << '\n';
        int x = a.back();
        a.pop_back();
        t2.push_back(x);
    };
    auto move_2 = [&]() {
        cout << -2 << '\n';
        int x = t2.back();
        t2.pop_back();
        assert(x == ++count);
    };
    auto move_1 = [&]() {
        cout << -1 << '\n';
        int x = t1.back();
        t1.pop_back();
        assert(x == ++count);
    };
    auto move12 = [&]() {
        cout << 12 << '\n';
        int x = t1.back();
        t1.pop_back();
        t2.push_back(x);
    };
    auto move21 = [&]() {
        cout << 12 << '\n';
        int x = t2.back();
        t2.pop_back();
        t1.push_back(x);
    };
    for (int i = 1; i <= n; ++i) {
        if (find(a.begin(), a.end(), i) != a.end()) {
            while (a.back() != i) {
                move1();
            }
            move2();
            move_2();
        }
        else {
            while (t1.back() != i) {
                move12();
            }
            move_1();
            while (t2.size()) {
                move21();
            }
        }
    }
    assert(count == n);
}

signed main() {
    solve();
}