#include<iostream>
#include<vector>
#include<algorithm>

#define ll long long

using namespace std;

int main() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	ll t = 0;
	for (int i = 0; i < n; ++i) cin >> a[i];
	for (int i = 0; i < n; ++i) cin >> b[i];
	for (int i = 0; i < n; ++i) {
		a[i] -= b[i];
		t += a[i];
	}
	if (t > 0) {
		cout << -1;
		return 0;
	}
	int l = n, r = -1;
	while (l - 1 > r) {
		int x = 0;
		vector<int> s = a;
		int m = (l + r) / 2;
		int dead = -1;
		for (int i = 0; i < n; ++i) {
			if (s[i] >= 0) {
				int it = max(max(dead, 0), i - m);
				while (a[i] > 0 && it < n) {
					
					int t = a[it];
					a[it] += min(-t, a[i]);
					a[i] -= min(-t, a[i]);
					if (a[it] == 0) {
						while (it < n && a[it] >= 0) it++;
					}
					if (it > min(i + m, n - 1)) {
						x = 8;
						break;
					}
				}
				dead = it;
			}
		}
		if (x == 8) r = m;
		else l = m;
	}
	cout << l;
}