#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>

#define ll long long
#define ld long double 

using namespace std;

ll l, n;
vector<string> v;
vector<vector<bool>> b;

bool prover(vector<bool> useda, vector<ll> s) {
	if ((ll)s.size() == 1) return true;
	vector<bool> p(26, false);
	for (ll g = 0; g < 26; ++g) {
		bool flag = true;
		for (ll i = 0; i < (ll)s.size(); ++i) {
			if (!b[s[i]][g]) flag = false;
		}
		p[g] = flag && !useda[g];
	}
	bool isa = false;
	for (ll i = 0; i < 26; ++i) {
		if (p[i]) {
			map<vector<bool>, vector<ll>> maap;
			for (ll dk = 0; dk < (ll)s.size(); ++dk) {
				vector<bool> vk(l, false);
				for (ll j = 0; j < l; ++j) {
					if (v[s[dk]][j] == char('a' + i)) vk[j] = true;
				}
				maap[vk].push_back(dk);
			}
			if ((ll)maap.size() == 1) useda[i] = true;
			if ((ll)maap.size() >= 2) {
				bool ans = true;
				useda[i] = true;
				for (auto h : maap) {
					ans = ans && prover(useda, h.second);
				}
				useda[i] = false;
				isa = isa || ans;
			}
		}
	}
	return isa;
}


int main() {
	cin >> l >> n;
	v.resize(n);
	b.resize(n, vector<bool>(26));
	for (ll i = 0; i < n; ++i) cin >> v[i];
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < l; ++j) {
			b[i][(ll)(v[i][j] - 'a')] = true;
		}
	}
	vector<ll> s(n);
	for (ll i = 0; i < n; ++i) s[i] = i;
	vector<bool> us(26, false);
	if (prover(us, s)) cout << "YES";
	else cout << "NO";
}