#include <bits/stdc++.h>

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ll long long
#define ld long double

#define int ll
#define double ld
#define endl '\n'

using namespace std;

bool tr(vector<int> a, vector<int> b, int k, int n) {
    deque<pair<int, int>> remind;
    deque<pair<int, int>> qu;
    for (int i = 0; i < n; ++i) {
        if (qu.size() > 0 and i - qu.front().x > k)
            return false;
        while (remind.size() > 0 and i - remind.front().x > k)
            remind.pop_front();

         while (remind.size() > 0 && a[i] > 0) {
            int take = min(remind.front().y, a[i]);
            a[i] -= take;
            remind.front().y -= take;
            if (remind.front().y == 0)
                remind.pop_front();
        }

        while (qu.size() > 0 and b[i] > 0) {
            int take = min(qu.front().y, b[i]);
            b[i] -= take;
            qu.front().y -= take;
            if (qu.front().y == 0)
                qu.pop_front();
        }

        if (a[i] > b[i]) {
            qu.push_back({i, a[i] - b[i]});
            a[i] = b[i];
        } else if (a[i] < b[i]) {
            remind.push_back({i, b[i] - a[i]});
        }

    }

    return a.back() <= b.back() and qu.size() == 0;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int & e : a)
        cin >> e;
    for (int & e : b)
        cin >> e;

    int sum_a = 0, sum_b = 0;
    for (int e : a)
        sum_a += e;
    for (int e : b)
        sum_b += e;

    if (sum_a > sum_b) {
        cout << -1 << endl;
        return;
    }

    bool ok = true;
    for (int i = 0; i < n; ++i) {
        if (b[i] < a[i]) {
            ok = false;
        }
    }
    if (ok) {
        cout << 0 << endl;
        exit(0);
    }

    int left = 0, right = n;
    while (left + 1 != right) {
        int m = (left + right) / 2;
        if (tr(a, b, m, n))
            right = m;
        else
            left = m;
    }

    cout << right << endl;
}

signed main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    solve();
}

