#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,popcnt")

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ll long long
#define ld long double

#define int ll
#define double ld
#define endl '\n'

using namespace std;

const int p = 239;
const int mod = 1e9 + 7;

const int maxl = 1e6;


vector<int> pr(maxl);


void precalc() {
    pr[0] = 1;
    for (int i = 1; i < maxl; ++i) {
        pr[i] = (pr[i - 1] * p ) % mod;
    }
}

void solve() {
    int l, n;
    cin >> l >> n;
    vector<string> arr(n);
    for (auto & e : arr)
        cin >> e;

    vector<vector<int>> groups;

    vector<vector<int>> gr;
    vector<bitset<26>> ban;
    vector<int> tmp(n);
    bitset<26> tmpb;
    iota(all(tmp), 0);

    gr.push_back(tmp);
    ban.push_back(tmpb);


    while (gr.size()) {
        if (gr.back().size() == 1) {
            gr.pop_back();
            ban.pop_back();
            continue;
        }

        if (ban.back().count() == 26) {
            cout << "NO" << endl;
            return;
        }

        bitset<26> aval = ~ban.back();

        for (int i : gr.back()) {
            bitset<26> has;
            for (char ch : arr[i])
                has[ch - 'a'] = true;
            aval = aval & has;
        }

        if (aval.count() == 0) {
            cout << "NO" << endl;
            return;
        }

        int u = aval._Find_first();

        unordered_map<int, vector<int>> new_groups;

        for (int i : gr.back()) {
            int poses = 0;
            for (char x = 0; x < l; ++x)
                if (arr[i][x] - 'a' == u)
                    poses += pr[x];
            new_groups[poses].push_back(i);
        }

        bitset<26> tmpp = ban.back();

        gr.pop_back();
        ban.pop_back();

        tmpp[u] = true;
        for (auto e : new_groups) {
            if (e.y.size() > 1) {
                gr.push_back(e.y);
                ban.push_back(tmpp);
            }
        }

    }

    cout << "YES" << endl;
}

signed main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL
    precalc();
    solve();
}


