#include <bits/stdc++.h>

using namespace std;
#define int long long

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (auto &x : a) cin >> x;
	for (auto &x : b) cin >> x;
	if (accumulate(b.begin(), b.end(), 0LL) < accumulate(a.begin(), a.end(), 0LL)) {
		cout << -1;
		return;
	}
	int l = 0, r = n + 1;
	while (l < r) {
		int m = (l + r) / 2;
		bool can = 1;
		vector<int> aa = a, bb = b;
		int ptr = 0;
		bool ok = 1;
		for (int i = 0; i < n; i++) {
			if (ptr < i && i - ptr > m) {
				ok = 0;
				break;
			}
			while (ptr < n && abs(i - ptr) <= m && b[i] > 0) {
				if (a[ptr] == 0) {
					ptr++;
				} else {
					int sub = min(b[i], a[ptr]);
					a[ptr] -= sub;
					b[i] -= sub;
				}
			} 
		}
		int cnt = count(a.begin(), a.end(), 0);
		a = aa, b = bb;
		if (cnt == n && ok) {
			r = m;
		} else {
			l = m + 1;
		}
	}

	cout << l;
}	

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}