#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define deb(a) cerr << #a << " = " << a << '\n';
#define int long long

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

typedef tree<
    pii,
    null_type,
    less<pii>,
    rb_tree_tag,
    tree_order_statistics_node_update>
ordered_set;

const int inf = 2e9;
const ll INF = 2e18;
const int MOD1 = 1e9 + 7;
const int MOD2 = 998244353;
const int P1 = 31;
const int P2 = 37;
const int dx[4] = {0, 0, -1, 1};
const int dy[4] = {-1, 1, 0, 0};
const ld Pi = acosl(-1);
const ld EPS = 1e-8;

int qqq = 1;
int n;

bool check(int m, vector <int> &a, vector <int> &b){
    queue <pair <int, int>> q;
    for (int i = 0; i < min(m + 1, n); i++){
        q.push({b[i], i});
    }
    for (int i = 0; i < n; i++){
        int x = a[i];
        while (!q.empty() && i - q.front().s > m){
            q.pop();
        }

        while (!q.empty() && x > 0){
            if (x >= q.front().f){
                x -= q.front().f;
                q.pop();
            }
            else{
                q.front().f -= x;
                x = 0;
            }
        }

        if (x != 0){
            if (m == 2)
                cout << i << '\n';
            return false;
        }
        if (i + m + 1 < n)
            q.push({b[i + m + 1], i});
    }

    return true;
}

pair<ld, int> v[5];

void solve() {
    /*cin >> n;
    vector <int> a(n), b(n);

    for (auto &i: a)
        cin >> i;
    for (auto &i: b)
        cin >> i;

    if (accumulate(a.begin(), a.end(), 0) > accumulate(b.begin(), b.end(), 0)){
        cout << -1 << '\n';
        return;
    }

    int l = -1, r = 1e7;
    while (r - l > 1){
        int m = (r + l) / 2;
        if (check(m, a, b)){
            r = m;
        }
        else{
            l = m;
        }
    }

    cout << r << '\n';*/
    for (int i = 0; i < 4; i++){
        int x;
        cin >> x;
        v[i] = {x, i};
    }
    sort(v, v + 4);
    if ((v[0].f - 1) * (v[3].f - 1) > (v[1].f - 1) * (v[2].f - 1)){
        v[0].f = (v[1].f - 1) * (v[2].f - 1) / (v[3].f - 1) + 1;
    }
    else if ((v[0].f - 1) * (v[3].f - 1) < (v[1].f - 1) * (v[2].f - 1)){
        v[1].f = (v[0].f - 1) * (v[3].f - 1) / (v[2].f - 1) + 1;
    }
    cout << fixed << setprecision(20);
    for (int i = 0; i < 4; i++)
        cout << v[i].s + 1 << ' ';
    cout << '\n';
    for (int i = 0; i < 4; i++)
        cout << v[i].f << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cin >> qqq;
    while (qqq--) {
        solve();
    }
    return 0;
}
