#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define deb(a) cerr << #a << " = " << a << '\n';
#define int long long

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

typedef tree<
    pii,
    null_type,
    less<pii>,
    rb_tree_tag,
    tree_order_statistics_node_update>
ordered_set;

const int inf = 2e9;
const ll INF = 2e18;
const int MOD1 = 1e9 + 7;
const int MOD2 = 998244353;
const int P1 = 31;
const int P2 = 37;
const int dx[4] = {0, 0, -1, 1};
const int dy[4] = {-1, 1, 0, 0};
const ld Pi = acosl(-1);
const ld EPS = 1e-8;
const int N = 2e6;
int qqq = 1;

vector<string> s;
vector<bool> used[N];
pair<int, int> h[N][26];

bool dfs(char cur, vector<int> &v){
    bool f1 = 1;
    //cout << cur << '\n';
    for (char c = cur + 1; c <= 'z'; c++){
        bool flag = 1;
        for (auto it : v)
            flag &= used[it][c - 'a'];
        if (flag){
            map<pair<int, int>, vector<int>> mp;
            for (auto it : v)
                mp[h[it][c - 'a']].eb(it);
            int mx = 0;
            for (auto it : mp){
                if (it.s.size() > 1)
                    f1 &= dfs(c, it.s);
                mx = max(mx, (int)it.s.size());
            }
            if (mx == 1)
                return 1;
            else
                return f1;
            break;
        }
    }
    return 0;
}

void solve() {
    int n, m;
    cin >> m >> n;
    s.resize(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];

    sort(s.begin(), s.end());
    s.resize(unique(s.begin(), s.end()) - s.begin());
    n = (int)s.size();
    //cout << n << '\n';
    for (int i = 0; i < n; i++){
        vector<bool> v(26, 0);
        for (auto it : s[i])
            v[it - 'a'] = 1;
        used[i] = v;
    }
    map<pair<int, int>, int> mp;
    for (int i = 0; i < 26; i++){
        for (int k = 0; k < n; k++){
            int h1 = 0, p = P1;
            int h2 = 0, p1 = P2;
            for (int j = 0; j < m; j++){
                if (s[k][j] - 'a' == i){
                    h1 += (s[k][j] - 'a' + 1) * p;
                    h2 += (s[k][j] - 'a' + 1) * p1;
                }
                h1 %= MOD1;
                p *= P1;
                p %= MOD1;
                h2 %= MOD2;
                p1 *= P2;
                p1 %= MOD2;
            }
            //cout << h1 << '\n';
            h[k][i] = {h1, h2};
        }
    }
    //cout << used[1]['b' - 'a'] << '\n';
    vector<int> v1;
    for (int i = 0; i < n; i++)
        v1.eb(i);
    bool f1 = dfs('a' - 1, v1);
    if (f1)
        cout << "YES";
    else
        cout << "NO";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cin >> qqq;
    while (qqq--) {
        solve();
    }
    return 0;
}
