#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <utility>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ctime>
#include <bitset>
using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9, MOD = 1e9 + 7, Q = 38;
const ld eps = 1e-9;
const ll ll_INF = 1e18;
mt19937 gen;
int n;


bool check(int k, vector<int> a, vector<int> b) {
	int i = 0, j = 0;
	if (a[i] > b[i]) {
		i = 1;
		j = 0;
	}
	else {
		i = 0;
		j = 1;
	}
	while (i < n && j < n) {
		if (i == j) {
			i++;
		}
		else if (i - j > k) {
			j++;
		}
		else if (i - j < -k) {
			i++;
		}
		else {
			if (a[i] < b[i]) {
				int d = b[i] - a[i];
				if (a[j] > d) {
					a[j] -= d;
					a[i] += d;
					i++;
				}
				else {
					a[i] += a[j];
					a[j] = 0;
					j++;
				}
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (a[i] > b[i]) return false;
	}
	return true;
}



void solve() {
	cin >> n;
	vector<int> a(n), b(n);
	ll sum_a = 0, sum_b = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		sum_a += a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		sum_b += b[i];
	}
	if (sum_a > sum_b) {
		cout << -1;
		return;
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i] > b[i]) ans++;
	}
	cout << ans;
}



signed main() {
	ios::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
	int t = 1;
	//	gen.seed(time(0));
	//	cout << fixed;
	//	cout.precision(15);
	//	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
