#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <utility>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ctime>
#include <bitset>
using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9, MOD = 1e9 + 7, Q = 38;
const ld eps = 1e-9;
const ll ll_INF = 1e18;
mt19937 gen;


void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	stack<int> s1, s2;
	vector<string> ans;
	int k1 = 0, k2 = 1;
	while (k1 != n) {
		if (a[k1] == k2) {
			ans.push_back("2");
			ans.push_back("-2");
			k2++;
			k1++;
		}
		else if (!s1.empty() && s1.top() == k2) {
			ans.push_back("-1");
			s1.pop();
			k2++;
		}
		else {
			while (!s1.empty() && s1.top() < a[k1]) {
				s2.push(s1.top());
				ans.push_back("12");
				s1.pop();
			}
			s1.push(a[k1]);
			ans.push_back("1");
			while (!s2.empty()) {
				s1.push(s2.top());
				s2.pop();
				ans.push_back("21");
			}
			k1++;
		}
	}
	while (!s1.empty()) {
		ans.push_back("-1");
		s1.pop();
	}
	for (int i = 0; i < ans.size(); ++i) {
		cout << ans[i] << "\n";
	}
}



signed main() {
	ios::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
	int t = 1;
	//	gen.seed(time(0));
	//	cout << fixed;
	//	cout.precision(15);
	//	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
