#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "-->"; cerr.flush()

using namespace std;

typedef	int ii;
typedef long long ll;
typedef long double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)3e5 + 5;
const ll mod = (ll)1e9 + 7;
const ll maxlog = 20;

void operator delete(void* q);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll n;

ll arr[cst];

ll pmin[cst];
ll pmax[cst];
ll smin[cst];
ll smax[cst];

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n;
    pmin[0] = inf;
    smin[n + 1] = inf;
    for (ll i = 1; i <= n; i++) {
        cin >> arr[i];
        pmin[i] = min(pmin[i - 1], arr[i]);
        pmax[i] = max(pmax[i - 1], arr[i]);
    }
    for (ll i = n; i >= 1; i--) {
        smin[i] = min(smin[i + 1], arr[i]);
        smax[i] = max(smax[i + 1], arr[i]);
    }
    cout << "1.000000000 ";
    for (ll i = 2; i <= n; i++) {
        ld t1 = 1.0 - (ld)pmin[i - 1] / (ld)smin[i];
        ld t2 = 1.0 - (ld)pmax[i - 1] / (ld)smax[i];
        t1 = max((ld)0.0, t1);
        t2 = max((ld)0.0, t2);
        ld delt1 = max((ld)pmax[i - 1], smax[i] * (1.0 - t1)) - min((ld)pmin[i - 1], smin[i] * (1.0 - t1));
        ld delt2 = max((ld)pmax[i - 1], smax[i] * (1.0 - t2)) - min((ld)pmin[i - 1], smin[i] * (1.0 - t2));
        if (t1 > t2) {
            swap(t1, t2);
            swap(delt1, delt2);
        }
        if (delt1 < delt2) cout << setprecision(10) << fixed << t1 << " ";
        else cout << setprecision(10) << fixed << t2 << " ";
    }
    ex();
}