#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "-->"; cerr.flush()

using namespace std;

typedef	int ii;
typedef long long ll;
typedef long double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)1e5 + 5;
const ll mod = (ll)1e9 + 7;
const ll maxlog = 20;

void operator delete(void* q);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ld tr[4];
ld t[4];
vector<ll> p(4);

ld check() {
    ld s1 = t[0] * t[3] + t[1] + t[2];
    ld s2 = t[0] + t[3] + t[1] * t[2];
    if (abs(s1 - s2) <= 1e-6) return s1;
    ld nw = (t[1] * t[2] + t[3] - t[1] - t[2]) / (t[3] - 1);
    if (nw > t[0] + 1e-7) return 0;
    if (nw + 1e-7 < 1.0) return 0;
    t[0] = nw;
    s1 = t[0] * t[3] + t[1] + t[2];
    s2 = t[0] + t[3] + t[1] * t[2];
    if (abs(s1 - s2) <= 1e-6) return s1;
    else return 0;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    for (ll i = 0; i < 4; i++) {
        cin >> tr[i];
        p[i] = i;
    }
    ld answ = 0;
    vector<ll> pans = p;
    do {
        for (ll i = 0; i < 4; i++) t[i] = tr[p[i]];
        ld x = check();
        if (x > answ) {
            answ = x;
            pans = p;
        }
    } while (next_permutation(all(p)));
    for (ll i : pans) cout << i + 1 << " ";
    cout << endl;
    for (ll i = 0; i < 4; i++) t[i] = tr[pans[i]];
    check();
    for (ll i = 0; i < 4; i++) cout << setprecision(8) << fixed << t[i] << " ";
    ex();
}