#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "-->"; cerr.flush()

using namespace std;

typedef	int ii;
typedef long long ll;
typedef long double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)1e5 + 5;
const ll mod = (ll)1e9 + 7;
const ll maxlog = 20;

void operator delete(void* q);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll l, n;

vector<ll> pos[cst][26];

bool split(vector<ll>& v) {
    if (v.size() <= 1) return true;
    ll c = 0;
    for (; c < 26; c++) {
        bool ok = 1;
        for (const ll& i : v) {
            if (pos[i][c].empty()) {
                ok = 0;
                break;
            }
        }
        if (ok) break;
    }
    if (c == 26) return false;
    vector<pair<vector<ll>, ll>> vc;
    for (ll& i : v) {
        vc.push_back({ pos[i][c], i });
        pos[i][c].clear();
    }
    sort(all(vc));
    vector<ll> curr;
    curr.push_back(vc[0].second);
    bool ret = 1;
    for (ll i = 1; i < vc.size(); i++) {
        if (vc[i].first == vc[i - 1].first) curr.push_back(vc[i].second);
        else {
            ret &= split(curr);
            curr.clear();
            curr.push_back(vc[i].second);
        }
    }
    ret &= split(curr);
    return ret;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> l >> n;
    for (ll i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (ll j = 0; j < l; j++) {
            pos[i][s[j] - 'a'].push_back(j);
        }
    }
    vector<ll> vc(n);
    iota(all(vc), 0);
    if (split(vc)) cout << "YES";
    else cout << "NO";
    ex();
}