#include <bits/stdc++.h>
#include <bits/extc++.h>

//#define int long long

using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define sz(x) int(size(x))
#define rep(i, a, b) for (int (i) = (a); (i) < (b); ++(i))
#define pb push_back

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long ll;

template<class T>
using Tree = tree<T, null_type, less<T>, rb_tree_tag,
        tree_order_statistics_node_update>;

void fastio() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}

bool recans(vector<int> v, vector<array<ll, 26>> &hmsk, vector<array<bool, 26>> &cnt) {
    if (v.size() < 2) return true;
//    array<vector<bool>, 26> msks{};
    array<ll, 26> mskshs{};
    array<bool, 26> ok{};
    array<bool, 26> dif{};
//    for (int j = 0; j < 26; ++j) msks[j] = msk[0][j], ok[j] = cnt[0][j], dif[j] = false;
    for (int j = 0; j < 26; ++j) mskshs[j] = hmsk[0][j], ok[j] = cnt[0][j], dif[j] = false;
//    for (int i = 1; i < v.size(); ++i) {
//        for (int j = 0; j < 26; ++j) {
//            ok[j] = ok[j] && cnt[i][j];
//            dif[j] = dif[j] || msks[j] != msk[i][j];
//        }
//    }
    for (int i: v) {
        for (int j = 0; j < 26; ++j) {
            ok[j] = ok[j] && cnt[i][j];
            dif[j] = dif[j] || mskshs[j] != hmsk[i][j];
        }
    }
    for (int j = 0; j < 26; ++j) {
        if (ok[j] && dif[j]) {
            bool ans = true;
            map<ll, vector<int>> vcs;
            for (int i: v) {
                vcs[hmsk[i][j]].push_back(i);
            }
            for (auto[key, val]: vcs) {
                ans = ans && recans(val, hmsk, cnt);
            }
            return ans;
        }
    }
    return false;
}

constexpr int D = 998244353;
constexpr int A = 239;

signed main() {
    fastio();
    int l, n;
    cin >> l >> n;
    vector<string> ss(n);
    for (auto &x: ss) {
        cin >> x;
        for (int i = 0; i < l; ++i) x[i] -= 'a';
    }
    sort(ss.begin(), ss.end());
    for (int i = 0; i < n - 1; ++i) {
        if (ss[i] == ss[i + 1]) {
            cout << "NO";
            return 0;
        }
    }
    vector<array<vector<bool>, 26>> msk(n, array<vector<bool>, 26>{});
    vector<array<bool, 26>> cnt(n, array<bool, 26>{});
    for (int i = 0; i < n; ++i) {
        array<vector<bool>, 26> &cans = msk[i];
        for (int j = 0; j < 26; ++j) cans[j] = vector<bool>(l);
        for (int j = 0; j < l; ++j) cans[ss[i][j]][j] = true, cnt[i][ss[i][j]] = true;
    }
    vector<array<ll, 26>> hmsk(n, array<ll, 26>{});
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 26; ++j) {
            ll ch = 0;
            for (bool w: msk[i][j]) ch = (A * ch + w) % D;
            hmsk[i][j] = ch;
        }
    }
    vector<int> v(n);
    for (int i = 0; i < n; ++i) v[i] = i;
    cout << ((recans(v, hmsk, cnt))? "YES\n": "NO\n");
}