#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,avx,fma,bmi2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#define endl '\n'
#define all(arr) arr.begin(), arr.end()
#define rall(arr) arr.rbegin(), arr.rend()
//#define int long long
using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
typedef pair<int, int> ipair;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> treap;

const int MAXN = 100100;
const int L = 26;
const int INF = 1e9;

int m, n;
string arr[MAXN];
int mrr[MAXN];
pair<string, int> brr[MAXN];
vector<int> G[MAXN][L];

void build() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			int c = arr[i][j] - 'a';
			mrr[i] |= (1 << c);
			G[i][c].push_back(j);
		}
		brr[i] = {string(m, '*'), i};
	}
}

bool solve(int l, int r) {
	/*
	for (int i = l; i < r; ++i)
		cerr << brr[i].first << ' ';
	cerr << endl;*/
	if (r - l <= 1) return true;
	int mask = -1;
	for (int i = l; i < r; ++i)
		mask &= mrr[brr[i].second];
	if (!mask) return false;
	vector<int> bits;
	for (int i = 0; i < L; ++i)
		if (mask >> i & 1)
			bits.push_back(i);
	int circ = bits[rand() % bits.size()];
//	int circ = 31 - __builtin_clz(mask);

	for (int i = l; i < r; ++i) {
		auto& [s, id] = brr[i];
		/*
		for (int c = 0; c < L; ++c) {
			if (!(mask >> c & 1)) continue;
			for (int j: G[id][c])
				s[j] = c + 'a';
		}
		mrr[id] &= (mask ^ -1);*/
		for (int j: G[id][circ])
			s[j] = circ + 'a';
		mrr[id] &= (-1 ^ (1 << circ));
	}
	sort(brr + l, brr + r);
	for (int i = l; i < r;) {
		int j = upper_bound(brr + l, brr + r, make_pair(brr[i].first, INF)) - brr;
		if (!solve(i, j)) return false;
		i = j;
	}
	return true;
}

int32_t main() {
	ios_base::sync_with_stdio(NULL), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10), srand(time(NULL));
	cin >> m >> n;
	for (int i = 0; i < n; ++i)
		cin >> arr[i];
	build();
	cout << (solve(0, n) ? "YES" : "NO") << endl;
}