#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<long long> A(n);
    for (int i = 0; i < n; ++i)
        cin >> A[i];
    vector<long long> B(n);
    for (int i = 0; i < n; ++i)
        cin >> B[i];
    vector<long long> pref_a(n + 1);
    for (int i = 0; i < n; ++i)
        pref_a[i + 1] = pref_a[i] + A[i];
    vector<long long> pref_b(n + 1);
    for (int i = 0; i < n; ++i)
        pref_b[i + 1] = pref_b[i] + B[i];
    int left = -1, right = n;
    while (right - left > 1) {
        int mid = (left + right) / 2;
        bool ok = true;
        long long mn = 1e18;
        for (int i = 0; i < n; ++i) {
            mn = min(mn, pref_a[i] - pref_b[max(0, i - mid)]);
            if (pref_a[i + 1] - pref_b[min(n, i + mid + 1)] > mn)
                ok = false;
        }
        if (ok)
            right = mid;
        else
            left = mid;
    }
    cout << (right == n ? -1 : right) << '\n';
    return 0;
}