//
// Created by olymp on 12.12.2021.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define ar array
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;

using namespace std;

vector<string> a;
vector<int> have;
int l;

bool solve(vector<int> &v, int us) {
    if ((int)v.size() <= 1) return true;
    int mask = us;
    for(auto &i : v) {
        mask &= have[i];
    }
    if (mask == 0) return false;
    int t = 0;
    while(((mask >> t) & 1) == 0) t++;
    char x = char('a' + t);
    int sz = v.size();
    vector<int> tp(sz, 0);
    rep(i, l) {
        vector<int> kek(sz, 0);
        vector<int> to(sz, 0);
        rep(j, sz) {
            int e = v[j];
            if (a[e][i] == x) {
                kek[tp[j]] |= 2;
            } else {
                kek[tp[j]] |= 1;
            }
        }
        int cur = 0;
        rep(j, sz) {
            if (kek[j] == 0) continue;
            to[j] = cur;
            cur++;
            if (kek[j] == 3) cur++;
        }
        rep(j, sz) {
            int e = v[j];
            int tt = tp[j];
            if (a[e][i] == x) {
                if (kek[tt] == 2) {
                    tp[j] = to[tt];
                } else {
                    tp[j] = to[tt] + 1;
                }
            } else {
                tp[j] = to[tt];
            }
        }
    }
    vector<vector<int>> nxt(sz);
    rep(i, sz) {
        nxt[tp[i]].push_back(v[i]);
    }
    us ^= (1 << t);
    rep(i, sz) {
        if (nxt[i].empty()) continue;
        if (!solve(nxt[i], us)) return false;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n; cin >> l >> n;
    have.resize(n);
    a.resize(n);
    rep(i, n) cin >> a[i];
    rep(i, n) {
        for(auto &c : a[i]) {
            have[i] |= (1 << (c - 'a'));
        }
    }
    vector<int> w(n);
    iota(all(w), 0);
    int t = 1 << 26;
    t--;
    if (solve(w, t)) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
    return 0;
}