#include <vector>
#include <iostream>
#include <algorithm>
#include <iomanip>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> A(n);
    for (int i = 0; i < n; ++i) {
        cin >> A[i];
        --A[i];
    }
    vector<bool> in_stack(n, false);
    int j = 0;
    vector<int> stack;
    for (int i = 0; i < n; ++i) {
        while (!in_stack[i]) {
            cout << 1 << '\n';
            stack.emplace_back(A[j]);
            in_stack[A[j]] = true;
            ++j;
        }
        int cnt = 0;
        while (stack[(int) stack.size() - cnt - 1] != i)
            ++cnt;
        vector<int> stack2;
        for (int _ = 0; _ < cnt; ++_) {
            stack2.emplace_back(stack.back());
            cout << 12 << '\n';
            stack.pop_back();
        }
        stack.pop_back();
        cout << -1 << '\n';
        for (int _ = 0; _ < cnt; ++_) {
            stack.emplace_back(stack2.back());
            cout << 21 << '\n';
            stack2.pop_back();
        }
    }
    return 0;
}