#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cmath>
#include <assert.h>
#include <queue>
#define int long long
using namespace std;

signed main() {
	int n; cin >> n;
	vector <int> a(n), b(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
	}

	int l = -1, r = n + 1;
	while (r - l > 1) {
		int k = (l + r) / 2;
		bool ok = true;
		vector <int> at(a);
		queue <int> q;
		for (int i = 0; i < k && i < n; i++) {
			q.push(i);
		}
		for (int i = 0; i < n; i++) {
			if (i + k < n)
				q.push(i + k);
			while (!q.empty() && at[q.front()] == 0) {
				q.pop();
			}
			if (!q.empty() && q.front() < i - k) {
				ok = false;
				break;
			}
			int zap = b[i];
			while (zap > 0 && !q.empty()) {
				int ind = q.front();
				if (zap >= at[ind]) {
					zap -= at[ind];
					q.pop();
				}
				else {
					at[ind] -= zap;
					zap = 0;
				}
			}
		}
		while (!q.empty() && at[q.front()] == 0) {
			q.pop();
		}
		if (ok && q.empty())
			r = k;
		else
			l = k;
	}
	if (r == n + 1)
		r = -1;
	cout << r;


	return 0;
}