#include <bits/stdc++.h>

using namespace std;

#define int long long


struct node_t {
	array<array<int, 26>, 20> next_bin;
	array<array<int, 26>, 20> sum_next_bin;
	int cnt;
	int sum;

	node_t() {
		for(int i = 0; i < 20; i++) {
			fill(next_bin[i].begin(), next_bin[i].end(), -1);
			fill(sum_next_bin[i].begin(), sum_next_bin[i].end(), 0);
		}
		cnt = 0;
		sum = 0;
	}
};

vector<node_t> nodes;


void add_string(const string& s) {
	int node = 0;
	for(char c: s) {
		if(nodes[node].next_bin[0][c - 'a'] == -1) {
			nodes[node].next_bin[0][c - 'a'] = nodes.size();
			nodes.emplace_back();
		}
		node = nodes[node].next_bin[0][c - 'a'];
	}
	nodes[node].cnt++;
}


void dfs(int node) {
	nodes[node].sum = nodes[node].cnt;

	int pref = nodes[node].cnt;
	for(int c = 0; c < 26; c++) {
		nodes[node].sum_next_bin[0][c] = pref;
		int chld = nodes[node].next_bin[0][c];
		if(chld != -1) {
			dfs(chld);
			pref += nodes[chld].sum;
			nodes[node].sum += nodes[chld].sum;
		}
	}

	for(int i = 1; i < 20; i++) {
		for(int c = 0; c < 26; c++) {
			int v = nodes[node].next_bin[i - 1][c];
			nodes[node].sum_next_bin[i][c] = nodes[node].sum_next_bin[i - 1][c];
			if(v != -1) {
				nodes[node].next_bin[i][c] = nodes[v].next_bin[i - 1][c];
				nodes[node].sum_next_bin[i][c] += nodes[v].sum_next_bin[i - 1][c];
			}
		}
	}

}


signed main() {
	nodes.emplace_back();


	int n, q;
	cin >> n >> q;

	vector<tuple<int, char, int, int>> ss;
	string s;
	cin >> s;
	for(int i = 0; i < s.size(); i++) {
		ss.emplace_back(i, s[i], 1, -1);
	}

	for(int i = 0; i < n; i++) {
		string t;
		cin >> t;
		add_string(t);
	}

	dfs(0);


	int node = 0;
	int ans = 0;
	for(int i = 0; i < s.size(); i++) {
		get<3>(ss[i]) = node;
		if(node != -1) {
			ans += nodes[node].sum_next_bin[0][s[i] - 'a'];
		}
		node = node == -1 ? -1 : nodes[node].next_bin[0][s[i] - 'a'];
	}
	cout << ans << "\n";

	for(int i = 0; i < q; i++) {
		int k;
		char c;
		cin >> k >> c;
		k--;

		int exp;
		auto it = lower_bound(ss.begin(), ss.end(), make_tuple(k, 0, 0, 0));
		if(it != ss.begin()) {
			--it;

			auto& [i, c, n, node] = *it;

			assert(k == 0 || i < k);
			assert(i + n >= k);

			int node1 = node;
			for(int j = 19; j >= 0 && node1 != -1; j--) {
				if((n >> j) & 1) {
					ans -= nodes[node1].sum_next_bin[j][c - 'a'];
					node1 = nodes[node1].next_bin[j][c - 'a'];
				}
			}
			n = k - i;

			node1 = node;
			for(int j = 19; j >= 0 && node1 != -1; j--) {
				if((n >> j) & 1) {
					ans += nodes[node1].sum_next_bin[j][c - 'a'];
					node1 = nodes[node1].next_bin[j][c - 'a'];
				}
			}

			exp = it - ss.begin() + 1;
		} else {
			exp = 0;
		}

		while(ss.size() > exp) {
			auto [i, c, n, node] = ss.back();
			for(int j = 19; j >= 0 && node != -1; j--) {
				if((n >> j) & 1) {
					ans -= nodes[node].sum_next_bin[j][c - 'a'];
					node = nodes[node].next_bin[j][c - 'a'];
				}
			}
			ss.pop_back();
		}

		int node;
		if(ss.empty()) {
			node = 0;
		} else {
			int i, c, n;
			tie(i, c, n, node) = ss.back();
			for(int j = 19; j >= 0 && node != -1; j--) {
				if((n >> j) & 1) {
					node = nodes[node].next_bin[j][c - 'a'];
				}
			}
		}

		int n = s.size() - k;
		ss.emplace_back(k, c, n, node);
		for(int j = 19; j >= 0 && node != -1; j--) {
			if((n >> j) & 1) {
				ans += nodes[node].sum_next_bin[j][c - 'a'];
				node = nodes[node].next_bin[j][c - 'a'];
			}
		}

		cout << ans << "\n";
	}

	return 0;
}
