#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vi vector<int>
#define pii pair<int, int>
#define pb push_back
#define vpii vector<pair<int, int> >

const long double eps = 1e-10;
const int INF = (1ll << 31ll) - 1ll;
const long long INFL = (1ll << 63ll) - 1ll;

void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(15);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
}

const size_t SIZE = 5e5 + 10;

bool check(vector<int> a, vector<int> &b, int k) {
    int n = a.size();
    int j = 0;
//    cout << k << '\n';
    for (int i = 0; i < n; i++) {
        while (a[i] > b[i]) {
            while (j < n && (a[j] >= b[j] || i - j > k))
                j++;
            if (j >= n || j - i > k)
                return false;
            int del = b[j] - a[j];
            int need = a[i] - b[i];
//            cout << i << " : " << j << " : " << del << " : " << need << '\n';
            if (need < del) {
                a[j] += need;
                a[i] -= need;
            } else {
                a[j] += del;
                a[i] -= del;
            }
        }
    }
    return true;
}

signed main() {
    fastio();

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    int l = -1, r = n;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (check(a, b, m)) {
            r = m;
        } else {
            l = m;
        }
    }
    if (r == n) {
        cout << -1 << '\n';
        return 0;
    }
    cout << r << '\n';

    return 0;
}
/*

 */