#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ld long double
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vi vector<int>
#define pii pair<int, int>
#define pb push_back
#define vpii vector<pair<int, int> >

const long double eps = 1e-12;
const int INF = (1ll << 31ll) - 1ll;
const ld INFL = 1e20;

void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(20);

//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
}

struct parabola {
    ld a, b, c;
    parabola() = default;
    parabola(ld a, ld b, ld c): a(a), b(b), c(c){}
    ld get(ld x) {
        return a * x * x + b * x + c;
    }
};

pair<ld, ld> inter(parabola t1, parabola t2) {
    ld a = t1.a - t2.a;
    ld b = t1.b - t2.b;
    ld c = t1.c - t2.c;
    ld d = b * b - 4 * a * c;
    if (d < -eps) {
        return {-INFL, INFL};
    }
    if (abs(a) < eps) {
        ld t = (-c) / b;
        if (abs((-t1.b / (2 * t1.a)) - (-t2.b / (2 * t2.a))) < eps) {
            return {-INFL, INFL};
        }
        if (-t1.b / (2 * t1.a) < -t2.b / (2 * t2.a)) {
            return {t, INFL};
        } else {
            return {-INFL, t};
        }
    }
    return {(-b - sqrtl(abs(d))) / (2 * a), (-b + sqrtl(abs(d))) / (2 * a)};
}

signed main() {
    fastio();

    int n;
    cin >> n;
    vector<parabola> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].a >> v[i].b >> v[i].c;
    }
    int pos = -1;
    ld mx = -INFL;
    for (int i = 0; i < n; i++) {
        ld cur = v[i].get(-v[i].b / (v[i].a * 2));
        if (v[i].a >= 0 && cur > mx - eps) {
            if (cur > mx + eps) {
                mx = cur;
                pos = i;
            } else if (abs(cur - mx) < eps && v[i].a > v[pos].a) {
                mx = cur;
                pos = i;
            }
        }
    }
    if (pos == -1) {
        cout << 0 << " " << -1e30 << '\n';
        return 0;
    }
    ld l = -INFL, r = INFL;
    for (int i = 0; i < n; i++) {
        if (i == pos)
            continue;
        pair<ld, ld> x = inter(v[pos], v[i]);
        l = max(l, x.fi);
        r = min(r, x.se);
    }
    cout << l << " " << v[pos].get(l) << '\n';

    return 0;
}
/*
1
1 0 0
===
4
1 2 3
1 -3 -5
-1 3 4
-2 4 6
 */