#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>

#define int long long
using namespace std;

long double eps = 1e-6;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(15);

    vector <pair <int, int>> t(4);
    for (int i = 0; i < 4; i++) {
        cin >> t[i].first;
        t[i].second = i;
    }
    sort(t.begin(), t.end());

    vector <long double> ans(4);
    for (int i = 0; i < 4; i++)
        ans[i] = t[i].first;
    long double prod = min((t[0].first - 1) * (t[3].first - 1), (t[1].first - 1) * (t[2].first - 1));

    if (abs(prod - (t[0].first - 1) * (t[3].first - 1)) < eps) {
        if (ans[1] < ans[2]) {
            if (ans[2] != 1)
                ans[1] = prod / (ans[2] - 1) + 1;
        } else {
            if (ans[1] != 1)
                ans[2] = prod / (ans[1] - 1) + 1;
        }
    } else {
        if (ans[0] < ans[3]) {
            if (ans[3] != 1)
                ans[0] = prod / (ans[3] - 1) + 1;
        } else {
            if (ans[0] != 1)
                ans[3] = prod / (ans[0] - 1) + 1;
        }
    }

    for (auto &[val, i]: t)
        cout << i + 1 << " ";
    cout << endl;
    for (auto &el: ans)
        cout << el << " ";
    cout << endl;


    return 0;
}
