#include <iostream>
#include <random>
#include <algorithm>
#include <deque>
#include <iomanip>

#pragma warning(disable : 4996)

using namespace std;

//define int long long
#define double long double
#define max(a, b) a<b ? b : a
#define min(a, b) a<b ? a : b
mt19937 rnd;

using namespace std;

inline int getint() {
	int res = 0;
	while (1) {
		char f = _getchar_nolock();
		if (f == ' ' || f == '\n') break;
		res = res * 10 + (f - '0');
	}
	return res;
}

const int inf = 1e9;
const int MAXN = 2e5;

int f[MAXN];
int max1[MAXN];
int max2[MAXN];
int min1[MAXN];
int min2[MAXN];

signed main() {
	//ios_base::sync_with_stdio(); cin.tie(0); cout.tie(0);
	cout << setprecision(11) << fixed;
	int n = getint();
	for (int i = 0; i < n; i++) {
		f[i] = getint();
	}
	max1[0] = f[0];
	max2[n - 1] = f[n - 1];
	min1[0] = f[0];
	min2[n - 1] = f[n - 1];
	for (int i = 1; i < n; i++) {
		max1[i] = max(max1[i - 1], f[i]);
		max2[n - i - 1] = max(max2[n - i], f[n - i - 1]);
		min1[i] = min(min1[i - 1], f[i]);
		min2[n - i - 1] = min(min2[n - i], f[n - i - 1]);
	}
	for (int i = 0; i < n; i++) {
		if (i == 0) {
			cout << 1.0 << ' ';
			continue;
		}
		pair <double, double> res;
		res.first = inf;
		res.second = -1;
		double a = min1[i - 1], b = max1[i - 1], c = min2[i], d = max2[i];
		if (c >= a && b * c >= a * d) {
			if (max1[i - 1] - min1[i - 1] <= res.first) {
				if (b - a < res.first) res.second = 1 - (double)a / c;
				else res.second = max(res.second, 1 - (double)a / c);
				res.first = max1[i - 1] - min1[i - 1];
			}
		}
		if (b <= d && a * d >= b * c) {
			double t = (double)b / d;
			if ((d - c) * t <= res.first) {
				if ((d - c) * t == res.first) res.second = max(res.second, 1 - t);
				else res.second = 1 - t;
				res.first = (d - c) * t;
			}
		}
		if (a <= c && d >= b) {
			double t = max(a / c, b / d);
			if (t * d - a <= res.first) {
				if (t * d - a == res.first) res.second = max(res.second, 1 - t);
				else res.second = 1 - t;
				res.first = t * d - a;
			}
		}
		if (c <= a && b >= d && b - c <= res.first) {
			if (b - c < res.first) res.second = 0;
			res.first = b - c;
		}
		if (b <= res.first) {
			res.second = 1;
			res.first = b;
		}
		cout << res.second << ' ';
	}
}