﻿#define _CRT_SECURE_NO_WARNINGS

#include <bitset>
#include <iostream>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <utility>
#include <cassert>
#include <vector>

#ifdef ONLINE_JUDGE
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

//#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << " = " << x << '\n';

using namespace std;

const int INF = int(1e9) + 7, p = 289;

int l, n;
string str[int(1e5)];

bool rec(vector<int>& ind) {
  vector<int> have(26, 1);

  for (int i : ind) {
    vector<int> kok(26);
    for (char c : str[i]) kok[c - 'a'] = 1;
    for (int i = 0; i < 26; ++i) {
      have[i] &= kok[i];
    }
  }

  map<vector<int>, vector<int>> mp;

  for (int i : ind) {
    vector<int> cur(26);
    for (int j = 0; j < sz(str[i]); ++j) {
      int ind = j + 1;
      if (have[str[i][j] - 'a']) {
        cur[str[i][j] - 'a'] = (1ll * cur[str[i][j] - 'a'] * p + ind) % INF;
      }
    }
    mp[cur].push_back(i);
  }

  if (sz(mp) == 1) {
    return sz(ind) == 1;
  } else {
    bool ans = true;
    for (auto& [x, y] : mp) {
      ans &= rec(y);
    }
    return ans;
  }
}

void solve() {
  cin >> l >> n;

  for (int i = 0; i < n; ++i) cin >> str[i];

  vector<int> ind(n);
  iota(ind.begin(), ind.end(), 0);

  cout << (rec(ind) ? "YES" : "NO");
}

signed main() {
  cin.tie(nullptr)->ios::sync_with_stdio(false);
  cout << fixed << setprecision(10);
  int tests = 1;
  //cin >> tests
  for (int test = 1; test <= tests; ++test) {
    cerr << "_______Test # " << test << "_______:\n";
    solve();
    cerr << '\n';
  }
}