﻿#define _CRT_SECURE_NO_WARNINGS

#include <bitset>
#include <iostream>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <utility>
#include <cassert>
#include <vector>

#ifdef ONLINE_JUDGE
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

//#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << " = " << x << '\n';

using namespace std;

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }

  reverse(a.begin(), a.end());
  vector<int> ans, pos(n + 1), st1, st2;
  for (int i = 1; i <= n; ++i) {
    if (!pos[i]) {
      while (a.back() != i) {
        pos[a.back()] = 1;
        ans.push_back(1);
        pos[a.back()] = 1;
        st1.push_back(a.back());
        a.pop_back();
      }
      a.pop_back();
      ans.push_back(1);
      ans.push_back(-1);
    } else if (pos[i] == 1) {
      while (st1.back() != i) {
        pos[st1.back()] = 2;
        ans.push_back(12);
        st2.push_back(st1.back());
        st1.pop_back();
      }
      st1.pop_back();
      ans.push_back(-1);
    } else {
      while (st2.back() != i) {
        pos[st2.back()] = 1;
        ans.push_back(21);
        st1.push_back(st2.back());
        st2.pop_back();
      }
      st2.pop_back();
      ans.push_back(-2);
    }
  }

  for (int longlongkok : ans) {
    cout << longlongkok << '\n';
  }
}

signed main() {
  cin.tie(nullptr)->ios::sync_with_stdio(false);
  int tests = 1;
  //cin >> tests
  for (int test = 1; test <= tests; ++test) {
    cerr << "_______Test # " << test << "_______:\n";
    solve();
  }
}