#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <queue>
#include <bitset>
#include <array>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;
typedef long long ll;
typedef long double ld;


bool OK(int k, vector<int> a) {
    int j = 0;
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        if (a[i] < 0) {
            while (a[i] != 0 && j < n) {
                if (a[j] <= 0) {
                    ++j;
                    continue;
                }
                if (abs(i - j) > k) {
                    break;
                }
                if (-a[i] >= a[j]) {
                    a[i] += a[j];
                    a[j] = 0;
                    ++j;
                } else {
                    a[j] += a[i];
                    a[i] = 0;
                    break;
                }
            }
        }
    }
    while (j < n && a[j] <= 0) {
        ++j;
    }
    return j == n;
}


int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n;
    cin >> n;
    vector<int> a(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        int delta;
        cin >> delta;
        a[i] -= delta;
//        cout << a[i] << endl;
    }
    int left = -1, right = n;
    while (right - left != 1) {
        int middle = (right + left) >> 1;
        if (OK(middle, a)) {
            right = middle;
        } else {
            left = middle;
        }
    }
    if (right == n) {
        cout << "-1" << endl;
    } else {
        cout << right << endl;
    }
    return 0;
}
