#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <queue>
#include <bitset>
#include <array>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

bool solve(int n, vector<string> a, vector<int> used) {
    if (n == 1)
        return true;
    for (int c = 0; c < 26; ++c) {
        if (used[c])
            continue;
        bool tmp = false;
        for (int j = 0; j < n; ++j) {
            bool find = false;
            for (auto i : a[j])
                if (i - 'a' == c) {
                    find = true;
                    break;
                }
            if (!find) {
                tmp = true;
                break;
            }
        }
        if (!tmp) {
            used[c] = 1;
            map<vector<int>, vector<string>> b;
            for (int j = 0; j < n; ++j) {
                vector<int> tmp;
                int ind = 0;
                for (auto i : a[j]) {
                    if (i - 'a' == c) {
                        tmp.push_back(ind);
                    }
                    ++ind;
                }
                b[tmp].push_back(a[j]);
            }
            bool res = true;
            for (auto i : b) {
                if (!solve(i.second.size(), i.second, used)) {
                    res = false;
                    break;
                }
            }
            return res;
        }
    }
    return false;
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int m, n;
    cin >> m >> n;
    vector<string> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (solve(n, a, vector<int> (26)))
        cout << "YES\n";
    else
        cout << "NO\n";
}
