#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <queue>
#include <bitset>
#include <array>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    vector<int> pos(n, -1);
    vector<int> s1, s2;
    int ind = 0;
    for (int i = 0; i < n; ++i) {
        if (pos[i] == -1) {
            while (a[ind] != i) {
                s1.push_back(a[ind]);
                pos[a[ind]] = 1;
                ++ind;
                cout << 1 << '\n';
            }
            ++ind;
            cout << 1 << '\n';
            cout << -1 << '\n';
        } else if (pos[i] == 1) {
            while (s1.back() != i) {
                cout << "12\n";
                int c = s1.back();
                pos[s1.back()] = 2;
                s1.pop_back();
                s2.push_back(c);
            }
            cout << -1 << '\n';
            s1.pop_back();
        } else {
            while (s2.back() != i) {
                cout << "21\n";
                int c = s2.back();
                pos[s2.back()] = 1;
                s2.pop_back();
                s1.push_back(c);
            }
            cout << -2 << '\n';
            s2.pop_back();
        }
    }
}
