#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <stack>
typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n;
    cin >> n;
    vector<ll> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    if (n == 1){
        cout << 1;
        return 0;
    }
    vector<ll> s_max(n + 1);
    s_max[n] = a[n];
    for (int i = n - 1; i >= 0; i--) s_max[i] = max(s_max[i + 1], a[i]);
    vector<ll> p_max(n + 1);
    p_max[1] = 0;
    for (int i = 2; i <= n; i++) p_max[i] = max(p_max[i - 1], a[i - 1]);
    vector<ll> p_min(n + 1);
    p_min[1] = a[1];
    for (int i = 2; i <= n; i++) p_min[i] = min(p_min[i - 1], a[i - 1]);
    vector<ll> s_min(n + 1);
    s_min[n] = a[n];
    for (int i = n - 1; i >= 0; i--) s_min[i] = min(s_min[i + 1], a[i]);
    cout << "1 ";
    for (int k = 2; k <= n; k++){
        int a = p_max[k];
        int c = s_max[k];
        int b = p_min[k];
        int d = s_min[k];
        ld t1 = max(1 - ld(a)/c, 1 - ld(b)/d);
        t1 = max(t1, ld(0.0));
        ld n1 = a - (1 - t1)*d;
        bool is_t2 = false;
        ld t2 = 0;
        ld n2 = 0;
        if (b*c <= d*a){
            t2 = 1 - ld(b)/d;
            t2 = max(t2, ld(0.0));
            n2 = a - b;
            is_t2 = true;
        }
        bool is_t3 = false;
        ld t3 = 0;
        ld n3 = 0;
        if (b*c >= d*a) {
            t3 = 1 - ld(a) / c;
            t3 = max(t3, ld(0.0));
            n3 = (1 - t3) * (c - d);
            is_t3 = true;
        }
        ld t4 = min(1 - ld(a)/c, 1 - ld(b)/d);
        bool bad_t4 = true;
        if (t4 >= ld(0.0)) bad_t4 = false;
        ld n4 = (1 - t4) * c - b;
        if (is_t2){
            // t1 t2 t4
            if (n1 < n2){
                if (n1 < n4 || bad_t4){
                    //n1
                    cout << fixed << setprecision(10) << t1 << ' ';
                }
                else{
                    //n4
                    cout << fixed << setprecision(10) << t4 << ' ';
                }
            }
            else{
                if (n2 < n4 || bad_t4){
                    //n2
                    cout << fixed << setprecision(10) << t2 << ' ';
                }
                else{
                    //n4
                    cout << fixed << setprecision(10) << t4 << ' ';
                }
            }
        }
        else{
            // t1 t3 t4
            if (n1 < n3){
                if (n1 < n4 || bad_t4){
                    //n1
                    cout << fixed << setprecision(10) << t1 << ' ';
                }
                else{
                    //n4
                    cout << fixed << setprecision(10) << t4 << ' ';
                }
            }
            else{
                if (n3 < n4 || bad_t4){
                    //n3
                    cout << fixed << setprecision(10) << t3 << ' ';
                }
                else{
                    //n4
                    cout << fixed << setprecision(10) << t4 << ' ';
                }
            }
        }

    }
    return 0;
}
