#include <iostream>
#include <vector>
#include <algorithm>

using ll = long long;
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

//    ifstream inp("input.txt");
//
//    inp.close();
//
//    ofstream out("output.txt");
//
//    out.close();

    ll n, temp;
    cin >> n;
    vector<ll> a(n);
    vector<pair<ll, ll>> b(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    ll pol_ind = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> temp;
        b[i] = pair(temp - a[i], i);
        if (b[i].first < 0)
            pol_ind++;
    }
    if (pol_ind == 0)
    {
        cout << 0 << '\n';
        return 0;
    }
    sort(b.begin(), b.end(), [](const pair<ll, ll> a, const pair<ll, ll> b)
    {
        return (a.first < b.first) || (a.first == b.first && a.second < b.second);
    });
    ll max_delta = -9999999999;
    for (int i = 0; i < pol_ind; i++) {
        while (b[i].first < 0)
        {
            for (int j = pol_ind; j < n; j++) {
                if (b[j].first >= abs(b[i].first)) {
                    b[j].first -= abs(b[i].first);
                    b[i].first = 0;
                }
                else
                {
                    b[i].first += b[j].first;
                    b[j].first = 0;
                }
                if (abs(b[i].second - b[j].second) > max_delta)
                    max_delta = abs(b[i].second - b[j].second);
            }
            if (b[i].first < 0)
            {
                cout << -1 << '\n';
                return 0;
            }
        }
    }
    cout << max_delta << '\n';
    return 0;
}
