#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <tuple>
#define ll long long
using namespace std;

const int INF = 1e9 + 7;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	int n;
	cin >> n;

	vector<int> a(n), b(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	for (int i = 0; i < n; ++i)
		cin >> b[i];

	// cout << "READ\n";

	int l = -1, r = 1e6 + 1;
	while (r - l > 1) {
		int k = (l + r) / 2;
		bool success = true;

		int ai = 0, bi = 0;
		vector<int> cur_a = a, cur_b = b;
		while (ai <= n / 2) {
			if (cur_a[ai] > cur_b[bi]) {
				cur_a[ai] -= cur_b[bi];
				cur_b[bi] = 0;
				bi++;
				if (abs(ai - bi) > k || bi >= n) {
					success = false;
					break;
				}
			}
			else if (cur_a[ai] < cur_b[bi]) {
				cur_b[bi] -= cur_a[ai];
				cur_a[ai] = 0;
				ai++;
				if (abs(ai - bi) > k)
					bi++;
			}
			else {
				cur_a[ai] = 0;
				cur_b[bi] = 0;
				ai++, bi++;
			}
		}

		ai = n - 1, bi = n - 1;

		while (ai > n / 2) {
			if (cur_a[ai] > cur_b[bi]) {
				cur_a[ai] -= cur_b[bi];
				cur_b[bi] = 0;
				bi--;
				if (abs(ai - bi) > k || bi < 0) {
					success = false;
					break;
				}
			}
			else if (cur_a[ai] < cur_b[bi]) {
				cur_b[bi] -= cur_a[ai];
				cur_a[ai] = 0;
				ai--;
				if (abs(ai - bi) > k)
					bi--;
			}
			else {
				cur_a[ai] = 0;
				cur_b[bi] = 0;
				ai--, bi--;
			}
		}

		if (success)
			r = k;
		else
			l = k;
	}

	if (r == 1e6 + 1)
		cout << -1 << "\n";
	else
		cout << r << "\n";
}
