#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

vector<int> a, b;
int n;

bool check(int k, vector<int> a_, vector<int> freek)
{   
    int left_not_zero = 0;
    // cout << "k - " << k << '\n';
    for (int i = 0; i < n; i++)
    {
        // cout << "ai " << a[i] << '\n';
        for (int j = max(max(0, i - k), left_not_zero); j < min(n, i + k + 1); j++)
        {   
            // cout << "for " << i << " - " << j << "\n";
            if (a_[i] > freek[j])
            {
                a_[i] -= freek[j];
                freek[j] = 0;
                left_not_zero++;
                // cout << "freeak " << j << " - 0\n";
                // cout << a[i] << ' ' << freek[i] << '\n';
            }
            else
            {
                freek[j] -= a_[i];
                a_[i] = 0;
                break;
            }
        }
        if (a_[i])
        {
            // cout << "false: " << i << ' ' << k << ' ' << a_[i] << '\n';
            return false;
        }
    }

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    cin >> n;

    a.resize(n);
    for (ll i = 0; i < n; i++)
        cin >> a[i];

    b.resize(n);
    for (ll i = 0; i < n; i++)
    {
        cin >> b[i];
    }

    // cout << pref_b[2] - pref_b[0] << '\n';
    // check(1);
    // return 0;
    ll l = -1, r = n;
    while (r - l > 1)
    {
        ll m = (l + r) / 2;
        if (!check(m, a, b))
        {
            l = m;
        }
        else
        {
            r = m;
        }
    }

    if (!check(r, a, b))
    {
        cout << -1 << '\n';
    }
    else
    {
        cout << r << '\n';
    }
}