#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
    #ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
    #endif

    int n;
    cin >> n;
    vector<ld> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<ld> prefmax = {a[0]};
    vector<ld> prefmin = {a[0]};
    vector<ld> sufmax{a[n-1]};
    vector<ld> sufmin{a[n-1]};
    for (int i = 1; i < n; ++i){
        prefmax.push_back(max(prefmax[i-1], a[i]));
        prefmin.push_back(min(prefmin[i-1], a[i]));
        sufmin.push_back(min(sufmin[i-1], a[n-1-i]));
        sufmax.push_back(max(sufmax[i-1], a[n-1-i]));
    }
    sufmin.pop_back();
    sufmax.pop_back();
    reverse(sufmax.begin(), sufmax.end());
    reverse(sufmin.begin(), sufmin.end());
    vector<ld> ans{1.00};
    // cout << "start\n";
    // for (auto i : prefmax){
        // cout << i << " ";
    // }
    // cout << "\nend\n";
    for (int i = 0; i < n- 1; ++i){
        if (prefmin[i] <= sufmin[i] && prefmax[i] >= sufmax[i]){
            ans.push_back(1 - prefmin[i] / sufmin[i]);
        } else if (prefmin[i] >= sufmin[i] && prefmax[i] <= sufmax[i]){
            ans.push_back(1 - prefmax[i] / sufmax[i]);
        } else if (prefmax[i] >= sufmax[i] && prefmin[i] >= sufmin[i]){
            ans.push_back(0);
        } else if (prefmin[i] >= sufmax[i]){
            ans.push_back(0);
        } else if (sufmin[i] >= prefmax[i]){
            ans.push_back(1 - min(prefmax[i] / sufmax[i], prefmin[i] / sufmin[i]));
        }
        else{
            ans.push_back(1 - min(prefmax[i] / sufmax[i], prefmin[i] / sufmin[i]));
        }
    }
    for (auto i : ans){
        cout << fixed << i << " ";
    }
    return 0;
}
