#include <iostream>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <stack>
#include <algorithm>
#include <vector>

#pragma gcc-optimize ("-Ofast")
#pragma gcc-optimize ("unroll-loops")

using itn = int;
using ll = long long;

const int INF = 1e9;

const long double EPS = 1e-9;

using namespace std;

int n;

vector <long double> a, sufmin, sufmax;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    sufmin.resize(n);
    sufmax.resize(n);
    sufmin[n - 1] = a[n - 1];
    sufmax[n - 1] = a[n - 1];
    for (int i = 1; i < n; ++i){
        sufmin[n - i - 1] = min(sufmin[n - i], a[n - i - 1]);
        sufmax[n - i - 1] = max(sufmax[n - i], a[n - i - 1]);
    }
    cout << fixed << setprecision(12);
    cout << 1.0 << " ";
    long double max1 = a[0], max2, min1 = a[0], min2;
    for (int i = 1; i < n; ++i) {
        max2 = sufmax[i], min2 = sufmin[i];
        if (max1 >= max2){
            if (min1 >= min2)
                cout << 0 << " ";
            else
                cout << 1 - min1 / min2 << " ";
        }
        else {
            if (min1 >= min2) {
                cout << 1 - max1 / max2 << " ";
            }
            else {
                long double ans1, ans2, t1, t2;
                t1 = 1 - min1 / min2;
                t2 = 1 - max1 / max2;
                ans1 = max(max1, max2 * (1 - t1)) - min(min1, min2 * (1 - t1));
                ans2 = max(max1, max2 * (1 - t2)) - min(min1, min2 * (1 - t2));
                if (abs(ans1 - ans2) < EPS)
                    cout << max(t1, t2) << " ";
                else if (ans1 < ans2)
                    cout << t1 << " ";
                else
                    cout << t2 << " ";
            }
        }
        max1 = max(max1, a[i]);
        min1 = min(min1, a[i]);
    }
}