#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>
#include <cmath>
#include <ctime>
#include <string>
#include <queue>
#include <iomanip>

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx2")
#pragma GCC optimization("unroll-loops")

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll n;
vector<ld> a;
const ld eps = 1e-10;
ld check(ld m, ll pos)
{
    ld mn = 1e18, mx = -1;
    for (int i = 0; i < n; i++)
    {
        ld now = a[i];
        if (i >= pos)
        {
            now = (1.0 - m) * a[i];
        }
        mn = min(mn, now);
        mx = max(mx, now);
    }
    return mx - mn;
}

void solve() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++)
    {
        ld l = 0.0, r = 1.0;
        ld ans;
        for(int j = 0; j < 1000; j++)
        {
            ld m1 = l + (r - l) / 3.0;
            ld m2 = r - (r - l) / 3.0;
            ld now = check(m1, i);
            ld too = check(m2, i);
            if (now < too)
            {
                r = m2;
                ans = m2;
            }
            else
            {
                l = m1;
                ans = m1;
                if (now == too)
                {
                    ans = m2;
                }
            }
        }
        cout << fixed << setprecision(20) << ans << ' ';
    }
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int tt = 1;
    //cin>>tt;
    while (tt--)
        solve();
}