#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>
#include <cmath>
#include <ctime>
#include <string>
#include <queue>
#include <iomanip>

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx2")
#pragma GCC optimization("unroll-loops")

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll n;
vector<ll> a;
vector<ll> pref_mn, pref_mx, suff_mn, suff_mx;
const ld eps = 1e-10;

ld check(ld m, ll pos)
{
    if (!pos) {
        return (1 - m) * (suff_mx[0] - suff_mn[0]);
    }
    ll first = min((ld)pref_mn[pos - 1], suff_mn[pos] * (1.0 - m));
    ll second = max((ld)pref_mx[pos - 1], suff_mx[pos] * (1.0 - m));
    return second - first;
}

void solve() {
    cin >> n;
    a.resize(n);
    pref_mn.resize(n, 1e18);
    pref_mx.resize(n, -1);
    suff_mn.resize(n, 1e18);
    suff_mx.resize(n, -1);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        pref_mn[i] = min(pref_mn[i], a[i]);
        pref_mx[i] = max(pref_mx[i], a[i]);
    }
    for (int i = n - 1; i >= 0; i--) {
        suff_mn[i] = min(suff_mn[i], a[i]);
        suff_mx[i] = max(suff_mx[i], a[i]);
    }
    for (int i = 0; i < n; i++)
    {
        ld l = 0.0, r = 1.0;
        ld ans;
        for(int j = 0; j < 100; j++)
        {
            ld m1 = l + (r - l) / 3.0;
            ld m2 = r - (r - l) / 3.0;
            ld now = check(m1, i);
            ld too = check(m2, i);
            if (now < too)
            {
                r = m2;
                ans = m2;
            }
            else
            {
                l = m1;
                ans = m1;
                if (now == too)
                {
                    ans = m2;
                }
            }
        }
        cout << fixed << setprecision(15) << ans << ' ';
    }
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0);
    int tt = 1;
    //cin>>tt;
    while (tt--)
        solve();
}