#define _USE_MATH_DEFINES

#include <iostream>
#include <iomanip>

#include <cmath>
#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

struct node {
    int a[26], sum, term;
    node() {
        for (int i = 0; i < 26; ++i)
            a[i] = -1;
        sum = 0;
        term = 0;
    }
};

vector<node> t(1);

void add(const string& s, int v = 0, int i = 0) {
    ++t[v].sum;
    if (i == s.size()) {
        ++t[v].term;
        return;
    }
    if (t[v].a[s[i] - 'a'] == -1) {
        t[v].a[s[i] - 'a'] = t.size();
        t.emplace_back();
    }
    add(s, t[v].a[s[i] - 'a'], i + 1);
    return;
}
int get(const string& s, int v = 0, int i = 0) {
    if (i == s.size())
        return 0; //t[v].term;

    int ans = t[v].term;
    for (int j = 0; j < int(s[i] - 'a'); ++j)
        if (t[v].a[j] != -1)
            ans += t[t[v].a[j]].sum;

    if (t[v].a[s[i] - 'a'] != -1)
        ans += get(s, t[v].a[s[i] - 'a'], i + 1);

    return ans;
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

    int n, q;
    cin >> n >> q;

    string s;
    cin >> s;

    for (int i = 0; i < n; ++i) {
        string temp;
        cin >> temp;
        add(temp);
    }

    //cout << endl;
    cout << get(s) << '\n';
    //cout << endl;

    while (q--) {
        int i; char c;
        cin >> i >> c;
        --i;
        for (; i < s.size(); ++i)
            s[i] = c;

        //cout << endl;
        cout << get(s) << '\n';
        //cout << endl;
    }
    return 0;
}