#define _USE_MATH_DEFINES

#include <iostream>
#include <iomanip>

#include <cmath>
#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    int l = -1, r = n;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        vector<int> curb = b;
        int temp = 0, it = 0;
        bool fail = 0;
        for (int i = 0; i < n; i++) {
            temp = a[i];
            it = max(i - mid, it);
            for (it; it < min(i + mid + 1, n); it++) {
                if (temp == 0)
                    break;
                if (curb[it] > 0) {
                    if (curb[it] >= temp) {
                        curb[it] -= temp, temp = 0;
                        break;
                    }
                    else {
                        temp -= curb[it], curb[it] = 0;
                    }
                }
            }
            if (temp != 0) {
                fail = 1;
                break;
            }
        }
        if (fail)
            l = mid;
        else
            r = mid;
    }
    if (r == n)
        cout << -1;
    else
        cout << r;
    return 0;
}