import math

inf = 1e5

if __name__ == '__main__':
    n = int(input())

    a, b, c = [0] * n, [0] * n, [0] * n
    for i in range(n):
        a[i], b[i], c[i] = map(int, input().split())

    min_y, max_y = inf, -inf
    cur_min, cur_max = -1, -1

    for i in range(n):
        x0 = -b[i] / (2 * a[i])
        y0 = a[i] * x0 * x0 + b[i] * x0 + c[i]

        if a[i] > 0:
            max_y = max(max_y, y0)
            cur_max = i
        else:
            min_y = min(min_y, y0)
            cur_min = i

    cur = -1
    Y = 0
    if cur_min == -1:
        Y = max_y
        cur = cur_max
    else:
        Y = min_y
        cur = cur_min

    sd = math.sqrt(b[cur] * b[cur] - 4 * a[cur] * (c[cur] - Y))

    x1 = (-b[cur] - sd) / (2 * a[cur])
    x2 = (-b[cur] + sd) / (2 * a[cur])

    x1_ = min(x1, x2)
    x2_ = max(x1, x2)

    print(f'{x2:.{8}f} {Y:.{8}f}')