#include <bits/stdc++.h>
#define int int64_t
#define F first
#define S second

using namespace std;

const long long mxn = 2e6 + 1;
const double inf = 1e18;
const double eps = 1e-11;

int n;
double suff[mxn], suffmx[mxn], suffmn[mxn];
double prefmx[mxn], prefmn[mxn];
double a[mxn];

double f(double t, int k) {
    double mx1 = prefmx[k - 1], mn1 = prefmn[k - 1];
    double mx2 = (1 - t) * suffmx[k], mn2 = (1 - t) * suffmn[k];
    double mx = max(mx1, mx2), mn = min(mn1, mn2);
    return mx - mn;
}


signed main () {

    cin >> n;
    prefmx[0] = -inf, prefmn[0] = inf;
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
        prefmx[i] = max(prefmx[i - 1], a[i]);
        prefmn[i] = min(prefmn[i - 1], a[i]);
    }
    suffmx[n + 1] = -inf, suffmn[n + 1] = inf;
    for(int i = n; i >= 1; i--) {
        suff[i] = suff[i + 1] + a[i];
        suffmx[i] = max(suffmx[i + 1], a[i]);
        suffmn[i] = min(suffmn[i + 1], a[i]);
    }
    for(int i = 1; i <= n; i++) {
        double l = 0, r = 1;
        for(int j = 1; j <= 105; j++) {
            double m1 = l + (r - l) / 3;
            double m2 = r - (r - l) / 3;
            if(f(m1, i) < f(m2, i)) r = m2;
            else if(f(m1, i) > f(m2, i)) l = m1;
            else {
                if(m1 * suff[i] < m2 * suff[i]) l = m2;
                else r = m1;
            }
        } double ans;
        if(f(l, i) == f(r, i)) {
            if(l * suff[i] > r * suff[i]) ans = l;
            else ans = r;
        } else {
            if(f(l, i) < f(r, i)) ans = l;
            else ans = r;
        }
        cout << fixed << setprecision(11) << ans << ' ';
    }
    return 0;
}
