#include <bits/stdc++.h>
#define int int64_t

using namespace std;

const long long mxn = 2e5 + 1;
const double inf = 1e18;
const double eps = 1e-11;

int n;
double a[mxn];

double f(double t, int k) {
    double mx = -inf, mn = inf;
    for(int i = 1; i <= n; i++) {
        if(i < k) mx = max(mx, a[i]), mn = min(mn, a[i]);
        else mx = max(mx, (1 - t) * a[i]), mn = min(mn, (1 - t) * a[i]);
    }
    return mx - mn;
}

signed main () {

    cin >> n;
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    for(int i = 1; i <= n; i++) {
        double l = 0, r = 1;
        while(r - l > eps) {
            double m1 = l + (r - l) / 3;
            double m2 = r - (r - l) / 3;
            if(f(m1, i) < f(m2, i)) r = m2;
            else l = m1;
        }
        cout << fixed << setprecision(10) << l << endl;
    }
    return 0;
}
