#include <bits/stdc++.h>
#define ll long long
#define clr clear
#define pb push_back
#define INF (ll)2e9

using namespace std;

int n;

const int MAXN = (int)2e5 + 20;

double a[MAXN], mn1[MAXN], mx1[MAXN], mn2[MAXN], mx2[MAXN];

vector < int > tp;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	cout << setprecision(10) << fixed;

	cin >> n;

	for (int i = 1; i <= n; ++i)
		cin >> a[i];
	
	mx1[1] = mn1[1] = a[1];
	for (int i = 2; i <= n; ++i)
	{
		mx1[i] = max(mx1[i - 1], a[i]);
		mn1[i] = min(mn1[i - 1], a[i]);
	}

	mx2[n] = mn2[n] = a[n];
	for (int i = n - 1; i > 0; --i)
	{
		mx2[i] = max(mx2[i + 1], a[i]);
		mn2[i] = min(mn2[i + 1], a[i]);
	}

	cout << 1;
	for (int k = 2; k <= n; ++k)
	{
		double ans = INF;

		double val1 = 1.0 - mn1[k - 1] / mn2[k], val2 = 1.0 - mx1[k - 1] / mx2[k];

		if (val1 >= max(val2, 0.0))
		{
			ans = mx1[k - 1] - mn1[k - 1];
			tp.pb(1);
		}

		double t2 = max(val1, max(val2, 0.0));
		double ans2 = mx1[k - 1] - (1 - t2) * mn2[k];

		if (fabs(ans2 - ans) < 1e-9)
			tp.pb(2);
		else if (ans2 < ans)
		{
			tp.clr();
			tp.pb(2);
			ans = ans2;
		}

		if (val2 >= 0.0 && val1 <= val2)
		{
			double t3 = val2;
			double ans3 = (1 - t3) * (mx2[k] - mn2[k]);
			if (fabs(ans3 - ans) < 1e-9)
				tp.pb(3);
			else if (ans3 < ans)
			{
				tp.clr();
				tp.pb(3);
				ans = ans3;
			}
		}

		if (min(val1, val2) >= 0.0)
		{
			double t4 = min(val1, val2);
			double ans4 = (1 - t4) * mx2[k] - mn1[k - 1];

			if (fabs(ans4 - ans) < 1e-9)
				tp.pb(4);
			else if (ans4 < ans)
			{
				tp.clr();
				tp.pb(4);
				ans = ans4;
			}
		}

		double t = 0.0;

		for (auto it: tp)
		{
			if (it == 1)
				t = max(t, val1);
			else if (it == 2)
				t = max(t, max(val1, max(val2, 0.0)));
			else if (it == 3)
				t = max(t, val2);
			else
				t = max(t, min(val1, val2));
		}

		cout << ' ' << t;
	}

	return 0;
}