#include<bits/stdc++.h>

#define x first
#define y second
#define pb push_back
#define sz(x) (x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

using ll = long long;
using pii = pair<int, int>;

vector<double> brr, fss;

void brute(vector<int> a) {
    int n = sz(a);
    vector<int> mns(n), mxs(n);
    for (int i = n-1; ~i; --i) {
        mxs[i] = max((i+1<n ? mxs[i+1] : 0), a[i]);
        mns[i] = min((i+1<n ? mns[i+1] : (int)1e9), a[i]);
    }
    int mn = a[0], mx = a[0];
    //cout << setprecision(10) << fixed;
    double one = 1;
    brr.pb(one);//cout << one << " ";
    for (int i = 1; i < n; ++i) {
        double mn1 = mn;
        double mx1 = mx;
        double mn2 = mns[i];
        double mx2 = mxs[i];
        double ans = 1e9;
        double tt = -1;
        for (double t = 0; t <= 1; t += 1e-5) {
            double f = max(mx1, mx2*(1.0-t));
            double s = min(mn1, mn2*(1.0-t));
            if (f-s <= ans) {
                ans = f-s;
                tt = t;
            }
        }
        brr.pb(tt);
        //cout << tt << " ";
        mn = min(mn, a[i]);
        mx = max(mx, a[i]);
    }
    //cout << endl;
}

void fast(vector<int> a) {
    int n = sz(a);
    vector<int> mns(n), mxs(n);
    for (int i = n-1; ~i; --i) {
        mxs[i] = max((i+1<n ? mxs[i+1] : 0), a[i]);
        mns[i] = min((i+1<n ? mns[i+1] : (int)1e9), a[i]);
    }
    int mn = a[0], mx = a[0];
    //cout << setprecision(10) << fixed;
    double one = 1, zero = 0;
    fss.pb(one);//cout << one << " ";
    for (int i = 1; i < n; ++i) {
        double mn1 = mn;
        double mx1 = mx;
        double mn2 = mns[i];
        double mx2 = mxs[i];
        if (mx2 <= mn1) {
            fss.pb(zero);
        } else if (mx1 <= mn2) {
            double t1 = 1.0 - mx1/mx2;
            double t2 = 1.0 - mn1/mn2;
            double f = mx1 - mn2*(1.0-t1);
            double s = mx2*(1.0-t2) - mn1;
            if (f < s) {
                fss.pb(t1);//cout << t1 << " ";
            } else {
                fss.pb(t2);//cout << t2 << " ";
            }
        } else if (mx2 >= mx1 && mn2 <= mn1) {
            double t1 = 0;
            double t2 = 1.0 - mx1/mx2;
            double f = mx2 - mn2;
            double s = mx1 - mn2*(1.0-t2);
            if (f < s) {
                fss.pb(t1);// << " ";
            } else {
                fss.pb(t2);// << " ";
            }
        } else if (mn1 <= mn2 && mx2 <= mx1) {
            fss.pb(1.0 - mn1/mn2);// << " ";
        } else if (mx2 <= mx1 && mn2 <= mn1) {
            fss.pb(zero);
        } else if (mx2 >= mx1 && mn2 >= mn1) {
            double t1 = 1.0 - mx1/mx2;
            double t2 = 1.0 - mn1/mn2;
            double f = mx1 - mn2*(1.0-t1);
            double s = mx2*(1.0-t2) - mn1;
            if (f < s) {
                fss.pb(t1);// << " ";
            } else {
                fss.pb(t2);// << " ";
            }
        } else {
            fss.pb(zero);// << " ";
        }
        mn = min(mn, a[i]);
        mx = max(mx, a[i]);
    }
    //cout << endl;
}

uniform_int_distribution<int> d(1, 1e9);
mt19937 rnd;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    rnd.seed(time(NULL));
    int n = 50;
    cin >> n;
    vector<int> a(n);
    for (int& x : a) cin >> x;
    fast(a);
    cout << setprecision(10) << fixed;
    for (double x : fss) cout << x << " ";

    /*while (1) {
        for (int& x : a) x = d(rnd);
        fss.clear();
        brr.clear();
        brute(a);
        fast(a);
        for (int i = 0; i < n; ++i) {
            if (fabs(fss[i]-brr[i]) > 1e-5) {
                cout << "HELLO\n";
                for (int x : a) cout << x << " ";
                cout << "\n";
                for (double x : fss) cout << x << " ";
                cout << "\n";
                for (double x : brr) cout << x << " ";
                exit(0);
            }
        }
        cerr << "c\n";
    }*/
    return 0;
}
