#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ld long double

using ll = long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1e6 + 10;
int go[N][26], cnt[N], now = 2, jump[N][26], par[20][N], dp[N], sz[N];
int d[N];
vector<pair<int,int>> t(4 * N, {-1, -1});

void update(int v, int tl, int tr, int l, int r, pair<int,int>p){
    if (l > r) return;
    if (tl == l && tr == r){
        t[v] = max(t[v], p);
        return;
    }
    int tm = (tl + tr) / 2;
    update(2 * v, tl, tm, l, min(r, tm), p), update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, p);
}

pair<int,int> get(int v, int l, int r, int pos, pair<int,int> p){
    p = max(p, t[v]);
    if (l == r){
        return p;
    }
    int m = (l + r) / 2;
    if (pos <= m) return get(2 * v, l, m, pos, p);
    else return get(2 * v + 1, m + 1, r, pos, p);
}

void build(string s){
    int v = 1;
    for (int i = 0; i < s.size(); i++){
        if (go[v][s[i] - 'a'] == 0) go[v][s[i] - 'a'] = now++;
        par[0][go[v][s[i] - 'a']] = v;
        v = go[v][s[i] - 'a'];
        d[v] = i + 1;
    }
    cnt[v]++;
}

void dfs(int v, int sum){
    dp[v] = sum;
    for (int j = 0; j < 26; j++){
        if (go[v][j] != 0){
            dfs(go[v][j], sum + cnt[v]);
            sum += sz[go[v][j]];
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, q, m;
    cin >> n >> q;
    vector<string> t(n);
    string s;
    cin >> s;
    m = s.size();
    for (int i = 0; i < s.size(); i++){
        update(1, 0, m - 1, i, i, {0, s[i] - 'a'});
    }
    for (int i = 0; i < n; i++){
        cin >> t[i];
        build(t[i]);
    }
    for (int i = now - 1; i >= 1; i--) {
        for (int j = 0; j < 26; j++) {
            jump[i][j] = (go[i][j] != 0 ? jump[go[i][j]][j] : i);
        }
    }
    par[0][1] = 1;
    for (int i = 1; i < 20; i++){
        for (int j = 1; j < now; j++){
            par[i][j] = par[i - 1][par[i - 1][j]];
        }
    }
    for (int i = 1; i < now; i++){
        sz[i] = cnt[i];
    }
    for (int i = now - 1; i >= 1; i--) {
        for (int j = 0; j < 26; j++) {
            if (go[i][j] != 0) {
                sz[i] += sz[go[i][j]];
            }
        }
    }
    dfs(1, 0);
    int v = 1;
    for (int i = 0; i < s.size(); i++){
        if (go[v][s[i] - 'a'] != 0){
            v = go[v][s[i] - 'a'];
        }
        else break;
    }
    int ans = dp[v];
    if (d[v] < s.size()){
        ans += cnt[v];
        for (int j = 0; j < s[d[v]] - 'a'; j++){
            if (go[v][j] == 0) continue;
            ans += sz[go[v][j]];
        }
    }
    cout << ans << '\n';
    for (int i = 0; i < q; i++){
        int k;
        char c;
        cin >> k >> c;
        update(1, 0, m - 1, k - 1, m - 1, {i + 1, c - 'a'});
        if (d[v] >= k) {
            for (int j = 19; j >= 0; j--) {
                if (d[par[j][v]] >= k) {
                    v = par[j][v];
                }
            }
            v = par[0][v];
            v = jump[v][c - 'a'];
        }
        else{
            if (d[v] + 1 == k){
                v = jump[v][c - 'a'];
            }
        }
        int ans = dp[v];
        if (d[v] < s.size()){
            ans += cnt[v];
            int val = get(1, 0, m - 1, d[v], {-1, -1}).second;
            for (int j = 0; j < val; j++){
                if (go[v][j] == 0) continue;
                ans += sz[go[v][j]];
            }
        }
        cout << ans << '\n';
    }
    return 0;
}