#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;
#define int ll
#define f first
#define s second
#define vi vector<int>
#define pii pair<int, int>
#define pb push_back
vector<pair<ld, pair<ld, ld>>> up, down;

const ld inf = 2e9;

bool check_up(ld y) {
    ld l = -inf, r = inf;
    for (auto u : up){
        ld now = u.s.f * u.s.f - 4 * u.f * (u.s.s - y);
        if (now < 0)
            return 0;
        ld f = (-u.s.f - sqrt(now)) / (2 * u.f);
        ld s = (-u.s.f + sqrt(now)) / (2 * u.f);
        l = max(l, f);
        r = min(r, s);
    }
    return (l < r);
}

bool check_down(ld y) {
    ld l = -inf, r = inf;
    for (auto u : down){
        ld now = u.s.f * u.s.f - 4 * u.f * (u.s.s - y);
        if (now < 0)
            return 0;
        ld s = (-u.s.f - sqrt(now)) / (2 * u.f);
        ld f = (-u.s.f + sqrt(now)) / (2 * u.f);
        l = max(l, f);
        r = min(r, s);
    }
    return (l < r);
}

ld get(ld y){
    ld l1 = -inf, r1 = inf;
    for (auto u : up){
        ld now = u.s.f * u.s.f - 4 * u.f * (u.s.s - y);
        if (now < 0)
            return 0;
        ld f = (-u.s.f - sqrt(now)) / (2 * u.f);
        ld s = (-u.s.f + sqrt(now)) / (2 * u.f);
        l1 = max(l1, f);
        r1 = min(r1, s);
    }
    ld l2 = -inf, r2 = inf;
    for (auto u : down){
        ld now = u.s.f * u.s.f - 4 * u.f * (u.s.s - y);
        if (now < 0)
            return 0;
        ld s = (-u.s.f - sqrt(now)) / (2 * u.f);
        ld f = (-u.s.f + sqrt(now)) / (2 * u.f);
        l2 = max(l2, f);
        r2 = min(r2, s);
    }
    return max(l1, l2) - min(r1, r2);
}

ld get_ans(ld y){
    ld l1 = -inf, r1 = inf;
    for (auto u : up){
        ld now = u.s.f * u.s.f - 4 * u.f * (u.s.s - y);
        if (now < 0)
            return 0;
        ld f = (-u.s.f - sqrt(now)) / (2 * u.f);
        ld s = (-u.s.f + sqrt(now)) / (2 * u.f);
        l1 = max(l1, f);
        r1 = min(r1, s);
    }
    ld l2 = -inf, r2 = inf;
    for (auto u : down){
        ld now = u.s.f * u.s.f - 4 * u.f * (u.s.s - y);
        if (now < 0)
            return 0;
        ld s = (-u.s.f - sqrt(now)) / (2 * u.f);
        ld f = (-u.s.f + sqrt(now)) / (2 * u.f);
        l2 = max(l2, f);
        r2 = min(r2, s);
    }
    return min(r1, r2);
}

void solve() {
    int n;
    ld a, b, c;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a >> b >> c;
        if (a > 0) {
            up.pb({a, {b, c}});
        } else {
            down.pb({a, {b, c}});
        }
    }
    const ld eps = 1e-6;
    ld l = -inf, r = inf;
    while(r > l + eps){
        ld mid = (r + l) / 2;
        if (check_up(mid)){
            r = mid;
        }else{
            l = mid;
        }
    }
    ld mn = r;
    l = -inf, r = inf;
    while(r > l + eps){
        ld mid = (r + l) / 2;
        if (check_down(mid)){
            l = mid;
        }else{
            r = mid;
        }
    }
    ld mx = l;
    l = mn, r = mx;
    while (r > l + eps) {
        ld f = l + (r - l) / 3;
        ld s = r - (r - l) / 3;
        ld f_ras = get(f);
        ld s_ras = get(s);
        if (f_ras < s_ras)
            r = s;
        else
            l = f;
    }
    ld x = get_ans(l);
    cout << fixed << x << ' ' << l << endl;
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(16);
    solve();
    return 0;
}