#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vsi = vector<set<ll>>;
using vmsi = vector<multiset<ll>>;


#ifndef DEBUG
#define endl '\n'
#endif


template<typename T, typename V>
istream &operator>>(istream &is, pair<T, V> &p) {
    is >> p.first >> p.second;
    return is;
}


template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &e: v) is >> e;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v) os << e << ' ';
    return os;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    cout.setf(ios::fixed);

    solve();
}

// ----------------

void solve() {
    ll n, m = 0;
    cin >> n;
    vi a(n);
    cin >> a;
    sort(a.begin(), a.end());
    if (n % 2 == 0) {
        for (int i = n - 1; i > n / 2 - 1; --i) {
            m += a[i];
        }
    } else {
        for (int i = n - 1; i > n / 2; --i) {
            m += a[i];
        }
    }
    cout << m;
}
