#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vsi = vector<set<ll>>;
using vmsi = vector<multiset<ll>>;
using ld = long double;


#ifndef DEBUG
#define endl '\n'
#endif


template<typename T, typename V>
istream &operator>>(istream &is, pair<T, V> &p) {
    is >> p.first >> p.second;
    return is;
}


template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &e: v) is >> e;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v) os << e << ' ';
    return os;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    cout.setf(ios::fixed);

    solve();
}

// ----------------

void solve() {
    ll n;
    cin >> n;
    vi a(n);
    cin >> a;
    reverse(a.begin(), a.end());

    vi s;
    vi ms{(ll) 1e18}, Ms{(ll) -1e18}, ma{(ll) 1e18}, Ma{(ll) -1e18};
    s.push_back(0);
    for (auto e: a) {
        ma.push_back(min(ma.back(), e));
        Ma.push_back(max(Ma.back(), e));
    }

    for (int i = 0; i < n; ++i) {

#define F1(t) ((ld) Ms.back() - (ld) ms.back())
#define F2(t) ((ld) Ms.back() - (ld) ma.back() + (t) * (ld) ma.back())
#define F3(t) ((ld) Ma.back() - (ld) ms.back() - (t) * (ld) Ma.back())
#define F4(t) ((1 - (t)) * ((ld) Ma.back() - (ld) ma.back()))
#define F(t) max({F1((t)), F2((t)), F3((t)), F4((t))})

        ld L = 0, R = 1;
        while (R - L > 1e-12) {
            ld M1 = L + (R - L) / 3 * 1;
            ld M2 = L + (R - L) / 3 * 2;
            ld f1 = F(M1);
            ld f2 = F(M2);
            if (f1 < f2) {
                R = M2;
            } else {
                L = M1;
            }
        }

        cout << R << ' ';
        s.push_back(a.back());
        ms.push_back(min(ms.back(), s.back()));
        Ms.push_back(max(Ms.back(), s.back()));
        ma.pop_back();
        Ma.pop_back();
        a.pop_back();
    }
    cout << endl;
}
