#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vsi = vector<set<ll>>;
using vmsi = vector<multiset<ll>>;


#ifndef DEBUG
#define endl '\n'
#endif


template<typename T, typename V>
istream &operator>>(istream &is, pair<T, V> &p) {
    is >> p.first >> p.second;
    return is;
}


template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &e: v) is >> e;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v) os << e << ' ';
    return os;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    cout.setf(ios::fixed);

    solve();
}

// ----------------

void solve() {
    ll n;
    cin >> n;
    vi a(n);
    cin >> a;
    reverse(a.begin(), a.end());
    vi p, q;
    vi pm, qm;

    auto i1 = [&a, &p, &pm]() {
        cout << '1' << endl;
        p.push_back(a.back());
        pm.push_back(min((pm.empty() ? (ll) 1e18 : pm.back()), p.back()));
        a.pop_back();
    };
    auto c21 = [&q, &qm, &p, &pm]() {
        cout << "21" << endl;
        p.push_back(q.back());
        pm.push_back(min((pm.empty() ? (ll) 1e18 : pm.back()), p.back()));
        q.pop_back();
        qm.pop_back();
    };
    auto c12 = [&q, &qm, &p, &pm]() {
        cout << "12" << endl;
        q.push_back(p.back());
        qm.push_back(min((qm.empty() ? (ll) 1e18 : qm.back()), q.back()));
        p.pop_back();
        pm.pop_back();
    };
    auto o1 = [&p, &pm]() {
        cout << "-1" << endl;
        p.pop_back();
        pm.pop_back();
    };
    auto o2 = [&q, &qm]() {
        cout << "-2" << endl;
        q.pop_back();
        qm.pop_back();
    };

    for (int i = 0; i < n; ++i) {
        i1();
    }

    for (int cur = 1; cur <= n;) {
        if (not pm.empty() and pm.back() == cur) {
            if (p.back() == cur) {
                ++cur;
                o1();
            } else c12();
        } else if (not qm.empty() and qm.back() == cur) {
            if (q.back() == cur) {
                ++cur;
                o2();
            } else c21();
        } else {
            assert(false);
            abort();
        }
    }

}
