#include <bits/stdc++.h>

using namespace std;

using ll = int_fast64_t;
using ull = uint_fast64_t;

#define int ll
#define len(a) (int)(a).size()
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


const int INF = 1 << 29;
const ll INFll = 1ll << 62;


template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &o: v)
        is >> o;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (T &o: v)
        os << o;
    return os;
}


void solve() {
    const double EPS = 1e-7;
    array<pair<int, int>, 4> arr{};
    for (int i = 0; i < 4; ++i) {
        cin >> arr[i].first;
        --arr[i].first;
        arr[i].second = i;
    }
    sort(all(arr));
    for (int i = 0; i < 4; ++i) {
        cout << arr[i].second + 1 << " ";
    }
    cout << "\n";
    double a = arr[0].first, b = arr[1].first,
    c = arr[2].first, d = arr[3].first;
    if(a == 0){
        b = 0;
        cout << setprecision(10) << fixed
             << a + 1 << " " << b + 1 << " "
             << c + 1<< " " << d + 1 << "\n";
        return;
    }
    if(a * d > b * c + EPS){
        d -= (a * d - b * c) / a;
    }else if(b * c > a * d + EPS){
        c -= (b * c - a * d) / b;
    }
    cout << setprecision(10) << fixed
     << a + 1 << " " << b + 1 << " "
     << c + 1<< " " << d + 1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
