#include <bits/stdc++.h>

using namespace std;
#define sz(a)a.size()
#define int long long
#define ll long long
#define dl double
#define all(v) v.begin(), v.end()
#define pii pair<int, int>
int n;

int  pos(int k, vector<int> a, vector<int> b) {
    int ai = 0, bi = 0;
    while (ai < n && bi < n) {
        if (bi - ai > k)return 0;
        if (ai - bi > k)bi++;
        if (a[ai] > b[bi]) {
            a[ai]-=b[bi];
            bi++;
        }
        else{
            b[bi]-=a[ai];
            ai++;
        }
    }
    if(ai == n)return 1;
    return 0;
}

void solve() {
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    int l = -1, r = 1e18;
    while (l < r - 1) {
        int m = (l + r) / 2;
        if (pos(m, a, b))r = m;
        else l = m;
    }
    if (!pos(r, a, b))cout << -1;
    else cout << r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}