#include <bits/stdc++.h>
#define int int64_t

using namespace std;

const int N = 1e6;

int n;
array<int, N> a, b, ans;

bool check (int k) {
    fill(ans.begin(), ans.end(), 0);
    int l = 0, r = k;
    for (int i = 0; i < n; i++) {
        int cur = a[i];
        while (l <= r && cur) {
            int delta = min(b[l] - ans[l], cur);
            ans[l] += delta;
            cur -= delta;
            if (b[l] - ans[l] == 0)
                l++;
        }
        if (l > r || cur) {
            return false;
        }
        r++;
        l = max(l, i + 1 - k);
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
    int s = 0;
    for (int i = 0; i < n; i++) {
        s += b[i] - a[i];
    }
    if (s < 0) {
        cout << -1;
        return 0;
    }
    int l = 0, r = n - 1;
    while (r - l > 1) {
        int m = l + (r - l) / 2;
        if (check(m))
            r = m;
        else
            l = m;
    }
    if (check(l))
        r = l;
    cout << r;
}