#include <bits/stdc++.h>

#define int int64_t
#define double long double

using namespace std;

const double eps = 1e-10;
const int N = 2e5;

multiset<double> pref, suf;

bool check (double m1, double m2) {
      double mx1 = max(*pref.rbegin(), *suf.rbegin() * (1 - m1)), mn1 = min(*pref.begin(), *suf.begin() * (1 - m1));
      double mx2 = max(*pref.rbegin(), *suf.rbegin() * (1 - m2)), mn2 = min(*pref.begin(), *suf.begin() * (1 - m2));
      double diff1 = mx1 - mn1;
      double diff2 = mx2 - mn2;
      /*cout << m1 << ' ' << m2 << '\n';
      cout << mx1 << ' ' << mx2 << '\n';
      cout << '\n';*/
      if (abs(diff1 - diff2) > eps) {
            if (diff1 < diff2)
                  return false;
            else
                  return true;
      }  else {
            if (m1 > m2)
                  return false;
            else
                  return true;
      }
}

int32_t main() {
      cout.precision(9);
      cout.setf(ios::fixed);
      int n;
      cin >> n;
      array<int, N> a;
      for (int i = 0; i < n; i++)
            cin >> a[i];
      for (int i = 1; i < n; i++)
            suf.insert(a[i]);
      pref.insert(a[0]);
      cout << 1. << ' ';
      for (int i = 1; i < n; i++) {
            double l = 0, r = 1;
            while (r - l > eps) {
                  double m1 = l + (r - l) / 3., m2 = r - (r - l) / 3.;
                  if (check(m1, m2))
                        l = m1;
                  else
                        r = m2;
            }
            cout << l << ' ';
            pref.insert(a[i]);
            suf.erase(suf.find(a[i]));
      }
}
