#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;

using ll = long long;

double a[300000];

double tree[300000];
double treem[300000];

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = a[l];
        return;
    }
    int md = (l + r) / 2;
    build(v * 2, l, md);
    build(v * 2 + 1, md + 1, r);
    tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
}

void buildm(int v, int l, int r)
{
    if (l == r)
    {
        treem[v] = a[l];
        return;
    }
    int md = (l + r) / 2;
    buildm(v * 2, l, md);
    buildm(v * 2 + 1, md + 1, r);
    treem[v] = max(treem[v * 2], treem[v * 2 + 1]);
}

double get_min(int v, int tl, int tr, int l, int r)
{
    if (tl >= l && tr <= r) return tree[v];
    if (tl > r || tr < l) return 2e9;
    int md = (tl + tr) / 2;
    return min(get_min(v * 2, tl, md, l, r), get_min(v * 2 + 1, md + 1, tr, l, r));
}

double get_max(int v, int tl, int tr, int l, int r)
{
    if (tl >= l && tr <= r) return treem[v];
    if (tl > r || tr < l) return 0;
    int md = (tl + tr) / 2;
    return max(get_max(v * 2, tl, md, l, r), get_max(v * 2 + 1, md + 1, tr, l, r));
}

int main()
{
    cout << setprecision(10) << fixed;
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }
    build(1, 1, n);
    buildm(1, 1, n);
    for (int i = 1; i <= n; i++)
    {
        if (i == 1)
        {
            cout << 1.0 << ' ';
            continue;
        }
        double k1 = get_min(1, 1, n, i, n);
        double k2 = get_max(1, 1, n, i, n);
        double kk1 = get_min(1, 1, n, 1, i - 1);
        double kk2 = get_max(1, 1, n, 1, i - 1);
        cout << max(0.00, 1.000 - kk1 / k2)  << ' ';
    }
    cout << '\n';
}
