#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()
#define int long long
using namespace std;


void INPUT(bool F = 0) {

    iostream::sync_with_stdio(false);
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);


}



signed main() {
    INPUT();

    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> mxp(n), mnp(n), mxs(n), mns(n);
    mxp[0] = mnp[0] = a[0];
    mxs[n-1] = mns[n-1] = a[n-1];
    for(int i = 1; i < n; i++) {
        mxp[i] = max(mxp[i-1], a[i]);
        mnp[i] = min(mnp[i-1], a[i]);
    }
    for(int i = n-2; i >= 0; i--) {
        mxs[i] = max(mxs[i+1], a[i]);
        mns[i] = min(mns[i+1], a[i]);
    }

    const long double eps = 1e-12, inf = 2e9, one = 1;
    auto eval = [&](int idx, long double t) {
        if(t < -eps || t > one + eps)
            return inf;
        long double Min = min<long double>(mnp[idx-1], (one - t) * mns[idx]);
        long double Max = max<long double>(mxp[idx-1], (one - t) * mxs[idx]);
        long double res = Max - Min;
        return res;
    };

    vector<long double> ans(n);
    for(int i = 0; i < n; i++) {
        if(i == 0) {
            ans[i] = 1;
            continue;
        }
        vector<long double> cand;
        cand.push_back((long double)0.0);
        cand.push_back(one);
        cand.push_back(one - (long double)mxp[i-1] / mxs[i]);
        cand.push_back(one - (long double)mnp[i-1] / mns[i]);

        long double res = inf, best_t = -1;
        for(auto it: cand) {
            long double this_res = eval(i, it);
            if(fabsl(this_res-res) < eps) {
                if(it > best_t) {
                    res = this_res, best_t = it;
                }
            }
            else if(this_res < res) {
                res = this_res, best_t = it;
            }
        }

        ans[i] = best_t;
    }

    for(auto it : ans)
        cout << fixed << setprecision(12) << it << " ";
    return 0;
}
