#include <bits/stdc++.h>
#define ll long long
#define ld long double
//#define inf (ll)1e18
#define all(x) (x).begin(),(x).end()
#define pii pair<int,int>
#define pll pair<ll,ll>
#define mpp make_pair
#define mtt make_tuple
using namespace std;

const int md = 1e9 + 7;
inline int add(int a, int b) {
    int res = a + b;
    if (res >= md) res %= md;
    return res;
}
inline int sub(int a, int b) { return add(a, md - b); }
inline int mul(int a, int b) { return a * 1ll * b % md; }

#define fi first
#define se second

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    ll n, k;
    cin >> n >> k;

    vector <ll> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i] >> b[i];

    vector <ll> df(n);
    vector <ll> p(n);

    ll inf = 1e18;

    for (int i = 0; i < n; ++i) {
        p[i] = max(a[i], b[i]);
        if (i) p[i] += p[i - 1];

        if (a[i] % k == b[i] % k) df[i] = inf;
        else df[i] = max(a[i], b[i]) - min(a[i], b[i]);
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = add(ans, mul(max(a[i], b[i]), mul(i + 1, n - i)));
    }

    vector <int> lg(n + 1);
    for (int i = 2; i <= n; ++i) lg[i] = lg[i >> 1] + 1;

    int LG = lg[n] + 1;
    vector < vector <ll> > s(n, vector <ll> (LG));

    for (int i = 0; i < n; ++i) s[i][0] = df[i];

    for (int k = 1; k < LG; ++k) {
        for (int v = 0; v + (1 << k) <= n; ++v) {
            s[v][k] = min(s[v][k - 1], s[v + (1 << (k - 1))][k - 1]);
        }
    }

    auto get = [&](int l, int r) {
        if (l > r) return inf;
        int p = lg[r - l + 1];
        return min(s[l][p], s[r - (1 << p) + 1][p]);
    };

    map <int, vector < pair <ll, pii> > > stk;
    map <int, ll> sstk;

    for (int i = 0; i < n; ++i) {

        int hui = p[i] % k;

        if (stk[hui].empty()) stk[hui] = {{inf, {i, 0}}}, sstk[hui] = 0;
        else {
            int pos = stk[hui].back().se.fi;
            ll val = get(pos + 1, i);

            ll cnt = 1;

            while (!stk[hui].empty() && stk[hui].back().fi >= val) {
                cnt += stk[hui].back().se.se;

                if (stk[hui].back().fi != inf)
                    sstk[hui] -= stk[hui].back().se.se * 1ll * stk[hui].back().fi;

                stk[hui].pop_back();
            }

            stk[hui].push_back({val, {i, cnt}});
            if (val != inf) sstk[hui] += cnt * 1ll * val;

//            cout << i + 1 <<  " - " << hui << '\n';
//            for (auto &[val, _] : stk[hui]) {
//                auto [pos, cnt] = _;
//                cout << val << " " << cnt << '\n';
//            }
//            cout << '\n';

//            assert(sstk[hui] == 0);
            ans = sub(ans, sstk[hui] % md);
        }
    }

    map <int, vector <int>> ids;
    for (int i = 0; i < n; ++i) ids[p[i] % k].push_back(i);

    map <int, vector <ll>> pfs;
    for (auto &[ele, vec] : ids) {
        pfs[ele].resize(vec.size());
        pfs[ele][0] = p[vec[0]] % md;

        for (int j = 1; j < vec.size(); ++j) {
            pfs[ele][j] = (pfs[ele][j - 1] + p[vec[j]]) % md;
        }
    }

    auto GETCNT = [&](int rem, int l, int r) {
        if (l > r) return 0LL;
        int p1 = lower_bound(all(ids[rem]), l) - ids[rem].begin();
        int p2 = upper_bound(all(ids[rem]), r) - ids[rem].begin() - 1;
        if (p1 > p2 || p1 == ids[rem].size() || p2 == -1) return 0LL;
        return p2 - p1 + 1;
    };
    auto GETSUM = [&](int rem, int l, int r) {
        if (l > r) return 0LL;
        int p1 = lower_bound(all(ids[rem]), l) - ids[rem].begin();
        int p2 = upper_bound(all(ids[rem]), r) - ids[rem].begin() - 1;
        if (p1 > p2 || p1 == ids[rem].size() || p2 == -1) return 0LL;
        return (pfs[rem][p2] - (!p1 ? 0 : pfs[rem][p1 - 1]) + md) % md;
    };

    for (int i = 0; i < n; ++i) {
        int hui = p[i] % k;

        int l = -1, r = i - 1, mid, ans1 = i + 2;

        while (l <= r) {
            mid = l + r >> 1;
            if (get(mid + 1, i) == inf) {
                ans1 = mid, r = mid - 1;
            }
            else l = mid + 1;
        }

        if (!hui && get(0, i) != inf) {
            ans = sub(ans, get(0, i) % md);
        }

        ll val = mul(p[i] % md, GETCNT(p[i] % k, ans1 + (ans1 == -1), i - 1));
        val = sub(val, GETSUM(p[i] % k, ans1 + (ans1 == -1), i - 1) % md);
        ans = sub(ans, val % md);

        if (ans1 == -1 && !hui) ans = sub(ans, p[i] % md);

//        for (int j = ans1; j < i; ++j) {
//
//            int f = (j == -1 ? 0 : p[j]);
//            if (p[i] % k != f % k) continue;
//
//            ans = sub(ans, (p[i] - f + md) % md);
//        }
    }

    cout << ans;
}
/*
2 2
1000000000 999999999
1000000000 999999999

*/
