#include <bits/stdc++.h>

using namespace std;

const int SIZE = 1e6 + 5;

int n, aa[SIZE], bb[SIZE];

bool check(int x) {
    int ptr = 0;
    vector<int> a(aa, aa + n), b(bb, bb + n);
    for(int i = 0; i < n; i++) {
        while(abs(i - ptr) > x) {
            ptr++;
        }
        while(ptr < n && a[i] && abs(ptr - i) <= x) {
            int cur = min(a[i], b[ptr]);
            b[ptr] -= cur;
            a[i] -= cur;
            if(!b[ptr]) ptr++;
        }
    }

    for(int i = 0; i < n; i++) {
        if(a[i] != 0) {
            return false;
        }
    }

    return true;
}

int main() {
    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> aa[i];
    }
    for(int i = 0; i < n; i++) {
        cin >> bb[i];
    }


    int j = -1;
    for(int i = n; i; i >>= 1) {
        while(i + j < n && !check(i + j)) {
            j += i;
        }
    }

    j++;

    if(j == n || !check(j)) {
        cout << -1;
    }
    else {
        cout << j;
    }


    return 0;
}
