#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fi first
#define se second
#define all(m) (m).begin(), (m).end()
#define rall(m) (m).rbegin(), (m).rend()
#define mp make_pair
#define vec vector
#define pb push_back
#define eb emplace_back
#define sz(x) (x).size()

typedef long double ld;
typedef pair <int, int> pii;
typedef long long ll;
typedef unsigned long long ull;


mt19937 rng((uint64_t) new char);

struct par{
    ld a, b, c;
    par(ld a = 0, ld b = 0, ld c = 0) : a(a), b(b), c(c) {}
};

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int n;
    cin >> n;
    vector <par> v(n);
    for (int i = 0; i < n; ++i){
        int a, b, c;
        cin >> a >> b >> c;
        v[i] = {a, b, c};
    }
    //shuffle(all(v), rng);

    ld l = 1e9 + 42, r = -1e9 - 42;

    for (int i = 0; i < n; ++i){
        l = min(-v[i].b / (v[i].a * (ld) 2), l);
        r = max(-v[i].b / (v[i].a * (ld) 2), r);
    }

    auto f = [&](ld x){
        int cnt = 1;
        ld y = v[0].a * x * x + v[0].b * x + v[0].c;
        for (int i = 1; i < n; ++i){
            if (v[i].a < 0) {
                cnt += (y <= v[i].a * x * x + v[i].b * x + v[i].c);
            }
            else {
                cnt += (y >= v[i].a * x * x + v[i].b * x + v[i].c);
            }
        }
        return cnt;
    };

    for (int it = 0; it < 100; ++it){
        ld m1 = l + (r - l) / ld(3);
        ld m2 = r - (r - l) / ld(3);
        //cout << fixed << setprecision(9) << l << ";" << r << " " << m1 << ": " << f(m1) << ", " << m2 << ": " << f(m2) << " ";
        if (f(m1) > f(m2)){
            r = m2;
            //cout << "<";
        }
        else{
            //cout << ">";
            l = m1;
        }
        //cout << "\n";
    }
    //cout << fixed << setprecision(9) << l << " " << r << "\n";
    ld x = l;
    ld y = v[0].a * x * x + v[0].b * x + v[0].c;

    cout << fixed << setprecision(6) << x << " " << y << "\n";
    return 0;
}
