#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define fi first
#define se second
#define all(m) (m).begin(), (m).end()
#define rall(m) (m).rbegin(), (m).rend()
#define mp make_pair
#define vec vector
#define pb push_back
#define eb emplace_back
#define sz(x) (x).size()
#define double long double

typedef pair <int, int> pii;
typedef long long ll;
typedef unsigned long long ull;


const int SIZE = 1e5 + 42;

mt19937_64 rng((uint64_t) new char);

int l, n;
ll rands[SIZE];
string s[SIZE];


bool rec(vec<int> &v) {
    if(v.size() == 1) {
        return 1;
    }

    int cur = (1 << 26) - 1;
    for(auto i : v) {
        int ccur = 0;
        for(auto j : s[i]) {
            if(j == '#') continue;
            ccur |= 1 << int(j - 'a');
        }
        cur &= ccur;
    }


    if(cur == 0) {
        return 0;
    }

    gp_hash_table<ll, vec<int>> ht;

    int sum = 0;
    for(auto i : v) {
        int cnt = 0;
        ll ccur = 0;
        for(int j = 0; j < l; j++) {
            if(s[i][j] == '#') {
                cnt++;
            }
            else if(cur & (1 << int(s[i][j] - 'a'))) {
                ccur ^= rands[j];
                s[i][j] = '#';
                cnt++;
            }
        }
        if(cnt == l) continue;
        ht[ccur].push_back(i);
        sum++;
    }

    if(ht.size() == 0) return 1;
    if(ht.size() == 1 && sum == v.size()) return 0;

    for(auto &i : ht) {
        if(!rec(i.second)) {
            return 0;
        }
    }

    return 1;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> l >> n;

    for(int i = 0; i < l; i++) {
        rands[i] = rng();
    }

    for(int i = 0; i < n; i++) {
        cin >> s[i];
    }



    vec<int> v;
    for(int i = 0; i < n; i++) v.push_back(i);

    if(rec(v)) {
        cout << "YES";
    }
    else {
        cout << "NO";
    }


    return 0;
}
