#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <utility>
#include <set>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <queue>
#include <cstring>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout << fixed << setprecision(10);
	int n;
	cin >> n;
	vector<int> vec(n);
	int gMax = 0, gMin = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> vec[i];
		if (vec[i] > vec[gMax]) gMax = i;
		if (vec[i] < vec[gMin]) gMin = i;
	}
	vector<int> plmin(n);
	vector<int> plmax(n);
	vector<int> slmin(n);
	vector<int> slmax(n);
	plmin[0] = 1e9 + 1;
	plmax[0] = 0;
	for (int i = 1; i < n; i++)
	{
		plmin[i] = min(plmin[i - 1], vec[i - 1]);
		plmax[i] = max(plmax[i - 1], vec[i - 1]);
	}
	slmin.back() = vec.back();
	slmax.back() = vec.back();
	for (int i = n - 2; i >= 0; i--)
	{
		slmin[i] = min(slmin[i + 1], vec[i]);
		slmax[i] = max(slmax[i + 1], vec[i]);
	}
	for (int k = 0; k < n; k++)
	{
		if (gMin >= k && gMax >= k) cout << 1.0 - (long double)plmax[k] / vec[gMax] << ' ';
		else if (gMin < k && gMax >= k) cout << 1.0 - min((long double)plmax[k] / vec[gMax], (long double)vec[gMin] / slmin[k]) << ' ';
		else if (gMax < k && gMin >= k) cout << 0.0 << ' ';
		else if (gMax < k && gMin < k) cout << 1.0 - (long double)vec[gMin] / slmin[k] << ' ';
	}
    return 0;
}
