#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define ll long long
#define pii pair<int, int>

ll binpow(ll n, int p) {
    ll ans = n;
    int pos = 1;
    while (pos < p) {
        if (pos * 2 <= p) {
            pos *= 2;
            ans *= ans;
        }
        else {
            pos++;
            ans *= n;
        }
    }
    return ans;
}

const int INF = 1e9 + 7;

vector<int> a, b;
int n;

bool ok(int k) {
    int sum = 0;
    for (int i = 0; i <= k; ++i) {
        sum += b[i];
    }
    for (int i = 0; i < n; ++i) {
        if (a[i] > sum) {
            return false;
        }
        if (i - k >= 0)
            sum -= b[i - k];
        if (i + k + 1 < n) {
            sum += b[i + k + 1];
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed;
    cout.precision(20);
    ////nfreopen("input.txt", "r", stdin);
    cin >> n;
    a.resize(n);
    b.resize(n);
    uint64_t sum1 = 0, sum2 = 0;
    for (auto& i : a) {
        cin >> i;
        sum1 += i;
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        sum2 += b[i];
    }
    if (sum2 < sum1) {
        cout << -1;
        return 0;
    }
    int cur = 0;
    int ans = 0, l = -1, r = 0;
	for (int i = 0; i < n; ++i) {
		cur += b[i] - a[i];
		if (cur < 0) {
			l = i;
		}
		else if (cur > 0 && l != -1) {
			r = i;
			ans = max(ans, r - l);
			l = -1;
		}
	}
	ans = 0;
	cur = 0;
	for (int i = n - 1; i >= 0; --i) {
		cur += b[i] - a[i];
		if (cur < 0) {
			l = i;
		}
		else if (cur > 0 && l != -1) {
			r = i;
			ans = max(ans, l - r + 2);
			l = -1;
		}
	}
	cout << ans;
    return 0;
}
