#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define ll long long
#define pii pair<int, int>

ll binpow(ll n, int p) {
	ll ans = n;
	int pos = 1;
	while (pos < p) {
		if (pos * 2 <= p) {
			pos *= 2;
			ans *= ans;
		}
		else {
			pos++;
			ans *= n;
		}
	}
	return ans;
}

const int INF = 1e9 + 7;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed;
	cout.precision(20);
	//freopen("input.txt", "r", stdin);
	int n;
	cin >> n;
	vector<int> a(n);
	for (auto& i: a) {
		cin >> i;
	}
	vector<int> lmax(n), lmin(n), rmax(n), rmin(n);
	int mn = INF, mx = 0;
	for (int i = 0; i < n; ++i) {
		if (mn > a[i]) {
			mn = a[i];
		}
		if (mx < a[i]) {
			mx = a[i];
		}
		lmax[i] = mx;
		lmin[i] = mn;
	}
	mn = INF, mx = 0;
	for (int i = n - 1; i >= 0; --i) {
		if (mn > a[i]) {
			mn = a[i];
		}
		if (mx < a[i]) {
			mx = a[i];
		}
		rmax[i] = mx;
		rmin[i] = mn;
	}
	cout << 1.0 << ' ';
	bool lmx, lmn;
	for (int i = 1; i < n; ++i) {
		double l = 0, r = 1;
		double m1, m2;
		double ans1, ans2;
		for (int j = 0; j < 1000; ++j) {
			m1 = l + (r - l) / 3.0;
			m2 = r - (r - l) / 3.0;
			ans1 = max(1.0 * lmax[i - 1], m1 * rmax[i]) - min(1.0 * lmin[i - 1], m1 * rmin[i]);
			ans2 = max(1.0 * lmax[i - 1], m2 * rmax[i]) - min(1.0 * lmin[i - 1], m2 * rmin[i]);
			if (ans1 > ans2) {
				l = m1;
			}
			else {
				r = m2;
			}
		}
		cout << 1.0 - r << ' ';
	}
	return 0;
}
