#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
constexpr ld EPS = 1e-9;

template<class T>
using V = vector<T>;
template<class T>
using VV = V<V<T>>;

using VLL = V<ll>;
using VVLL = VV<ll>;

#define FOR(i, n) for(ll i = 0; i < n; ++i)
#define ALL(a) begin(a), end(a)

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cout << setprecision(12);

    ll n;
    cin >> n;

    VLL a(n);
    for(auto& i : a)
        cin >> i;

    cout << "1 ";

    multiset<ll> m;
    for(ll i = 1; i < n; ++i)
        m.insert(a[i]);

    ll mx = a[0], mn = a[0];
    for(ll i = 1; i < n; ++i)
    {
        ll mxr = *m.rbegin(), mnr = *m.begin();
        ld r = 0, ans = 1e10;
        auto upd = [&](ld t)
        {
            if(t < 0 || t > 1)
                return;

            ld x = max((1 - t) * mxr, (ld)mx) - min((ld)mn, (1 - t) * mnr);
            if(abs(x - ans) <= EPS)
            {
                r = max(r, t);
            }
            else if(x < ans)
            {
                ans = x;
                r = t;
            }
        };
        upd(0);
        upd(1);

        //(1 - t)mxr = mx
        //1 - t = mx / mxr
        //t = 1 - mx / mxr

        ld t = 1 - 1.0L * mx / mxr;
        upd(t);

        t = 1 - 1.0L * mn / mnr;
        upd(t);

        cout << r << " ";
        m.erase(a[i]);
        mn = min(mn, a[i]);
        mx = max(mx, a[i]);
    }
}
