#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define ft first
#define sc second
#define ld long double
#define sz(v) (int)((v).size())

using namespace std;

mt19937_64 rnd(time(0));
const int ITER = 1e9;
const int N = 1e5 + 55;
const int INF = 1e9;

int n;
ld a[N];
ld b[N];
ld c[N];

bool check(ld x, ld y) {
//    cout << x << ' ' << y << '\n';
    for (int i = 0; i < n; i ++) {
        if (a[i] > 0.0) {
            if (y < a[i] * x * x + b[i] * x + c[i]) return false;
        }
        if (a[i] < 0.0) {
            if (y > a[i] * x * x + b[i] * x + c[i]) return false;
        }
    }
    return true;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    set <pair<ld, pair <ld, ld> > > s;
    for (int i = 0; i < n; i ++) {
        cin >> a[i] >> b[i] >> c[i];
        s.insert({a[i], {b[i], c[i]}});
    }
    int cn = 0;
    for (auto it : s) {
        a[cn] = it.ft;
        b[cn] = it.sc.ft;
        c[cn] = it.sc.sc;
//        cout << a[cn] << ' ' << b[cn] << ' ' << c[cn] << '\n';
        cn ++;
    }
    n = cn;
    cout << fixed << setprecision(12);
    if (n == 1) {
        ld x = -b[0] / 2 / a[0];
        if (a[0] > 0) cout << x << ' ' << (ld)INF;
        else cout << x << ' ' << (ld)(-INF);
        return 0;
    }
    for (int i = 0; i < ITER; i ++) {
        while(true) {
            int x = rnd() % n;
            int y = 0;
            if (x == y) {
                continue;
            }
            ld A = a[x] - a[y];
            ld B = b[x] - b[y];
            ld C = c[x] - c[y];
            if (A == 0.0) {
                ld x0 = -C / B;
                ld y0 = A * x0 * x0 + B * x0 + C;
                    if (check(x0, y0)) {
                    cout << x0 << ' ' << y0;
                    return 0;
                }
            }
            else {
                ld D = B * B - 4.0 * A * C;
                D = sqrt(D);
                ld x0 = (-B - D) / 2.0 / A;
                ld x1 = (-B + D) / 2.0 / A;
                ld y0 = a[x] * x0 * x0 + b[x] * x0 + c[x];
                ld y1 = a[x] * x1 * x1 + b[x] * x1 + c[x];
                cout << x << ' ' << x0 << ' ' << y0 << ' ' << x1 << ' ' << y1 << '\n';
                if (check(x0, y0)) {
                    cout << x0 << ' ' << y0;
                    return 0;
                }
                if (check(x1, y1)) {
                    cout << x1 << ' ' << y1;
                    return 0;
                }
            }
            break;
        }
    }
    return 0;
}

/*
4
1 2 3
1 -3 -5
-1 3 4
-2 4 6
*/






















