#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
const ld eps=3e-6;

ld calc(ld a,ld b,ld c,ld d)
{
    return a*d+c+b;
}

void fix(ld mas[])
{
    ld c1=calc(mas[1],mas[2],mas[3],mas[4]);
    ld c2=calc(mas[2],mas[1],mas[4],mas[3]);
    ld t,v1,v2;
    if(abs(c1-c2)<eps)
        return ;
    if(c1>c2)
    {
        t=(mas[2]-1)*(mas[3]-1)/(mas[4]-1)+1;
        v1=calc(t,mas[2],mas[3],mas[4]);
        t=(mas[2]-1)*(mas[3]-1)/(mas[1]-1)+1;
        v2=calc(mas[1],mas[2],mas[3],t);
        if(v1>v2)
            mas[1]=(mas[2]-1)*(mas[3]-1)/(mas[4]-1)+1;
        else
            mas[4]=t;
    }
    else
    {
        t=(mas[1]-1)*(mas[4]-1)/(mas[3]-1)+1;
        v1=calc(mas[1],t,mas[3],mas[4]);
        t=(mas[1]-1)*(mas[4]-1)/(mas[2]-1)+1;
        v2=calc(mas[1],mas[2],t,mas[4]);
        if(v1>v2)
            mas[2]=(mas[1]-1)*(mas[4]-1)/(mas[3]-1)+1;
        else
            mas[3]=t;
    }
    return ;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int ansi[5]={0},curi[5]={0},st[5]={0};
    long double ans[5]={0};
    long double cur[5]={0};
    for(int i=1;i<5;i++)
    {
        curi[i]=i;
        cin >> st[i];
    }
    do
    {
        for(int i=1;i<5;i++)
            cur[i]=st[curi[i]];
        fix(cur);
        if(ansi[1]==0)
        {
            for(int i=1;i<5;i++)
                ansi[i]=curi[i];
            for(int i=1;i<5;i++)
                ans[i]=cur[i];
            continue;
        }
        if(calc(ans[1],ans[2],ans[3],ans[4])<calc(cur[1],cur[2],cur[3],cur[4]))
        {
            for(int i=1;i<5;i++)
                ansi[i]=curi[i];
            for(int i=1;i<5;i++)
                ans[i]=cur[i];
        }
    }while(next_permutation(curi+1,curi+5));
    for(int i=1;i<5;i++)
        cout << ansi[i] << " ";
    cout << "\n";
    cout << fixed << setprecision(9);
    for(int i=1;i<5;i++)
    {
        assert(ans[i]>= 1.0);
        cout << ans[i] << " ";
    }
    cout << "\n";
    return 0;
}
