#include <bits/stdc++.h>
using namespace std;

struct bs{
    int n;
    int sz;
    vector<int>el;
    inline void init(int nn){
        n=nn;
        sz=n/32+1;
        el.resize(sz);
    }
    bool operator==(bs&e){
        for(int i=0;i<sz;i++)if(el[i]!=e.el[i])return 0;
        return 1;
    }
    inline bool zero_check(){
        //cout << el[0] << "\n";
        for(int i = 0;i < sz;i++){
            if(el[i]) return 1;
        }
        return 0;
    }
    inline void set(int pos,int val){
        int i=pos/32;
        pos%=32;
        int mask=((unsigned)-1)^(1<<pos);
        el[i]&=mask;
        el[i]|=(val<<pos);
    }
    inline int hash_1(){
        long long ans = 141251213513515135;
        for(int i = 0;i < sz;i++) ans^=el[i];
        return (ans>>32)^ans;
    }
    inline int hash_2(){
        long long ans = 152261831513511354;
        for(int i = 0;i < sz;i++) ans^=(el[i]<<(11*(i&3)+3));
        return (ans>>32)^ans;
    }
    inline int hash_3(){
        long long ans = 41356154135115351;
        for(int i = 0;i < sz;i++) ans^=(el[i]<<(7*(i&5)+7));
        return (ans>>32)^ans;
    }
    inline int hash_4(){
        long long ans = 135376324125423523;
        for(int i = 0;i < sz;i++) ans^=(el[i]<<(5*(i&2)+9));
        return (ans>>32)^ans;
    }
    inline pair<pair<int,int>,pair<int,int>> hash_(){
        return {{hash_1(),hash_2()},{hash_3(),hash_4()}};
    }
};
vector<bs> bitsets[26];
void solve(vector<int> indexs,int blocked_abs){
    char a = 0;
    if(indexs.size() <= 1) return;
    for(int i = 0;i < 26;i++){
        bool flag = 1;
        if((blocked_abs>>i)&1) continue;
        //cout << i << " ";
        for(int j = 0;j < indexs.size();j++){
            if(!bitsets[i][indexs[j]].zero_check()){
                //cout << (char)('a'+i) << " " << indexs[j] << "\n";
                flag = 0;
                break;
            }
        }
        if(flag){
            a = 'a'+i;
            //break;
        }
    }
    //cout << a << "\n";
    if(a == 0){
        //for(int i = 0;i < indexs.size();i++){
        //    cout << indexs[i] << " ";
        //}
        cout << "NO\n";
        exit(0);
    }
    blocked_abs|=(1<<(a-'a'));
    map< pair<pair<int,int>,pair<int,int> >,int> mp;
    int cnt = 0;
    vector<pair<int,int>> vt;
    for(int i = 0;i < indexs.size();i++){
        pair<pair<int,int>,pair<int,int>> hash_ = bitsets[(a-'a')][indexs[i]].hash_();
        int ind = cnt;
        if(mp.count(hash_)) ind = mp[hash_];
        else ind = ++cnt,mp[hash_] = ind;
        //cout << hash_.first.first << " " << hash_.first.second << " " << hash_.second.first << " " << hash_.second.second << "\n";
        vt.push_back({ind,i});
    }
    sort(vt.begin(),vt.end());
    //for(int i =0;i < vt.size();i++){
    //    cout << vt[i].first << " " << vt[i].second << "\n";
    //}
    int last = -1;
    vector<int> tmp;
    for(int i = 0;i < vt.size();i++){
        if(i and vt[i].first != last){
            solve(tmp,blocked_abs);
            tmp.clear();
        }
        tmp.push_back(vt[i].second);
        last =vt[i].first;
    }
    solve(tmp,blocked_abs);
    tmp.clear();
}
int main()
{
    // PLEASE 1e15/64 in 1 sec
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int l,n;
    cin>>l>>n;
    for(int i =0;i < 26;i++) bitsets[i].resize(n);
    for(int _=0;_<n;_++){
        string s;
        cin>>s;
        for(int c=0;c<26;c++){
            bitsets[c][_].init(l);
            for(int ii=0;ii<l;ii++)bitsets[c][_].set(ii,(s[ii]-'a'==c));
        }
    }
    //for(int i = 0;i < 26;i++){
        //cout << (char)(i+'a') << " " << bitsets[i][0].el[0] << " "<< bitsets[i][1].el[0] << "\n";
    //}
    vector<int> tmp;
    for(int i =0;i < n;i++) tmp.push_back(i);
    solve(tmp,0);
    cout << "YES\n";

}
