/*#include <bits/stdc++.h>
#define ll long long
#define dbl double

using namespace std;

struct parabola
{
    dbl a, b, c;
};

const int N = 1e5 + 10;
const double INF = LONG_MAX * 1.0;
parabola v[N];

dbl y1, y2;

void calculate_borders(int i1, int i2)
{
    dbl A = v[i1].a - v[i2].a;
    dbl B = v[i1].b - v[i2].b;
    dbl C = v[i1].c - v[i2].c;

    dbl D = B * B - 4.0 * A * C;
    dbl x1 = (-B + sqrt(D)) / (2.0 * A);
    dbl x2 = (-B - sqrt(D)) / (2.0 * A);

    y1 = v[i1].a * x1 * x1 + v[i1].b * x1 + v[i1].c;
    y2 = v[i1].a * x2 * x2 + v[i1].b * x2 + v[i1].c;

    if (y1 > y2)
        swap(y1, y2);
    return;
}

vector < pair <dbl, dbl> > more_than_t(dbl a, dbl b, dbl c, dbl t)
{
    vector < pair <dbl, dbl> > ans;

    dbl D = b * b - 4.0 * a * c;
    if (D < 0)
    {
        ans.push_back({-INF, INF});
        return ans;
    }
    if (D == 0)
    {
        dbl x = -b / (2.0 * a);
        ans.push_back({-INF, x});
        ans.push_back({x, INF});
        return ans;
    }
    if (D > 0)
    {
        dbl x1 = (-b - sqrt(D)) / (2.0 * a);
        dbl x2 = (-b + sqrt(D)) / (2.0 * a);
        if (a > 0)
        {
            ans.push_back({-INF, x1});
            ans.push_back({x2, INF});
        }
        else
            ans.push_back({x1, x2});
        return ans;
    }
}

vector < pair <dbl, dbl> > less_than_t(dbl a, dbl b, dbl c, dbl t)
{
    vector < pair <dbl, dbl> > ans;

    dbl D = b * b - 4.0 * a * c;
    if (D < 0)
    {
        ans.push_back({-INF, INF});
        return ans;
    }
    if (D == 0)
    {
        dbl x = -b / (2.0 * a);
        ans.push_back({-INF, x});
        ans.push_back({x, INF});
        return ans;
    }
    if (D > 0)
    {
        dbl x1 = (-b - sqrt(D)) / (2.0 * a);
        dbl x2 = (-b + sqrt(D)) / (2.0 * a);
        if (a < 0)
        {
            ans.push_back({-INF, x1});
            ans.push_back({x2, INF});
        }
        else
            ans.push_back({x1, x2});
        return ans;
    }
}

vector <dbl, dbl> intersection(vector < pair <dbl, dlb> > , vector < pair <dbl, dbl> > )
{
    dbl lans, rans;
    lans = max(l1, l2);
    rans = min(r1, r2);
    return {lans, rans};
}

int main()
{
    int n;
    cin >> n;
    int posind = -1, negind = -1;
    for (int i = 1; i <= n; ++i)
    {
        cin >> v[i].a >> v[i].b >> v[i].c;
        if (v[i].a < 0)
            negind = i;
        else
            posind = i;
    }

    if (negind == -1 && posind != -1)
    {
        dbl yans = 1e9 * 1.0;
        vector < pair <dbl, dbl> > total;
        for (int i = 1; i <= n; ++i)
        {
            vector < pair <dbl, dbl> > segment = more_than_t(v[i].a, v[i].b, v[i].c, yans);
            if (total.size() == 0)
                total = segment;
            else
            {
                if (segment.size() == 1)
                {
                    if (total.size() == 1)
                    {
                        pair <dbl, dbl> temp = intersection(segment[0].first, segment[0].second, total[0].first, total[0].second);
                        total.clear();
                        total.push_back(temp);
                    }
                    else if (total.size() == 2)
                    {
                        pair <dbl, dbl> temp = intersection(segment[0].first, segment[0].second, total[0].first, total[0].second);
                        pair <dbl, dbl> temp1 = intersection(segment[0].first, segment[0].second, total[1].first, total[1].second);
                        total.clear();
                        total.push_back(temp);
                        total.push_back(temp1);
                    }
                }
                else
                    if (segment.size() == 2)
                    {
                        if (total.size() == 1)
                        {
                            pair <dbl, dbl> temp = intersection(segment[0].first, segment[0].second, total[0].first, total[0].second);
                            pair <dbl, dbl> temp1 = intersection(segment[1].first, segment[1].second, total[0].first, total[0].second);
                            total.clear();
                            total.push_back(temp);
                            total.push_back(temp1);
                        }
                        else if (total.size() == 2)
                        {
                            pair <dbl, dbl> temp = intersection(segment[0].first, segment[0].second, total[0].first, total[0].second);
                            pair <dbl, dbl> temp1 = intersection(segment[1].first, segment[1].second, total[1].first, total[1].second);
                            total.clear();
                            total.push_back(temp);
                            total.push_back(temp1);
                        }
                    }
            }
        }
        return 0;
    }
    if (posind == -1 && negind != -1)
    {

        return 0;
    }

    ///exists
    calculate_borders(posind, negind);

}




    /*
    for(auto i : v) {
        for(int j = 0; j < 26; j++) {
            cout << char(j + int('a')) << ": ";
            for(int k = 0; k < i[j].size(); k++){
                cout << i[j][k] << ' ';
            }
        }
    }*/



/*#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int N = 1e6 +10;

string s[N], pattern;
vector < int > g[N];
vector <int> v;

void modify(int ind)
{
    string cur = s[ind];
    int start = 0;
    for (int i = 1; i < cur.length(); ++i)
        if (cur[i] != cur[start])
        {
            g[ind].push_back(start);
            start = i;
        }
    g[ind].push_back(start);
    return;
}

bool pattern_is_bigger(int ind)
{
    size_t pi = 0, ci = 0;
    while ()
    {
        if (pattern[v[pi]] VS g[ind][])
    }
}

int main()
{
    int n, q;
    cin >> n >> q;
    cin >> pattern;
    for (int i = 1; i <= n; ++i)
        cin >> s[i];
    sort(s + 1, s + n + 1);
    for (int i = 1; i <= n; ++i)
        modify(i);

    int start = 0;
    for (int i = 1; i < pattern.length(); ++i)
        if (pattern[i] != pattern[start])
        {
            v.push_back(start);
            start = i;
        }
    v.push_back(start);


}
*/

*/
