#include <bits/stdc++.h>
#define PB push_back

using namespace std;

typedef long long ll;
typedef long double ld;

ll n;
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed;
    cout << setprecision(10);
    cin >> n;
    vector<ld> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    vector<ld> mxp(n);
    vector<ld> mxs(n);
    vector<ld> mnp(n);
    vector<ld> mns(n);
    mxp[0] = v[0];
    mnp[0] = v[0];
    for (int i = 1; i < n; i++) {
        mxp[i] = max(v[i], mxp[i - 1]);
        mnp[i] = min(v[i], mnp[i - 1]);
    }
    mxs[n - 1] = v[n - 1];
    mns[n - 1] = v[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        mxs[i] = max(v[i], mxs[i + 1]);
        mns[i] = min(v[i], mns[i + 1]);
    }
    cout << 1.0L << ' ';
    for (int i = 1; i < n; i++) {
        ld a = mxp[i - 1];
        ld b = mxs[i];
        ld c = mnp[i - 1];
        ld d = mns[i];
//        cout << a << ' ' << b << ' ' << c << ' ' << d << '\n';
        ld l = 0, r = 1;
        while (r - l > 1e-8) {
            ld mid1 = l + (r - l) / 3;
            ld mid2 = r - (r - l) / 3;
            ld x1 = max(a, b * (1.0 - mid1)) - min(c, d * (1.0 - mid1));
            ld x2 = max(a, b * (1.0 - mid2)) - min(c, d * (1.0 - mid2));
//            cout << mid1 << ' ' << mid2 << ' ' << x1 << ' ' << x2 << '\n';
            if (x1 <= x2) {
                r = mid2;
            }
            else {
                l = mid1;
            }
        }
        ld x = max(a, b * (1.0 - l)) - min(c, d * (1.0 - l));
//        cout << l << ' ' << x << '\n';
        r = 1;
        while (r - l > 1e-8) {
            ld mid = (r + l) / 2;
            ld x1 = max(a, b * (1.0 - mid)) - min(c, d * (1.0 - mid));
//            cout << mid << ' ' << x1 << '\n';
            if (abs(x - x1) <= 1e-8) {
                l = mid;
//                cout << "A";
            }
            else {
                r = mid;
            }
        }
        cout << l << ' ';
    }
}
