#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <iomanip>
#include <map>

using namespace std;

typedef long long ll;

const int N = 2e5+5;

double a[N], max1[N], max2[N], min1[N], min2[N];

int n;

int main()
{
    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    max1[0] = a[0];
    min1[0] = a[0];
    for(int i = 1; i < n; i++) {
        max1[i] = max(max1[i-1], a[i]);
        min1[i] = min(min1[i-1], a[i]);
    }
    min2[n-1] = a[n-1];
    max2[n-1] = a[n-1];
    for(int i = n-2; i >= 0; i--) {
        max2[i] = max(max2[i+1], a[i]);
        min2[i] = min(min2[i+1], a[i]);
    }
    double o = 1, z = 0;
    cout << fixed << setprecision(10) << o << ' ';
    for(int k = 1; k < n; k++) {
        if(max1[k-1] > max2[k] && min1[k-1] > min2[k]) {
            cout << z << ' ';
            continue;
        }
        if(max1[k-1] < max2[k] && min1[k-1] > min2[k]) {
            cout << 1 - 1.0*max1[k-1]/max2[k] << ' ';
            continue;
        }
        if(max1[k-1] > max2[k] && min1[k-1] < min2[k]) {
            cout << 1 - 1.0*min1[k-1]/min2[k] << ' ';
            continue;
        }
        if(max1[k-1] < max2[k] && min1[k-1] < min2[k]) {
            cout << max(1 - 1.0*max1[k-1]/max2[k],1 - 1.0 *min1[k-1]/min2[k]) << ' ';
            continue;
        }
    }
    return 0;
}
