#include <bits/stdc++.h>

#define int long long
#define point pair<int,int>
#define ff first
#define ss second

using namespace std;

int n;
deque <point> pref, suf;

bool check(int k, vector<int> a, vector<int> b) {
    for (int i = 0; i < n; ++i)
        suf.push_back({b[i], i});


    for (int i = 0; i < n; ++i) {
        if (suf.front().ss == i)
            pref.push_back(suf.front()), suf.pop_front();

        while (a[i] && !pref.empty() && i - pref.back().ss <= k) {
            int & pos = pref.back().ss, & val = pref.back().ff;

            if (val <= a[i])
                a[i] -= val, pref.pop_back();
            else val -= a[i], a[i] = 0;
        }

        while (a[i] && !suf.empty() && suf.front().ss - i <= k) {
            int & pos = suf.front().ss, & val = suf.front().ff;

            if (val <= a[i])
                a[i] -= val, suf.pop_front();
            else val -= a[i], a[i] = 0;
        }

        if (a[i]) return false;
    }

    return true;
}

main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n;
    vector<int> a(n), b(n);
    int sum1 = 0, sum2 = 0;
    for (int i = 0; i < n; i++)
        cin >> a[i], sum1 += a[i];

    for (int i = 0; i < n; i++)
        cin >> b[i], sum2 += b[i];

    if (sum1 > sum2) {
        cout << -1 << '\n';
        return 0;
    }

    int l = 0, r = n - 1;
    while (l + 1 < r) {
        int mid = (l + r) >> 1;
        if (check(mid, a, b))
            r = mid;
        else
            l = mid;
    }

    cout << r - !check(r, a, b);

    return 0;
}
