#include <bits/stdc++.h>

#define int long long
#define point pair<int,int>
#define ff first
#define ss second

using namespace std;

int n;

bool check(int k, vector<int> a, vector<int> b) {
    deque <point> dq;

    for (int i = 0; i < n; ++i)
        dq.push_back({b[i], i});

    for (int i = 0; i < n; ++i) {
        while (!dq.empty() && abs(i - dq.front().ss) > k)
            dq.pop_front();

        while (!dq.empty() && abs(dq.front().ss - i) <= k && a[i]) {
            if (a[i] >= dq.front().ff)
                a[i] -= dq.front().ff, dq.pop_front();
            else dq.front().ff -= a[i], a[i] = 0;

            if (!dq.empty() && !dq.front().ff)
                dq.pop_front();
        }

        if (a[i]) return false;
    }

    return true;
}

main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n;
    vector<int> a(n), b(n);
    int sum1 = 0, sum2 = 0;
    for (int i = 0; i < n; i++)
        cin >> a[i], sum1 += a[i];

    for (int i = 0; i < n; i++)
        cin >> b[i], sum2 += b[i];

    if (sum1 > sum2) {
        cout << -1 << '\n';
        return 0;
    }

    int l = 0, r = n - 1;
    while (l + 1 < r) {
        int mid = (l + r) >> 1;
        if (check(mid, a, b))
            r = mid;
        else
            l = mid;
    }

    cout << l + !check(l, a, b);

    return 0;
}
