#include <bits/stdc++.h>

#define int long long
#define point pair<int,int>
#define ff first
#define ss second

using namespace std;

const int N = 1e5 + 128;
const int P = 1e9 + 7;
const int L = 1e6 + 128;

const int INF = 1e17 + 10;

int h[N][26];
vector <int> pw(N);

int cnt[N][26];
string str[N];
vector <int> v[N][26];

void init() {
    pw[0] = 1;
    for (int i = 1; i < N; i++)
        pw[i] = pw[i-1] * P;
}

int get_hash(int i, int j) {
    if (v[i][j].empty())
        return -INF;
    int res = v[i][j][0]+1;
    for (int k = 1; k < (int) v[i][j].size(); k++)
        res = res + ((v[i][j][k]+1) * pw[k]);
    return res;
}

int l, n;

char get(vector <char> &used, set <int> &able) {
    for (int j = 0; j < 26; j++) {
        if (used[j]) continue;
        bool nice = true;
        for (auto c : able) {
            if (v[c][j].empty()) {
                nice = false;
                break;
            }
        }
        if (nice)
            return char(j + 'a');
    }
    cout << "NO\n";
    exit(0);
}

void rec(set<int> able, vector<char> used) {
//    cout << "ALLLO\n";
    if (able.empty()) {
        cout << "YES\n";
        exit(0);
    }
    char x = get(used, able);
    used[x - 'a'] = true;
//    cout << "ALALLAL : " << x << '\n';
    unordered_map <int, set<int>> mp;
    for (auto c : able)
        if (h[c][x - 'a'] != -INF)
            mp[h[c][x - 'a']].insert(c);
    int cnt = 0;
    for (auto [l, r] : mp)
        if ((int) r.size() > 1)
            rec(r, used);
        else
            cnt++;
    if (cnt == (int) mp.size()) {
        cout << "YES\n";
        exit(0);
    }
}

void test_case() {
    cin >> l >> n;
    for (int i = 0; i < n; i++)
        cin >> str[i];
    for (int i = 0; i < n; i++)
        for (int j = 0; j < (int) str[i].size(); j++)
            v[i][str[i][j] - 'a'].push_back(j);
    set <int> able;
    for (int i = 0; i < n; i++)
        able.insert(i);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < 26; j++)
            h[i][j] = get_hash(i, j);
//    for (int i = 0; i < n; i++) {
//        cout << i << '\n';
//        for (int j = 0; j < 26; j++) {
//            cout << char(j + 'a') << '\n';
//            for (auto c : v[i][j])
//                cout << c << ' ';
//            cout << '\n';
//        }
//        cout << '\n';
//    }
    vector <char> used(26, false);
    rec(able, used);
}

main () {
    init();
    test_case();
    return 0;
}
