#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using ld = long double;
using pld = pair<ld, ld>;

const int ALPHABET_SIZE = 26, MAXLEN = 1e6;

/*struct Node {
    int go[ALPHABET_SIZE] = {0};
    bool is_end = false;
};

Node trie[MAXLEN];
int trie_size = 1;

bool can_go(int v, char ch) {
    return trie[v].go[ch - 'a'] != 0;
}

int go(int v, char ch) {
    return trie[v].go[ch - 'a'];
}

void create(int v, char ch) {
    trie[v].go
}*/
void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    ll sum1 = 0, sum2 = 0;
    for (int &i: a) {
        cin >> i;
        sum1 += i;
    }
    vector <int> b(n);
    for (int &i: b) {
        cin >> i;
        sum2 += i;
    }
    if (sum1 > sum2) {
        cout << -1;
        return;
    }
    bool good = true;
    for (int i = 0; i < n; i++) {
        if (a[i] > b[i]) {
            good = false;
        }
    }
    if (good) {
        cout << 0;
        return;
    }
    int r = 1e9;
    int l = -1;
    int mid;
    deque <pair <ll, int> > unsolved;
    deque <pair <ll, int> > difs;
    while (r - l > 1) {
        unsolved.clear();
        difs.clear();
        mid = (r + l) / 2;
        good = true;
        for (int i = 0; i < n; i++) {
            unsolved.push_back({a[i], i});
            difs.push_back({b[i], i});
            while (i - difs.front().second > mid) {
                difs.pop_front();
            }
            if (i - unsolved.front().second > mid) {
                good = false;
                break;
            }
            while (difs.size() && unsolved.size()) {
                if (difs.front().first == unsolved.front().first) {
                    difs.pop_front();
                    unsolved.pop_front();
                    continue;
                }
                if (difs.front().first > unsolved.front().first) {
                    difs[0].first -= unsolved[0].first;
                    unsolved.pop_front();
                } else {
                    unsolved[0].first -= difs[0].first;
                    difs.pop_front();
                }
            }
        }
        if (unsolved.size()) {
            good = false;
        }
        if (good) {
            r = mid;
        }
        else {
            l = mid;
        }
    }
    cout << r;
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
