#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;
using ld = long double;
using pld = pair<ld, ld>;

const int ALPHABET_SIZE = 26, MAXLEN = 1e6;

/*struct Node {
    int go[ALPHABET_SIZE] = {0};
    bool is_end = false;
};

Node trie[MAXLEN];
int trie_size = 1;

bool can_go(int v, char ch) {
    return trie[v].go[ch - 'a'] != 0;
}

int go(int v, char ch) {
    return trie[v].go[ch - 'a'];
}

void create(int v, char ch) {
    trie[v].go
}*/
const int MAXN = 2 * 1e5 + 20;
const ll INF = 1e18 + 1e17;
const ld EPS = 1e-9;
ll a[MAXN], pmn[MAXN], pmx[MAXN], smn[MAXN], smx[MAXN];
ld ans[MAXN];

void solve() {
    vector <int> fir;
    vector <int> sec;
    int n;
    cin >> n;
    vector <int> inp(n);
    for (int &i: inp) {
        cin >> i;
    }
    for (int i = 0; i < n; i++) {
        while (fir.size() && fir.back() > inp[i]) {
            cout << 12 << '\n';
            sec.push_back(fir.back());
            fir.pop_back();
        }
        while (sec.size() && sec.back() < inp[i]) {
            cout << 21 << '\n';
            fir.push_back(sec.back());
            sec.pop_back();
        }
        cout << 1 << '\n';
        fir.push_back(inp[i]);
    }
    while (fir.size()) {
        cout << 12 << '\n';
        sec.push_back(fir.back());
        fir.pop_back();
    }
    while (sec.size()) {
        cout << -2 << '\n';
        sec.pop_back();
    }
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
