/*#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stdlib.h>
#include <math.h>
#include <cmath>
#include <map>
#include <queue>
#include <iomanip>
#include <stack>

typedef long long ll;

using namespace std;

//ll n,m;
ll MOD=998244353;

void IO()
{
    cin.tie(0);
    cout.tie(0);
    cout.sync_with_stdio(0);
}

ll fak(ll n)
{
    ll ans=1;
    for(ll i=1;i<=n;i++)
    {
        ans*=i;
        ans%=MOD;
    }
    return ans;
}

ll pw(ll n,ll k)
{
    if(k==0)
    {
        return 1;
    }
    if(k%2==0)
    {
        ll m=pw(n,k/2);
        return (m*m)%MOD;
    }
    return (pw(n,k-1)*n)%MOD;
}

ll obr(ll n)
{
    return pw(n,MOD-2);
}

int main() {
    ll n,m;
    cin>>n>>m;
    //cout<<fak(m+n-2)<<' '<<obr(3)<<' ';
    ll k=(((fak(m+n-2ll)*obr(fak(n-1ll)))%MOD)*obr(fak(m-1ll)))%MOD;
    cout<<k<<' '<<((((k+1ll)*k)%MOD)*obr(2ll))%MOD;
}*/
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stdlib.h>
#include <math.h>
#include <cmath>
#include <map>

typedef long long ll;

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i: a) {
        cin >> i;
    }
    vector<int> b(n);
    for (auto &i: b) {
        cin >> i;
    }
    int ans1 = 0;
    if (true) {
        set<pair<int, int>> s1;
        set<pair<int, int>> s2;
        for (int i = 0; i < n; ++i) {
            if (a[i] < b[i]) {
                int x = b[i] - a[i];
                while (x > 0 && !s2.empty()) {
                    if (s2.begin()->second < x) {
                        int ind = s2.begin()->first, v = s2.begin()->second;
                        x -= s2.begin()->second;
                        ans1 = max(ans1, i - ind);
                        s2.erase(s2.begin());
                    } else {
                        int ind = s2.begin()->first, v = s2.begin()->second;
                        s2.erase(s2.begin());
                        s2.insert({ind, v - x});
                        ans1 = max(ans1, i - ind);
                        x = 0;
                    }
                }
                if (x > 0) {
                    s1.insert({i, x});
                }
                //cout << 1 << ' ' << i << ' ' << x << ' ';
            } else {
                int x = a[i] - b[i];
                while (x > 0 && !s1.empty()) {
                    if ((s1.rbegin())->second > x) {
                        int ind = (s1.rbegin())->first, v = (s1.rbegin())->second;
                        s1.erase({ind, v});
                        v -= x;
                        s1.insert({ind, v});
                        ans1 = max(ans1, i - ind);
                        x = 0;
                    } else {
                        x -= (s1.rbegin())->second;
                        int ind = (s1.rbegin())->first, v = (s1.rbegin())->second;
                        s1.erase({ind, v});
                        ans1 = max(ans1, i - ind);
                    }
                }
                if (x > 0) {
                    s2.insert({i, x});
                }
                //cout << 2 << ' ' << i << ' ' << x << ' ';
            }
            //cout << ans1 << '\n';
        }
        if (!s2.empty()) {
            ans1 = -1;
        }
    }
    set<pair<int, int>> s1;
    set<pair<int, int>> s2;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] < b[i]) {
            int x = b[i] - a[i];
            while (x > 0 && !s2.empty()) {
                if (s2.begin()->second < x) {
                    int ind = s2.begin()->first, v = s2.begin()->second;
                    x -= s2.begin()->second;
                    ans = max(ans, i - ind);
                    s2.erase(s2.begin());
                } else {
                    int ind = s2.begin()->first, v = s2.begin()->second;
                    s2.erase(s2.begin());
                    s2.insert({ind, v - x});
                    ans = max(ans, i - ind);
                    x = 0;
                }
            }
            if (x > 0) {
                s1.insert({i, x});
            }
            //cout << 1 << ' ' << i << ' ' << x << ' ';
        } else {
            int x = a[i] - b[i];
            while (x > 0 && !s1.empty()) {
                if ((s1.begin())->second > x) {
                    int ind = (s1.begin())->first, v = (s1.begin())->second;
                    s1.erase({ind, v});
                    v -= x;
                    s1.insert({ind, v});
                    ans = max(ans, i - ind);
                    x = 0;
                } else {
                    x -= (s1.begin())->second;
                    int ind = (s1.begin())->first, v = (s1.begin())->second;
                    s1.erase({ind, v});
                    ans = max(ans, i - ind);
                }
            }
            if (x > 0) {
                s2.insert({i, x});
            }
            //cout << 2 << ' ' << i << ' ' << x << ' ';
        }
        //cout << ans << '\n';
    }
    if (!s2.empty()) {
        ans = -1;
    }
    cout << min(ans, ans1);
}