#include<bits/stdc++.h>
#define f first
#define s second
#define fi first
#define se second
#define _ << ' '  <<

typedef long long ll;
typedef long double ld;

using namespace std;

const int N = 2e5 +5;
const ld EPS = 1.0e-10;

int n, a[N];
int pref_min[N], pref_max[N], suff_min[N], suff_max[N];

ld t;

ld calc_curr(int k) {
    ld mx1 = (ld) pref_max[k - 1], mn1 = (ld) pref_min[k - 1];
    ld mx2 = ((ld) 1.0 - t) * suff_max[k], mn2 = ((ld) 1.0 - t) * suff_min[k];
    ld mx = max(mx1, mx2), mn = min(mn1, mn2);
    return mx - mn;
}

void check(ld t1, int k) {
    ld mx1 = (ld) pref_max[k - 1], mn1 = (ld) pref_min[k - 1];
    ld mx2 = ((ld) 1.0 - t1) * suff_max[k], mn2 = ((ld) 1.0 - t1) * suff_min[k];
    ld mx = max(mx1, mx2), mn = min(mn1, mn2), curr_ans = calc_curr(k);
    if (fabsl(curr_ans - mx + mn) <= EPS) {
        t = max(t, t1);
        return;
    }
    if (curr_ans > mx - mn) {
        t = t1;
    }
}

void solve() {
    cout << fixed << setprecision(15);
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++i) {
        if (i > 1) {
            pref_min[i] = pref_min[i - 1];
            pref_max[i] = pref_max[i - 1];
        } else {
            pref_min[i] = a[i];
            pref_max[i] = a[i];
        }
        pref_min[i] = min(pref_min[i], a[i]);
        pref_max[i] = max(pref_max[i], a[i]);
    }
    for (int i = n; i >= 1; --i) {
        if (i < n) {
            suff_min[i] = suff_min[i + 1];
            suff_max[i] = suff_max[i + 1];
        } else {
            suff_min[i] = a[i];
            suff_max[i] = a[i];
        }
        suff_min[i] = min(suff_min[i], a[i]);
        suff_max[i] = max(suff_max[i], a[i]);
    }
    for (int k = 1; k <= n; ++k) {
        if (k == 1) {
            cout << (ld) 1.0 << " ";
        } else {
            int mx1 = pref_max[k - 1], mn1 = pref_min[k - 1];
            int mx2 = suff_max[k], mn2 = suff_min[k];
            ld t1 = (ld) 1.0 - (ld) mx1 / (ld) mx2;
            ld t2 = (ld) 1.0 - (ld) mn1 / (ld) mn2;
            ld t3 = (ld) 1.0;
            t = (ld) 0.0;
            if (mx1 <= mx2) check(t1, k);
            if (mn1 <= mn2) check(t2, k);
            check(t3, k);
            cout << t << " ";
        }
    }
    cout << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
#endif // LOCAC

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}

