#include<bits/stdc++.h>
#define f first
#define s second
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define _ << ' '  <<
#define sz(x) (int)x.size()

typedef long long ll;

using namespace std;

const int P = 31, MOD = 1e9 + 7, MAXM = 1e6 + 10, MAXN = 1e5;

int add(int x, int y) {
    return (x + y < MOD ? x + y : x + y - MOD);
}

int dec(int x, int y) {
    return (x - y < 0 ? x - y + MOD : x - y);
}

int mul(int x, int y) {
    return 1ll * x* y % MOD;
}

int pw[MAXM];
int hs[MAXN][26];

string s[MAXN];

int n;

void precalc() {
    pw[0] = 1;
    for (int i = 1; i < MAXM; i++) pw[i] = mul(pw[i - 1], P);
    for (int i = 0; i < n; i++) {
        char c;
        for (int j = 0; j < sz(s[i]); j++) {
            c = s[i][j];
            hs[i][c - 'a'] = add(hs[i][c - 'a'], pw[j]);
        }
    }
}



bool dfs(vector<int> ind, set<int> used) {
    if (sz(ind) <= 1) return 1;
    /*cout << "dfs" << endl;
    cout << "ind" << endl;
    for (auto el : ind) cout << el + 1 << ' ';
    cout << endl;
    cout << "used" << endl;
    for (auto el : used) cout << (char) ('a' + el) << ' ';
    cout << endl;*/
    for (int i = 0; i < 26; i++) {
        if (used.count(i)) continue;
        bool fl = 1;
        for (auto j : ind) {
            if (hs[j][i] == 0) {
                fl = 0;
                break;
            }
        }
        if (!fl) continue;
        //cout << "found char" _ (char) ('a' + i) << endl;
        map<int, vector<int> > m;
        for (auto j : ind) {
            m[hs[j][i]].push_back(j);
        }
        used.insert(i);
        for (auto el : m) {
            if (!dfs(el.s, used)) {
                return 0;
            }
        }
        return 1;
    }
    return 0;
}

void solve() {
    int l;
    cin >> l >> n;
    for (int i = 0; i < n; i++) cin >> s[i];
    precalc();
    vector<int> a(n);
    iota(all(a), 0);
    if (dfs(a, set<int> ())) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
#endif // LOCAC

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}

/*
dfs
ind
1 2
used

found char l
dfs
ind
2
used
l
found char d
dfs
ind
2
used
d l
found char o
dfs
ind
2
used
d l o
found char r
dfs
ind
2
used
d l o r
found char w
dfs
ind
2
used
d l o r w
NO
*/


