#include<bits/stdc++.h>
#define f first
#define s second
#define fi first
#define se second
#define _ << ' '  <<

typedef long long ll;

using namespace std;

const int N = 5e5 + 5, LOG = 20, inf = 1e9;

const int MOD = 1e9 + 7;

int add(int x, int y) {
    return x + y >= MOD ? x + y - MOD : x + y;
}

int sub(int x, int y) {
    return x - y < 0 ? x - y + MOD : x - y;
}

int mul(int x, int y) {
    return 1ll * x * y % MOD;
}

int n, k, a[N], b[N], d[N];
ll pref[N];

/*int get(int L, int R) {
    int mn = inf;
    for (int i = L; i <= R; ++i) {
        mn = min(mn, d[i]);
    }
    return mn;
}*/

int lenfor[N];
int sp[LOG][N];

void build() {
    for (int i = 2; i <= n; ++i) {
        lenfor[i] = lenfor[i >> 1] + 1;
    }
    for (int j = 0; j < LOG; ++j) {
        for (int i = 0; i <= n; ++i) {
            sp[j][i] = inf;
        }
    }
    for (int j = 0; j < LOG; ++j) {
        for (int i = 1; i + (1 << j) - 1 <= n; ++i) {
            if (!j) {
                sp[j][i] = d[i];
            } else {
                sp[j][i] = min(sp[j - 1][i], sp[j - 1][i + (1 << (j - 1))]);
            }
        }
    }
}

int get_dmin(int L, int R) {
    int len = lenfor[R - L + 1];
    return min(sp[len][L], sp[len][R - (1 << len) + 1]);
}

int sum[4 * N], value[4 * N];

void upd(int v, int tl, int tr, int val) {
    value[v] = val;
    sum[v] = mul(value[v], tr - tl);
}

void push(int v, int tl, int tr) {
    if (!value[v]) {
        return;
    }
    int tm = (tl + tr) / 2;
    upd(v * 2 + 1, tl, tm, value[v]);
    upd(v * 2 + 2, tm, tr, value[v]);
    value[v] = 0;
}

void update(int v, int tl, int tr, int L, int R, int val) {
    if (tl >= R || L >= tr) {
        return;
    }
    if (L <= tl && tr <= R) {
        upd(v, tl, tr, val);
        return;
    }
    push(v, tl, tr);
    int tm = (tl + tr) / 2;
    update(v * 2 + 1, tl, tm, L, R, val);
    update(v * 2 + 2, tm, tr, L, R, val);
    sum[v] = add(sum[v * 2 + 1], sum[v * 2 + 2]);
}

void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        sum[v] = 0;
        value[v] = 0;
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm, tr);
}

int get(int v, int tl, int tr, int L, int R) {
    if (tl >= R || L >= tr) {
        return 0;
    }
    if (L <= tl && tr <= R) {
        return sum[v];
    }
    push(v, tl, tr);
    int tm = (tl + tr) / 2;
    return add(get(v * 2 + 1, tl, tm, L, R), get(v * 2 + 2, tm, tr, L, R));
}

int solve(vector<int> &pos) {
    int ans = 0;
    int m = (int) pos.size();
    build(0, 0, m);
    for (int i = 1; i < m; ++i) {
        int mn = get_dmin(pos[i - 1] + 1, pos[i]);
        int lef = -1, rig = i - 1;
        while (lef + 1 < rig) {
            int mid = (lef + rig) / 2;
            if (get_dmin(pos[mid] + 1, pos[mid + 1]) < mn) {
                lef = mid;
            } else {
                rig = mid;
            }
        }
        update(0, 0, m, rig, i, mn);
        ans = add(ans, get(0, 0, m, 0, i));
    }
    return ans;
}

vector<int> pos[N];

void solve() {
    cin >> n >> k;
    vector<int> diff;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i] >> b[i];
        if (a[i] < b[i]) {
            swap(a[i], b[i]);
        }
        d[i] = a[i] - b[i];
        pref[i] = (pref[i - 1] + a[i]) % k;
        diff.emplace_back(pref[i]);
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        ans = add(ans, mul(i, mul(a[i], n - i + 1)));
    }
    /*for (int L = 0; L < n; ++L) {
        for (int R = L + 1; R <= n; ++R) {
            if (pref[L] == pref[R]) {
                ans -= get(L + 1, R);
            }
        }
    }
    cout << ans << "\n";*/
    build();
    diff.emplace_back(0);
    sort(diff.begin(), diff.end());
    diff.resize(unique(diff.begin(), diff.end()) - diff.begin());
    for (int i = 0; i <= n; ++i) {
        pref[i] = lower_bound(diff.begin(), diff.end(), pref[i]) - diff.begin();
        pos[pref[i]].emplace_back(i);
    }
    for (int v = 0; v < (int) diff.size(); ++v) {
        ans = sub(ans, solve(pos[v]));
    }
    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
#endif // LOCAC

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}

