#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#define sz(x) (int)x.size()
#define all(c) c.begin(), x.end()
#define eb emplace_back
#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define umap unordered_map
#define uset unordered_set
//#define LONG
using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;

const int inf9 = 1e9 + 10;
const ll inf18 = 1e18 + 10;

#ifdef LONG
#define int ll
#define inf inf18
#else
#define inf inf9
#endif

template <typename T1, typename T2> istream& operator>>(istream& is, pair <T1, T2>& a){is >> a.ff >> a.ss;return is;}
template <typename T1, typename T2> ostream& operator<<(ostream& os, pair <T1, T2> a){os << "(" << a.ff << ", " << a.ss << ")";return os;}
template <typename T> istream& operator>>(istream& is, vector <T>& a){for (int i = 0; i < a.size(); i++){is >> a[i];}return is;}
template <typename T> ostream& operator<<(ostream& os, vector <T> a){for (int i = 0; i < a.size(); i++){os << a[i] << " ";}os << endl;return os;}
template <typename T> void print(T a){for (auto x : a){cout << x << " ";}cout << endl;}

const int B = 239, M7 = 1e9 + 7, M9 = 1e9 + 9, N = 1e5 + 10;
int l;
string a[N];
int h7[N][26], h9[N][26];
int used[26];

ll comp(int x, int y)
{
    return ((ll)x) * M9 + y;
}

bool answer(vector <int>& gr)
{
    for (int c = 0; c < 26; c++)
    {
        if (!used[c])
        {
            bool f = true;
            int cnt = 0;
            umap <int, int> d;
            vector <vector <int> > hash;
            for (auto i : gr)
            {
                ll h = comp(h7[i][c], h9[i][c]);
                if (h == 0)
                {
                    f = false;
                    break;
                }
                if (d.find(h) == d.end())
                {
                    d[h] = cnt + 1;
                    cnt++;
                    hash.resize(cnt);
                }
                hash[d[h] - 1].pb(i);
            }
            if (!f)
            {
                continue;
            }
            used[c] = 1;
            for (auto x : hash)
            {
                if (x.size() > 1)
                {
                    if (!answer(x))
                    {
                        used[c] = 0;
                        f = false;
                        break;
                    }
                }
            }
            if (f)
            {
                return true;
            }
        }
    }
    return false;
}

void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

int32_t main()
{
    fastio();
    int n;
    cin >> l >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    for (int c = 0; c < 26; c++)
    {
        for (int i = 0; i < n; i++)
        {
            ll hash7 = 0, hash9 = 0;
            for (int j = 0; j < l; j++)
            {
                if (a[i][j] == c + 'a')
                {
                    hash7 = (hash7 * B + j + 31) % M7;
                    hash9 = (hash9 * B + j + 31) % M9;
                }
            }
            h7[i][c] = hash7;
            h9[i][c] = hash9;
        }
    }
    vector <int> z(n);
    for (int i = 0; i < n; i++)
    {
        z[i] = i;
    }
    cout << (answer(z) ? "YES" : "NO");
}