#include <bits/stdc++.h>

using namespace std;
#define int long long
#define fi first
#define se second
#define sz(x) long(x.size())
#define all(x) x.begin(), x.end()

const int MX = 1e6 + 10;
const int INF = 2e18;
const int MOD = 1e9 + 7;

int n, T;
int a[MX], b[MX];

bool ok(int k) {
    deque<pair<int, int>> d;
    for (int i = 0; i < n; i++) d.push_back({i, b[i]});
    for (int i = 0; i < n; i++) {
        while (sz(d) > 0 && i - d.front().first > k) d.pop_front();
        int s = a[i];
        while (s) {
            if (sz(d) == 0ll) return 0;
            auto[x, cnt] = d.front();
            if (abs(i - x) <= k) {
                int mi = min(cnt, s);
                s -= mi;
                d.front().second -= mi;
                if (d.front().se == 0)
                    d.pop_front();
            } else {
                return 0;
            }
        }
    }
    return 1;
}

void solve() {
    cin >> n;
    int s1 = 0, s2 = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s1 += a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        s2 += b[i];
    }
    if (s1 > s2) {
        cout << -1;
        return;
    }
    int l = -1, r = n;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (ok(m)) r = m;
        else l = m;
    }
    cout << r << "\n";
}

signed main() {
    //ios::sync_with_stdio(0), cin.tie(0);
    solve();
}