#include <bits/stdc++.h>

using namespace std;

#define ll long long

ll n;
vector<ll> sa;
vector<ll> sb;

bool f(ll k)
{
    ll d = 0;
    for (int i = 1; i <= n; ++i)
    {
        if (d + sa[min(n, i + k)] - sa[max(0ll, i - k - 1)] > sb[min(n, i + k)] - sb[max(0ll, i - k - 1)])
        {
            return false;
        }
        if (sb[i] < sa[i])
            d = sa[i] - sb[i];
    }
    return true;
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    vector<ll> a(n, 0);
    vector<ll> b(n, 0);
    sa.resize(n + 1, 0);
    sb.resize(n + 1, 0);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        sa[i + 1] = a[i];
        if (i != 0)
            sa[i + 1] += sa[i];
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> b[i];
        sb[i + 1] = b[i];
        if (i != 0)
            sb[i + 1] += sb[i];
    }
    ll l = -1, r = n + 1;
    while (r - l > 1)
    {
        ll m = l + (r - l) / 2;
        if (f(m))
            r = m;
        else
            l = m;
    }
    if (!f(r))
    {
        cout << -1;
        return 0;
    }
    cout << r;
}
/*
5
1 100 200 0 1
100 10 100 100 100
*/
