#include <iostream>
#include <stack>
using namespace std;

long long n;
long long A[1000000], B[1000000];

bool f(long long r) {
    long long s = 0;
    for (long long i = 0; i <= r; i++)
        s += B[i];
    for (long long i = 0; i < n; i++)
    {
        if (A[i] > s)
            return false;
        if (i - r >= 0)
        {
            s -= B[i - r];
        }
        if (i + r+1 < n)
            s += B[i + r+1];

    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    cin >> n;
    for (long long i = 0; i < n; i++) {
        cin >> A[i];
    }
    for (long long i = 0; i < n; i++) {
        cin >> B[i];
    }
    long long l = -1, r = n;
    while (r - l > 1) {
        long long c = (r + l) / 2;
        if (f(c)) {
            r = c;
        }
        else {
            l = c;
        }
    }
    if (f(r)) {
        cout << r;
    }
    else {
        cout << -1;
    }
}