#include<bits/stdc++.h>
using namespace std;
typedef long double ld;
typedef long long ll;

#define int ld
#define ff first
#define ss second
#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int INF = 1e9 + 10;
ld EPS = 1e-7;

ld check(vector<int>& pmx, vector<int>& pmn, vector<int>& smn, vector<int>& smx, ld t, int k) {
    ld ans1 = 0;
    if (k != 0) {
        ans1 = pmx[k - 1];
    }
    ans1 = max(ans1, (1.0 - t) * smx[k]);
    ld ans2 = INF;
    if (k != 0) {
        ans2 = pmn[k - 1];
    }
    ans2 = min(ans2, (1.0 - t) * smn[k]);
   // if (t == 0) cout << ans1 << " " << ans2 << endl;
    return abs(ans1 - ans2);
}

signed main() {
    fastio();
    ll n;
    cin >> n;
    vector<int> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> pmx(n), pmn(n, INF), smx(n), smn(n, INF);
    for (ll i = 0; i < n; ++i) {
        if (i != 0) {
            pmx[i] = pmx[i - 1];
            pmn[i] = pmn[i - 1];
        }
        pmx[i] = max(pmx[i], a[i]);
        pmn[i] = min(pmn[i], a[i]);
    }
    for (ll i = n - 1; i >= 0; --i) {
        if (i != n - 1) {
            smx[i] = smx[i + 1];
            smn[i] = smn[i + 1];
        }
        smx[i] = max(smx[i], a[i]);
        smn[i] = min(smn[i], a[i]);
    }

    for (ll k = 0; k < n; ++k) {
        ld l = 0, r = 1;
        for (ll i = 0; i < 80; ++i) {
            ld ml = (r - l) / 3.0 + l;
            ld mr = r - (r - l) / 3.0;
            if (check(pmx, pmn, smn, smx, ml, k) >= check(pmx, pmn, smn, smx, mr, k)) l = ml;
            else r = mr;
        }
        if ((check(pmx, pmn, smn, smx, r, k) - check(pmx, pmn, smn, smx, 0, k)) > EPS) {
            r = 0;
        }
        cout << fixed << setprecision(13) << r << " ";
    }
}
