#include<bits/stdc++.h>

using namespace std;
typedef long double ld;
typedef long long ll;

#define int ll
#define ff first
#define ss second
#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int INF = 1e9 + 10;
ld EPS = 1e-7;

const int pP[2] = {239, 179};
const int pMOD[2] = {1791791791791, (int)1e9 + 7};

int n, l;

bool get(const vector<string> &b, int P, int MOD) {
    vector<vector<int>> mask(n, vector<int>(26, 0));
    for (int i = 0; i < n; ++i) {
        string s = b[i];
        for (int c = 0; c < 26; ++c) {
            int ans = 0;
            for (int j = 0; j < s.size(); ++j) {
                int nw = ((s[j] - 'a') == c);
                ans = (ans + nw) * P;
                ans %= MOD;
            }
            mask[i][c] = ans;
        }
    }
    vector<int> u(26, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 26; ++j) {
            if (mask[i][j] > 0) {
                ++u[j];
            }
        }
    }
    char ok = '*';
    for (char j = 'a'; j <= 'z'; ++j) {
        if (u[j - 'a'] == n) {
            ok = j;
        }
    }
    if (ok == '*') {
        return false;
    }
    set<pair<pair<int, int>, vector<int>>> st;
    for (int i = 0; i < n; ++i) {
        int cur_mask = mask[i][ok - 'a'];
        auto nw = st.lower_bound({{cur_mask, -INF}, {}});
        if (nw != st.end() && nw->X.X == cur_mask) {
            auto cur = *nw;
            st.erase(cur);
            cur.Y.push_back(i);
            st.insert(cur);
        } else {
            st.insert({{cur_mask, 1ll << (int)(ok - 'a')}, {i}});
        }
    }
    vector<pair<pair<int, int>, vector<int>>> tmp; // {{mask_, mask_forR_bukv}, {i1, i2, i3}}
    for (auto &el : st) {
        if (el.Y.size() <= 1) {
            tmp.push_back(el);
        }
    }
    for (auto &el : tmp) {
        st.erase(el);
    }
    while (!st.empty()) {
        auto cur = *st.rbegin();
        ok = '*';
        st.erase(cur);
        if (cur.Y.size() == 1) continue;
        int mask_for_let = cur.X.Y;
        u.assign(26, 0);
        vector<set<int>> q(26);
        for (auto &i : cur.Y) {
            for (int j = 0; j < 26; ++j) {
                if (mask[i][j] == 0) continue;
                int now = ((mask_for_let >> j) & 1ll);
                if (!now) {
                    ++u[j];
                    q[j].insert(mask[i][j]);
                }
            }
        }
        for (int j = 0; j < 26; ++j) {
            if (u[j] == cur.Y.size() && q[j].size() != 1) {
                ok = (char)(j + 'a');
            }
        }
        if (ok == '*') {
            return false;
        }
        mask_for_let += (1ll << (int)(ok - 'a'));
        for (auto &i : cur.Y) {
            int cur_mask = mask[i][ok - 'a'];
            auto nw = st.lower_bound({{cur_mask, -INF}, {}});
            if (nw != st.end() && nw->X.X == cur_mask) {
                auto curr = *nw;
                st.erase(curr);
                curr.Y.push_back(i);
                st.insert(curr);
            } else {
                st.insert({{cur_mask, mask_for_let}, {i}});
            }
        }
        tmp.clear();
        for (auto &el : st) {
            if (el.Y.size() == 1) {
                tmp.push_back(el);
            }
        }
        for (auto &el : tmp) {
            st.erase(el);
        }
    }
    return true;
}

signed main() {
    fastio();
    cin >> l >> n;

    vector<string> b(n);
    for (auto &i : b) {
        cin >> i;
    }
    for (int j = 0; j < 1; ++j) {
        for (int i = 0; i < 2; ++i) {
            if (get(b, pP[i], pMOD[i])) {
                cout << "YES";
                return 0;
            }
        }
    }
    cout << "NO";
}