#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>
#include <math.h>
#include <cmath>
#include <stack>

#define ll long long
#define vi vector<ll>
#define all(a) a.begin(), a.end()
#define pii pair<int,int>
#define forn(n) for(ll i = 0; i < n; i++)
#define nl '\n'
#define pb(x) push_back(x)

using namespace std;

ll gcd (ll a, ll b) {
	while (b > 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

void print_bin(int n, int a) {
	for (int i = n - 1; i >= 0; i--) {
		cout << ((a & (1 << i)) > 0);
	}
	cout << nl;
}

int main(){
	int n;
	cin >> n;
	stack<int> st1;
	stack<int> st2;
	set<int> s1;
	set<int> s2;
	int curwag = 1;
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		if (x == curwag) {
			curwag += 1;
			cout << 1 << nl;
			cout << -1 << nl;
		}
		else if (st1.size() == 0) {
			st1.push(x);
			s1.insert(x);
			cout << 1 << nl;
		}
		else if(x < st1.top()){
			st1.push(x);
			s1.insert(x);
			cout << 1 << nl;
		}
		else {
			st2.push(x);
			s2.insert(x);
			cout << 2 << nl;
		}
	}
	while (curwag <= n) {
		if (s1.find(curwag) != s1.end()) {
			s1.erase(curwag);
			int x = st1.top();
			while (x != curwag) {
				int t = st1.top();
				st1.pop();
				st2.push(t);
				s1.erase(t);
				s2.insert(t);
				x = st1.top();
				cout << 12 << nl;
			}
			st1.pop();
			cout << -1 << nl;
		}
		else if (s2.find(curwag) != s2.end()) {
			s2.erase(curwag);
			int x = st2.top();
			while (x != curwag) {
				int t = st2.top();
				st2.pop();
				st1.push(t);
				s2.erase(t);
				s1.insert(t);
				x = st2.top();
				cout << 21 << nl;
			}
			st2.pop();
			cout << -2 << nl;
		}
		else {
			cout << "!!!!" << curwag << nl;
			break;
		}
		curwag += 1;
	}
}
