from itertools import combinations
from collections import defaultdict
l, n = map(int, input().split())
words = []
for _ in range(n):
    word = defaultdict(set)
    for letter_idx, letter in enumerate(input()):
        word[letter].add(letter_idx)
    words.append(word)
empty_set = set()
answer = True
for w1, w2 in combinations(words, 2):
    s = False
    for letter in (set(w1.keys()) | set(w2.keys())):
        if letter not in w1 or letter not in w2:
            continue
        if w1[letter] - w2[letter] != empty_set:
            s = True
            break
    if not s:
        answer = False
        break

print('YES' if answer else 'NO')
