#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<int> a(n);
	for (int& i : a) cin >> i;
	vector<pair<int, int>> mml(n);
	vector<pair<int, int>> mmr(n);
	mml[0] = { a[0], a[0] };
	mmr[n - 1] = { a[n - 1], a[n - 1] };
	for (int i = 1; i < n; ++i) {
		mml[i] = { max(mml[i - 1].first, a[i]), min(mml[i - 1].second, a[i]) };
		mmr[n - 1 - i] = { max(mmr[n - i].first, a[n - 1 - i]), min(mmr[n - i].second, a[n - 1 - i]) };
	}
	cout << "1.00 ";
	int min1, min2, max1, max2;
	double ans;
	for (int i = 1; i < n; ++i) {
		min1 = mml[i - 1].second;
		min2 = mmr[i].second;
		max1 = mml[i - 1].first;
		max2 = mmr[i].first;
		if (min1 <= min2 && max1 >= max2) {
			ans = 1.0 - double(min1) / min2;
		}
		else if (min1 >= min2 && max1 <= max2) {
			ans = 1.0 - double(max1) / max2;
		}
		else if (max1 >= max2 && min2 <= min1)
			ans = 0.0;
		else {
			ans = 1.0 - double(max1) / max2;
		}
		cout << ans << " ";
	}

	return 0;
}