#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <iomanip>
#include <stack>
#include <unordered_map>

using namespace std;

#define ll long long
#define ull unsigned long long
#define add push_back
#define mpr make_pair
#define ft first
#define sc second
#define all(v) v.begin(), v.end()
#define sz(v) (ll)v.size()
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#define endl '\n'

const int N = 1005;

int n;
int w[N];
int a[N];
stack<int> st0, st1, st2;

int main() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = n - 1; i >= 0; i--) {
		st0.push(a[i]);
		w[a[i]] = 0;
	}
	for (int now = 1; now <= n; now++) {
		if (w[now] == 0) {
			while (st0.top() != now) {
				st1.push(st0.top());
				w[st0.top()] = 1;
				st0.pop();
				cout << "1" << endl;
			}
			cout << "1" << endl;
			cout << "-1" << endl;
			w[now] = -1;
			st0.pop();
		}
		else if (w[now] == 1) {
			while (st1.top() != now) {
				st2.push(st1.top());
				w[st1.top()] = 2;
				st1.pop();
				cout << "12" << endl;
			}
			cout << "-1" << endl;
			w[now] = -1;
			st1.pop();
		}
		else if (w[now] == 2) {
			while (st2.top() != now) {
				st1.push(st2.top());
				w[st2.top()] = 1;
				st2.pop();
				cout << "21" << endl;
			}
			cout << "-2" << endl;
			w[now] = -1;
			st2.pop();
		}
	}
	return 0;
}