#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <iomanip>
#include <stack>
#include <unordered_map>

using namespace std;

#define ll long long
#define ull unsigned long long
#define add push_back
#define mpr make_pair
#define ft first
#define sc second
#define all(v) v.begin(), v.end()
#define sz(v) (ll)v.size()
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

const int N = 1000011;
ll a[N], b[N], suma, sumb;

int main() {
	fastio;
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		suma += a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		sumb += b[i];
	}
	if (suma > sumb) cout << -1 << endl;
	else {
		int l = 0, r = n - 1, ans = -1;
		while (l <= r) {
			int m = (l + r) / 2;
			int i = 0, j = 0, nowa = a[0], nowb = b[0];
			while (i < n && j < n) {
				if (abs(i - j) > m) {
					j++;
					nowb = b[j];
				}
				else {
					if (nowa <= nowb) {
						nowb -= nowa;
						i++;
						nowa = a[i];
					}
					else {
						nowa -= nowb;
						j++;
						nowb = b[j];
					}
				}
			}
			if (i >= n) {
				ans = m;
				r = m - 1;
			}
			else l = m + 1;
		}
		cout << ans << endl;
	}
	return 0;
}