#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <iomanip>
#include <stack>
#include <unordered_map>

using namespace std;

#define ll long long
#define ull unsigned long long
#define add push_back
#define mpr make_pair
#define ft first
#define sc second
#define all(v) v.begin(), v.end()
#define sz(v) (ll)v.size()
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

const int N = 100005;

long long n;
long double a[N];
long double lmx[N], lmn[N], rmx[N], rmn[N];

int main() {

	cout << fixed;
	cout << setprecision(9);

	fastio;

	//cout << (long double)1000000000 << endl;

	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 1; i < n; i++) {
		if (i == 1) {
			lmn[i] = a[i - 1];
			lmx[i] = a[i - 1];
		}
		else {
			lmn[i] = min(lmn[i - 1], a[i - 1]);
			lmx[i] = max(lmx[i - 1], a[i - 1]);
		}
	}
	for (int i = n - 1; i >= 0; i--) {
		if (i == n - 1) {
			rmx[i] = a[i];
			rmn[i] = a[i];
		}
		else {
			rmx[i] = max(a[i], rmx[i + 1]);
			rmn[i] = min(a[i], rmn[i + 1]);
		}
	}

	/*
	for (int i = 0; i < n; i++) {
	cout << lmx[i] << " ";
	}
	cout << endl;
	for (int i = 0; i < n; i++) {
	cout << lmn[i] << " ";
	}
	cout << endl;
	for (int i = 0; i < n; i++) {
	cout << rmx[i] << " ";
	}
	cout << endl;
	for (int i = 0; i < n; i++) {
	cout << rmn[i] << " ";
	}
	cout << endl;
	*/

	cout << (long double)1 << " ";
	long double F, S;
	for (int i = 1; i < n; i++) {
		F = ((rmx[i] - lmx[i]) / rmx[i]);
		S = ((rmn[i] - lmn[i]) / rmn[i]);
		cout << max({ F, S, (long double)0 }) << " ";
	}
	cout << endl;
	return 0;
}