#include <bits/stdc++.h>

using namespace std;

#define pii pair<int, int>
#define f first
#define s second

bool check(int n, int k, vector<int> a, vector<int> b){
    if (k == n) return true;
    queue<pii> st;
    for (int i = 0; i < k+1; ++i) st.push({i, b[i]});
    //cerr << "cur : " << k << "\n";
    for (int i = 0; i < n; ++i){
        //cerr << a[i] << "\n";
        while (a[i] > 0){
            if (st.empty()) return false;
            int idx = st.front().f;
            int cur = st.front().s;
            int x = min(cur, a[i]);
            a[i] -= x;
            cur -= x;
            if (cur == 0) st.pop();
            if (cur != 0) st.front().s = cur;
        }

        //cerr << a[i] << " " << st.size() << "\n";

        int idx = n + 5;
        if (!st.empty()) idx = st.front().f;
        if (idx == i - k) st.pop();
        if (i + k + 1 < n) st.push({i + k + 1, b[i + k + 1]});

    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n; cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];

    int l = 0, r = n;
    while (l <= r){
        int mid = (l + r) / 2;
        if (check(n, mid, a, b)) r = mid - 1;
        else l = mid + 1;
    }

    if (l == n) l = -1;
    cout << l << "\n";

    return 0;
}
