#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,sse4,popcnt")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <complex>
#include <array>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <cstring>
#include <bitset>
#include <list>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cassert>

#define sq(x) ((x) * (x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errp(x) cerr << "["#x"]  {" << ((x).first) << ", " << ((x).second) << "}\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2> inline bool relax(T1& a, const T2& b) {
    return a > b ? a = b, true : false;
}

template <typename T1, typename T2> inline bool strain(T1& a, const T2& b) {
    return a < b ? a = b, true : false;
}

// :::::::::::::::::::::::::::::::

// rusfree8049
// edefegecafy

#define v vector

void solve() {
    ll n;
    cin >> n;
    v<ll> a(n);
    for(ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    v<ll> pmi, pma, smi, sma;
    pmi = pma = smi = sma = v<ll>(n);
    pmi[0] = pma[0] = a[0];
    for(ll i = 1; i < n; ++i) {
        pmi[i] = min(pmi[i - 1], a[i]);
        pma[i] = max(pma[i - 1], a[i]);
    }
    smi[n - 1] = sma[n - 1] = a[n - 1];
    for(ll i = n - 2; i >= 0; --i) {
        smi[i] = min(smi[i + 1], a[i]);
        sma[i] = max(sma[i + 1], a[i]);
    }
    cout.precision(10);
    cout << fixed <<  1.0l << ' ';
    for(ll k = 1; k < n; ++k) {
        v<ld> ts = {0, 1, (ld)pmi[k - 1] / smi[k], (ld)pma[k - 1] / sma[k]};
        ld optit = 1;
        ld optin = 1e18;
        for(ld t : ts) {
            if(t >= 0 && t <= 1) {
                ld ma = max({(ld)pmi[k - 1], (ld)pma[k - 1], t * (ld) smi[k], t * (ld)sma[k]});
                ld mi = min({(ld)pmi[k - 1], (ld)pma[k - 1], t * (ld) smi[k], t * (ld)sma[k]});
                //cout << ma << ' ' << mi << ' ' << t << endl;
                if(optin > ma - mi || (abs(optin - ma + mi) <= 1e-10l && t < optit)) {
                    optit = t;
                    optin = ma - mi;
                }
            }
        }
        cout << (1 - optit) << ' ';
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);
    
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    
    return 0;
}
