#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,sse4,popcnt")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <complex>
#include <array>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <sstream>
#include <cmath>
#include <cstring>
#include <bitset>
#include <list>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cassert>

#define sq(x) ((x) * (x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errp(x) cerr << "["#x"]  {" << ((x).first) << ", " << ((x).second) << "}\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2> inline bool relax(T1& a, const T2& b) {
    return a > b ? a = b, true : false;
}

template <typename T1, typename T2> inline bool strain(T1& a, const T2& b) {
    return a < b ? a = b, true : false;
}

// :::::::::::::::::::::::::::::::

// rusfree8049
// edefegecafy



void solve() {
    ll t[4];
    cin >> t[0] >> t[1] >> t[2] >> t[3];
    ll perm[4];
    iota(perm, perm + 4, 0ll);
    ld ma = -1;
    ld mav[4];
    ll maperm[4];
    do {
        ll num = t[perm[1]] + t[perm[2]] - t[perm[3]] - t[perm[1]] * t[perm[2]];
        ll denom = 1 - t[perm[3]];
        if(denom == 0) {
            if (num == 0) {
                ll x = t[perm[0]] * t[perm[3]] + t[perm[1]] + t[perm[2]];
                if(x > ma) {
                    ma = x;
                    for(ll i = 0; i < 4; ++i) {
                        mav[i] = t[perm[i]];
                    }
                    for(ll i = 0; i < 4; ++i) {
                        maperm[i] = perm[i];
                    }
                }
            }
        } else {
            ld res = (ld)num / denom;
            ld x = res * t[perm[3]] + t[perm[1]] + t[perm[2]];
            //            cout << num << ' ' << denom << ' ' << res << ' ';
            //            for(ll i = 1; i < 4; ++i) {
            //                cout << t[perm[i]] << ' ';
            //            }
            //            cout << endl;
            //err(x);
            if(res <= t[perm[0]] + 1e-5l && x > ma) {
                ma = x;
                mav[0] = res;
                for(ll i = 1; i < 4; ++i) {
                    mav[i] = t[perm[i]];
                }
                for(ll i = 0; i < 4; ++i) {
                    maperm[i] = perm[i];
                }
            }
        }
    } while(next_permutation(perm, perm + 4));
    for(ll i = 0; i < 4; ++i) {
        cout << maperm[i] + 1 << ' ';
    }
    cout << '\n';
    cout.precision(10);
    cout << fixed;
    for(ll i = 0; i < 4; ++i) {
        cout << mav[i] << ' ';
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);
    
    int t = 1;
    //    cin >> t;
    while (t--)
        solve();
    
    return 0;
}
