#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <numeric>

using namespace std;

typedef vector<int> vi;
typedef long long ll;
typedef long double ld;

vi a, b;

bool comp(int x, int y) {
    return a[x] < a[y];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vi inds(n);
    a = vi(n);
    b = vi(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    iota(inds.begin(), inds.end(), 0);
    sort(inds.begin(), inds.end(), comp);
    int res = 0;
    for (int i = 0; i < n; i++) {
        int ind = inds[i];
        int d = 0;
        while (a[ind] > 0 && (ind - d >= 0 || ind + d < n)){
            if (ind - d >= 0 && ind + d < n) {
                int ind1 = b[ind - d] >= b[ind + d] ? ind - d : ind + d;
                int ind2 = b[ind - d] >= b[ind + d] ? ind + d : ind - d;
                if (b[ind1] >= a[ind]) {
                    b[ind1] -= a[ind];
                    a[ind] = 0;
                }
                else {
                    a[ind] -= b[ind1];
                    b[ind1] = 0;
                    if (b[ind2] >= a[ind]) {
                        b[ind2] -= a[ind];
                        a[ind] = 0;
                    }
                    else {
                        a[ind] -= b[ind2];
                        b[ind2] = 0;
                    }
                }
            }
            else if (ind - d >= 0) {
                if (b[ind - d] >= a[ind]) {
                    b[ind - d] -= a[ind];
                    a[ind] = 0;
                }
                else {
                    a[ind] -= b[ind - d];
                    b[ind - d] = 0;
                }
            }
            else if (ind + d < n) {
                if (b[ind + d] >= a[ind]) {
                    b[ind + d] -= a[ind];
                    a[ind] = 0;
                }
                else {
                    a[ind] -= b[ind + d];
                    b[ind + d] = 0;
                }
            }
            res = max(res, d);
            d++;
        }
        if (a[ind] > 0) {
            res = -1;
            break;
        }
    }
    cout << res;
}
