#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <algorithm>
#include<vector>
#include<queue>
#include<set>
#include<map>
#include<math.h>
#include<string>
#include<random>
#include<cmath>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define endl '\n'
#define all(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back

const int N = 1e6 + 10;

ll a[N], b[N];

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	ll sum1 = 0, sum2 = 0;
	for (int q = 0; q < n; q++)
	{
		cin >> a[q];
		sum1 += a[q];
	}
	for (int q = 0; q < n; q++)
	{
		cin >> b[q];
		sum2 += b[q];
	}
	if (sum2 < sum1)
	{
		cout << -1;
		return 0;
	}
	int l = -1;
	int r = n - 1;
	while (r - l != 1)
	{
		int m = (l + r) / 2;
		queue<pair<int, int>> now;
		for (int q = 0; q <= m; q++)
		{
			now.push(mp(b[q], q));
		}
		bool can = true;
		for (int q = 0; q < n; q++)
		{
			int val = a[q];
			while (now.size() > 0 && val >= now.front().first)
			{
				val -= now.front().first;
				now.pop();
			}
			if (val > 0 && now.size() == 0)
			{
				can = false;
				break;
			}
			now.front().first -= val;
			if (now.front().second == q - m)
			{
				now.pop();
			}
			if (q + m + 1 < n)
			{
				now.push(mp(b[q + m + 1], q + m + 1));
			}
		}
		if (can)
		{
			r = m;
		}
		else
		{
			l = m;
		}
	}
	cout << r;

}