#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <algorithm>
#include<vector>
#include<queue>
#include<set>
#include<map>
#include<math.h>
#include<string>
#include<random>
#include<cmath>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define endl '\n'
#define all(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back

const int N = 2e5 + 10;

string str[N];

const int mod = 1e9 + 7;
const int p = 259;

ll a[N];

ll mxsuf[N], mnsuf[N];

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	for (int q = 0; q < n; q++)
	{
		cin >> a[q];
	}
	cout << fixed << setprecision(18);
	mxsuf[n - 1] = a[n - 1];
	mnsuf[n - 1] = a[n - 1];
	for (int q = n - 2; q > -1;q--)
	{
		mxsuf[q] = max(mxsuf[q + 1], a[q]);
		mnsuf[q] = min(mnsuf[q + 1], a[q]);
	}
	cout << ld(1) << " ";
	ll mx = a[0];
	ll mn = a[0];
	for (int q = 1; q < n; q++)
	{
		ll mx1 = mxsuf[q];
		ll mn1 = mnsuf[q];
		ld ans = 1e10;
		ld koefans = 0;
		
		if (mx1 >= mx)
		{
			ld koef = ld(mx) / mx1;
			ld mnn = min(ld(mn), mn1 * koef);
			if (mx - mnn < ans)
			{
				ans = mx - mnn;
				koefans = koef;
			}
		}
		if (mx1 >= mn)
		{
			ld koef = ld(mn) / mx1;
			ld mnn = min(ld(mn), mn1 * koef);
			if (mx - mnn < ans)
			{
				ans = mx - mnn;
				koefans = koef;
			}
		}
		if (mn1 >= mx)
		{
			ld koef = ld(mx) / mn1;
			ld mnx = max(ld(mx), mx1 * koef);
			if (mnx - mn < ans)
			{
				ans = mnx - mn;
				koefans = koef;
			}
		}
		if (mn1 >= mn)
		{
			ld koef = ld(mn) / mn1;
			ld mnx = max(ld(mx), mx1 * koef);
			if (mnx - mn < ans)
			{
				ans = mnx - mn;
				koefans = koef;
			}
		}
		if (mn >= mx1 && mx - mn1 < ans)
		{
			ans = mx - mn1;
			koefans = 1;
		}
		cout << (1 - koefans) << " ";
		mx = max(mx, a[q]);
		mn = min(mn, a[q]);
	}
}