﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

#define endl '\n';
using namespace std;
using ll = long long;
int n;
vector <ll> a, b, p;

bool ch(ll m)
{
    vector <ll> c(n);
    for (int i = 0; i < n; i++)
    {
        c[i] = p[min(n - 1, i + m)];
        if (i - 2 >= 0)
            c[i] -= p[i - 2];
    }
    for (int i = 0; i < n; i++)
    {
        if (c[i] < b[i])
            return 0;
    }
    return 1;
}

int main()
{
//#ifdef _DEBUG
  //  freopen("input.txt", "r", stdin);
//#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
   // cout.tie(0);
//#endif
    cin >> n;
    a.resize(n);
    b.resize(n);
    p.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        p[i] = a[i];
        if (i)
            p[i] += p[i - 1];
    }
    ll s = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
        s += b[i];
    }
    if (s < p[n - 1])
    {
        cout << -1;
        return 0;
    }
    ll l = -1, r = n + 1;
    while (r - l > 1)
    {
        ll m = (l + r) / 2;
        if (ch(m))
            r = m;
        else
            l = m;
    }
    cout << r;
}
