﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

#define endl '\n';
using namespace std;
using ll = long long;
ll n;
vector <ll> a, b, p;

bool ch(ll m)
{
	ll z = 0;
	for (int i = 0; i < min(n, m + 1); i++)
		z += b[i];

	for (int i = 0; i < n; i++)
	{
		if (z < a[i])
			return 0;
		ll q = max(0ll, min(z, a[i]));
		if (i - m >= 0)
		{
			z -= a[i - m];
			z -= max(0ll, q - m);
		}
		if (i + 1 + m < n)
			z += a[i];
	}
	return 1;
}

int main()
{
	//#ifdef _DEBUG
	  //  freopen("input.txt", "r", stdin);
	//#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	// cout.tie(0);
 //#endif
	cin >> n;
	a.resize(n);
	b.resize(n);
	p.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		p[i] = a[i];
		if (i)
			p[i] += p[i - 1];
	}
	ll s = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		s += b[i];
	}
	if (s < p[n - 1])
	{
		cout << -1;
		return 0;
	}
	ll l = -1, r = n + 1;
	while (r - l > 1)
	{
		ll m = (l + r) / 2;
		if (ch(m))
			r = m;
		else
			l = m;
	}
	cout << r;
}