﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <string>
#define endl '\n';
using namespace std;
using ll = long long;
int n;
const int N = 2e5 + 10;
double a[N];
double mnpref[N];
double mxpref[N];
double mnsuff[N];
double mxsuff[N];
long double f(long double q, int w) {
    long double curr1 = mxpref[w - 1];
    long double curr2 = mxsuff[w];
    long double c = max(curr1, curr2 * (1 - q));
    curr1 = mnpref[w - 1];
    curr2 = mnsuff[w];
    long double d = min(curr1, curr2 * (1 - q));
    return c - d;
}
int main()
{
    //#ifdef _DEBUG
      //  freopen("input.txt", "r", stdin);
    //#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    // cout.tie(0);
 //#endif
    cout << fixed << setprecision(10);
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    mnpref[1] = a[1];
    mxpref[1] = a[1];
    for (int i = 2; i <= n; i++) {
        mnpref[i] = min(mnpref[i - 1], a[i]);
        mxpref[i] = max(mxpref[i - 1], a[i]);
    }
    mxsuff[n] = a[n];
    mnsuff[n] = a[n];
    for (int i = n - 1; i >= 1; i--) {
        mxsuff[i] = max(mxsuff[i + 1], a[i]);
        mnsuff[i] = min(mnsuff[i + 1], a[i]);
    }
    cout << 1.0 << " ";
    for (int i = 2; i <= n; i++) {
        long double L = 0;
        long double R = 1;
        for (int cur = 0; cur < 53; cur ++) {
            long double m1 = L + (R - L) / 3;
            long double m2 = R - (R - L) / 3;
            if (f(m1, i) < f(m2, i)) {
                R = m2;;
            }
            else {
                L = m1;
            }
        }
        cout << L << " ";
    }
}