#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
//typedef __int128_t int128;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = acos(-1);

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ld START_TIME, TIME;

void solve() {

}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    START_TIME = clock();
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
#ifdef LOCAL
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    cout << fixed << setprecision(10);
    int n;
    cin >> n;
    vector<ld> a(n);
    multiset<ld> f, s;
    for (auto& i : a) {
        cin >> i;
        s.emplace(i);
    }
    s.erase(s.find(a[0]));
    f.emplace(a[0]);
    cout << (ld)1 << " ";
    for (int i = 1; i < n; ++i) {
        ld mn1 = *f.begin(), mx1 = *f.rbegin();
        ld mn2 = *s.begin(), mx2 = *s.rbegin();
        ld c0 = max(mx1, mx2) - min(mn1, mn2);

        ld t1 = 0;
        if (mn2 >= mn1) t1 = (mn2 - mn1) / mn2;
        ld c1 = (max(mx1, mx2 * (1 - t1)) - min(mn1, mn2 * (1 - t1)));
        ld t2 = 0;
        if (mx2 >= mx1) t2 = (mx2 - mx1) / mx2;
        ld c2 = (max(mx1, mx2 * (1 - t2)) - min(mn1, mn2 * (1 - t2)));
        f.emplace(a[i]);
        s.erase(s.find(a[i]));
        ld res = 0;
        if (c1 <= c0 && c1 <= c2) {
            res = max(res, t1);
        }
        if (c2 <= c0 && c2 <= c1) {
            res = max(res, t2);
        }
        cout << res << " ";
    }
    return 0;
}