#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
//typedef __int128_t int128;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = acos(-1);

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ld START_TIME, TIME;

int n;
int a[2000];
int inT[2000];

void solve() {
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
    }

    vector<int> t[3];
    int it = 0;
    for(int i = 1; i <= n; i++)
    {
        if(inT[i] != 0)
        {
            int id = inT[i];
            while(t[id].back() != i)
            {
                cout << id << (3 - id) << endl;
                t[3 - id].push_back(t[id].back());
                inT[t[id].back()] = 3 - inT[t[id].back()];
                t[id].pop_back();
            }
            cout << '-' << id << endl;
        }
        else
        {
            while(a[it] != i)
            {
                int id = 2;
                if(t[1].size() < t[2].size())
                {
                    id = 1;
                }

                cout << id << endl;
                t[id].push_back(a[it]);
                inT[a[it]] = id;
                it++;
            }
            it++;
            cout << 1 << endl;
            cout << -1 << endl;
        }
    }

}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    START_TIME = clock();
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
#ifdef LOCAL
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    return 0;
}