#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <cmath>
#include <random>
#include <bitset>
#include <algorithm>
#include <deque>

#define int long long
#define double long double


using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    for (int i = 0; i < n; ++i) {
        a[i] -= 1;
    }
    vector<int> b(n);
    int j = 0;
    deque<int> c, d;
    for (int i = 0; i < n; ++i) {
        if (b[i] == 0) {
            while (a[j] != i) {

                cout << 1 << '\n';
                c.push_back(a[j]);
                b[a[j]] = 1;
                j += 1;
            }
            cout << 1 << '\n';
            cout << -1 << '\n';
            j += 1;
        } else if (b[i] == 1) {
            while (c.back() != i) {
                cout << 12 << '\n';
                int e = c.back();
                c.pop_back();
                d.push_back(e);
                b[e] = 2;
            }
            cout << -1 << '\n';
            c.pop_back();
        } else {
            while (d.back() != i) {
                cout << 21 << '\n';
                int e = d.back();
                d.pop_back();
                c.push_back(e);
                b[e] = 1;
            }
            cout << -2 << '\n';
            d.pop_back();
        }

    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(10);
#endif

    solve();
}
