#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <random>
using namespace std;
using ll = long long;

mt19937 rng(228);
int rand(int l, int r) {
	return uniform_int_distribution<int>(l, r)(rng);
}
const int inf = 1e9 + 9;
#define int long long
int n;

int a[2000000];
int b[2000000];
int kek[2000000];

int good(int m) {
	vector <vector<int>> ve(n);
	for (int i = 0; i < n; ++i) {
		int l = max(i - m, 0ll);
		ve[l].push_back(i);
	}
	int uk = 0;
	fill(kek, kek + n, 0);
	for (int i = 0; i < n; ++i) {
		for (auto j : ve[i]) {
			kek[min(n - 1, j + m)] += a[j];
		}
		int nw = b[i];
		while (uk <= min(i + 2 * m, n - 1) && nw != 0) {
			int qw = min(nw, kek[uk]);
			nw -= qw;
			kek[uk] -= qw;
			if (!kek[uk]) ++uk;
		}
		uk = min(uk, n - 1);
		if (kek[i] != 0) {
			return 0;
		}
	}
	return 1;
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	int l = -1;
	int r = 1e7;
	while (r - l > 1) {
		int mi = (l + r) / 2;
		if (good(mi)) {
			r = mi;
		}
		else {
			l = mi;
		}
	}
	if (r > 4e6) {
		cout << -1;
	}
	else {
		cout << r;
	}
	return 0;
}