#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;
#define int long long 

int n;
int a[1000010];
int b[1000010];
int c[1000010];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i) cin >> a[i];
	for (int i = 1; i <= n; ++i) cin >> b[i];

	int l = -1, r = n + 1;

	while (l + 1 < r)
	{
		int  m = (l + r) >> 1;

		bool ok = true;
		int p = 1;
		for (int i = 1; i <= n; ++i)
		{
			c[i] = a[i];
			while (true)
			{
				if (p == i) break;
				if (c[p] > b[p])
				{
					if (i - p > m)
					{
						ok = false;
						break;
					}
					else if (c[p] - b[p] <= b[i] - c[i])
					{
						c[i] += c[p] - b[p];
						c[p] = b[p];
						++p;
						continue;
					}
					else if (b[i] >= c[i])
					{
						c[p] -= b[i] - c[i];
						c[i] = b[i];
						break;
					}
					else
					{
						break;
					}
				}
				else if (i - p > m)
				{
					++p;
					continue;
				}
				else
				{
					auto todo = max(0ll, min(c[i] - b[i], b[p] - c[p]));
					c[i] -= todo;
					c[p] += todo;
					if (c[i] > b[i])
					{
						++p;
						continue;
					}
					else
					{
						break;
					}
				}
			}
			if (!ok) break;
		}
		for (int i = 1; i <= n; ++i) if (c[i] > b[i])
		{
			ok = false;
			break;
		}
		if (ok)
		{
			r = m;
		}
		else
		{
			l = m;
		}
	}

	cout << (r == n + 1 ? -1 : r);
	return 0;
}