
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>

using namespace std;

typedef long long ll;

int l, n;
vector<string> arr;

bool solve(vector<int> &inds, char last = 'a') {
	if (inds.size() == 1) {
		return true;
	}
	for (char c = last; c <= 'z'; c++) {
		int cnt = 0;
		for (auto i: inds) {
			for (int j = 0; j < l; j++) {
				if (arr[i][j] == c) {
					cnt++;
					break;
				}
			}
		}
		if (cnt == inds.size()) {
			map<vector<int>, vector<int>> mm;
			for (auto i: inds) {
				vector<int> new_inds;
				for (int j = 0; j < l; j++) {
					if (arr[i][j] == c) {
						new_inds.push_back(j);
					}
				}
				mm[new_inds].push_back(i);
			}
			for (auto &el : mm) {
				if (!solve(el.second, c + 1)) {
					return false;
				}
			}
			return true;
		}
	}
	return false;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> l >> n;
	arr.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector<int> inds(n);
	for (int i = 0; i < n; i++) {
		inds[i] = i;
	}
	if (solve(inds)) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}
	return 0;
}