#include<iostream>
#include<vector>
#include<algorithm>

#define _CRT_SECURE_NO_WARNINGS

using namespace std;
typedef long long ll;
int n;
vector<int> a;
vector<int> b;

bool ok(int k, vector<int> a, vector<int> b) {
	int i = 0, j = 0;
	while (i < n) {
		while (b[i] > 0 && abs(i - j) <= k) {
			while (j < n && a[j] == 0) j++;
			if (j >= n) break;
			if (a[j] >= b[i]) {
				a[j] -= b[i];
				b[i] = 0;
			}
			else {
				b[i] -= a[j];
				a[j] = 0;
				j++;
			}
		}
		i++;
	}
	if (j >= n) return true;
	return false;
}

ll sum(vector<int>& a) {
	ll sum = 0;
	for (auto& i : a) sum += i;
	return sum;
}

int main() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		int x; cin >> x;
		a.push_back(x);
	}
	for (int i = 0; i < n; ++i) {
		int x; cin >> x;
		b.push_back(x);
	}
	if (sum(a) > sum(b)) {
		cout << -1;
		return 0;
	}
	int l = -1, r = n - 1;
	while (r > l + 1) {
		int mid = (l + r) / 2;
		if (ok(mid, a, b)) r = mid;
		else l = mid;
	}
	cout << r;
}