#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <ccomplex>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <iostream>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <limits>
#include <stack>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<long long, long long> Pair;

const long long MOD = 1e9 + 7;
const long long INF = LLONG_MAX;

#define endl "\n"
#define debug cout << "# sus" << endl;

//#define FILE

void solve() {
    int n; cin >> n;
    vector<int> v;
    for (int i = 0; i < n; ++i) {
        int a; cin >> a;
        v.push_back(a);
    }

    int c = 1;
    stack<int> a1;
    set<int> s1;
    stack<int> a2;
    set<int> s2;

    for (int i: v) {
        if (i != c) {
            a1.push(i);
            s1.insert(i);
            cout << "1" << endl;
        } else {
            cout << "1" << endl;
            cout << "-1" << endl;
            ++c;
        }
    }

    while (!a1.empty() || !a2.empty()) {
        if (s1.count(c) > 0) {
            while (a1.top() != c) {
                cout << "12" << endl;
                a2.push(a1.top());
                s1.erase(a1.top());
                s2.insert(a1.top());
                a1.pop();
            }
            cout << "-1" << endl;
            a1.pop();
            s1.erase(c);
        } else {
            while (a2.top() != c) {
                cout << "21" << endl;
                a1.push(a2.top());
                s2.erase(a2.top());
                s1.insert(a2.top());
                a2.pop();
            }
            cout << "-2" << endl;
            s2.erase(c);
            a2.pop();
        }
        ++c;
    }
}

signed main() {
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    long long tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
