#include <bits/stdc++.h>

#define all(_v) ((_v).begin(), (_v).end())
#define rall(_v) ((_v).rbegin(), (_v).rend())
#define F first
#define pb push_back
#define S second
#define sq(_x) ((_x) * (_x))
using namespace std;
using ll = long long;
const int maxn = 1e6 + 10;

int t[maxn * 4];

void update(int v, int tl, int tr, int pos){
  if (tl == tr){
    t[v] = 1;
    return;
  }
  int tm = (tl + tr) / 2;
  if (pos <= tm)
    update(v * 2, tl, tm, pos);
  else
    update(v * 2 + 1, tm + 1, tr, pos);
  t[v] = t[v * 2] + t[v * 2 + 1];
}

int get(int v, int tl, int tr, int l, int r){
  if (tl > r || tr < l)
    return 0;
  if (l <= tl && tr <= r)
    return t[v];
  int tm = (tl + tr) / 2;
  return get(v * 2, tl, tm, l, r) + get(v * 2 + 1, tm + 1, tr, l, r);
}

bool comp(pair<int, int> A, pair<int, int> B){
  if (A.F < B.F){
    return true;
  } else if (A.F == B.F){
    return A.S < B.S;
  }
}

bool comp1(pair<int, int> A, pair<int, int> B){
  if (A.F > B.F){
    return true;
  } else if (A.F == B.F){
    return A.S < B.S;
  }
}

main (){
  ios_base::sync_with_stdio(NULL);
  cin.tie(NULL);
  cout.tie(NULL);
  int n;
  cin >> n;
  ll s1, s2;
  s1 = s2 = 0;
  vector<int> a(n + 10), b(n + 10);
  for (int i = 1;i <= n;++i){
    cin >> a[i];
    s1 += a[i];
  }
  for (int i = 1;i <= n;++i){
    cin >> b[i];
    s2 += b[i];
  }
  if (s2 < s1){
    cout << "-1";
    return 0;
  }
  vector<int> pos;
  ll q, w;
  q = w = 0;
  pos.pb(0);
  for (int i = 1;i <= n;++i){
    q += a[i];
    w += b[i];
    if (q > w){
      pos.pb(i);
      pos.pb(i);
    }
  }

  int ans = 0;
  for (int i = 0;i < pos.size() - 1;++i)
    ans = max(ans, pos[i] - 1);
  cout << ans << "\n";
}
