#include <bits/stdc++.h>

#define all(_v) ((_v).begin(), (_v).end())
#define rall(_v) ((_v).rbegin(), (_v).rend())
#define F first
#define pb push_back
#define S second
#define sq(_x) ((_x) * (_x))
using namespace std;
using ll = long long;
const int maxn = 2e5 + 10;
const double eps = 0.000000001;

int tmax[maxn * 4], tmin[maxn * 4];\
vector<int> a(maxn);
int n;

void build(int v, int tl, int tr){
  if (tl == tr){
    tmax[tl] = a[tl];
    tmin[tl] = a[tl];
    return;
  }
  int tm = (tl + tr) / 2;
  build(v * 2, tl, tm);
  build(v * 2 + 1, tm + 1, tr);
  tmax[v] = max(tmax[v * 2], tmax[v * 2 + 1]);
  tmin[v] = min(tmin[v * 2], tmin[v * 2 + 1]);
}

int Max(int v, int tl, int tr, int l, int r){
  if (tl > r || tr < l)
    return 0;
  if (l <= tl && tr <= r)
    return tmax[v];
  int tm = (tl + tr) / 2;
  return max(Max(v * 2, tl, tm, l, r), Max(v * 2 + 1, tm + 1, tr, l, r));
}

int Min(int v, int tl, int tr, int l, int r){
  if (tl > r || tr < l)
    return INT_MAX / 2;
  if (l <= tl && tr <= r)
    return tmin[v];
  int tm = (tl + tr) / 2;
  return min(Min(v * 2, tl, tm, l, r), Min(v * 2 + 1, tm + 1, tr, l, r));
}

double f(double val, int k){
  double MX = max(Max(1, 1, n, 1, k - 1) * 1.0, val * Max(1, 1, n, k, n));
  double MN = min(Min(1, 1, n, 1, k - 1) * 1.0, val * Min(1, 1, n, k, n));
  return MX - MN;
}

main (){
  ios_base::sync_with_stdio(NULL);
  cin.tie(NULL);
  cout.tie(NULL);
  //cout.precision(10);
  cin >> n;
  vector<double> ans(n + 10, 0.0);
  for (int i = 1;i <= n;++i){
    cin >> a[i];
  }
  build(1, 1, n);
  for (double k = 1;k <= n;++k){
    double l = 0.0, r = 1.0;
    while (r - l > eps){
      double m1, m2;
      m1 = (r + l) / 3.0;
      m2 = (2.0 * r - 2.0 * l) / 3.0;
      if (f(l, k) > f(m1, k))
        l = m1;
      if (f(r, k) > f(m2, k))
        r = m2;
    }
    cout << fixed << setprecision(10) << r << " ";
  }
}
