// VkoshpKostroma.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

//Kostroma

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <stack>
#include <map>

using namespace std;

const int mod = 1e9 + 7;
vector<int> step;
const int st = 173;

vector<string> bigdata;
int L;
long long cnt = 0;

bool get_ans(vector<int> A, vector<bool> was) {
	cnt++;
	if (cnt >= 10000000) {
		return false;
	}
	vector<int> in;
	vector<int> out;
	if (A.size() <= 1) {
		return true;
	}
	char let = '#';
	for (char ll = 'a'; ll <= 'z'; ++ll) {
		if (was[ll - 'a']) {
			continue;
		}
		bool fl = true;
		for (int i = 0; i < A.size(); ++i) {
			bool fl1 = false;
			for (int j = 0; j < L; ++j) {
				if (bigdata[A[i]][j] == ll) {
					fl1 = true;
					break;
				}
			}
			if (!fl1) {
				fl = false;
				break;
			}
		}
		if (fl) {
			let = ll;
			break;
		}
	}
	//cout << A.size() << ' ' << let << ' ' << pos << endl;
	if (let == '#') {
		return false;
	}
	was[let - 'a'] = true;
	vector<int> hashes(A.size(), 0);
	for (int i = 0; i < A.size(); ++i) {
		for (int j = 0; j < L; ++j) {
			if (bigdata[A[i]][j] == let) {
				hashes[i] += step[j];
				hashes[i] %= mod;
			}
		}
	}
	map<int, int> dict;
	vector<vector<int> > razb;
	for (int i = 0; i < A.size(); ++i) {
		if (dict.find(hashes[i]) == dict.end()) {
			dict[hashes[i]] = razb.size();
			razb.push_back({ A[i] });
		}
		else {
			razb[dict[hashes[i]]].push_back(A[i]);
		}
	}
	bool fl = true;
	for (int i = 0; i < razb.size(); ++i) {
		fl = fl && get_ans(razb[i], was);
	}
	return fl;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout << fixed << setprecision(12);
	int n;
	cin >> L;
	cin >> n;
	bigdata.resize(n);
	step.resize(L);
	step[0] = 1;
	for (int i = 1; i < L; ++i) {
		step[i] = step[i - 1] * st;
	}
	vector<int> start;
	vector<bool> w(26, false);
	for (int i = 0; i < n; ++i) {
		start.push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> bigdata[i];
	}
	if (get_ans(start, w)) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file