#include <iostream>
#include <vector>
#include <algorithm>


#pragma GCC target("avx");
#pragma GCC optimize(3);
#pragma GCC optimize("inline-functions")



#define ll long long
#define ld long double
#define pr pair<ll, ll>
#define vl vector<ll>
#define all(a) (a.begin(), a.end())

using namespace std;

void solve() {
	int n;
	cin >> n;

	vector<int> vec(n);

	for (auto& e : vec) cin >> e;

	sort(vec.begin(), vec.end());

	ll sum = 0;
	for (int i = (n + 1) / 2; i < n; ++i) sum += vec[i];
	cout << sum << endl;
}



int main() {
	ios::sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	ll t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}