#include <bits/stdc++.h>
using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(obj) obj.begin(), obj.end()
#define pb push_back()
#define fi first
#define se second
#define int long long
using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using s64 = long long;

void solve(istream& in, ostream& out) {
    int n;
    cin >> n;
    vector<s64> a(n), b(n);
    s64 suma = 0, sumb = 0;
    for(int i = 0; i < n; i++){
        cin >> a[i];
        suma += a[i];
    }
    for(int i = 0; i < n; i++){
        cin >> b[i];
        sumb += b[i];
    }

    if(suma > sumb){
        cout << "-1\n";
        return;
    }

    bool ok = true;
    for(int i = 0; i < n; i++){
        if(a[i] > b[i]){
            ok = false;
        }
    }
    if(ok){
        cout << "0\n";
        return;
    }

    auto f = [&](int k){
        auto save_a = a;

        for(int i = 0; i < n; i++) {
            if(a[i] < b[i]){
                for(int j = i + 1; j < n && j - i <= k; j++){
                    if(a[j] > 0){
                        s64 d = min(b[i] - a[i], a[j]);
                        a[i] += d;
                        a[j] -= d;
                    }
                }
            }
            else if(a[i] > b[i]) {
                for(int j = i + 1; j < n && j - i <= k; j++){
                    if(a[j] < b[j]){
                        s64 d = min(b[j] - a[j], a[i] - b[i]);
                        a[i] -= d;
                        a[j] += d;
                    }
                }
            }
            if(i + 1 < n && a[i] > b[i]){
                a[i + 1] += a[i] - b[i];
                a[i] = b[i];
            }
        }

        bool ok = true;
        for(int i = 0; i < n; i++){
            if(a[i] > b[i]){
                ok = false;
            }
        }
        a = save_a;
        return ok;
    };

    int l = 0, r = n - 1;
    while(l < r - 1){
        int m = (l + r) / 2;
        if(f(m)){
            r = m;
        }
        else{
            l = m;
        }
    }
    cout << r << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    solve(cin, cout);
    return 0;
}
