#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define all(x) x.begin(), x.end()
using namespace std;


vector<string> arr;
bool f(vector<char> slov, vector<int> index) {
	for (char b = 'a'; b <= 'z'; ++b) {
		bool flag_count = false;
		for (char i : slov) {
			if (i == b) {
				flag_count = true;
			}
		}
		if (flag_count) { continue; }

		bool flag_ret = true;
		for (int i : index) {
			bool flag = false;
			for (char bu : arr[i]) {
				if (bu == b) {
					flag = true;
				}
			}
			if (!flag) {
				flag_ret = false;
			}
		}

		if (flag_ret) {
			map<vector<int>, vector<int>> sol;
			for (int i : index) {
				vector<int> indexLocal;
				for (int j = 0; j < arr[i].size(); ++j) {
					if (arr[i][j] == b) {
						indexLocal.push_back(j);
					}
				}
				sol[indexLocal].push_back(i);
			}

			slov.push_back(b);
			for (auto& it : sol) {
				if (it.second.size() > 1) {
					if (!f(slov, it.second)) {
						return false;
					}
				}
			}
			return true;
		}
	}
	return false;
}

signed main() {
	int n, m;
	cin >> m >> n;
	for (int i = 0; i < n; ++i) {
		string str;
		cin >> str;
		arr.push_back(str);
	}
	vector<char> slov;
	vector<int> index(n);
	for (int i = 0; i < n; ++i) {
		index[i] = i;
	}
	if (f(slov, index)) {
		cout << "YES";
	}
	else {
		cout << "NO";
	}
}


/*
bool does_it_suit(double m, int amin, int amax, int bmin, int bmax) {
	double tmax = max((double)m / (bmax - bmin), (double)(amax - m) / bmin);
	double tmin = (double)(amin + m) / bmax;
	if (tmax >= tmin)
		return 1;
	return 0;
}
double f(double m, int amin, int amax, int bmin, int bmax) {
	return (1 - (double)(amax - m) / bmin);
}

signed main() {
	cout.setf(ios::fixed);
	cout.precision(20);
	int n;
	cin >> n;
	vector<int>a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<int>p_max(n);
	vector<int>s_max(n);
	vector<int>p_min(n);
	vector<int>s_min(n);
	p_max[0] = p_min[0] = a[0];
	s_max[n - 1] = s_min[n - 1] = a[n - 1];
	for (int i = 1; i < n; ++i) {
		p_max[i] = max(p_max[i - 1], a[i]);
		p_min[i] = min(p_min[i - 1], a[i]);
	    s_max[n - 1 - i] = max(s_max[n - i], a[n - 1 - i]);
		s_min[n - 1 - i] = min(s_min[n - i], a[n - 1 - i]);
	}
	cout << 1 << " ";
	for (int i = 1; i < n; ++i) {
		double mq = p_max[i - 1] - p_min[i - 1], mr = 6;
		for (int j = 0; j < 101; ++j) {
			double m = (mq + mr) / 2;
			if (does_it_suit(m,p_min[i - 1],p_max[i - 1],s_min[i], s_max[i])) {
				mr = m;
			}
			else
				mq = m;
		}
		cout << f(mr, p_min[i - 1], p_max[i - 1], s_min[i], s_max[i]) << ' ';
	}

}
*/
