#include <bits/stdc++.h>
#define fori for (int i = 0; i < n; ++i)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;
#ifdef local
bool debug = true;
#else
bool debug = false;
#endif

const ll INF = 1e9 + 1337;

inline void solve() {
	int n;
	cin >> n;

	vector <ll> a(n);
	for (ll &x: a) cin >> x;

	vector <ll> suff_sum(n + 1);
	vector <ll> pref_max(n + 1, 0), pref_min(n + 1, INF);
	vector <ll> suff_max(n + 1, 0), suff_min(n + 1, INF);

	for (int i = 0; i < n; i++) {
		pref_max[i + 1] = max(pref_max[i], a[i]);
		pref_min[i + 1] = min(pref_min[i], a[i]);
	}

	for (int i = n - 1; i >= 0; i--) {
		suff_max[i] = max(suff_max[i + 1], a[i]);
		suff_min[i] = min(suff_min[i + 1], a[i]);
		suff_sum[i] = suff_sum[i + 1] + a[i];
	}

	auto f = [&] (int k, ld t) {
		// cout << pref_max[k] << ' ' << suff_max[k] << '\n';
		// cout << pref_min[k] << ' ' << suff_min[k] << '\n';

		ld mx = max((ld)pref_max[k], suff_max[k] * (1 - t));
		ld mn = min((ld)pref_min[k], suff_min[k] * (1 - t));
		ld b = t * suff_sum[k];
		return make_pair(mx - mn, -b);
	};

	for (int k = 0; k < n; k++) { // FUCKING K = 0
		ld m1, m2, l = 0, r = 1;

		for (int i = 0; i < 100; i++) {
			m1 = l + (r - l) / 3;
			m2 = r - (r - l) / 3;
			
			if (f(k, m1) > f(k, m2)) {
				l = m1;
			} else {
				r = m2;
			}

			// cout << setprecision(5) << fixed << k << ' ' << m1 << ' ' << f(k, m1).first << "," << f(k, m1).second << '\n';
		}

		cout << setprecision(14) << fixed << l << ' ';
		// cout << setprecision(5) << fixed << k << ' ' << l << ' ' << f(k, l).first << "," << f(k, l).second << '\n';
	}

	// int k = 1; ld t = 0.75;
	// cout << setprecision(5) << fixed << f(k, t).first << ' ' << f(k, t).second << endl;

	cout << '\n';
}

signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	
	solve();
}

/*

3
1 4 2




1 4
1 2
1.50000 1 4
1 2
4.50000


*/