#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <bits/stdc++.h>
#include <set>

using namespace std;
const double EPS = 1e-10;

long double min_l, min_r, max_l, max_r;

long double f(long double x) {
    //cout << "max = " << max(max_r*(1-x), max_l) << " min = " << min(min_l, min_r*(1-x)) << "\n";
	return max(max_r*(1-x), max_l) - min(min_l, min_r*(1-x));
}

int main()
{
	int n;
	cin >> n;
	vector<int> v(n);

	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}

	vector<int> pr_min(n), pr_max(n), po_min(n), po_max(n);
	pr_min[0] = v[0];
	pr_max[0] = v[0];
	for (int i = 1; i < n; i++) {
		pr_min[i] = min(pr_min[i - 1], v[i]);
		pr_max[i] = max(pr_max[i - 1], v[i]);
	}

	po_min[n-1] = v[n-1];
	po_max[n-1] = v[n-1];
	for (int i = n-2; i >= 0; i--) {
		po_min[i] = min(po_min[i + 1], v[i]);
		po_max[i] = max(po_max[i + 1], v[i]);
	}

	for (int i = 0; i < n; i++) {
		min_l = i==0?1e15: pr_min[i-1];
		min_r = po_min[i];
		max_l = i==0?-1e16:pr_max[i-1];
		max_r = po_max[i];

		long double l = 0, r = 1;
		for(int j = 0; j < 150; j++) {
            long double m = (l + r) / 2;
			if (f(m) >= f(m + EPS))
				l = m;
			else
				r = m;
            //cout << setprecision(30) << m << " " << f(m) << " " << f(m+EPS) << "\n";
		}
		//cout << f(r) << " " << f(r+EPS) << "\n";
        cout << setprecision(30) << l << "\n";
	}
}
