#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

#define SZ(sp) (sp.size())

template < typename T >
using orde = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;
template < typename T >
using order = tree < T, null_type, less_equal <>, rb_tree_tag, tree_order_statistics_node_update >;
// find_by_order() yk-l
// order_of_key() kol-vo

#define int long long

int get_h(vector < int > &arr) {
    int ans = 0;
    int P = 1e5 + 3;
    int mod = 1e18 + 3;
    int p = 1;
    for (int i = 0; i < SZ(arr); ++i) {
        ans = (ans + (arr[i] * p) % mod) % mod;
        p = (p * P) % mod;
    }
    return ans;
}

int l, n;
vector < vector < char > > good;
vector < vector < int > > h;

char rec(vector < int > &pos, vector < char > &used) {
    for (int i = 0; i < 26; ++i) {
        if (used[i]) {
            continue;
        }
        char fl = true;
        for (auto &el: pos) {
            if (!good[el][i]) {
                fl = false;
                break;
            }
        }
        if (fl) {
            map < int, vector < int > > cnt;
            for (auto &el: pos) {
                cnt[h[el][i]].emplace_back(el);
            }
            fl = true;
            for (auto &[key, val]: cnt) {
                if (SZ(val) > 1) {
                    fl = false;
                    break;
                }
            }
            if (fl) {
                return true;
            }
            used[i] = true;
            for (auto &[key, val]: cnt) {
                if (rec(val, used)) {
                    return true;
                }
            }
            used[i] = false;
        }
    }
    return false;
}

void solve() {
    cin >> n >> l;
    vector < string > arr(l);
    for (auto &el: arr) {
        cin >> el;
    }
    h.resize(l, vector < int > (26));
    good.resize(l, vector < char > (26));
    for (int i = 0; i < l; ++i) {
        for (int j = 0; j < 26; ++j) {
            vector < int > sp;
            for (int k = 0; k < n; ++k) {
                if (arr[i][k] - 'a' == j) {
                    sp.emplace_back(k);
                    good[i][j] = true;
                }
            }
            h[i][j] = get_h(sp);
        }
    }
    vector < int > pos(l);
    for (int i = 0; i < l; ++i) {
        pos[i] = i;
    }
    vector < char > used(26);
    if (rec(pos, used)) {
        cout << "YES";
    }
    else {
        cout << "NO";
    }
}

int32_t main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
}




