#include <bits/stdc++.h>

using namespace std;

int main() {
    const long long INF = 2 * 1e9;
    int n;
    cin >> n;
    vector<int> a(n);
    cout << setprecision(10) << fixed;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int p = 0;
    while ((1 << (p + 1)) <= n) {
        p++;
    }
    vector<vector<int>> sparse_table_max(p + 1);
    sparse_table_max[0].resize(n);
    for (int i = 0; i < n; i++) {
        sparse_table_max[0][i] = a[i];
    }
    for (int i = 1; i <= p; i++) {
        sparse_table_max[i].resize(n);
        for (int j = 0; j <= n - (1 << i); j++) {
            sparse_table_max[i][j] = max(sparse_table_max[i - 1][j], sparse_table_max[i - 1][j + (1 << (i - 1))]);
        }
    }
    vector<vector<int>> sparse_table_min(p + 1);
    sparse_table_min[0].resize(n);
    for (int i = 0; i < n; i++) {
        sparse_table_min[0][i] = a[i];
    }
    for (int i = 1; i <= p; i++) {
        sparse_table_min[i].resize(n);
        for (int j = 0; j <= n - (1 << i); j++) {
            sparse_table_min[i][j] = min(sparse_table_min[i - 1][j], sparse_table_min[i - 1][j + (1 << (i - 1))]);
        }
    }
    for (int k = 0; k < n; k++) {
        double left = 0.0;
        double right = 1.0;
        int q1 = 0;
        while ((1 << (q1 + 1)) <= k) {
            q1++;
        }
        int min1, max1;
        if (k == 0) {
            min1 = INF;
            max1 = -INF;
        } else {
            min1 = min(sparse_table_min[q1][0], sparse_table_min[q1][k - (1 << q1)]);
            max1 = max(sparse_table_max[q1][0], sparse_table_max[q1][k - (1 << q1)]);
        }
        int q2 = 0;
        while ((1 << (q2 + 1)) <= n - k) {
            q2++;
        }
        int min2, max2;
        min2 = min(sparse_table_min[q2][k], sparse_table_min[q2][n - (1 << q2)]);
        max2 = max(sparse_table_max[q2][k], sparse_table_max[q2][n - (1 << q2)]);
        //cout << k << " " << min1 << " " << max1 << " " << min2 << " " << max2 << "\n";
        while (right - left > 1e-10) {
            double mid1 = left + (right - left) / 3;
            double mid2 = right - (right - left) / 3;
            double f1, f2;
            f1 = max((double)max1, (double)max2 * (1 - mid1)) - min((double)min1, (double)min2 * (1 - mid1));
            f2 = max((double)max1, (double)max2 * (1 - mid2)) - min((double)min1, (double)min2 * (1 - mid2));
            if (f1 < f2){
                right = mid2;
            }
            else{
                left = mid1;
            }
        }
        cout << (right + left) / 2 << " ";
    }
    return 0;
}