#include <bits/stdc++.h>
#pragma comment(linker, "/stack:20000000000")
#pragma GCC optimize("Ofast")
#pragma target("avx,fma")
#pragma target("tune=negative")

using namespace std;

typedef long long ll;

const int N = 1e6 +3;
int n;
int a[N], b[N], c[N];

bool check(int k) {
    int p = 0;
    copy(b, b + n, c);
    for (int i = 0; i < n; ++i) {
        if (p < i-k) ++p;
        int s = a[i];
        while (p < n && p <= i+k && s > 0) {
            if (s >= c[p]) {
                s -= c[p];
                c[p] = 0;
                ++p;
            } else {
                c[p] -= s;
                s = 0;
            }
        }
        if (s > 0) return false;
    }
    return true;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    scanf("%d", &n);
    for (int i = 0; i < n; ++i) scanf("%d", &a[i]);
    for (int i = 0; i < n; ++i) scanf("%d", &b[i]);
    if (accumulate(a, a + n, 0ll) > accumulate(b, b + n, 0ll)) {
        printf("-1\n");
        return 0;
    }
    int l = 0, r = n;
    if (check(0)) {
        printf("0\n"); return 0;
    }
    while (r - l > 1) {
        int m = l + r >> 1;
        if (check(m)) {
            r = m;
        } else {
            l = m;
        }
    }
    printf("%d\n", r);

}
