#include <bits/stdc++.h>

using namespace std;

#define MP make_pair

typedef long long ll;

const int N = 1e6 + 3e2;

int n;
int a[N], b[N];

bool check(int k){
    ll sum = 0;
    for (int i = 1; i <= k; i++) sum += b[i] - a[i];

    if (sum < 0) return false;

    for (int i = 2; i + k - 1 <= n; i++){
        sum -= b[i - 1] - a[i - 1];
        sum += b[i + k - 1] - a[i + k - 1];
        if (sum < 0) return false;
    }

    return true;
}

void solve(){
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) cin >> b[i];

    int ans = -1;

    int l = 0, r = (n + 1) / 2;
    while (l <= r){
        int m = (l + r) >> 1;
        if (check(2 * m + 1)){
            ans = m;
            r = m - 1;
        } else l = m + 1;
    }

    cout << ans;

}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int tests = 1;
    //cin >> tests;

    for (int test = 1; test <= tests; test++){
        solve();
    }

    return 0;
}
