#include <bits/stdc++.h>

using namespace std;

void print(stack<pair<int, bool>> f, stack<pair<int, bool>> s) {
  cout << "f stack: ";
  while (!f.empty()) {
    cout << f.top().first << ' ';
    f.pop();
  }

  cout << endl;
  cout << "s stack: ";

  while (!s.empty()) {
    cout << s.top().first << ' ';
    s.pop();
  }
  cout << endl;
}

int main() {
  int n;
  cin >> n;

  queue<short> arr;
  priority_queue<short, vector<short>, greater<short>> helper;

  for (int i = 0; i < n; ++i) {
    int x;
    cin >> x;
    helper.push(x);

    arr.push(x);
  }

  stack<pair<int, bool>> f, s;

  set<short> f_set, s_set;

  while (!arr.empty()) {
    int train = arr.front(), tvalue = helper.top();

    arr.pop();

    if (train == tvalue) {
      cout << 1 << endl;
      cout << -1 << endl;
      helper.pop();
    } else {
      if (f.empty()) {
        f.push({train, false});
        f_set.insert(train);
        cout << 1 << endl;
        continue;
      }
      if (s.empty()) {
        s.push({train, false});
        s_set.insert(train);
        cout << 2 << endl;
        continue;
      }

      if (train <= f.top().first && train <= s.top().first) {
        if (s.size() > f.size()) {
          cout << 1 << endl;
          f.push({train, false});
          f_set.insert(train);
        } else {
          cout << 2 << endl;
          s.push({train, false});
          s_set.insert(train);
        }
      } else if (train <= f.top().first) {
        cout << 1 << endl;
        f.push({train, false});
        f_set.insert(train);
      } else if (train <= s.top().first) {
        cout << 2 << endl;
        s.push({train, false});
        s_set.insert(train);
      } else {
        if (s.top().first >= f.top().first) {
          cout << 2 << endl;
          s.push({train, true});
          s_set.insert(train);
        } else {
          cout << 1 << endl;
          f.push({train, false});
          f_set.insert(train);
        }
      }
    }
  }

  // print(f, s);

  while (!f.empty() || !s.empty()) {
    int tvalue = helper.top();

    if (!f_set.empty() && f_set.find(tvalue) != f_set.end()) {
      while (f.top().first != tvalue) {
        cout << 12 << endl;
        s.push(f.top());
        s_set.insert(f.top().first);
        f_set.erase(f.top().first);
        f.pop();
      }
      cout << -1 << endl;
      f_set.erase(f.top().first);
      f.pop();
      helper.pop();
    } else {
      while (s.top().first != tvalue) {
        cout << 21 << endl;
        f.push(s.top());
        f_set.insert(s.top().first);
        s_set.erase(s.top().first);
        s.pop();
      }
      cout << -2 << endl;
      s_set.erase(s.top().first);
      s.pop();
      helper.pop();
    }
  }

  // while (!f.empty() || !s.empty()) {
  //   print(f, s);

  //   pair<int, bool> ftop = f.top(), stop = s.top();

  //   if (f.empty() && !stop.second) {
  //     cout << 1 << endl;
  //     stop.second = false;
  //     f.push(stop);
  //     s.pop();
  //     continue;
  //   }

  //   if (s.empty() && !ftop.second) {
  //     cout << 2 << endl;
  //     ftop.second = false;
  //     s.push(ftop);
  //     f.pop();
  //     continue;
  //   }

  //   if (!ftop.second && ftop.first <= stop.first) {
  //     cout << -1 << endl;
  //     f.pop();
  //   } else if (!stop.second && stop.first < ftop.first) {
  //     cout << -2 << endl;
  //     s.pop();
  //   } else if (ftop.first && stop.first) {
  //     if (ftop.first <= stop.first) {
  //       cout << 2 << endl;
  //       ftop.second = false;
  //       s.push(ftop);
  //       f.pop();
  //     } else {
  //       cout << 1 << endl;
  //       stop.second = false;
  //       f.push(stop);
  //       s.pop();
  //     }
  //   }
  // }

  return 0;
}