#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define pii pair<int,int>

void solve () {
    int n; cin >> n;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    vector<int> log(n + 1);
    log[1] = 0;
    for (int i = 2; i <= n; ++i) {
        log[i] = log[i / 2] + 1;
    }
    vector<vector<int>> st1(n + 1, vector<int> (20)), st2(n + 1, vector<int> (20));
    for (int i = 1; i <= n; ++i) {
        st1[i][0] = a[i];
        st2[i][0] = a[i];
    }
    for (int j = 1; j <= log[n]; ++j) {
        for (int i = 1; (i + (1 << j) - 1) <= n; ++i) {
            st1[i][j] = max(st1[i][j - 1], st1[i + (1 << (j - 1))][j - 1]);
            st2[i][j] = min(st2[i][j - 1], st2[i + (1 << (j - 1))][j - 1]);
        }
    }
    auto getMax = [&] (int l, int r) {
        int c = log[r - l + 1];
        return max(st1[l][c], st1[r - (1 << c) + 1][c]);
    };
    auto getMin = [&] (int l, int r) {
        int c = log[r - l + 1];
        return min(st2[l][c], st2[r - (1 << c) + 1][c]);
    };
    auto f = [&] (int k, ld t) {
        ld ma = getMax(k, n) * t;
        ld mi = getMin(k, n) * t;
        if (k > 1) {
            ma = max(ma, (ld)getMax(1, k - 1));
            mi = min(mi, (ld)getMin(1, k - 1));
        }
        return ma - mi;
    };
    cout << fixed << setprecision(16);
    for (int k = 1; k <= n; ++k) {
        ld l = 0, r = 1, m1, m2;
        for (int i = 0; i < 200; ++i) {
            m1 = l + (r - l) / 3;
            m2 = r - (r - l) / 3;
            ld t1 = f(k, m1), t2 = f(k, m2);
            if (t1 > t2) {
                l = m1;
            } else {
                r = m2;
            }
        }
        cout << 1 - (l + r) / 2 << ' ';
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}
