#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

const long long maxN = 1e5;

struct item {
	std::vector<long long> c[26];
} a[maxN];

bool used[26], all[26];
long long l, n, b[maxN], letter;
std::string s;

bool cmp(long long i, long long j) {
	if (a[i].c[letter].size() == a[j].c[letter].size()) {
		for (long long h = 0; h < a[i].c[letter].size(); h++)
			if (a[i].c[letter][h] != a[j].c[letter][h])
				return a[i].c[letter][h] < a[j].c[letter][h];
		return false;
	}
	return a[i].c[letter].size() < a[j].c[letter].size();
}

bool check(long long l, long long r) {
	if (r - l == 1)
		return true;
	std::fill(all, all + 26, true);
	for (long long i = l; i < r; i++)
		for (long long j = 0; j < 26; j++)
			if (a[i].c[j].size() == 0)
				all[j] = false;
	long long let = -1;
	for (long long i = 0; i < 26; i++)
		if (all[i] && !used[i]) {
			let = i;
			break;
		}
	if (let == -1)
		return false;
	letter = let;
	used[let] = true;
	std::sort(b + l, b + r, cmp);
	for (long long i = l, j = l + 1; i < r && j <= r; j++) {
		if (j == r) {
			bool f = check(i, j);
			if (!f)
				return false;
			break;
		}
		if (a[i].c[let].size() != a[j].c[let].size()) {
			bool f = check(i, j);
			if (!f)
				return false;
			i = j;
		}
		else {
			for (long long h = 0; h < a[i].c[let].size(); h++)
				if (a[i].c[let][h] != a[j].c[let][h]) {
					bool f = check(i, j);
					if (!f)
						return false;
					i = j;
					break;
				}
		}
	}
	used[let] = false;
	return true;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> l >> n;
	for (long long i = 0; i < n; i++) {
		b[i] = i;
		std::cin >> s;
		for (long long j = 0; j < l; j++)
			a[i].c[s[j] - 'a'].push_back(j);
	}
	if (check(0, n))
		std::cout << "YES";
	else
		std::cout << "NO";
	return 0;
}